<?php
/*
prefs.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['titleimg']) || $_SESSION['titleimg']!=$_SESSION['CFG']->imagedir."/tlt_system.png"){
   $_SESSION['titleimg'] = $_SESSION['CFG']->imagedir."/tlt_system.png";
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
   case "preferences":
      preferences();
      break;
      
	case "modules" :
		modules();
		break;

	case "users":
		users();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function ReadConfig()
{
}

function WriteConfig()
{
/*
   if(!file_exists('../bhmis.php')){
      if(isset($_POST['config'])){
       // Build the file, if we can't build it we report an error.
       $cfg_file_name = $_POST['dirroot'] . "/bhmis.php";
       @$config_file = fopen($cfg_file_name, "w");
       if(!$config_file){
          echo "<h1>Error Writing Config File</h1><br>\n";
          echo "<p>I could not create the required configuration file '$cfg_file_name'.\n";
          echo "The most usual reason for this is that the directory is not writable\n";
          echo "by the web server user.\n";
          echo "<p>Check that the web server user (typically 'apache') either owns the\n";
          echo "directory or has either group or other write access to the directory.\n";
          echo "<p>Once you have done that you should reload this page.\n";
          exit;
      }
      fwrite($config_file, 'error_reporting(E_ALL);');
      fwrite($config_file, 'require_once(\"lib/misuser.php\");');
      fwrite($config_file, 'require_once(\"lib/page.php\");');
      fwrite($config_file, 'require_once(\"lib/timedate.php\");');
      fwrite($config_file, 'require_once(\"lib/createmod.php\");');
      fwrite($config_file, 'session_start();');
      fwrite($config_file, 'define('BHMIS_BASE', dirname(__FILE__));');
      fwrite($config_file, 'if(!isset($_SESSION['CFG'])){');
      fwrite($config_file, '$_SESSION['CFG']->progname = "BhMIS";');
      fwrite($config_file, '$_SESSION['CFG']->version = "0.9.5-1 (Loki)";');
      fwrite($config_file, '$_SESSION['CFG']->buildasshole = "A.K.";');
      fwrite($config_file, '$_SESSION['CFG']->builddate = "2nd Feb 2004";');
      fwrite($config_file, '$_SESSION['CFG']->dbtype = "mysql";');
      fwrite($config_file, '$_SESSION['CFG']->dbdatasource = "bananas";');
      fwrite($config_file, '$_SESSION['CFG']->dbhost = "localhost";');
      fwrite($config_file, '$_SESSION['CFG']->dbname = "bananas";');
      fwrite($config_file, '$_SESSION['CFG']->dbuser = "root";');
      fwrite($config_file, '$_SESSION['CFG']->dbpass = "bollocks";');
      fwrite($config_file, '$_SESSION['CFG']->onlinehelp  = true;');
      fwrite($config_file, '$_SESSION['CFG']->confirmdelete  = true;');
      fwrite($config_file, '$_SESSION['CFG']->pagesize  = 20;');
      fwrite($config_file, '$_SESSION['CFG']->wwwpage     = "/bhmis/main.php";');
      fwrite($config_file, '$_SESSION['CFG']->wwwroot     = "/bhmis";');
      fwrite($config_file, '$_SESSION['CFG']->dirroot     = "/usr/share/bhpos/mis";');
      fwrite($config_file, '$_SESSION['CFG']->templatedir = $_SESSION['CFG']->dirroot."/templates";');
      fwrite($config_file, '$_SESSION['CFG']->libdir      = $_SESSION['CFG']->dirroot."/lib";');
      fwrite($config_file, '$_SESSION['CFG']->styledir	   = $_SESSION['CFG']->wwwroot."/styles";');
      fwrite($config_file, '$_SESSION['CFG']->imagedir    = $_SESSION['CFG']->wwwroot."/images";');
      fwrite($config_file, '$_SESSION['CFG']->peopleimg   = $_SESSION['CFG']->dirroot."/people_images";');
      fwrite($config_file, '$_SESSION['CFG']->prodimg     = $_SESSION['CFG']->dirroot."/product_images";');
      fwrite($config_file, '$_SESSION['CFG']->wordlist    = $_SESSION['CFG']->libdir."/wordlist.txt";');
      fwrite($config_file, '$_SESSION['CFG']->support     = "missupport@bananahead.com";');
      fwrite($config_file, '}');
      fwrite($config_file, 'require_once($_SESSION['CFG']->libdir."/sql/".$_SESSION['CFG']->dbtype.".php");');
      fwrite($config_file, 'require_once($_SESSION['CFG']->libdir."/bhlib.php");');
      fwrite($config_file, 'require_once($_SESSION['CFG']->libdir."/".$_SESSION['CFG']->dbtype."lib.php");');
      fwrite($config_file, 'if(!isset($_SESSION['misuser'])){');
      fwrite($config_file, '$_SESSION['misuser'] = new MisUser;');
      fwrite($config_file, '}');
      fwrite($config_file, 'if(!isset($_SESSION['pageindex'])){');
      fwrite($config_file, '$_SESSION['pageindex'] = new Page;');
      fwrite($config_file, '$_SESSION['pageindex']->SetPageSize($_SESSION['CFG']->pagesize);');
      fwrite($config_file, '}');
      fwrite($config_file, 'if($_SESSION['CFG']->dbtype=="mysql"){');
      fwrite($config_file, '$_SESSION['CFG']->dbh=db_connect($_SESSION['CFG']->dbhost, $_SESSION['CFG']->dbname, $_SESSION['CFG']->dbuser, $_SESSION['CFG']->dbpass); ');
      fwrite($config_file, 'if(!$_SESSION['CFG']->dbh){');
      fwrite($config_file, 'exit;');
      fwrite($config_file, '}');
      fwrite($config_file, 'else{');
      fwrite($config_file, '$result=db_query(login_qry5) or die('Unable to query setup.'); ');
		fwrite($config_file, '$s = db_fetch_array($result);');
      fwrite($config_file, '$_SESSION['CFG']->siteID=$s['siteID'];');
      fwrite($config_file, '$_SESSION['CFG']->IsMaster=$s['IsMaster'];');
      fwrite($config_file, '$_SESSION['CFG']->companyname=$s['name'];');
      fwrite($config_file, '$qry=sprintf(login_qry6, $_SESSION['CFG']->siteID);');
      fwrite($config_file, '$result=db_query($qry) or die('Unable to query setup.'); ');
		fwrite($config_file, '$s = db_fetch_array($result);');
      fwrite($config_file, '$_SESSION['CFG']->sitename = $s['name'];');
      fwrite($config_file, '}');
      fwrite($config_file, '}');
      fwrite($config_file, 'else if($_SESSION['CFG']->dbtype=="postgresql"){');
      fwrite($config_file, '$_SESSION['CFG']->dbh=db_connect("host=$_SESSION[CFG]->dbhost dbname=$_SESSION[CFG]->dbname user=$_SESSION[CFG]->dbuser password=$_SESSION[CFG]->dbpass");');
      fwrite($config_file, 'if(!$_SESSION['CFG']->dbh){');
      fwrite($config_file, 'exit;');
      fwrite($config_file, '}');
      fwrite($config_file, '}');
      fwrite($config_file, 'else if($_SESSION['CFG']->dbtype=="odbc"){');
      fwrite($config_file, '}');
      fwrite($config_file, 'else if($_SESSION['CFG']->dbtype=="oracle"){');
      fwrite($config_file, '}');
      fwrite($config_file, 'else{');
      fwrite($config_file, 'exit;');
      fwrite($config_file, '}');
  
      fclose($config_file);
      $bypass_auth = true;
      //include 'install_modules.php';
      exit;
   } 
   else{
    // Build the form, determining the basics from our environment
   }
   */
}

function preferences()
{
   echo "<blockquote><div align=\"left\"><b>Preferences</b></div><br>\n
   <div align=\"left\">Preferences are in progress, suffice to say it will run to things like
   show help buttons (Y/N), confirm delete, list sizes, fonts, colours, themes, automatic debit 
   to my bank account, etc..
   </div><br><div align=\"left\"><i>Scheduled for version 0.9.8</i></div></blockquote>";

}

function users()
{
   echo "<blockquote><div align=\"left\"><b>BhMIS User Management</b></div><br>\n
   <div align=\"left\">The MIS Users page will connect users to login types to persmissions,
   to interfaces. It will also setup a users modules, and menu build optons (i.e. every user can have
   a custom menu - or a limited acces menu.</div><br>
   <div align=\"left\"><i>Scheduled for v0.9.8.</i></div></blockquote>";
}

?>
