<?php
/*
mismodule.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}

if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], mismodule_pagetitle)!=0){
   $_SESSION['title']=mismodule_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(mismodule_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
   case "clear":
		addModule();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseModule($id);
		break;

	case "edit" :
		editModule($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelModule($_REQUEST['id']);
      }
      else{
         deleteModule($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listModule($_REQUEST['id']);
      }
      break;  
	
   case "cfmdelete" :
      deleteModule($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listModule();
		break;
      
	case "add" :
		insertModule($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		break;

	case "commit" :
		commitModule($_POST);
      listModule();
		break;
      
	case "list":
	default :
      $id=updateNav($_POST);
		listModule();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(mismodule_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm['id']=0;
   $frm['moduleid']=0;
   $frm['version']=0;
   $frm['name']="";
   $frm['title']="";
   $frm['author']="";
   $frm['cmid']="";
   $frm['description']="";
   $frm['enabled']="N";

	return $frm;
}
function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(mismodule_qry2, $id);
   }
   else{
      $qry=sprintf(mismodule_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm['id']=$row['id'];
   $frm['moduleid']=$row['moduleid'];
   $frm['version']=$row['version'];
   $frm['name']=$row['name'];
   $frm['title']=$row['title'];
   $frm['author']=$row['author'];
   $frm['cmid']=$row['cmid'];
   $frm['description']=$row['description'];
   $frm['enabled']=$row['enabled'];

	return $frm;
}

function addModule()
{
   $frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = "MIS Module Add";

	include("templates/mismodule.php");
}

function editModule($id) 
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "MIS Module Edit";
	
	include("templates/mismodule.php");
}

function browseModule($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "MIS Module Browse";
	
	include("templates/mismodule.php");
}

function chkdelModule($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["heading"] = "MIS Module Delete";
   $frm["newaction"] = "cfmdelete";
   
   include("templates/mismodule.php");
}

function deleteModule($id) 
{
   $qry=sprintf(mismodule_qry7, $id);
   db_query($qry);
}

function insertModule($frm) 
{
   $a=new Address();
   $a->SetFromForm($frm);
   $adid=$a->Add();
   
   $qry=sprintf(mismodule_qry4, 0, $frm['moduleid'],$frm['version'],$frm['name'],$frm['title'],$frm['author'],
   $frm['cmid'],$frm['description'],$frm['enabled']);
   
	db_query($qry);
   
   $frm["newaction"] = "cmmit";
   $frm["heading"] = "MIS Module Add";
	
	include("templates/mismodule.php");
}

function commitModule($frm) 
{
   $a=new Address();
   $a->SetFromForm($frm);
   $aid=$frm['addressID'];
   $a->Commit($aid);
	
   $qry=sprintf(mismodule_qry5, $frm['moduleid'],$frm['version'],$frm['name'],$frm['title'],$frm['author'],
   $frm['cmid'],$frm['description'],$frm['enabled'],$frm['id']);
      
   db_query($qry);
}

function misMenu($a, $typeid)
{
/*
   if($a=="commit" || $a=="add"){
	   print "<select name=\"$cname\" width=\"250\">\n";
	   while($myrow = $result->FetchRow()){
			$boo=$myrow["id"];
		   $poo=$myrow["Name"];
		   if($id==$boo){
			   print "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		print "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
		print "</select>\n";
   }
   else{
      $qry=sprintf(bhlib_qry2, $id); 
      $result=db_query($qry);
      if($myrow = $result->FetchRow()){
         echo $myrow[0];
      }
      else{
         echo "Not Set";
      }
   }
   
   if($row['type']==0){ // menu
      print "<tr><td colspan=\"2\"><h3>";
      print $row['name'];
      print "</h3></td></tr>\n";
   }
   else if($row['type']==1){ // item
      print "<tr><td>";
      print $row['name'];
      print "</td><td>";
      if($row['action']==""){
         print "&nbsp;</td></tr>\n";
      }
      else{
         print $row['action'];
         print "</td></tr>\n";
      }
   }
   else if($row['type']==2){ // action
      print "<tr><td>";
      print $row['name'];
      print "</td><td>";
      if($row['action']==""){
         print "&nbsp;</td></tr>\n";
      }
      else{
         print $row['action'];
         print "</td></tr>\n";
      }
   }*/
}

function listModule($id)
{
   $qry=sprintf(mismodule_qry4, $id);
   $result=db_query($qry);
   $frm["newaction"] = "list";
   
   echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
   }
}

?>
