<?php
/*
dept.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001 - 2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/locale.php");
require_once($_SESSION['CFG']->libdir."/currency.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], company_dept_pagetitle)!=0){
   $_SESSION['title']=company_dept_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(dept_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addDept();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseDept($id);
		break;

	case "edit" :
		editDept($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelDept($_REQUEST['id']);
      }
      else{
         deleteBank($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listDept($_POST['ID']);
      }
		break;

	case "cfmdelete" :
		deleteDept($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
		listDept();
		break;

	case "add" :
		insertDept($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listDept();
		break;

	case "commit" :
		commitDept($id, $_POST);
		listDept();
		break;

	case "nameindex" :
		nameIndex($id, $_POST);
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listDept();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(dept_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
	$frm["id"] = 0;
   $frm["deptid"] = "";
   $frm["name"] = "";
   $frm["siteid"] = "";
   $frm["annualbudget"] = "";
   $frm["headid"] = "";
   $frm["localeid"] = "";
   $frm["currencyid"] = "";
   $frm["active"] = "";
	$frm["bcname"]="";
	$frm["sitename"]="";

	return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(dept_qry2, $id);
   }
   else{
      $qry=sprintf(dept_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
	$frm["id"] = $id;
	$frm["deptid"]=$row["deptid"];
	$frm["name"] = $row["name"];
	$frm["siteid"]=$row["siteid"];
	$frm["annualbudget"] = $row["annualbudget"];
	$frm["headid"] = $row["headid"];
	$frm["localeid"] = $row["localeid"];
   $frm["currencyid"] = $row["currencyid"];
   $frm["active"] = $row["active"];

   $qry=sprintf(site_qry12, $frm["siteid"]);
	$result=db_query($qry);
	$row = $result->FetchRow();
	$frm["sitename"]=$row["name"];

	return $frm;
}

function fillNames($fl) 
{
	$result=db_query("SELECT id, fname, lname from employee WHERE lname LIKE '$fl%' ORDER BY lname");
	echo "<select name=\"index\" width=\"250\">\n";
	while($row = $result->FetchRow()){
		$i=$row["id"];
		$l=$row["lname"];
		$f=$row["fname"];
		$n=$row["lname"] . ", " . $row["fname"];
		if($id==$boo){
			echo "<option selected value=\"$i\"> $n </option>\n";
		}
		else{
			echo "<option value=\"$i\"> $n </option>\n";
		}
	}
	echo "</select>\n";
}

function addDept()
{
	$frm=clearform();
	$frm["newaction"] = "add";
   $frm["heading"] = "Department Add";
   
	include("templates/deptedit.php");
}

function editDept($id) 
{
	$frm=fillform($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Department Edit";

	include("templates/deptedit.php");
}

function browseDept($id) 
{
	$frm=fillform($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Department Browse";
   
	include("templates/deptedit.php");
}

function fillGroupDeps($id)
{
	echo "<tr><td colspan=\"2\"><h3>Dependant groups</h3></td></tr>";
	fillassignedgroups($id);
}

function fillassignedgroups($id)
{
	$result=db_query("SELECT groupid, name FROM groups WHERE deptid = '$id'");	
	while($row = $result->FetchRow()){
		$idg=$row["groupID"];
		$name=$row["name"];
		echo "<tr><td colspan=\"2\"><a href=\"group.php?action=browse&id=$idg\">$name</a></td></tr>\n";
	}
}

function insertDept($frm) 
{
	$name=$frm["name"];
	$query = "INSERT INTO departments VALUES(0, 0, 
      '$frm[name]',
      '$frm[siteid]',
		'$frm[annualbudget]',
      '$frm[headid]',
      '$frm[localeid]',
		'$frm[currencyid]',
      '$frm[active]')";
	$qid = db_query($query);
}

function commitDept($frm) 
{
	$qid = db_query("update departments set 
		deptid='$frm[deptid]', 
		name='$frm[name]', 
		siteid='$frm[siteid]', 
		annualbudget='$frm[annualbudget]', 
		headid='$frm[headid]',
		localeid='$frm[localeid]',
		currencyid='$frm[currencyid]',
		active='$frm[active]'
		where id = '$frm[id]'");
}

function chkdelDept($id)
{
	$result=db_query("SELECT id from groups where deptid = '$id'");
	$frm["numgroups"]=db_num_rows($result);

	$result=db_query("SELECT name FROM departments WHERE id = '$id'");
	if($row = $result->FetchRow()){
	   $frm["name"]=$row["name"];
   }
   else{
      $frm["name"]="&nbsp;";
   }
	$frm["newaction"] = "cfmdelete";
   $frm["reassign"] = "0";
   $frm["ID"] = $id;
   $frm["heading"] = "Department Delete";
   
	include("templates/deptdel.php");
}

function deleteDept($frm)
{
	if($frm["reassign"]=="1"){
		$ndept=$frm["deptID"];
		$qid = db_query("update groups set deptid = '$ndept' where deptid = '$frm[id]'");
	}
	else{
		$qid = db_query("update groups set deptid = '0' where deptid = '$frm[id]'");	
	}

	$qid = db_query("delete from departments where id = '$frm[id]'");

}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "currencyid");
}

function LocaleCombo($action, $id)
{
   $a=new Locale();
   $a->Combo($action, $id, "localeid");
}

function listDept()
{
	$q=$_SESSION["pageindex"]->query(dept_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Department</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		$n=$myrow["name"];
		print "<tr><td>$n</td>";
		print "<td>";
		$wibbler=$myrow["id"];
		print "<a href=\"dept.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"dept.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"dept.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
