<?php
/*
gacc.php

Copyright (C)2002 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], company_acc_pagetitle)!=0){
   $_SESSION['title']=company_acc_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(gacc_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addAh();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseAh($id);
		break;

	case "edit" :
		editAh($id);
		break;

	case "delete" :
		deleteAh($id);
      $_SESSION["pageindex"]->deletion(CountNum());
		listAh();
		break;

	case "add" :
		insertAh($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listAh();
		break;

	case "commit" :
		commitAh($id, $_POST);
		listAh();
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listAh();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(gacc_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "";
	$frm["accountnumber"] = "";
	$frm["name"] = "";
   	
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(gacc_qry2, $id);
   }
   else{
      $qry=sprintf(gacc_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

   $frm["id"] = $id;
	$frm["accountnumber"] = $row["accountnumber"];
	$frm["name"] = $row["name"];
	
	return $frm;
}

function addAh()
{
   $frm=clearForm();
	$frm["newaction"] = "add";
	$frm["heading"] = "Gov Account Add";
   
	include("templates/gaccedit.php");
}

function editAh($id) 
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Gov Account Edit";
	
	include("templates/gaccedit.php");
}

function browseAh($id) 
{
   $frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Gov Account Browse";
	
	include("templates/gaccedit.php");
}

function deleteAh($id) 
{
	$frm["heading"] = "Gov Account Delete";
}

function insertAh($id, $frm) 
{
	$qid = db_query("INSERT INTO gaccref (accountnumber, name) values (
	'$frm[accountnumber]',
  	'$frm[name]')");
}

function commitAh($id, $frm) 
{
	$qid = db_query("UPDATE gaccref SET 
	accountnumber='$frm[accountnumber]',
  	name='$frm[name]'
	WHERE id = $id");
}

function listAh()
{
   $q=$_SESSION["pageindex"]->query(gacc_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		$n=$row["name"];		
		print "<tr><td>$n</td><td>";
		$wibbler=$row["id"];
		print "<a href=\"gacc.php?action=browse&id=$wibbler\">".misc_listadd."</a>&nbsp;\n";
		print "<a href=\"gacc.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"gacc.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}
?>
