<?php
/*
setup.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/createmod.php");
require_once($_SESSION['CFG']->libdir."/address.php");
require_once($_SESSION['CFG']->libdir."/locale.php");
require_once($_SESSION['CFG']->libdir."/currency.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], company_setup_pagetitle)!=0){
   $_SESSION['title']=company_setup_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "add" :
		addSetup($_POST);
		editSetup();
		break;

	case "commit" :
		commitSetup($_POST);
		editSetup();
		break;

	case "edit" :
	default :
		editSetup();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function clearForm()
{
	$frm["id"] = "0";
	$frm["name"] = "";
	$frm["accdate"] = "";
	$frm["regnum"] = "";
	$frm["vatnum"] = "";
	$frm["ismaster"] = "";
	$frm["master"] = "";
	$frm["accdate"] = "";
  	$frm["cmid"]= "";
	$frm["connectmethod"] = "NONE";
  	$frm["connectdata"] = "";
  	$frm["connectlogin"] = "";
  	$frm["connectpassword"] = "";
  	$frm["connecttime"] = "";

	return $frm;
}

function fillForm()
{
	$result=db_query(setup_qry1);
	$row = $result->FetchRow();
	$frm["id"] = $row["id"];
	$frm["name"] = $row["name"];
	$frm["accdate"] = $row["accountingdate"];
	$frm["regnum"] = $row["regnumber"];
	$frm["vatnum"] = $row["vatnumber"];
	$frm["ismaster"] = $row["ismaster"];
	$frm["master"] = $row["master"];
	$frm["cmid"]= $row["cmid"];
	$frm["connectmethod"] = $row["connectmethod"];
   $frm["connectdata"]  = $row["connectdata"];
   $frm["connectlogin"]  = $row["connectlogin"];
   $frm["connectpassword"] = $row["connectpassword"];
   $frm["connecttime"] = $row["connecttime"];

	return $frm;
}

function editSetup() 
{
   //global $lang;
	$frm=fillForm();
	$frm["newaction"] = "commit";
	$frm["action"]="edit";

	include("templates/setup.php");
}

function commitSetup($frm) 
{
	$accdate="0000-" . $frm['month'] . "-" . $frm['day'];
   $query=sprintf(setup_qry2,$frm['name'],$accdate,$frm['regnum'],$frm['vatnum']);
	/*
   $query = "UPDATE setup SET 
      name='$frm[name]', 
		accountingDate='$accdate', 
		regNumber='$frm[regnum]', 
		vatNumber='$frm[vatnum]' WHERE ID='0'";
		IsMaster = '$frm[ismaster]', 
	   Master = '$frm[master]',
		ConnectMethod = '$frm[ConnectMethod]',
      ConnectData = '$frm[ConnectData]',
  		ConnectLogin = '$frm[ConnectLogin]',
  		ConnectPassword = '$frm[ConnectPassword]',
  		ConnectTime = '$frm[ConnectTime]'
		WHERE ID='0'";
      */

	$qid = db_query($query);
	error_log($query);
	$result=db_query(login_qry1) or die('Unable to combo query');
	$row = $result->FetchRow();
	$v=$row[0];

   $mw=$_SESSION['misuser']->GetEmployee();
   $query=sprintf(setup_qry3,$v, $mw, $frm['cmID']);
	$result=db_query($query);
}

function CreateModTable($id)
{
   $cm=new CreateMod();
   $cm->Fill($id);
   $cm->FillTable();
}

function DateControl($a, $d)
{
   $td=new TimeDate();
   $td->parse($d);
   $td->datecontrol($a, "");
}

?>
