<?php
/*
tax.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/account.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], company_tax_pagetitle)!=0){
   $_SESSION['title']=company_tax_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(tax_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addTax();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseTax($id);
		break;

	case "edit" :
		editTax($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelTax($_REQUEST['id']);
      }
      else{
         deleteTax($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listTax();
      }
      break;  
	
   case "cfmdelete" :
      deleteTax($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listTax();
		break;
      
	case "add" :
		insertTax($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listTax();
		break;

	case "commit" :
		commitTax($_POST);
		listTax();
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listTax();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(tax_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"] = 0;
	$frm["taxid"]="";
	$frm["accountid"] = "";
	$frm["rate"] = "0.00";
	$frm["onmenu"] = "N";
   
   return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(tax_qry2, $id);
   }
   else{
      $qry=sprintf(tax_qry3, $id);
   }
   
   $result=db_query($qry);
	$row = $result->FetchRow();
	
	$frm["id"] = $id;
   $frm["taxid"]=$row["taxid"];
	$frm["accountid"] = $row["accountid"];
	$frm["onmenu"] = $row["onmenu"];
   $frm["rate"] = $row["rate"];
   
   return $frm;
}

function addTax()
{
   $frm=clearform();
	$frm["newaction"] = "add";
   $frm["heading"] = "Tax Add";

	include("templates/taxedit.php");
}

function editTax($id) 
{  
   $frm=fillform($id, false);
   
	$frm["newaction"] = "commit";
   $frm["heading"] = "Tax Edit";

	include("templates/taxedit.php");
}

function browseTax($id) 
{
   $frm=fillform($id, true);
   
	$frm["newaction"] = "commit";
   $frm["heading"] = "Tax Edit";
   
	include("templates/taxedit.php");
}

function insertTax($frm) 
{
	if(!isset($frm['onmenu']))
		$frm['onmenu'] = 'N';
	else
		$frm['onmenu'] = 'Y';
	$accid = db_query("select * from account where accountnumber='$frm[accountid]'");
	if (!$accid || ! ($nrow = $accid->FetchRow()))
		die('You must enter the account in Accounts first!');
	if($frm['rate'] >= 1)
		$frm['rate']=($frm['rate']/100);
	$qid = db_query("INSERT INTO taxrate (accountid, rate, onmenu) values ('$frm[accountid]','$frm[rate]','$frm[onmenu]')");
}

function commitTax($frm) 
{
/*
	if ( ! isset($frm['OnMenu']) )
		$frm['OnMenu'] = 'N';
	else
		$frm['OnMenu'] = 'Y';
	$accid = db_query("select * from account where accountnumber='$frm[accountID]'");
	if (!$accid || ! ($nrow = db_fetch_array($accid)))
		die('You must use a valid Account Number!');*/
	if($frm['Rate'] >= 1)
		$frm['Rate']=($frm['Rate']/100);
   $qid = db_query("UPDATE taxrate SET accountid=$frm[accountid], rate='$frm[rate]', onmenu='".YN($frm["onmenu"])."' where id='$frm[id]'");
}

function chkdelTax($id)
{
	$_SESSION["pageindex"]->setprev("delete");
	$result=db_query("SELECT * FROM taxrate WHERE id = '$id'");
	$row = $result->FetchRow();

	$nid=$row["accountID"];
	$nresult=db_query("SELECT * from account WHERE accountnumber='$nid'");
	$nrow = $nresult->FetchRow();

	$frm["name"] = $nrow["name"];
	$frm["rate"] = $row["rate"]; 
	$frm["newaction"] = "cfmdelete";
	$frm["id"] = $id;
	$frm["accountid"] = $nrow["accountnumber"];
	$frm["onmenu"] = $row["onmenu"];
	$frm["heading"] = "Tax Delete";

	include("templates/taxedit.php");
}

function deleteTax($id)
{
	$qid = db_query("DELETE from taxrate where id = '$id'");
}

function fillAccountCombo($a, $id)
{
   $acc=new Account();
   $acc->Combo($a, $id, "accountid");
}

function listTax()
{
	$q=$_SESSION["pageindex"]->query(tax_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Rate</h3></td><td><h3>On Menu</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		$om=$row["onmenu"];
		print "<tr><td>";
		printf ("%0.2f%%", $row["rate"] * 100);
		print "</td><td>";
		if($om=="Y"){
			print "<input type=\"checkbox\" name=\"onmenu\" value=\"Y\" checked>";
		}
		else{
			print "<input type=\"checkbox\" name=\"onmenu\" value=\"N\">";
		}
		print "</td><td>";
		$wibbler=$row["id"];
		print "<a href=\"tax.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"tax.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"tax.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
