<?php
/*
 * address.php
 *
 * @version	0.9.6
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2004 Al Kingsley
 * @package	MIS
 * @access	public
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], contact_pagetitle)!=0){
   $_SESSION['title']=contact_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(address_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}
function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addAddress();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseAddress($id);
		break;

	case "edit" :
		editAddress($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelAddress($_REQUEST['id']);
      }
      else{
         deleteAddress($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listAddress();
      }
		break;

	case "cfmdelete" :
		deleteAddress($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listAddress();
		break;

	case "add" :
		insertAddress($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listAddress();
		break;

	case "commit" :
		commitAddress($_POST);
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listAddress();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
	$result=db_query(address_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["showdeps"] = "";
	$frm["numemps"] = 0;
	$frm["numsupp"] = 0;
	$frm["numsite"] = 0;
	$frm["numcust"] = 0;
	$frm["numbank"] = 0;
	
   $frm["id"] = "";
	$frm["address1"]="";
	$frm["address2"]="";
	$frm["address3"]="";
	$frm["city"]="";
   $frm["state"]="";
	$frm["postcode"]="";
	$frm["country"]="";
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(address_qry2, $id);
   }
   else{
      $qry=sprintf(address_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm["id"]=$row["id"];
	$frm["address1"]=$row["address1"];
	$frm["address2"]=$row["address2"];
	$frm["address3"]=$row["address3"];
	$frm["city"]=$row["city"];
   $frm["state"]=$row["state"];
	$frm["postcode"]=$row["postcode"];
	$frm["country"]=$row["country"];

	$result=db_query("select id from employee where addressid = '$id'");
   if($result){
      $frm["numemps"] = $result->RecordCount();
   }
   else{
      $frm["numeps"] = 0;
   }
   
	$result=db_query("select id from supplier where addressid = '$id'");
   if($result){
	   $frm["numsupp"] = $result->RecordCount();
	}
   else{
      $frm["numsupp"] = 0;
   }
   
   $result=db_query("select id from sites where addressid = '$id'");
   if($result){
	   $frm["numsite"] = $result->RecordCount();
   }
	else{
      $frm["numsite"] = 0;
   }
   
   $result=db_query("select id from customer where addressid = '$id'");
	if($result){
      $frm["numcust"] = $result->RecordCount();
   }
   else{
      $frm["numcust"] = 0;
   }
	$result=db_query("select id from bankdetails where addressid = '$id'");
   if($result){
	   $frm["numbank"] = $result->RecordCount();
   }
   else{
      $frm["numbank"] = 0;
   }
   
	return $frm;
}

function addAddress()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	$frm["id"] = "Auto number";
   $frm["heading"] = "Address Add";

	include("templates/addredit.php");
}

function editAddress($id) 
{
	$frm=fillForm($id, false);
	//$frm["showdeps"] = $showdeps;
	$frm["newaction"] = "commit";
   $frm["heading"] = "Address Edit";

	include("templates/addredit.php");
}

function browseAddress($id) 
{
	$frm=fillForm($id, true);
	//$frm["showdeps"] = $showdeps;
	$frm["newaction"] = "browse";
   $frm["heading"] = "Address Browse";
	
	include("templates/addredit.php");
}

function fillEmployees($id)
{
	$result=db_query("SELECT id, lname, fname from employee where addressid = '$id'");	
	if(db_num_rows($result)==0){
		echo "<tr><td colspan=\"2\"><i>None</i></td></tr>"; 
	}
	else{
		while($row = $result->FetchRow()){
			$did=$row["id"];
			$name=$row["name"];
			echo "<tr><td colspan=\"2\"><a href=\"dept?action=browse&id=$did\">$name</a></td></tr>";
		}
	}
}
function fillSuppliers($id)
{
	$result=db_query("select id, name from supplier where addressid = '$id'");	
	if(db_num_rows($result)==0){
		echo "<tr><td colspan=\"2\"><i>None</i></td></tr>"; 
	}
	else{
		while($row = $result->FetchRow()){
			$did=$row["id"];
			$name=$row["name"];
			echo "<tr><td colspan=\"2\"><a href=\"dept?action=browse&id=$did\">$name</a></td></tr>";
		}
	}
}
function fillCustomers($id)
{
	$result=db_query("select id, name from customer where addressid = '$id'");	
	if(db_num_rows($result)==0){
		echo "<tr><td colspan=\"2\"><i>None</i></td></tr>"; 
	}
	else{
		while($row = $result->FetchRow()){
			$did=$row["id"];
			$name=$row["name"];
			echo "<tr><td colspan=\"2\"><a href=\"dept?action=browse&id=$did\">$name</a></td></tr>";
		}
	}
}
function fillSites($id)
{
	$result=db_query("select id, name from sites where addressid = '$id'");	
	if(db_num_rows($result)==0){
		echo "<tr><td colspan=\"2\"><i>None</i></td></tr>"; 
	}
	else{
		while($row = $result->FetchRow()){
			$did=$row["di"];
			$name=$row["name"];
			echo "<tr><td colspan=\"2\"><a href=\"dept?action=browse&id=$did\">$name</a></td></tr>";
		}
	}
}
function fillBanks($id)
{
	$result=db_query("select id, name from bankdetails where addressid = '$id'");	
	if(db_num_rows($result)==0){
		echo "<tr><td colspan=\"2\"><i>None</i></td></tr>"; 
	}
	else{
		while($row = $result->FetchRow()){
			$did=$row["ID"];
			$name=$row["name"];
			echo "<tr><td colspan=\"2\"><a href=\"dept?action=browse&id=$did\">$name</a></td></tr>";
		}
	}
}

function chkdelAddress($id)
{
   $frm=fillform($id, false);
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Address Delete";
	include("templates/addredit.php");
}

function deleteAddress($id) 
{
	db_query("DELETE from address WHERE id = '$id'");
}

function insertAddress($frm) 
{
	$a1=$frm["address1"]; 
	$a2=$frm["address2"];
	$a3=$frm["address3"];
	$c=$frm["city"];
   $s=$frm["state"]; 
	$p=$frm["postcode"]; 
	$t=$frm["country"];
	db_query("INSERT INTO address VALUES ('', '$a1', '$a2', '$c', '$s','$p', '$t')");
}

function commitAddress($frm) 
{
	$qid = db_query("UPDATE address set 
		address1='$frm[address1]', 
		address2 = '$frm[address2]', 
		city = '$frm[city]', 
      state = '$frm[state]', 
		postcode = '$frm[postcode]', 
		country = '$frm[country]' 	
		where id = '$frm[id]'");
}

function fillCountries($id)
{
	$result=db_query("select country from currency");

	echo "<select name=\"department\" width=\"250\">\n";
	while($row = $result->FetchRow()){
		$boo=$row["id"];
		$poo=$row["Country"]. " - " . $row["BigName"];
		if($id==$boo){
			print "<option selected value=\"$boo\"> $poo </option>\n";
		}
		else{
			print "<option value=\"$boo\"> $poo </option>\n";
		}
	}
	echo "</select>\n";
}

function fillAddressCombo($id)
{
	$result=db_query("SELECT * from departments");
	echo "<select name=\"department\" width=\"250\">\n";
	while($row = $result->FetchRow()){
		$boo=$row["id"];
		$poo=$row["name"];
		if($id==$boo){
			print "<option selected value=\"$boo\"> $poo </option>\n";
		}
		else{
			print "<option value=\"$boo\"> $poo </option>\n";
		}
	}
	echo "</select>\n";
}


function listAddress()
{
	$q=$_SESSION["pageindex"]->query(address_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>PostCode</h3></td><td><h3>Adddress 1</h3><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		$n=$myrow["postcode"];
      if($n=="") $n="&nbsp;";
		$a=$myrow["address1"];
      if($a=="") $a="&nbsp;";
		print "<tr><td>$n</td><td>$a</td>";
		print "<td>";
		$wibbler=$myrow["id"];
		print "<a href=\"address.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"address.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"address.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}
?>
