<?php
/*
contact.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
require_once($_SESSION['CFG']->libdir."/address.php");
require_once($_SESSION['CFG']->libdir."/contact.php");

if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], contact_pagetitle)!=0){
   $_SESSION['title']=contact_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(contact_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}


switch($_REQUEST['action']){
	case "clear" :
		addContact();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseContact($id);
		break;

	case "edit" :
		editContact($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelContact($_REQUEST['id']);
      }
      else{
         deleteContact($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listContact();
      }
      break;  
	
   case "cfmdelete" :
      deleteContact($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listContact();
		break;

	case "add" :
		insertContact($_POST);
      $_SESSION["pageindex"]->addition(NumRows(CountNum()));
      listContact($id);
		break;

	case "commit" :
		commitContact($_POST);
      listContact();
		break;
/*   
   case "itemadd" :
		itemadd($_POST);
		break;
   
   case "itemedit" :
      itemedit($id);
		break;
      
   case "itemcommit" :
		itemcommit($_POST);
		break;
   
   case "contacthide" :
		contactHide($id);
		break;
      
   case "addfromref":
      addFromRef($id, $ref);
      break;

   case "addwithref":
      addWithRef($_POST);
      break;
*/
	case "list":
	default :
      $id=updateNav($_POST);
		listContact();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(contact_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "";
   $frm["contactid"] = "";
   $frm["contactdetailsid"] = "";
   $frm["ownerid"] = "";
   $frm["addressid"] = "";
   $frm["imageid"] = "";
   $frm["titleid"] = "";
	$frm["firstname"] = "";
	$frm["lastname"] = "";
	$frm["middleinitial"] = "";
   $frm["birthdate"] = "";
	$frm["lastcontact"] = "";
   $frm["timezone"] = "";
   $frm["private"] = "";
   $frm["memoid"] = "";

	return $frm;
}

function fillForm($id, $bOffset)
{
    if($bOffset){
      $qry=sprintf(contact_qry2, $id);
   }
   else{
      $qry=sprintf(contact_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
   $frm["id"] = $id;
   $frm["contactid"] = $row["contactid"];
   $frm["contactdetailsid"] = $row["contactdetailsid"];
   $frm["ownerid"] = $row["ownerid"];
   $frm["addressid"] = $row["addressid"];
   $frm["imageid"] = $row["imageid"];
   $frm["titleid"] = $row["titleid"];
	$frm["firstname"] = $row["firstname"];
	$frm["lastname"] = $row["lastname"];
	$frm["middleinitial"] = $row["middleinitial"];
   $frm["birthdate"] = $row["birthdate"];
	$frm["lastcontact"] = $row["lastcontact"];
   $frm["timezone"] = $row["timezone"];
   $frm["private"] = $row["private"];
   $frm["memoid"] = $row["memoid"];
   
	return $frm;
}

function addContact()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = "Contact Add";
	
	include("templates/conedit.php");
}

function editContact($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Contact Edit";
		
	include("templates/conedit.php");
}

function browseContact($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Contact Browse";
		
	include("templates/conedit.php");
}

function insertContact($frm) 
{
   // add address
   $addr=new Address();
   $addr->FillFromForm($frm);
   $aid=$addr->Commit();
   
   // add image
   if(isset($frm[''])){
      
   }
   
   /*
   $frm["id"] = $id;
   $frm["contactid"] = $row["contactid"];
   $frm["contactdetailsid"] = $row["contactdetailsid"];
   $frm["ownerid"] = $row["ownerid"];
   $frm["addressid"] = $row["addressid"];
   $frm["imageid"] = $row["imageid"];
   $frm["title"] = $row["title"];
	$frm["firstname"] = $row["firstname"];
	$frm["lastname"] = $row["lastname"];
	$frm["middleinitial"] = $row["middleinitial"];
	$frm["lastcontact"] = $row["lastcontact"];
   $frm["timezone"] = $row["timezone"];
   $frm["private"] = $row["private"];
   */
   
   $c=$frm["title"];
	$fn=$frm["firstname"];
	$ln=$frm["lastname"];
   $d=$frm["middleinitial"];
	
	$qid = db_query("INSERT INTO contacts VALUES ('', '','0','$c','$fn','$ln','$d','')");
   db_query("UPDATE contacts SET contactid='LAST_INSERT_ID()' WHERE id='LAST_INSERT_ID()'");
   
   if(isset($_SESSION["contact"])){
      $_SESSION["contact"]->Commit();
	}
}

function commitContact($frm) 
{
	$qid = db_query("UPDATE contacts 
   SET contactid='$frm[contactid]',
   contactdetailsid='$frm[contactdetailsid]',
   title='$frm[title]',
   firstname='$frm[firstname]',
   lastname='$frm[lastname]',
   middleinitial='$frm[middleinitial]',
   lastcontact='$frm[lastcontact]' 
   WHERE id = $id");
}

function chkdelContact($id)
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Contact Delete";
		
	include("templates/conedit.php");
}

function deleteContact($id) 
{
	$qid = db_query("DELETE FROM contacts WHERE id = '$id'");
   $frm["heading"] = "Contact Delete";
	
	include("templates/condel.php");
}

function Tree($a, $cdid)
{
   ContactTree($a, $cdid);
}

function AddressTable($a, $aid)
{
   $addr=new Address();
   $addr->FillTable($a, $aid, "address");
}

function TitleCombo($a, $aid)
{
}

function Image($a, $iid)
{
}

function addFromRef($id, $ref)
{
	$frm=clearForm();
   $frm["ContactID"] = $id;
   $frm["backref"] = $ref;
	$frm["newaction"] = "addwithref";
   $frm["heading"] = "Contact Add";
	
	include("templates/conedit.php");
}

function addWithRef($frm)
{
   db_query("UPDATE contacts SET 
      contactid='$frm[contactid]',
      contactdetailsid='0',
      title='$frm[title]',
      firstname='$frm[firstname]',
      lastname='$frm[lastname]',
      middleinitial='$frm[middleinitial]'
      where id = '$frm[backref]'");
}


function itemList($a, $contactdetailsid)
{
   
   /*
   $ref=$_SERVER['PHP_SELF']."?action=itemedit&id=".$id;
   
   $c=new Contact();
   $c->Fill($id);
   
   $c->ItemList($a, $id, $ref, "contact.php", "Contact Details");
   */
}

function contactHide($id)
{
   $frm=fillForm($id);
   
	$frm["newaction"] = "commit";
   $frm["heading"] = "Contact Edit";
	
	include("templates/conedit.php");
}

function itemadd($frm)
{
   $item=&new ContactDetailsItem();
   $item->Set(0, 0, $frm["type"], $frm["data"], true);
   
   $frm=fillCurrForm();
   /*
   if(isset($_SESSION["contact"])){
		$_SESSION["contact"]->AddItem($item);
	}*/
   $frm["newaction"] = "commit";
   $frm["heading"] = "Contact Edit";
		
	include("templates/conedit.php");
}

function itemedit($id)
{
   $c=new Contact();
   $c->Fill($id);
   $frm["ID"]=$id;
   $frm=$c->FillForm($frm);
   
   $frm["newaction"] = "itemcommit";
   $frm["heading"] = "Contact Item Edit";
		
	include("templates/conedit.php");
}

function itemcommit($frm)
{
   /*
   if(isset($_SESSION["contact"])){
      $_SESSION["contact"]->ItemCommit($frm["type"], $frm["data"]);
	}*/
   $frm=fillCurrForm();
   $frm["newaction"] = "commit";
   $frm["heading"] = "Contact Edit";
		
	include("templates/conedit.php");
}

function listContact()
{
	$q=$_SESSION["pageindex"]->query(contact_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Last Contact</h3><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		$wibbler=$row["id"];
		$n=$row["firstname"]." ".$row["lastname"];
		$ls=$row["lastcontact"];

		print "<tr><td>$n</td><td>$ls</td><td>\n";
		print "<a href=\"contact.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"contact.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"contact.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
