<?php
/*
image.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], contact_pagetitle)!=0){
   $_SESSION['title']=contact_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(image_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}


switch($_REQUEST['action']){
	case "clear" :
		addImage();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseImage($id);
		break;

	case "edit" :
		editImage($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelImage($_REQUEST['id']);
      }
      else{
         deleteImage($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listImage();
      }
		break;

	case "cfmdelete" :
		deleteImage($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listImage();
		break;

	case "add" :
		insertImage($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listImage();
		break;

	case "commit" :
		commitImage($_POST);
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listImage();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(image_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"] = "";
   $frm["type"] = "";
   $frm["reffile"] = "";
   $frm["width"] = "";
   $frm["height"] = "";
   $frm["bbp"] = "";
   $frm["scale"] = "";
   
   return $frm;
}

function fillform($id, $bOffset) 
{
	if($bOffset){
      $qry=sprintf(image_qry2, $id);
   }
   else{
      $qry=sprintf(image_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
	
	$frm["newaction"] = "commit";
	$frm["id"] = $row["id"];
   $frm["type"] = $row["type"];
   $frm["reffile"] = $row["reffile"];
   $frm["width"] = $row["width"];
   $frm["height"] = $row["height"];
   $frm["bbp"] = $row["bbp"];
   $frm["scale"] = $row["scale"];
	
	return $frm;
}

function addImage()
{
   $frm=clearform();
   
	$frm["newaction"] = "add";
	$frm["id"] = "";
   $frm["heading"] = "Image Add";

	include("templates/imageedit.php");
}

function editImage($id) 
{
	$frm=fillform($id, false);
	
	$frm["newaction"] = "commit";
   $frm["heading"] = "Image Edit";
	
	include("templates/imageedit.php");
}

function browseImage($id) 
{
	$frm=fillform($id, true);
	
	$frm["newaction"] = "browse";
   $frm["heading"] = "Image Browse";

	include("templates/imageedit.php");
}

function chkdelImage($id)
{
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Image Delete";
	include("templates/imagedel.php");
}

function deleteImage($id) 
{
   $qry=sprintf(image_qry7, $id);
	db_query($qry);
}

function insertImage($frm) 
{
   $size = getimagesize($_FILES['reffile']['tmp_name']);
   $w=$size[0];
   $h=$size[1];
   
   if($frm['type']==BHSQL_IMAGEDATA_PERSON){
      if(move_uploaded_file($_FILES['reffile']['tmp_name'], $_SESSION['CFG']->peopleimg .'/'. $_FILES['reffile']['name'])){
         $f='/people_images/'.$_FILES['reffile']['name'];
      }
      else{
         return;
      }
   }
   else{
      if(move_uploaded_file($_FILES['reffile']['tmp_name'], $_SESSION['CFG']->prodimg .'/'. $_FILES['reffile']['name'])){
         $f='/product_images/'.$_FILES['reffile']['name'];
      }
      else{
         return;
      }
   }
   $qry=sprintf(image_qry5, $frm['type'],$f,$w,$h,$frm['bbp'],$frm['scale']);
	db_query($qry);
}

function commitImage($frm) 
{
   $size = getimagesize($_FILES['reffile']['tmp_name']);
   $w=$size[0];
   $h=$size[1];
   
   if($frm['type']==BHSQL_IMAGEDATA_PERSON){
      if(move_uploaded_file($_FILES['reffile']['tmp_name'], $_SESSION['CFG']->peopleimg .'/'. $_FILES['reffile']['name'])){
         $f='/people_images/'.$_FILES['reffile']['name'];
      }
      else{
         return;
      }
   }
   else{
      if(move_uploaded_file($_FILES['reffile']['tmp_name'], $_SESSION['CFG']->prodimg .'/'. $_FILES['reffile']['name'])){
         $f='/product_images/'.$_FILES['reffile']['name'];
      }
      else{
         return;
      }
   }
   $qry=sprintf(image_qry6, $frm['type'],$f,$w,$h,$frm['bbp'],$frm['scale'],$frm['id']);
	db_query($qry);
}

function listImage()
{
	$q=$_SESSION["pageindex"]->query(image_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Image</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		$n=$myrow["reffile"];
		echo "<tr><td>$n</td>";
		echo "<td>";
		$wibbler=$myrow["id"];
		echo "<a href=\"image.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		echo "<a href=\"image.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		echo "<a href=\"image.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
