<?php
/*
chargeacc.php

Copyright (C)2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.

*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/chargeaccount.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['titleimg']) || $_SESSION['titleimg']!=$_SESSION['CFG']->imagedir."/tlt_customer.png"){
   $_SESSION['titleimg'] = $_SESSION['CFG']->imagedir."/tlt_customer.png";
   //echo "<meta http-equiv=\"refresh\" content=\"0\" src=\"header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(chargeacc_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}


switch($_REQUEST['action']){
	case "clear" :
		addChargeAcc();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseChargeAcc($id);
		break;

	case "edit" :
		editChargeAcc($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelChargeAcc($_REQUEST['id']);
      }
      else{
         deleteChargeAcc($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listBank();
      }
      break;  
	
   case "cfmdelete" :
      deleteChargeAcc($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listChargeAcc();
		break;

	case "add" :
      $_SESSION["pageindex"]->addition(CountNum());
		insertChargeAcc($_POST);
      listChargeAcc();
		break;

	case "commit" :
		commitChargeAcc($_POST);
      listChargeAcc();
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listChargeAcc();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(chargeacc_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["ID"] = 0;
   $frm["chargeID"] = '';
   $frm["cmid"] = '';
   $frm["creditlimit"] = '';
   $frm["lasttransaction"] = '';
   $frm["accountID"] = '';
   $frm["standardTerms"] = '';
   $frm["CODTerms"] = '';
   $frm["prepaidTerms"] = '';
   $frm["termsType"] = '';
   $frm["dueMonthEnd"] = '';
   $frm["dueDays"] = '';
   $frm["discountDays"] = '';
   $frm["discount"] = '';
   $frm["Notes"] = '';
   
   return $frm;
}

function fillForm($id, $bOffset)
{
   //$ca=new ChargeAccount($id, $bOffset);
   
   if($bOffset){
      $qry=sprintf(chargeacc_qry2, $id);
   }
   else{
      $qry=sprintf(chargeacc_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
  
   $frm["ID"] = $id;
   $frm["chargeID"] = $row['chargeID'];
   $frm["cmid"] = $row['cmid'];
   $frm["creditlimit"] = $row['creditlimit'];
   $frm["lasttransaction"] = $row['lasttransaction'];
   $frm["accountID"] = $row['accountID'];
   $frm["standardTerms"] = $row['standardTerms'];
   $frm["CODTerms"] = $row['CODTerms'];
   $frm["prepaidTerms"] = $row['prepaidTerms'];
   $frm["termsType"] = $row['termsType'];
   $frm["dueMonthEnd"] = $row['dueMonthEnd'];
   $frm["dueDays"] = $row['dueDays'];
   $frm["discountDays"] = $row['discountDays'];
   $frm["discount"] = $row['discount'];
   $frm["Notes"] = $row['Notes'];

   return $frm;
}


function addChargeAcc()
{
   $frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = "Charge Account Add";

	include("templates/chargeaccedit.php");
}

function editChargeAcc($id) 
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Charge Account Edit";
	
	include("templates/chargeaccedit.php");
}

function browseChargeAcc($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Charge Account Browse";
	
	include("templates/chargeaccedit.php");
}

function deleteChargeAcc($id) 
{
   $frm["heading"] = "Charge Account Delete";
}

function insertChargeAcc($frm) 
{
	db_query("INSERT INTO chargeacc VALUES ()");
}

function commitChargeAcc($id, $frm) 
{
   $a=new Address();
   $a->SetFromForm($frm);
	if(!$a->Find(false)){
      $aid=$a->Add();
   }
   else{
      $aid=$a->GetID();
   }
	
   db_query("UPDATE chargeaccount SET WHERE ID=$id");
}

function CreateModTable($id)
{
   $cm=new CreateMod();
   $cm->Fill($id);
   $cm->FillTable();
}

function ChargeAcc($a, $id)
{
   $c=new ChargeAccount();
   $c->FillTable($a, $id, "Account Details");
}

function listChargeAcc()
{
	$q=$_SESSION["pageindex"]->query(chargeacc_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
      $nresult=db_query("SELECT FirstName, LastName FROM contacts WHERE ID = '$myrow[2]'");
      if($nrow = $nresult->FetchRow()){
         $n=$nrow[0] . " " . $nrow[1];
      }
      else{
         $n="Not Set";
      }
		print "<tr><td>$n</td><td>";
		$wibbler=$myrow["ID"];
		print "<a href=\"chargeacc.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"chargeacc.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"chargeacc.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
