<?php
/*
cust.php

Copyright (C)2003  Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/address.php");
require_once($_SESSION['CFG']->libdir."/account.php");
require_once($_SESSION['CFG']->libdir."/chargeaccount.php");
require_once($_SESSION['CFG']->libdir."/contact.php");
require_once($_SESSION['CFG']->libdir."/createmod.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], customer_pagetitle)!=0){
   $_SESSION['title']=customer_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(customer_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addCustomer();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseCustomer($id);
		break;

	case "edit" :
		editCustomer($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelCustomer($_REQUEST['id']);
      }
      else{
         deleteCustomer($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listCustomer();
      }
		break;

	case "cfmdelete" :
		deleteSite($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listCustomer();
		break;

	case "add" :
		insertCustomer($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		break;

	case "commit" :
		commitCustomer($_POST);
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listCustomer();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(customer_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["id"] = "";
   $frm["cmid"] = 0;
   $frm["contactid"] = "";
   $frm["storecardid"] = "";
   $frm["loyalityid"] = "";
   $frm["signatureid"] = "";
   $frm["chargeaccountid"] = "";
   $frm["notes"] = "";
   
   return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(customer_qry2, $id);
   }
   else{
      $qry=sprintf(customer_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
  
   $frm["id"] = $id;
   $frm["cmid"] = $row["cmid"];
   $frm["contactid"] = $row["contactid"];
   $frm["storecardid"] = $row["storecardid"];
   $frm["loyalityid"] = $row["loyalityid"];
   $frm["signatureid"] = $row["signatureid"];
   $frm["chargeaccountid"] = $row["chargeaccountid"];
   $frm["notes"] = $row["notes"];
   
   return $frm;
}


function addCustomer()
{
   $frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = "Customer Add";

	include("templates/custedit.php");
}

function editCustomer($id) 
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Customer Edit";
	
	include("templates/custedit.php");
}

function browseCustomer($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Customer Browse";
	
	include("templates/custedit.php");
}

function chkdelCustomer($id)
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Customer Delete";
   
	include("templates/custdel.php");
}

function deleteCustomer($id) 
{
   $qry=sprintf(customer_qry5, $id);
	$result=db_query($qry);
}

function insertCustomer($frm) 
{
/*
	$a=new Address();
   $a->SetFromForm($frm);
	if(!$a->Find(false)){
      $aid=$a->Add();
   }
   else{
      $aid=$a->GetID();
   }*/
   $qry=sprintf(customer_qry6,$cmid,$frm["contactid"],$frm["storecardid"],$frm["loyalityid"],
   $frm["creditlimit"],$frm["signatureid"],$frm["chargeaccountid"],$frm["notes"]);
   
   $result=db_query($qry);
}

function commitCustomer($id, $frm) 
{
/*
   $a=new Address();
   $a->SetFromForm($frm);
	if(!$a->Find(false)){
      $aid=$a->Add();
   }
   else{
      $aid=$a->GetID();
   }
	*/
   $qry=sprintf(customer_qry7,$cmid,$frm["contactid"],$frm["storecardid"],$frm["loyalityid"],
   $frm["creditlimit"],$frm["signatureid"],$frm["chargeaccountid"],$frm["notes"], $frm["id"]);
   $result=db_query($qry);
}
/*
function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "Address");
}
*/
function ContactName($a, $id) 
{
   $c=new Contact($id);
   //$c->fill($id);
   $c->Table($a, $id);
}

function CreateModTable($id)
{
   $cm=new CreateMod();
   $cm->Fill($id);
   $cm->FillTable();
}

function ChargeAcc($a, $id)
{
   $c=new ChargeAccount();
   $c->Table($a, $id, "Account Details");
}

function AddressTable($a, $id)
{
   $qry=sprintf(customer_qry9, $id);
   $result=db_query($qry);
   $row = $result->FetchRow();
   $aid=$row["addressid"];
   
   $addr=new Address();
   $addr->FillTable($a, $aid, "Address");
}

function listCustomer()
{
	$q=$_SESSION["pageindex"]->query(customer_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
      $qry=sprintf(customer_qry8, $row[2]);
	   $nresult=db_query($qry);
      if($nrow = $nresult->FetchRow()){
         $n=$nrow[0] . " " . $nrow[1];
      }
      else{
         $n="Not Set";
      }
		print "<tr><td>$n</td><td>";
		$wibbler=$row["id"];
		print "<a href=\"cust.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"cust.php?action=edit&id=$wibbler\">".misc_listedite."</a>&nbsp; \n";
		print "<a href=\"cust.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
