<?php
/*
layby.php

Copyright (C)2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/createmod.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['titleimg']) || $_SESSION['titleimg']!=$_SESSION['CFG']->imagedir."/tlt_customer.png"){
   $_SESSION['titleimg'] = $_SESSION['CFG']->imagedir."/tlt_customer.png";
   //echo "<meta http-equiv=\"refresh\" content=\"0\" src=\"header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(layby_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}


switch($_REQUEST['action']){
	case "clear" :
		addLayby();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseLayby($id);
		break;

	case "edit" :
		editLayby($id);
		break;

	case "delete" :
		deleteLayby($id);
		break;

	case "add" :
		insertLayby($_POST);
		break;

	case "commit" :
		commitLayby($id, $_POST);
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listLayby($id);
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(layby_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["ID"] = 0;
   $frm["orderID"] ="";
   $frm["orderNumber"] ="";
   $frm["customerID"] ="";
   $frm["transactionID"] ="";
   $frm["statusID"] ="";
   $frm["datePlaced"] ="";
   $frm["dateRequired"] ="";
   $frm["total"] ="";
   $frm["paid"] ="";
   
   return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(layby_qry2, $id);
   }
   else{
      $qry=sprintf(layby_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
  
   $frm["ID"] = $id;
   $frm["orderID"] = $row["orderID"];
   $frm["orderNumber"] = $row["rderNumber"];
   $frm["customerID"] = $row["customerID"];
   $frm["transactionID"] = $row["transactionID"];
   $frm["statusID"] = $row["statusID"];
   $frm["datePlaced"] = $row["datePlaced"];
   $frm["dateRequired"] = $row["dateRequired"];
   $frm["total"] = $row["total"];
   $frm["paid"] = $row["paid"];

   return $frm;
}


function addLayby()
{
   $frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = "Layby Add";

	include("templates/laybyedit.php");
}

function editLayby($id) 
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Layby Edit";
	
	include("templates/laybyedit.php");
}

function browseLayby($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Layby Browse";
	
	include("templates/laybyedit.php");
}

function deleteLayby($id) 
{
   $frm["heading"] = "Layby Delete";
}

function insertLayby($frm) 
{
	db_query("INSERT INTO layby VALUES ('',
      '$frm[typeID]',
      '$frm[name]',
      '$aid',
      '$frm[InvoiceName]',
      '$frm[InvoiceContactID]',
      '$frm[InvoiceAddressID]',
      '$frm[ContactID]',
      '$frm[creditlimit]',
      '$frm[creditperiod]',
      '$frm[lasttransaction]',
      '$frm[AccoutTypeID]'");
}

function commitLayby($id, $frm) 
{
   $a=new Address();
   $a->SetFromForm($frm);
	if(!$a->Find(false)){
      $aid=$a->Add();
   }
   else{
      $aid=$a->GetID();
   }
	
   db_query("UPDATE layby SET
      cmID='$frm[typeID]',
      name='$frm[name]',
      AddressID='$aid',
      ShipAddressID='$frm[ShipAddressID]',
      InvoiceName='$frm[InvoiceName]',
      InvoiceAddressID='$frm[InvoiceAddressID]',
      ContactID='$frm[ContactID]',
      BuyerID='$frm[BuyerID]',
      creditlimit='$frm[creditlimit]',
      creditperiod='$frm[creditperiod]',
      lasttransaction='$frm[lasttransaction]',
      AccoutTypeID='$frm[AccoutTypeID]' WHERE ID=$id");
}

function CreateModTable($id)
{
   $cm=new CreateMod();
   $cm->Fill($id);
   $cm->FillTable();
}

function listLayby($id)
{
	$q=$_SESSION["pageindex"]->query(layby_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
      $nresult=db_query("SELECT FirstName, LastName FROM contacts WHERE ID = '$myrow[2]'");
      if($nrow = $result->FetchRow()){
         $n=$nrow[0] . " " . $nrow[1];
      }
      else{
         $n="Not Set";
      }
		print "<tr><td>$n</td><td>";
		$wibbler=$myrow["ID"];
		print "<a href=\"layby.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"layby.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"layby.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
