<?php
/*
collection.php - collection lists

Copyright (C) 2003 Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001 - 2003 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

function CollectionCombo($id)
{
   $result=db_query("SELECT * FROM collection WHERE collectionID != '0'");
   echo "<select name=\"collection\" width=\"250\">\n";
   while($row = $result->FetchRow()){
      $cresult=db_query("SELECT count(*) FROM productcollection WHERE prodcollID = '$row[3]'");
  	   if($crow = $cresult->FetchRow()) $n=$crow[0];
      else $n=0;
      if($id == $row[0]) echo"<option value=\"$row[0]\" selected>$row[1] - $n products</option>\n";
      else echo"<option value=\"$row[0]\">$row[1] - $n products</option>\n";
   }
   echo "</select>\n";
}

/*
 * A collection entity.
 *
 * @version	0.9.2
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2003 Al Kingsley
 * @package	MIS
 * @access	public
 */
 
class Collection
{
   /** The contactdetails db ID.
   * @var	ID
   */
   var $ID;
   var $name;
   var $description;
   var $collectionID;
   
   function Collection()
   {
      $this->ID=0;
      $this->name="";
      $this->description="";
      $this->collectionID=0;
   }
   
   function Fill($id)
   {  
      $result=db_query("SELECT * FROM collection WHERE ID='$id'");
      if($row = $result->FetchRow()){
         $this->ID=$id;
         $this->name=$row[1];
         $this->description=$row[2];
         $this->collectionID=$row[3];
         return true;
      }
      return false;
   }
   
   function Commit()
   {
   }
   
   function AddProduct($pid)
   {
      db_query("INSERT INTO productcollection VALUES ('$this->collectionID','$pid')"); 
   }
   
   function DeleteProduct($pid)
   {
      db_query("DELETE FROM productcollection WHERE prodcollID = '$this->collectionID' AND productID='$pid'");
   }
   
   function Merge($id, $filename)
   {
      if(!$this->Fill($id)){
         return false;
      }
      $fp = fopen ($filename, "w");
      if($fp==FALSE){
         return false;
      }
      
      //name, plu, price (comma separated)
      $result=db_query("SELECT * FROM productcollection WHERE prodcollID = '$this->collectionID'");
      if(db_num_rows($result)==0){
         return false;
      }
      while($row = $result->FetchRow()){
         $presult=db_query("SELECT Name, PLU, sellquantityid FROM product WHERE ID = '$row[1]'");
         if($prow = $presult->FetchRow()){
            if(!fwrite($fp, $prow[0].",")) {
               print "Cannot write to file ($filename)";
               exit;
            }
            fwrite($fp, $prow[1].",");
            $sresult=db_query("SELECT Price FROM prodpricequantity WHERE pqID = '$prow[2]' and nameID='1'");
            if($srow = $sresult->FetchRow()){
               fwrite($fp, $srow[0]."\n");
            }
         }
      }
      fclose($fp);
   }
   
   function FillTable($id)
   {  
      if(!$this->Fill($id)){
         return false;
      }
      
      echo "<table width='100%' border='1' cellspacing='2' cellpadding='2' class=\"collection\">\n";
      echo "<tr>\n";
	   $result=db_query("SELECT * FROM productcollection WHERE prodcollID = '$this->collectionID'");
  	   while($row = $result->FetchRow()){  		   
         $productID=$row[0];
         $presult=db_query("SELECT PLU, Name FROM product WHERE ID = '$productID'");
  	      if($prow = $presult->FetchRow()){
   	      echo "<tr><td>$prow[0]</td><td>$prow[1]</td><td></td></tr>\n";
         }
      }
      echo "</tr></table>\n";
      return true;
   }
   
   function FillCollectionTable($a, $id)
   {
      if(!$this->Fill($id)){
         return false;
      }
      echo "<form method=\"post\" action=\"$_SERVER[PHP_SELF]\">";
      echo "<table width='100%' border='1' cellspacing='2' cellpadding='2' class=\"collection\">\n";
      echo "<tr>\n";
	   $result=db_query("SELECT * FROM productcollection WHERE prodcollID = '$this->collectionID'");
      if(db_num_rows($result)==0){
         if($a=="commit"){
            echo "<tr><td> - </td><td> - </td><td><a href=\"collection.php?action=additem\">Add</a></td></tr>\n";
         }
         else{
            echo "<tr><td>No Products</td></tr></table>";
         }
         return false;
      }
  	   while($row = $result->FetchRow()){  		   
         $productID=$row[1];
         $presult=db_query("SELECT PLU, Name FROM product WHERE ID = '$productID'");
  	      if($prow = $presult->FetchRow()){
   	      echo "<tr><td>$prow[0]</td><td>$prow[1]</td>\n";
            if($a=="commit"){
               echo "<td><a href=\"collection.php?action=deleteitem&cid=$this->collectionID&id=$productID\">Delete</a></td>\n";
            }
         }
         echo "</tr>\n";
      }
      if($a!="browse"){
         echo "<tr><input type=\"hidden\" name=\"action\" value=\"additem\">\n";
         echo "<input type=\"hidden\" name=\"id\" value=\"$this->ID\">\n";
         echo "<input type=\"hidden\" name=\"cid\" value=\"$this->collectionID\">\n";
         echo "<td><input type=\"text\" name=\"PLU\" size=\"16\" maxlength=\"128\" value=\"\"></td>\n";
         echo "<td> - </td>\n";
         echo "<td><input type=\"submit\" value=\"Add\"></td></tr>\n";
      }
      echo "</table></form>\n";
      return true;
   }
}

?>
