<?php
require_once("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/tree.php");
/*
 * contacts.php
 * A generic contact details entity.
 *
 * @version	0.9.7
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2003-2004 Al Kingsley
 * @package	MIS
 * @access	public
 */
 
function ContactTree($a, $contactid)
{
   $closed="folder_closed.png";
   $open="folder_open.png";
   $station_icon="icon_station.png";
   
   if($a=="add") return;
   
   if($a=="commit") $a="edit";
   $cpage=$_SESSION['CFG']->wwwroot.'/contact/contact.php?action='.$a;
   $cdpage=$_SESSION['CFG']->wwwroot.'/contact/contactdetail.php?action='.$a;
   
   echo "<script language=\"javascript\" type=\"text/javascript\">";
   include $_SESSION['CFG']->templatedir . '/tree.js';
   echo "</script>\n";
   
   $tree = new HTML_TreeMenu();
   $node = new HTML_TreeNode(array('text'=>"Contacts",'icon'=>$closed,'expandedIcon'=>$open));
   $qry=sprintf(contact_qry8, $contactid);
   $result=db_query($qry);
   while($row = $result->FetchRow()){
      $n=$row['title']." ".$row['firstname']." ".$row['lastname'];
      $contact=&$node->addItem(new HTML_TreeNode(array('text'=>$n,'link'=>"$cpage&id=".$row['id'],
         'icon'=>$closed,'expandedIcon'=>$open)));
      $qry=sprintf(contactdetails_qry8, $row['contactdetailsid']);
      $cdresult=db_query($qry);
      while($cdrow = $cdresult->FetchRow()){
         $qry=sprintf(contacttype_qry3, $cdrow['typeid']);
         $tresult=db_query($qry);
         if($trow = $tresult->FetchRow()){
            $t=$trow['name'];
         }
         else{
            $t="---";
         }
         $t=$t." ".$cdrow['data'];
         $contact->addItem(new HTML_TreeNode(array('text'=>$t,'link'=>"$cdpage&id=".$cdrow['id'],
            'icon'=>$closed,'expandedIcon'=>$open)));
      }
   }
   $tree->addItem($node);
   $treedisp = new HTML_TreeMenu_DHTML($tree, array('images'=>$_SESSION['CFG']->imagedir));
   
   echo "<table border=\"0\" cellpadding=\"5\" width=\"95%\">\n";
   echo "<tr><td>";
   $treedisp->printMenu();
   echo "</td></tr>\n";
   echo "</table>\n";
}

function ContactDetailsTable($a, $cdid)
{
   $c=0;
   $qry=sprintf(contactdetails_qry8, $cdid);
   $result=db_query($qry);
   while($cdrow = $result->FetchRow()){
      $qry=sprintf(contacttype_qry3, $cdrow['typeid']);
      $tresult=db_query($qry);
      if($c%2==0){
         echo "<tr bgcolor=\"#CFCFCF\"><td>";
      }
      else{
         echo "<tr><td>";
      }
      if($trow = $tresult->FetchRow()){
         $t=$trow['name'];
      }
      else{
         $t="---";
      }
      echo "$t</td><td>";
      echo $cdrow['data'];
      echo "</td></tr>";
      $c++;
   }
}

function ContactDetailsTree($a, $cdid)
{
   $closed="folder_closed.png";
   $open="folder_open.png";
   $station_icon="icon_station.png";
   
   $tree = new HTML_TreeMenu();
   $node = new HTML_TreeNode(array('text'=>"Contacts",'icon'=>$closed,'expandedIcon'=>$open));
   $qry=sprintf(contactdetails_qry8, $cdid);
   $result=db_query($qry);
   while($cdrow = $result->FetchRow()){
      $qry=sprintf(contacttype_qry3, $row['typeid']);
      $tresult=db_query($qry);
      if($trow = $tresult->FetchRow()){
         $t=$row['name'];
      }
      else{
         $t="---";
      }
      $t=$t." ".$cdrow['data'];
      $node->addItem(new HTML_TreeNode(array('text'=>$t,'icon'=>$closed,'expandedIcon'=>$open)));
   }
   $tree->addItem($node);
   $treedisp = new HTML_TreeMenu_DHTML($tree, array('images'=>$_SESSION['CFG']->imagedir));
   
   echo "<table border=\"0\" cellpadding=\"5\" width=\"95%\">\n";
   echo "<tr><td>";
   $treedisp->printMenu();
   echo "</td></tr>\n";
   echo "</table>\n";
}

function ContactTypeCombo($a, $id, $cname)
{
   if($a=="commit" || $a=="add"){
      $result=db_query(contacttype_qry7);
      echo "<select name=\"$cname\">\n";
 	   while($row = $result->FetchRow()){
  	   	$boo=$row["id"];
   	   $poo=$row["name"];
  	   	if($id==$boo){
   	   	echo "<option selected value=\"$boo\"> $poo </option>\n";
  		   }
     		else{
      		echo "<option value=\"$boo\"> $poo </option>\n";
  		   }
      }
      echo "</select>\n";
   }
   else{
      $qry=sprintf(contacttype_qry3, $id);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         echo $row[1];
      }
      else{
         echo "Not Set";
      }
   }
}
 
class ContactDetailsItem
{
   /** The contactdetails db id.
   * @var	id
   */
   var $id;
   
   /** The contactdetails db ContactDetailsid.
   * @var	ContactDetailsid
   */
   var $contactdetailsid;
   
   /** The details type.
   * @var	type contacttype id
   */
   var $typeid;
   
   /** The details data.
   * @var	data
   */
   var $data;

   /**
   * Constructor.
   * @access	public
   */
	function ContactDetailsItem($id=false)
	{
      if($id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      $this->id=0;
      $this->contactdetailsid=0;
      $this->typeid=0;
      $this->data="";
	}
   
   function Getid() { return $this->id; }
   
   function Fill($id, $bOffset=false)
   {
      if($id==0){
         return false;
      }
      
      if($bOffset){
         $qry=sprintf(contactdetails_qry2, $id);
      }
      else{
         $qry=sprintf(contactdetails_qry3, $id);
      }
	   $result=db_query($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->contactdetailsid=$row["contactdetailsid"];
         $this->typeid=$row["typeid"];
         $this->data=$row["data"];
         return true;
      }
      return false;
   }
   
   /**
   * General Set.
   * @access	public
   */
   function Set($a, $b, $c, $d)
   {
      $this->id=$a;
      $this->contactdetailsid=$b;
      $this->typeid=$c;
      $this->data=$d;
   }
   
   function SetFromForm($frm)
   {
      $this->contactdetailsid=$frm["contactdetailsid"];
      $this->typeid=$frm["typeid"];
      $this->data=$frm["data"];
   }
   
   function Add()
   {
      $qry=sprintf(contactdetails_qry4, $this->contactdetailsid, $this->typeid, $this->data);
      db_query($qry);
       
       db_query(misc_qry1);
       if($row = $result->FetchRow()){
          $this->id=$row[0];
       }
       return $this->id;
   }
   
   function Commit()
   {
      $qry=sprintf(contactdetails_qry5, $this->contactdetailsid, $this->typeid, $this->data, $this->id);
      db_query($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(contactdetails_qry6, $this->id);
      db_query($qry);
   }
   
   function TypeCombo($a, $id, $cname)
   {
      if($a=="commit" || $a=="add"){
         $result=db_query(contacttype_qry7);
         echo "<select name=\"$cname\" width=\"250\">\n";
   	   while($row = $result->FetchRow()){
   	   	$boo=$row["id"];
	   	   $poo=$row["name"];
   	   	if($id==$boo){
	   	   	echo "<option selected value=\"$boo\"> $poo </option>\n";
   		   }
      		else{
	      		echo "<option value=\"$boo\"> $poo </option>\n";
   		   }
	      }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(contacttype_qry3, $id);
         $result=db_query($qry);
         if($row = $result->FetchRow()){
            echo $row[1];
         }
         else{
            echo "Not Set";
         }
      }
   }
   
   function Row($a, $id, $bOffset=true)
   {
      if($this->id==0){
         if($bOffset)
            $this->Fill($id, true);
         else
            $this->Fill($id, false);
      }
      echo "<tr><td>";
      $this->TypeCombo($a, $this->typeid, "typeid" );
	   echo"</td><td>";
      entry($a, "data", 68, 64, $this->data);
	   echo"</td></tr>\n";
   }
   
   function Table($a, $id, $title, $bOffset=true, $bInside=false)
   {
      if($this->id==0){
         if($bOffset)
            $this->Fill($id, true);
         else
            $this->Fill($id, false);
      }
      if(!$bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"address\">\n";
	      echo "<tr>\n";
	      echo "<td colspan=\"2\" align=\"center\"><h3>$title</h3></td></tr>\n";
      }
      echo "<tr><td width=\"20%\" align=\"right\">Type</td><td>";
      $this->TypeCombo($a, $this->typeid, "typeid" );
	   echo"</td></tr>\n";
      echo "<tr><td width=\"20%\" align=\"right\">Value</td><td>";
      entry($a, "data", 68, 64, $this->data);
	   echo"</td></tr>\n";
      if(!$bInside){
   	   echo "</table>\n";
      }
   }
}

class Contact
{
   var $id;
   var $contactid;
	var $contactdetailsid;
   var $ownerid;
   var $addressid;
   var $imageid;
   var $companyid;
   var $title;
   var $firstname;
   var $lastname;
   var $middleinitial;
   var $birthdate;
   var $lastcontact;
   var $timezone;
   var $private;
   var $memoid;
   var $cditems;

	function Contact($id=false)
	{
      if($id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      $this->id=0;
	   $this->contactid=0;
		$this->contactdetailsid=0;
      $this->owner="";
      $this->title="";
      $this->firstname="";
      $this->lastname="";
      $this->middleinitial="";
      $this->lastcontact="";
      $this->private="";
      $this->cditems = array();
	}
   
   function Set($a,$b,$c,$d,$e,$f,$g,$h,$i)
   {
      $this->contactid=$a;
		$this->contactdetailsid=$b;
      $this->owner=$c;
      $this->title=$d;
      $this->firstname=$e;
      $this->lastname=$f;
      $this->middleinitial=$g;
      $this->lastcontact=$h;
      $this->private=$i;
   }
   
   function Fill($id, $bOffset=true)
   {
      if($id==0){
         return false;
      }
      if($bOffset){
         $qry=sprintf(contact_qry2, $id);
      }
      else{
         $qry=sprintf(contact_qry3, $id);
      }
	   $result=db_query($qry);
      
		if($result){
         if($result->RecordCount()==0) return false;
      }
		$this->contactid=$id;
      
		if($row = $result->FetchRow()){
         $this->id=$row[0];
         $this->owner=$row[3];
         $this->title=$row[4];
         $this->firstname=$row[5];
         $this->lastname=$row[6];
         $this->middleinitial=$row[7];
         $this->lastcontact=$row[8];
         $this->private=$row[9];
         
         $qry=sprintf(contactdetails_qry3, $id);
         $result=db_query($qry);
    
         if($result){
            if($result->RecordCount()==0) return false;
         }
         
         $this->contactid=$id;
         if(!isset($this->cditems)){
             $this->cditems = array();
         }
		   while($row = $result->FetchRow()){
            $item=&new ContactDetailsItem();
            if($item->Fill($row[0])){
               array_push($this->cditems, $item);
            }
         }
      }
      
      return true;
   }
   
   function AddItem($i)
	{
      if(isset($this->cditems)){
         $i->Add();
         array_push($this->cditems, $i);
      }
   }
   
   function EditItem($id)
   {
      $item=&new ContactItem();
      if($item->Fill($id, false)){
         $item->FillFromForm($frm);
         $item->Commit();
         // adjust array value
      }
   }
   
	function ItemList($a, $b, $c, $d, $e)
   {
      if(isset($this->cditems)){
      }
   }
   
   function ItemCommit($b, $c)
	{
   }
   
	function FillForm()
	{
		$frm["id"]=$this->id;
   	$frm["contactid"] = $this->contactid;
   	$frm["contactdetailsid"] = $this->contactdetailsid;
      $frm["owner"] = $this->owner;
   	$frm["title"] = $this->title;
		$frm["firstname"] = $this->firstname;
		$frm["lastname"] = $this->lastname;
		$frm["middleinitial"] = $this->middleinitial;
		$frm["lastcontact"] = $this->lastcontact;
      $frm["private"] = $this->private;
   	
		return $frm;
	}
   
   function Commit()
	{
   }
   
   function Row($a, $id)
	{
      echo "<tr><td>$this->title $this->firstname $this->lastname</td></tr>\n";
   }
   
   function Table($a, $id)
	{
      $this->Fill($id, false);
      
      echo "<table class=\"contact\">\n";
      if($a=="browse"){
         echo "<tr><td width=\"30%\" align=\"right\">Title</td><td>$this->title</td></tr>\n";
         echo "<tr><td align=\"right\">First Name</td><td>$this->firstname</td></tr>\n";
         echo "<tr><td align=\"right\">Middle Initial</td><td>$this->middleinitial</td></tr>\n";
         echo "<tr><td align=\"right\">Last Name</td><td>$this->lastname</td></tr>\n";
         echo "<tr><td id=ctype>Type</td><td id=ctype>Data</td></tr>\n";
      }
      else if($a=="add" || $a=="commit"){
         echo "<tr><td width=\"30%\" align=\"right\">Title</td>\n";
         echo "<td><input type=\"text\" name=\"title\" size=\"32\" maxlength=\"32\" value=\"$this->title\"></td></tr>\n";
         echo "<tr><td align=\"right\">First Name</td>\n";
         echo "<td><input type=\"text\" name=\"firstname\" size=\"48\" maxlength=\"64\" value=\"$this->firstname\"></td></tr>\n";
         echo "<tr><td align=\"right\">Middle Initial</td>\n";
         echo "<td><input type=\"text\" name=\"middleinitial\" size=\"4\" maxlength=\"1\" value=\"$this->middleinitial\"></td></tr>\n";
         echo "<tr><td align=\"right\">Last Name</td>\n";
         echo "<td><input type=\"text\" name=\"lastname\" size=\"48\" maxlength=\"64\" value=\"$this->lastname\"></td></tr>\n";
      }
      foreach($this->cditems as $i){
		   $i->Row($a, 0, 0);
		}
      echo "</table>\n";
   }
}

class ContactList
{
   var $id;
   var $Contactid;
   var $curr_item;
   var $items;

	function ContactList()
	{
      $this->id=0;
		$this->Contactid=0;
      $curr_item=-1;
      $this->items = array();
	}
   
   function Fill($id)
   {
      $qry=sprintf(contact_qry8, $id);
      $result=db_query($qry);
      
		if(db_num_rows($result)==0){
			return false;
		}
      $this->Contactid=$id;
		while($row = $result->FetchRow()){
         $item=&new Contact();
         $item->Fill($row[0]);
         //$item->Set($row[0], $row[1], $row[2], $row[3],$row[4],$row[5],$row[7],$row[7]);
         array_push($this->items, $item);
      }
		db_free_result($result);
      
      return true;
   }
   
   function SimpleTable($a, $id)
   {
      // name => details 0
      //         ...
      //      => details n
   }
   
   function Add($cid, $table, $tid)
   {
      if($cid==0){
         // no contacts, so contactid is the same as the id for backref insert.
         db_query("INSERT into contacts VALUES()");
         $this->id=$this->Contactid=db_insert_id();
         db_query("update contacts set Contactid='$this->Contactid' where id='$this->Contactid'");
         // now the calling table needs an insert...
         db_query("update $table set Contactid='$this->Contactid' where id='$tid'");
      }
      else{
         $this->Contactid=$cid;
         db_query("INSERT into contacts VALUES()");
         $this->id=db_insert_id();
         db_query("update contacts set Contactid='$this->Contactid' where id='$this->id'");
      }
      header("Location: ../contact/contact.php?action=addfromref&id=$this->Contactid&ref=$this->id");
   }
   
   function Table($a, $id, $ref, $table, $tid, $page)
   {
      echo "<table border=\"0\" cellpadding=\"2\" width=\"100%\" class=\"contactlist\">\n";
      if($a=="commit"){
         echo "<tr bgcolor=\"002277\"><td><a href=\"$ref\"><font color=\"white\">Show Contacts</font></a>\n";
         echo "&nbsp;<img src=\"../images/uparrow.png\" width=\"15\" height=\"15\"></td></tr></table>";
         return;
      }
      else if($a!="browse"){
         echo "<tr bgcolor=\"002277\"><td colspan=\"4\"><a href=\"$page?action=contacthide&id=$tid\"><font color=\"white\">Hide Contacts</font></a>\n";
         echo "&nbsp;<img src=\"../images/downarrow.png\" width=\"15\" height=\"15\"></td></tr>";
      }
      if($a=="contactadd"){
         $num=count($this->items);
		   echo "<tr><th colspan=\"4\" align=\"left\" class=\"contactlist\">Contacts - $num Items</th></tr>";
		   echo "<tr><td><b>Last Name</b></td><td><b>First Name</b></td><td><b>Entries</b></td><td><b>Action</b></td></tr>\n";
         echo "</tr></table>";
         return;
      }
      if($a=="contactcommit"){
         if($this->Contactid==0){
            if(!$this->Fill($id)){
               // no contacts, so contactid is the same as the id for backref insert.
               //db_query("INSERT into contacts VALUES()");
               //$this->Contactid=db_insert_id();
               //db_query("update contacts set Contactid='$this->Contactid' where id='$this->Contactid'");
               // now the calling table needs an insert...
               //db_query("update $table set Contactid='$this->Contactid' where id='$tid'");
		         echo "<tr><th colspan=\"4\" align=\"left\" class=\"contactlist\">Contacts - 0 Items</th></tr>";
		         echo "<tr><td><b>Last Name</b></td><td><b>First Name</b></td><td><b>Entries</b></td><td><b>Action</b></td></tr>\n";
               echo "<td>---</td><td>---</td><td>---</td><td><a href=\"$page?action=contactadd&id=$tid&cid=$id\">Add</a></td>\n";
               echo "</tr></table>";
               return;
            }
         }
      }
   
      if($this->Contactid==0){
         if(!$this->Fill($id)){
            if($a=="browse"){
               echo "<tr><td><b>No Contacts</b></td></tr></table>";
               return;
            }
         }
      }
      $num=count($this->items);
      if($num==0){
         if($a=="browse"){
            echo "<tr><td><b>No Contacts</b></td></tr></table>";
            return;
         }
      }
      
		echo "<tr><th colspan=\"4\" align=\"left\" class=\"contactlist\">Contacts - $num Items</th></tr>";
		echo "<tr><td><b>Last Name</b></td><td><b>First Name</b></td><td><b>Entries</b></td><td><b>Action</b></td></tr>\n";
      
      $count=1;
		foreach($this->items as $c=>$ii){
         if(!isset($ii)) continue;
			$f=$ii->GetFirstName();
         $l=$ii->GetLastName();
         $i=$ii->GetMiddleInitial();
         $n=$ii->NumDetails();
         $id=$ii->Getid();

			if(($count%2)==0){
				echo "<tr bgcolor=\"#CCCCCC\">\n";
			}
			else{
				echo "<tr bgcolor=\"FFFFFF\">\n";
			}
         if($a=="contactcommit"){
            echo "<td>$l</td><td>$f</td><td>$n</td><td><a href=\"../contact/contact.php?action=edit&id=$id\">Edit</a></td>\n";
         }
         else if($a=="browse"){
            echo "<td>$l</td><td>$f</td><td>$n</td><td>&nbsp;</td>\n";
         }
         else{
            echo "<td>$l</td><td>$f</td><td>$n</td><td><a href=\"../contact/contact.php?action=edit&id=$id\">Edit</a></td>\n";
         }
         
         echo "</tr>\n";
         $count++;
      }
      if($a!="browse"){
         echo "<tr><td>---</td><td>---</td><td>---</td><td><a href=\"$page?action=contactadd&id=$tid&cid=$id\">Add</a></td>\n";
      }
      echo "</tr></table>";
   }
}

?>
