<?php
/*
 * A memo thingy.
 *
 * @version	0.9.7
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2004 Al Kingsley
 * @package	MIS
 * @access	public
 */
require_once("createmod.php");

class Memo
{
   var $id;
   var $cmid;
	var $data;
   
   function Address($id=false)
   {
      if($id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      $this->id=0;
      $this->cmid=0;
	   $this->data='';
   }
   
   function Getid() { return $this->id; }
   
   function Fill($id, $bOffset=true)
   {
      if($id==0){
         return false;
      }
      if($bOffset){
         $qry=sprintf(address_qry2, $id);
      }
      else{
         $qry=sprintf(address_qry3, $id);
      }
      
	   $result=db_query($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->cmid=$row["cmid"];
	      $this->data=$row[">data"];
         
         return true;
      }
      return false;
   }
   
   function Set($a,$b)
   {
      $this->cmid=$a;
	   $this->data=$b;
   }
   
   function setfromform($frm)
   {
      $this->cmid=$frm['cmid'];
	   $this->data=$frm['data'];
   }
   
   function Add()
   {
      $qry=sprintf(memo_qry4, $this->cmid,$this->data);
      db_query($qry);
       
       $result=db_query(misc_qry1);
       if($row = $result->FetchRow()){
          $this->id=$row[0];
       }
       return $this->id;
   }
   
   function Commit($id)
   {
      $qry=sprintf(memo_qry4, $this->cmid,$this->data $id);
      db_query($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(memo_qry6, $this->id);
      db_query($qry);
   }
   
   function Table($a, $id, $title, $bInside=false)
   {
      if($a=="commit" || $a=="add"){
         $this->Fill($id, false);
      }
      else{
         $this->Fill($id, true);
      }
      
      if(!$bInside){
         echo "<table class=\"memo\">\n";
         echo "<th colspan=\"2\">$title</th>\n";
      }

	   echo "<tr><td class=\"tinsert\" colspan=\"2\">\n";
      $cm=new CreateMod();
      $cm->Fill($this->cmid);
      $cm->FillTable();
      echo "</td></tr>\n";
	
   	echo "<tr>\n";
      echo "<td class=\"label\">".memo_data."</td>\n";
      echo "<td>";
	   textarea($a, "data", 64, 255, $this->data);
   	echo"</td>\n";
	   echo "</tr>\n";
   }
}

?>
