<?
/*
plusd.php

Copyright (C)2003  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.

*/
require_once(require_once($_SESSION['CFG']->libdir."/timedate.php");

define ("BHPOS_TYPE_SERVICE",3);
define ("BHPOS_TYPE_INFO",4);
define ("BHMSG_SERVICE_SYSTEM",1);
define ("BHMSG_SERVICE_CLIENT",2);
define ("BHMSG_SERVICE_SITE",3);
define ("BHMSG_SERVICE_MESSAGE",4);
define ("BHMSG_SERVICE_DATABASE",5);
define ("BHMSG_SERVICE_CUSTOMER",6);
define ("BHMSG_SERVICE_FINANCIAL",7);
define ("BHMSG_SERVICE_PNP",8);
define ("BHMSG_SERVICE_CCV",9);
define ("BHMSG_SERVICE_KEYMAP",10);

define ("BHMSG_SERVICE_SYSTEM_NUMCLIENTS",5);
define ("BHMSG_SERVICE_SYSTEM_NUMTRANSOPEN",6);
define ("BHMSG_SERVICE_SYSTEM_LOAD",7);
define ("BHMSG_SERVICE_SYSTEM_MAXLOAD", 8);
define ("BHMSG_SERVICE_SYSTEM_WAKE_POST",9);
define ("BHMSG_SERVICE_SYSTEM_WAKE_ALL",10);
define ("BHMSG_SERVICE_SYSTEM_VERSION_SERVER",11);
define ("BHMSG_SERVICE_SYSTEM_VERSION_CLIENT",12);
define ("BHMSG_SERVICE_SYSTEM_VERSION_PROTOCOL",13);
define ("BHMSG_SERVICE_SYSTEM_CLIENTACK",15);

define ("BHMSG_SERVICE_SITE_SITE_NUM",1);
define ("BHMSG_SERVICE_SITE_SITE_DETAILS",2);
define ("BHMSG_SERVICE_SITE_SITE_ACTIVE",3);
define ("BHMSG_SERVICE_SITE_DEPT_NUM",4);
define ("BHMSG_SERVICE_SITE_DEPT_DETAILS",5);
define ("BHMSG_SERVICE_SITE_DEPT_ACTIVE",6);
define ("BHMSG_SERVICE_SITE_GROUP_NUM",7);
define ("BHMSG_SERVICE_SITE_GROUP_DETAILS",8);
define ("BHMSG_SERVICE_SITE_GROUP_ACTIVE",9);
define ("BHMSG_SERVICE_SITE_STATION_NUM",10);
define ("BHMSG_SERVICE_SITE_STATION_DETAILS",11);
define ("BHMSG_SERVICE_SITE_STATION_ACTIVE",12);

define ("BHMSG_SERVICE_CLIENT_GETCASH",9);
define ("BHMSG_SERVICE_CLIENT_SETCASH",10);

define ("BHMSG_SERVICE_KEYMAP_SET",1);
define ("BHMSG_SERVICE_KEYMAP_DROP",2);
define ("BHMSG_SERVICE_KEYMAP_ADD",3);
define ("BHMSG_SERVICE_KEYMAP_EDIT",4);
define ("BHMSG_SERVICE_KEYMAP_DELETE",5);

/**
 * plusd interface
 *
 * @version	v0.9.6
 * @package	MIS2
 */
class Plusd
{
	var $address;
   var $port;
   var $fp;
	var $timeout;
   var $last_status;

	function Plusd()
	{
		$this->address='127.0.0.1';
      $this->port=6672;
	   $this->timeout=1;
	   $this->last_status=0;
	}
   
   function Open()
   {
      $fp = @fsockopen('udp://'.$address, port, $errno, $errstr, 10);
      if(!$fp){
         $err="Connection Error: $errno - $errstr";
      } 
      else{
         stream_set_timeout($fp, $timeout);
         fwrite($fp,"\n");
         echo fread($fp, 26);
         fclose($fp);
      }
   }
   
   function Close()
   {
      if($fp){
         fclose($fp);
      }
   }
   
   function Get($m)
   {
      if(!$fp){
         return true;
      }
      $start = time();
      if(!fwrite($fp, $m)){
         return true;
      }
      $res = fread($fp, 2000);
   }
}

class PlusdReporter extends Plusd
{
   var $start_time;
   var $update_time;
   var $current_time;
   var $events;
   var $run_current;
   var $run_average;
   var $run_derivative;
   
   function PlusdReporter()
   {
      $start_time=new TimeDate();
      $update_time=new TimeDate();
      $current_time=new TimeDate();
      $events=array();
      $run_current=array();
      $run_average=array();
      $run_derivative=array();
   }
   
   function Add($event, $context)
   {
   }
   
   function Remove($event, $context)
   {
   }
   
   function Update($event, $context, $value)
   {
   }
   
   function Reset()
   {
   }
   
   function Tick()
   {
   }
}

?>
