<?php

//user.php

/*
 * An user entity.
 *
 * @version	0.9.6
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2004 Al Kingsley
 * @package	MIS
 * @access	public
 */

class User
{
   var $id;
	var $login;
	var $password;
	var $userdata;
	var $profile;
	var $logintypesid;
	var $employeeid;
  
   
   function User()
   {
      $this->id=0;
      $this->login='';
	   $this->password='';
   	$this->userdata='';
	   $this->profile='';
      $this->logintypesid=0;
   	$this->employeeid=0;
      $this->stationid=0;
      $this->interfaceid=0;
   }
   
   function GetID() { return $this->id; }
   
   function Fill($id, $bOffset=true)
   {
      if($bOffset){
         $qry=sprintf(user_qry2, $id);
      }
      else{
         $qry=sprintf(user_qry3, $id);
      }
      
	   $result=db_query($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->login=$row["pogin"];
         $this->password=$row["password"];
         $this->userdata=$row["userdata"];
         $this->profile=$row["profile"];
         $this->logintypesid=$row["logintypesid"];
	      $this->employeeid=$row["employeeid"];
         
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d,$e,$f)
   {
      $this->login=$a;
      $this->password=$b;
      $this->userdata=$c;
      $this->profile=$d;
      $this->logintypesid=$e;
	   $this->employeeid=$f;
   }
   
   function SetFromForm($frm)
   {
      $this->login=$frm['login'];
      $this->password=$frm['password'];
      $this->userdata=$frm['userdata'];
      $this->profile=$frm['profile'];
      $this->logintypesid=$frm['logintypesid'];
	   $this->employeeid=$frm['employeeid'];
   }
   
   function Add()
   {
      $qry=sprintf(user_qry5, $this->login,$this->password,$this->userdata,$this->profile,
         $this->logintypesid,$this->employeeid);
      db_query($qry);
       
       $result=db_query(misc_qry1);
       if($row = $result->FetchRow()){
          $this->id=$row[0];
       }
       return $this->id;
   }
   
   function Commit()
   {
      $qry=sprintf(user_qry6, $this->login,$this->password,$this->userdata,$this->profile,
         $this->logintypesid,$this->employeeid, $this->id);
      db_query($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(user_qry7, $this->id);
      db_query($qry);
   }
   
   function perms($a, $row, $bLine)
   {
      $on=$_SESSION['CFG']->libdir."/tick.png";
      $off=$_SESSION['CFG']->libdir."/cancel.png";
      
      if($bLine) print "<td>Login</td>\n";
      if($a=="commit" || $a=="add"){
         if($row["perm_login"]=='Y'){
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_login\" value=\"1\" checked></td>\n";
         }
         else{
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_login\" value=\"0\"></td>\n";
         }
      }
      else{
         if($row["perm_login"]=='Y'){
            print "<td align=\"center\"><image src=\"$on\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
         else{
            print "<td align=\"center\"><image src=\"$off\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
      }
      if($bLine) print "<td>List</td>\n";
      if($a=="commit" || $a=="add"){
         if($row["perm_list"]=='Y'){
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_list\" value=\"1\" checked></td>\n";
         }
         else{
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_list\" value=\"0\"></td>\n";
         }
      }
      else{
         if($row["perm_list"]=='Y'){
            print "<td align=\"center\"><image src=\"$on\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
         else{
            print "<td align=\"center\"><image src=\"$off\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
      }
      if($bLine) print "<td>Browse</td>\n";
      if($a=="commit" || $a=="add"){
         if($row["perm_browse"]=='Y'){
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_browse\" value=\"1\" checked></td>\n";
         }
         else{
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_browse\" value=\"0\"></td>\n";
         }
      }
      else{
         if($row["perm_browse"]=='Y'){
            print "<td align=\"center\"><image src=\"$on\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
         else{
            print "<td align=\"center\"><image src=\"$off\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
      }
      if($bLine) print "<td>Add</td>\n";
      if($a=="commit" || $a=="add"){
         if($row["perm_add"]=='Y'){
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_add\" value=\"1\" checked></td>\n";
       }
         else{
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_add\" value=\"0\"></td>\n";
         }
      }
      else{
         if($row["perm_add"]=='Y'){
            print "<td align=\"center\"><image src=\"$on\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
         else{
            print "<td align=\"center\"><image src=\"$off\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
      }
      if($bLine) print "<td>Edit</td>\n";
      if($a=="commit" || $a=="add"){
         if($row["perm_edit"]=='Y'){
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_edit\" value=\"1\" checked></td>\n";
         }
         else{
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_edit\" value=\"0\"></td>\n";
         }
      }
      else{
         if($row["perm_edit"]=='Y'){
            print "<td align=\"center\"><image src=\"$on\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
         else{
            print "<td align=\"center\"><image src=\"$off\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
      }
      if($bLine) print "<td>Delete</td>\n";
      if($a=="commit" || $a=="add"){
         if($row["perm_delete"]=='Y'){
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_delete\" value=\"1\" checked></td>\n";
         }
         else{
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_delete\" value=\"0\"></td>\n";
         }
      }
      else{
         if($row["perm_delete"]=='Y'){
            print "<td align=\"center\"><image src=\"$on\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
         else{
            print "<td align=\"center\"><image src=\"$off\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
      }
   }
   
   function StationCombo($a, $id, $cname)
   {
      //$this->StationID=$id;
      
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\" width=\"250\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $qry=sprintf(station_qry4, $id, $id);
         $result=db_query($qry);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         echo "<select name=\"$cname\" width=\"250\">\n";
   	   $qry=sprintf(user_qry9, $id, $id);
         $result=db_query($qry);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
   }
   
   function InterfaceCombo($a, $id, $cname)
   {
      
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\" width=\"250\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $qry=sprintf(user_qry12);
         $result=db_query($qry);
      	while($row = $result->FetchRow()){
            db_query($qry);
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         echo "<select name=\"$cname\" width=\"250\">\n";
 
   	   $qry=sprintf(user_qry10, $id, $id);
         $result=db_query($qry);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
   }
   
   function LoginTypesCombo($a, $id, $cname)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\" width=\"250\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $qry=sprintf(user_qry13, $id, $id);
         $result=db_query($qry);
      	while($row = $result->FetchRow()){
            db_query($qry);
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         echo "<select name=\"$cname\" width=\"250\">\n";
 
   	   $qry=sprintf(user_qry13, $this->id, $this->id);
         $result=db_query($qry);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
   }
   
   function PermLine($a, $id)
   {
      echo "<tr>\n";
      $qry=sprintf(user_qry14, $id, $id);
      db_query($qry);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         perms($a, $row, true);
      }
      echo "</tr>\n";
   }
   
   function PermTable($a, $id)
   {
      echo "<tr><td><h3>login</h3></td><td><h3>list</h3></td><td><h3>browse</h3></td><td><h3>add</h3></td><td><h3>edit</h3></td><td><h3>delete</h3></td></tr>\n";
      $qry=sprintf(user_qry8, $id, $id);
      db_query($qry);
      $result=db_query($qry);
      $c=1;
      while($row = $result->FetchRow()){
         if($c%2==0){
            echo "<tr bgcolor=\"#CFCFCF\">\n";
         }
         else{
            echo "<tr>\n";
         }
         perms($a, $row, false);
      
         echo "</tr>\n";
         $c++;
      }
   }
   
   function Stations($a, $id, $postID, $bInside=false)
   {
      if(!$bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"address\">\n";
         echo "<tr>\n";
      }
      echo "<tr><td><h3>Name</h3></td><td><h3>Interface</h3><td><h3>Type</h3></td><td><h3>login</h3></td><td><h3>list</h3></td><td><h3>browse</h3></td><td><h3>add</h3></td><td><h3>edit</h3></td><td><h3>delete</h3></td></tr>\n";
      $qry=sprintf(user_qry8, $this->ID, $this->ID);
      db_query($qry);
      $c=1;
      while($row = $result->FetchRow()){
         if($c%2==0){
            echo "<tr bgcolor=\"#CFCFCF\">\n";
         }
         else{
            echo "<tr>\n";
         }
         echo "<td>$row[1]</td><td>$row[2]</td><td>$row[3]</td>\n";
         perms($a, $row);
      
         echo "</tr>\n";
         $c++;
      }
      if(!$bInside){
         echo "</table>\n";
      }
   }
   
   function FillTable($a, $id, $title, $bInside=false)
   {
      if($a=="commit" || $a=="add"){
         $this->Fill($id, false);
      }
      else{
         $this->Fill($id, true);
      }
      
      if(!$bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"address\">\n";
         echo "<tr>\n";
	      echo "<td colspan=\"2\" align=\"center\"><h3>$title</h3></td></tr>\n";
      }

	   echo "<tr>\n";
      echo "<td width=\"20%\" align=\"right\">Login</td>\n";
      echo "<td>";
	   entry($a, "login", 32, 16, $this->login);
   	echo"</td>\n";
	   echo "</tr>\n";
	
   	echo "<tr>\n";
      echo "<td align=\"right\">Password</td>\n";
      echo "<td>";
	   entry($a, "password", 32, 16, $this->password);
   	echo"</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td align=\"right\">User Data</td>\n";
   	echo "<td>";
      entry($a, "userdata", 68, 64,$this->userdata);
   	echo"</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td align=\"right\">Profile</td>\n";
      echo "<td>";
	   entry($a, "profile", 68, 64, $this->profile);
   	echo "</td>\n";
	   echo "</tr>\n";
   
      echo "<tr>\n";
      echo "<td align=\"right\">Login Types</td>\n";
      echo "<td>";
	   entry($a, "state", 32, 32, $this->state);
   	echo "</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td align=\"right\">Employee</td>\n";
      echo "<td>";
	   entry($a, "postcode", 32, 32, $this->postcode);
   	echo "</td>\n";
	   echo "</tr>\n";
	
   	echo "<tr>\n";
      echo "<td align=\"right\">Country</td>\n";
      echo "<td>";
	   entry($a, "country", 32, 32, $this->country);
   	echo "</td>\n";
	   echo "</tr>\n";
      if(!$bInside){
   	   echo "</table>\n";
      }
   }
   
   function Find($bOutput)
   {
      $band=0;
      $ba1=0;
      $ba2=0;
      $ba3=0;
      $bc=0;
      $bs=0;
      $bp=0;
      $bcn=0;
      
      $query="SELECT * FROM users WHERE ";
      if($this->Address1!=''){
         $query.="Address1='$this->Address1'";
         $ba1=1;
         $band=1;
      }
      if($this->Address2!=''){
         if($band==0){
            $query.="Address2='$this->Address2'";
            $band=1;
         }
         else{
            $query.="and Address2='$this->Address2'";
         }
         $ba2=1;
      }
      if($this->Address3!=''){
         if($band==0){
            $query.="Address3='$this->Address3'";
            $band=1;
         }
         else{
            $query.="and Address3='$this->Address3'";
         }
         $ba3=1;
      }
      if($this->City!=''){
         if($band==0){
            $query.="City='$this->City'";
            $band=1;
         }
         else{
            $query.="and City='$this->City'";
         }
         $bc=1;
      }
      if($this->State!=''){
         if($band==0){
            $query.="State='$this->State'";
            $band=1;
         }
         else{
            $query.="and State='$this->State'";
         }
         $bs=1;
      }
      if($this->PostCode!=''){
         if($band==0){
            $query.="PostCode='$this->PostCode'";
            $band=1;
         }
         else{
            $query.="and PostCode='$this->PostCode'";
         }
         $bp=1;
      }
      if($this->Country!=''){
         if($band==0){
            $query.="Country='$this->Country'";
            $band=1;
         }
         else{
            $query.="and Country='$this->Country'";
         }
         $bcn=1;
      }
      
      $result=db_query($query);
      $n=db_num_rows($result);
      if(!$bOutput){
         if($n==0){
            return false;
         }
         else{
            return true;
         }
      }
      
      if($n==0){
         echo "<br><br><center><h2>No matching Address found for search Criteria</h2></center>";
         return false;
      }
      
      echo "<table width=\"100%\"><tr><td colspan=\"6\" align=\"center\"><h3>Found $n Matches</h3></td></tr>\n";
      echo "<tr><td><h3>Address1</h3></td><td><h3>Address2</h3></td><td><h3>Address3</h3></td>\n";
      echo "<td><h3>City</h3></td><td><h3>State</h3></td><td><h3>Post Code</h3></td><td><h3>Country</h3></td>\n";
      while($row = $result->FetchRow()){
         echo "<tr><td>\n";
         if($ba1){
            echo "<b>$row[Address1]</b>";
         }
         else{
             echo $row['Address1'];
         }
         echo "</td><td>";
         if($ba2){
            echo "<b>$row[Address2]</b>";
         }
         else{
            echo $row['Address2'];
         }
         echo "</td><td>";
         if($ba3){
            echo "<b>$row[Address3]</b>";
         }
         else{
            echo $row['Address3'];
         }
         echo "</td><td>";
         if($bc){
            echo "<b>$row[City]</b>";
         }
         else{
            echo $row['City'];
         }
         echo "</td><td>";
         if($bs){
            echo "<b>$row[State]</b>";
         }
         else{
            echo $row['State'];
         }
         echo "</td><td>";
         if($bp){
            echo "<b>$row[PostCode]</b>";
         }
         else{
            echo $row['PostCode'];
         }
         echo "</td><td>";
         if($bcn){
            echo "<b>$row[Country]</b>";
         }
         else{
            echo $row['Country'];
         }
         echo "</td></tr>\n";
      }
      echo "</table>\n";
      
      return true;
   }
}

?>
