<?php
/*
porder.php

Copyright (C)2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/account.php");
require_once($_SESSION['CFG']->libdir."/address.php");
require_once($_SESSION['CFG']->libdir."/contact.php");
require_once($_SESSION['CFG']->libdir."/createmod.php");
require_once($_SESSION['CFG']->libdir."/chargeaccount.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}
/*
if($_SESSION["pageindex"]->CheckNum(supplier_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}
*/
function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "rolevel" :
		rolevel();
		break;

	case "order":
		order();
		break;

	case "demand" :
		demand();
		break;
      
  case "autogen" :
		autogen();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function rolevel()
{
   $qry=sprintf(reorder_qry5, 20);
   $result=db_query($qry);
   echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Barcode</h3></td><td><h3>Name</h3></td><td><h3>S</h3></td><td><h3>RO</h3></td><td><h3>O</h3></td><td><h3>Supplier</h3></td><td><h3>Action</h3></td></tr>";
   while($row = $result->FetchRow()){
      $qry=sprintf(reorder_qry3, $row[0]);
      $presult=db_query($qry);
      if($prow = $presult->FetchRow()){
         echo "<tr><td>$prow[PLU]</td><td>$prow[Name]</td><td>$row[InStock]</td><td>$row[ROLevel]</td><td>$row[OnOrder]</td>\n";

         $qry=sprintf(reorder_qry4, $row[1]);
         $sresult=db_query($qry);
         if($srow = $sresult->FetchRow()){
            echo "<td>$srow[name]</td><td>&nbsp;</td></tr>\n";
         }
      }
   }
   echo "</table>";
	echo "<br><br>";
}

function order()
{
   $qry=sprintf(reorder_qry7, 20);
   $result=db_query($qry);
   echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Barcode</h3></td><td><h3>Name</h3></td><td><h3>S</h3></td><td><h3>RO</h3></td><td><h3>O</h3></td><td><h3>Supplier</h3></td><td><h3>Action</h3></td></tr>";
   while($row = $result->FetchRow()){
      $qry=sprintf(reorder_qry3, $row[0]);
      $presult=db_query($qry);
      if($prow = $presult->FetchRow()){
         echo "<tr><td>$prow[PLU]</td><td>$prow[Name]</td><td>$row[InStock]</td><td>$row[ROLevel]</td><td>$row[OnOrder]</td>\n";

         $qry=sprintf(reorder_qry4, $row[1]);
         $sresult=db_query($qry);
         if($srow = $sresult->FetchRow()){
            echo "<td>$srow[name]</td><td>&nbsp;</td></tr>\n";
         }
      }
   }
   echo "</table>";
	echo "<br><br>";
}

function demand()
{
	//$frm=clearForm();
	$frm["newaction"] = "add";
	$frm["id"] = "";
   $frm["heading"] = "Supplier Add";

	include("templates/supplieredit.php");
}

function autogen()
{
   $result=db_query(reorder_qry8);
   $f=1;
	echo "<br><table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Product</h3></td><td><h3>Qty</h3></td></tr>";
   while($row = $result->FetchRow()){
      if($f){
         $f=0;
         $supplierID=-1;
         $csid=$row['id'];
      }
      else{
         $supplierID=$row['id'];
      }
      
      // stock difference from rolevel
      $sqty=$row['rolevel']-($row['instock']+$row['onorder']-$row['reservedqty']);
      
      // check for standard order size
      if($sqty < $row['roqty']){
      }
      
      // check max stock isn't exceeded.
      if(($row['instock']+$row['onorder']-$row['reservedqty']+$sqty) > $row['maxstock']){
         $qty=$sqty-($row['maxstock']-($row['instock']+$row['onorder']-$row['reservedqty']+$sqty));
      }
      else{
         $qty=$sqty;
      }
      
      if($supplierID!=$csid){
         $c=new CreateMod();
         $c->Fill(0);
         $cmid=$c->Commit();
         //ID, buyquantitypriceid,InStock,ROLevel,OnOrder
         $qry=sprintf(purchase_qry8, "","",$cmid,"0000-00-00","0000-00-00",$supplierID,0,0,0,0,0,0);
         $presult=db_query(misc_qry1);
         $prow = $presult->FetchRow();
         $poid=$row[0];
         $supplierID=$row['id'];
         echo "<tr><td colspan=\"2\"><h3>$poid - $row[name]</h3></td>\n";
      }
      
      if($supplierID==$csid){
         echo "<tr><td>&nbsp;</td><td>$qty</td></tr>\n";
         $qry=sprintf(porderitem_qry8, $poid, $qty, $row['invid']);
      }
      
      $csid=$row['id'];
   }
   echo "</table><br>\n";
}

function listSupplier()
{
	$q=$_SESSION["pageindex"]->query(supplier_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
   echo "<table border=\"0\" cellpadding=\"0\" width=\"100%\">\n";
   echo "<tr><td>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Supplier</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		$n=$myrow["name"];
      if($n=="") $n="&nbsp;";
		print "<tr><td>$n</td>";
		print "<td>";
		$wibbler=$myrow["ID"];
		print "<a href=\"supplier.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"supplier.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"supplier.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
