<?php
/*
purchase.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/items.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['titleimg']) || $_SESSION['titleimg']!=$_SESSION['CFG']->imagedir."/tlt_purchase.png"){
   $_SESSION['titleimg'] = $_SESSION['CFG']->imagedir."/tlt_purchase.png";
   //echo "<meta http-equiv=\"refresh\" content=\"0\" src=\"header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(purchase_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}


switch($_REQUEST['action']){
	case "clear" :
		addPurchase();
		break;

	case "browse":
		$id=updateNav($_POST);
		browsePurchase($id);
		break;

	case "edit" :
		editPurchase($id);
		break;
      
   case "delete" :
		chkdelPurchase($id);
		break;

	case "cfmdelete" :
		deletePurchase($id);
      $_SESSION["pageindex"]->deletion(CountNum());
		break;

	case "add" :
		insertPurchase();
      $_SESSION["pageindex"]->addition(CountNum());
		break;

	case "commit" :
		commitPurchase($id, $_POSTS);
		break;
		
	case "itemadd" :
		itemAdd($_POST);
		break;

	case "itemedit" :
		break;
      
	case "itemeditsel" :
		break;

	case "createorder" :
		createOrder();
		break;

	case "approval" :
		approvalPurchase();
		break;

	case "approvecommit" :
		approvalCommmit($id);
		break;
		
   case "dispatch" :
		dispatchPurchase();
		break;

	case "dispatchcommit" :
		dispatchCommit($id);
		break;

   case "status":
      status();
      break;
      
   case "statusqry":
      statusqry($_POST);
      break;
      
	case "list":
	default :
		listPurchase();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(purchase_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["Id"] = "";
   $frm["purchaseorderid"] = "";
   $frm["purchasenumber"] = "";
   $frm["statusid"] = "0";
   $frm["name"] = "";
   $frm["cmid"] = "";
   $frm["dispatchdate"] = "";
   $frm["arriveddate"] = "";
   $frm["supplierid"] = "";
   $frm["shippingid"] = "";
   $frm["requestedby"] = "";
   $frm["approvedby"] = "";
   $frm["accountid"] = "";
   $frm["transactionid"] = "";
   $frm["linkid"] = "";

	if(isset($_SESSION["purchaseorder"])){
		unset($_SESSION["purchaseorder"]);
		$_SESSION["purchaseorder"] = new InvItems;
	}
	
	return $frm;
}

function itemList()
{
	if(!isset($_SESSION["purchaseorder"])){
		$_SESSION["purchaseorder"] = new InvItems;
	}

	if(isset($_SESSION["purchaseorder"])){
		$_SESSION["purchaseorder"]->buildItemList("Purchase Order");
	}
	else{
		echo "no purchase order class instansiated...";
	}
}

function itemAdd($frm)
{
   $frm["heading"] = "New Purchase Order";

	$ni = new InvItem();

	$ni->SetPLU($frm["PLU"]);

	if(isset($frm["Qty"]) && $frm["Qty"]!=0){
		$ni->SetQty($frm["Qty"]);
	}

	if(($err=$ni->CheckPLU())){
		switch(err){
		case 1:	echo "<br><br><center><b>Error $err: PLU not set.</b></center>"; break;
		case 2:	echo "<br><br><center><b>Error $err: PLU not Found.</b></center>"; break;
		case 3:	echo "<br><br><center><b>Error $err: Inventory Item not Found.</b></center>"; break;
		case 4:	echo "<br><br><center><b>Error $err: Buy Price not Found.</b></center>"; break;
		case 5:	echo "<br><br><center><b>Error $err: Supplier does not supply this item.</b></center>"; break;
		exit;
		}
	}

	if(isset($_SESSION["purchaseorder"])){
		if($_SESSION["purchaseorder"]->NumItems()!=0){
			if($ni->GetSupplier()==$_SESSION["purchaseorder"]->GetSupplier()){
				$_SESSION["purchaseorder"]->Add($ni);
				$frm["newaction"] = "add";
				$frm["supplierID"] = $ni->GetSupplier();
				if($frm["supplierID"]==0){
					$frm["supplierName"]="Not Set";
				}
				else{
					$result=db_query("SELECT name FROM supplier WHERE ID = '$frm[supplierID]'");
					if($row = $result->FetchRow()){
						$frm["supplierName"]=$row["name"];
					}
					else{
						$frm["supplierName"]="Not Set";
					}
				}
				include("templates/purchedit.php");
				exit;
			}
			else{
				echo "<br><center><b><i>The supplier is not the same for this item</i></b><center>\n";
				include("templates/purchedit.php");
				exit;
			}
		}
		else{
			$_SESSION["purchaseorder"]->SetSupplier($ni->GetSupplier());
			if($ni->GetSupplier()==$_SESSION["purchaseorder"]->GetSupplier()){
				$_SESSION["purchaseorder"]->Add($ni);
				$frm["newaction"] = "add";
				$frm["supplierID"] = $ni->GetSupplier();
				if($frm["supplierID"]==0){
					$frm["supplierName"]="Not Set";
				}
				else{
					$result=db_query("SELECT name FROM supplier WHERE ID = '$frm[supplierID]'");
					if($row = $result->FetchRow()){
						$frm["supplierName"]=$row["name"];
					}
					else{
						$frm["supplierName"]="Not Set";
					}
				}
				include("templates/purchedit.php");
				exit;
			}
			else{
				echo "<br><center><b><i>The supplier is not the same for this item</i></b><center>\n";
				include("templates/purchedit.php");
				exit;
			}
		}
	}
	else{
		echo "error - no purchase order";
	}
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(purchase_qry2, $id);
   }
   else{
      $qry=sprintf(purchase_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
	
	$frm["ID"]=$id;
   $frm["purchaseorderID"] = $row["purchaseorderID"];
   $frm["purchaseNumber"] = $row["purchaseNumber"];
   $frm["statusID"] = $row["statusID"];
   $frm["name"] = $row["name"];
   $frm["cmID"] = $row["cmID"];
   $frm["dispatchDate"] = $row["dispatchDate"];
   $frm["arrivedDate"] = $row["arrivedDate"];
   $frm["supplierID"] = $row["supplierID"];
   $frm["shippingID"] = $row["shippingID"];
   $frm["requestedBy"] = $row["requestedBy"];
   $frm["approvedBy"] = $row["approvedBy"];
   $frm["accountID"] = $row["accountID"];
   $frm["transactionID"] = $row["transactionID"];
   $frm["linkID"] = $row["linkID"];

	return $frm;
}

function addPurchase()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = "New Purchase Order";
	
	include("templates/purchedit.php");

	exit;
}

function editPurchase($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Edit Purchase Order";
		
	include("templates/purchedit.php");

}

function browsePurchase($id) 
{
   $frm["heading"] = "Browse Purchase Orders";
   
   $result=db_query(purchase_qry1);
	$row = $result->FetchRow();
   if($row[0]==0){
      include("templates/purchnone.php");
      exit;
   }

	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Browse Purchase Orders";
		
	include("templates/purchedit.php");
}

function deletePurchase($id) 
{
	$qid = db_query("DELETE FROM purchaseorder WHERE ID = '$id'");
	
	include("templates/purchdel.php");
}

function insertPurchase($frm) 
{
	$qid = db_query("INSERT INTO purchaseorder VALUES ('', '$fn','$ln','$pid','$lc')");
}

function commitPurchase($id, $frm) 
{

}

function createOrder()
{
	global $_SESSION;
	$eid=$_SESSION["user"]["EmployeeID"];
	$sid=$_SESSION["purchaseorder"]->GetSupplier();
	db_query("INSERT INTO createmod VALUES ('',CURDATE(),CURDATE(),'$eid','$eid')");

	db_query("INSERT INTO purchaseorder VALUES ('',
      '0',
      '0',
      '2',
		'No Name',
		LAST_INSERT_ID(),
		'0000-00-00',
		'0000-00-00',
		'$sid',
      '0',
		'$eid',
		'0','0','0','0')");

	$pid= db_insert_id();
	db_query("UPDATE purchaseorder SET purchaseorderID = '$pid'");
	$_SESSION["purchaseorder"]->fillpitems($pid);

	echo "<br><br><center><h3>Purchase Order has been placed - awaiting approval</h3></center>";
}

function approvalPurchase()
{
	$result=db_query("SELECT * from purchaseorder WHERE statusID='2'");
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Created On</h3></td><td><h3>Created By</h3></td><td><h3>Supplier</h3><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		$pid=$row["ID"];
		$wibbler=$row["supplierID"];
		$cmid=$row["cmID"];
		$sresult=db_query("SELECT name from supplier WHERE ID='$wibbler'");
		$srow = $sresult->FetchRow();
		$sname=$srow["name"];
		db_free_result($sresult); 
		
		$sresult=db_query("SELECT CreationDate, CreatedBy from createmod WHERE ID='$cmid'");
		$srow = $sresult->FetchRow();
		$cdate=$srow["CreationDate"];
		$cwho=$srow["CreatedBy"];
		db_free_result($sresult);

		$sresult=db_query("SELECT fname, lname from employee WHERE ID='$cwho'");
		$srow = $sresult->FetchRow();
		$who=$srow["fname"]." ".$srow["lname"] ;

		db_free_result($sresult);

		print "<tr><td>$cdate</td><td>$who</td><td>$sname</td><td>\n";
		print "<a href=\"purchase.php?action=approvecommit&id=$pid\">approve</a>&nbsp;\n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";

   exit;
}

function approvalCommmit($id)
{
	$eid=$_SESSION["user"]["EmployeeID"];
	db_query("UPDATE purchaseorder SET approvedBy ='$eid', statusID='3' WHERE ID='$id'");
	echo "<br><br><center><h3>Purchase Approved - Awaiting Dispatch</h3></center>";
	exit;
}

function dispatchPurchase()
{
	$result=db_query("SELECT * from purchaseorder WHERE statusID='3'");
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Created On</h3></td><td><h3>Created By</h3></td><td><h3>Supplier</h3><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		$pid=$row["ID"];
		$wibbler=$row["supplierID"];
		$cmid=$row["cmID"];
		$sresult=db_query("SELECT name from supplier WHERE ID='$wibbler'");
		$srow = $sresult->FetchRow();
		$sname=$srow["name"];
		db_free_result($sresult); 
		
		$sresult=db_query("SELECT CreationDate, CreatedBy from createmod WHERE ID='$cmid'");
		$srow = $sresult->FetchRow();
		$cdate=$srow["CreationDate"];
		$cwho=$srow["CreatedBy"];
		db_free_result($sresult);

		$sresult=db_query("SELECT fname, lname from employee WHERE ID='$cwho'");
		$srow = $sresult->FetchRow();
		$who=$srow["fname"]." ".$srow["lname"] ;

		db_free_result($sresult);

		print "<tr><td>$cdate</td><td>$who</td><td>$sname</td><td>\n";
		print "<a href=\"purchase.php?action=dispatchcommit&id=$pid\">dispatch</a>&nbsp;\n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";

   exit;
}

function dispatchCommit($id)
{
	db_query("UPDATE purchaseorder SET statusID='4' WHERE ID='$id'");
	db_query("UPDATE purchaseorder SET dispatchDate=CURDATE() WHERE ID='$id'");
   $qry=sprintf(porderitem_qry9, $id);
   $result=db_query($qry);
   while($row = $result->FetchRow()){
      $qry=sprintf(porderitem_qry10, $row['Quantity'], $row['InventoryID']);
      db_query($qry);
   }
	echo "<br><br><center><h3>Order Dispatched - awaiting Goods In<br><br><br>Need to fill in print form code here...</h3></center>";
	exit;
}

function prnPOHeader()
{
}

function prnCompanyInfo()
{
}

function prnOrderNumber()
{
}

function prnDeliveryAddress() 
{
}

function prnSupplierAddress()
{
}

function prnitemList()
{
}


function listPurchase()
{
	$q=$_SESSION["pageindex"]->query(purchase_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Purchase Number</h3></td><td><h3>Status</h3><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		$wibbler=$row["ID"];
		$s=$row["statusID"];
		$n=$row["purchaseNumber"];

		print "<tr><td>$n</td><td>";
      fillPurchaseStatusCombo("browse","",$s);
      print "</td><td>\n";
		print "<a href=\"purchase.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"purchase.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"purchase.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
