<?php
/*
location.php

Copyright (C)2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/reporter.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], reports_loc_pagetitle)!=0){
   $_SESSION['title']=reports_loc_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}


if(!isset($prodrep)){
   $prodrep=& new ProductReporter();
}

switch($_REQUEST['action']){
   case "station" :
      stationsales($HTTP_POST_VARS);
      break;
      
	case "group" :
		groupsales($HTTP_POST_VARS);
		break;
      
   case "dept" :
		deptsales($HTTP_POST_VARS);
		break;
   
   case "site" :
   default:
		sitesales($HTTP_POST_VARS);
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function clearForm()
{
   $frm["stationid"]="";
   $frm["groupid"]="";
   $frm["deptid"]="";
   $frm["siteid"]="";
   $frm["reporttype"] = "incremental";
   $frm["newaction"] = "query";
   include("templates/locreport.php");
}

function stationsales($frm)
{
   $frm["heading"] = "Sales By Station";
   include("templates/locreport.php");
}

function groupsales($frm)
{
   $frm["heading"] = "Sales By Group";
   include("templates/locreport.php");
}

function deptsales($frm)
{
   $frm["heading"] = "Sales By Department";
   include("templates/locreport.php");
}

function sitesales($frm)
{
   $frm["heading"] = "Sales By Site";
   include("templates/locreport.php");
}

?>
