<?php
/*
target.php

Copyright (C)2003 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], reports_targ_pagetitle)!=0){
   $_SESSION['title']=reports_targ_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(target_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}


switch($_REQUEST['action']){
	case "clear" :
		addTarget();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseTarget($id);
		break;

	case "edit" :
		editTarget($id);
		break;

	case "delete" :
		chkdelTarget($id);
		break;

	case "cfmdelete" :
		deleteTarget($id);
      $_SESSION["pageindex"]->deletion(CountNum());
		break;

	case "add" :
		insertTarget($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		break;

	case "commit" :
		commitTarget($_POST);
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listTarget();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(target_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["newaction"] = "";
	   
	$frm["id"]="";
   $frm["cmid"]="";
   $frm["productid"]="day";
	$frm["periodtype"]="";
	$frm["period"]="";
	$frm["targettype"]="quantity";
   $frm["target"]="";
	
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(target_qry2, $id);
   }
   else{
      $qry=sprintf(target_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

   $frm["id"]=$row["id"];
   $frm["cmid"]=$row["cmid"];
   $frm["productid"]=$row["productid"];
	$frm["periodtype"]=$row["periodtype"];
	$frm["period"]=$row["period"];
	$frm["targettype"]=$row["targettype"];
   $frm["target"]=$row["target"];

	return $frm;
}

function addTarget()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	$frm["id"] = "Auto number";
   $frm["heading"] = "Target Add";

	include("templates/targedit.php");
}

function editTarget($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Target Edit";

	include("templates/targedit.php");
}

function browseTarget($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Target Browse";
	
	include("templates/targedit.php");
}

function chkdelTarget($id)
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Target Delete";
	include("templates/targdel.php");
}

function deleteTarget($id) 
{
   $qry=sprintf(target_qry5, $id);
	$result=db_query($qry);
}

function insertTarget($frm) 
{
   $qry=sprintf(target_qry6,$frm['cmid'],$frm['productID'],$frm['periodType'],$frm['period'],$frm['targetType'],
   $frm['target']);
   $result=db_query($qry);
}

function commitTarget($frm) 
{
   $qry=sprintf(target_qry6,$frm['cmid'],$frm['productID'],$frm['periodType'],$frm['period'],$frm['targetType'],
   $frm['target'], $frm['id']);
   $result=db_query($qry);
}

function CreateModTable($id)
{
   $cm=new CreateMod();
   $cm->Fill($id);
   $cm->FillTable();
}

function targperiodtypeCombo($a, $c, $id)
{
   $typelist = array('day', 'week', 'month', 'quarter', 'year');
   
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"$c\" width=\"250\">\n";
	   foreach ($typelist as $typeid) {
	      print "<option ";
   	   if($id == $typeid)
	         print "selected ";
	      print "value='$typeid'>$typeid</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $id;
   }
}

function targtypeCombo($a, $c, $id)
{
   $typelist = array('quantity', 'sales');
   
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"$c\" width=\"250\">\n";
	   foreach ($typelist as $typeid) {
	      print "<option ";
   	   if($id == $typeid)
	         print "selected ";
	      print "value='$typeid'>$typeid</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $id;
   }
}

function fillprodBrief($a, $pid)
{
   $result=db_query("select plu, name from product where id='$pid'");
   $row = $result->FetchRow();
   if($a=="commit" || $a=="add"){
      echo "<td align=\"right\">PLU</td><td>";
      entry($a, "PLU", 32, 32, $row[0]);
      echo "</td></tr>\n";
      echo "<tr><td align=\"right\">Name</td><td>$row[1]</td>\n";
   }
   else{
      echo "<td align=\"right\">PLU</td><td>$row[0]</td></tr>\n";
      echo "<tr><td align=\"right\">Name</td><td>$row[1]</td>\n";
   }
}

function listTarget()
{
	$q=$_SESSION["pageindex"]->query($target_qry4);
	$result=db_query($q);

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>PLU</h3></td><td><h3>Name</h3><td><h3>Action</h3></td></tr>";
   if($result){
   	while($row = $result->FetchRow()){
         $presult=db_query("select plu, name from product where id='$myrow[productid]'");
         $prow = $presult->FetchRow();
   		echo "<tr><td>$prow[0]</td><td>$prow[1]</td>\n";
	   	echo "<td>";
		   $wibbler=$row["id"];
   		echo "<a href=\"target.php?action=clear\">add</a>&nbsp;\n";
	   	echo "<a href=\"target.php?action=edit&id=$wibbler\">edit</a>&nbsp; \n";
		   echo "<a href=\"target.php?action=delete&id=$wibbler\">delete</a>&nbsp; \n";
   		echo "</td></tr>\n";
	   }
   }
   else{
   }
	echo "</table>";
	echo "<br><br>";
}

?>
