<?php
/*
banktrans.php

Copyright (C)2004  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], station_if_pagetitle)!=0){
   $_SESSION['title']=station_if_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(interface_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}
 
switch($_REQUEST['action']){
	case "clear" :
		addInterface();
		break;
		
	case "browse" :
      $id=updateNav($_POST);
		browseInterface($id);
		break;

	case "edit" :
		editInterface($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelInterface($_REQUEST['id']);
      }
      else{
         deleteInterface($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listInterface($_REQUEST['id']);
      }
		break;
      
   case "cfmdelete" :
      deleteInterface($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listInterface();
		break;

	case "add" :
		insertInterface($_POST);
      $_SESSION["pageindex"]->setnum(CountNum());
		listInterface();
		break;

	case "commit" :
		commitInterface($_POST);
		listInterface();
		break;

	case "list" :
	default :
      $id=updateNav($_POST);
		listInterface();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(interface_qry1);
   if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm['id'] = 0;
   $frm['name'] = "" ;
   $frm['description'] = "";

   return $frm;
}

function fillform($id, $bOffset)
{

   if($bOffset){
      $qry=sprintf(interface_qry2, $id);
   }
   else{
      $qry=sprintf(interface_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm['id'] = $id;
   $frm['name'] = $row['name'];
   $frm['description'] = $row['description'];

	return $frm;
}

function addInterface() 
{
   $frm=clearForm();
   $frm["newaction"] = "add";
   $frm["heading"] = "Interface Add";

	include("templates/ifedit.php");   
}

function browseInterface($id) 
{
	$frm = fillform($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Interface Browse";

	include("templates/ifedit.php");
}

function editInterface($id) 
{
	$frm = fillform($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Interface Edit";

	include("templates/ifedit.php");
}

function deleteInterface($id) 
{
   $qry=sprintf(interface_qry7, $id);
	db_query($qry);
}

function chkdelInterface($id)
{
   $frm = fillform($id, false);
   $frm["newaction"] = "cfmdelete";
   $frm["id"] = $id;
   $frm["heading"] = "Interface Delete";
   
	include("templates/ifedit.php");
}

function insertInterface($frm) 
{
   $qry=sprintf(interface_qry5, $frm['name'],$frm['description']);
	db_query($qry);
}

function commitInterface($frm) 
{
	$qry=sprintf(interface_qry6, $frm['name'],$frm['description'],$frm['id']);
	db_query($qry);
}

function listInterface()
{
   $q=$_SESSION["pageindex"]->query(interface_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Description</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		$wibbler=$myrow["id"];
		printf ("<tr><td>%s</td>\n<td>%s</td>\n<td>", $myrow["name"], $myrow["description"]);
		print "<a href=\"interface.php?action=clear\">add</a>&nbsp;\n";
		print "<a href=\"interface.php?action=edit&id=$wibbler\">edit</a>&nbsp; \n";
		print "<a href=\"interface.php?action=delete&id=$wibbler\">delete</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
