<?php
/*
stationorg.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/tree.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], station_org_pagetitle)!=0){
   $_SESSION['title']=station_org_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

include($_SESSION['CFG']->templatedir."/ptheader.php");

switch($_REQUEST['action']){
	case "build" :
		HtmlBuildTree();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function HtmlBuildTree()
{
   $closed="folder_closed.png";
   $open="folder_open.png";
   $station_icon="icon_station.png";
   
   $tree = new HTML_TreeMenu();
   $result=db_query(setup_qry4);
   if($row = $result->FetchRow()){
      $node = new HTML_TreeNode(array('text'=>$row[0],'icon'=>$closed,'expandedIcon'=>$open));
   }
   else{
      $node = new HTML_TreeNode(array('text'=>"Organization",'icon'=>$closed,'expandedIcon'=>$open));
   }
   $sites=&$node->addItem(new HTML_TreeNode(array('text'=>"Sites",'icon'=>$closed,'expandedIcon'=>$open)));
   
	$sresult=db_query(site_qry7);
	while($srow = $sresult->FetchRow()){
      $sn=&$sites->addItem(new HTML_TreeNode(array('text'=>$srow['name'], 'link'=>"site.php?action=browse&id=".$srow['id'],
      'icon'=>$closed,'expandedIcon'=>$open)));
      
      $depts=&$sn->addItem(new HTML_TreeNode(array('text'=>"Departments",'icon'=>$closed,'expandedIcon'=>$open)));
      $dqry=sprintf(dept_qry5, $srow['id']);
      $dresult=db_query($dqry);
      while($drow = $dresult->FetchRow()){
         $gn=&$depts->addItem(new HTML_TreeNode(array('text'=>$drow['name'], 'link'=>"dept.php?action=browse&id=".$drow['id'],
         'icon'=>$closed,'expandedIcon'=>$open)));
         
         $groups=&$gn->addItem(new HTML_TreeNode(array('text'=>"Groups",'icon'=>$closed,'expandedIcon'=>$open)));
         
         $gqry=sprintf(group_qry5, $drow['id']);
         $gresult=db_query($gqry);
         while($grow = $gresult->FetchRow()){
            $stn=&$groups->addItem(new HTML_TreeNode(array('text'=>$grow['name'], 'link'=>"group.php?action=browse&id=".$grow['id'],
            'icon'=>$closed,'expandedIcon'=>$open)));
         
            $stations=&$stn->addItem(new HTML_TreeNode(array('text'=>"Stations",'icon'=>$closed,'expandedIcon'=>$open)));
            
            $stqry=sprintf(station_qry8, $grow['id']);
            $stresult=db_query($stqry);
            while($strow = $stresult->FetchRow()){
               $stations->addItem(new HTML_TreeNode(array('text'=>$strow['name'], 'link'=>"station.php?action=browse&id=".$strow['id'],
               'icon'=>$station_icon)));
            }
         }
      }
   }
   $tree->addItem($node);
   $treedisp = new HTML_TreeMenu_DHTML($tree, array('images'=>$_SESSION['CFG']->imagedir));
   
   echo "<br>\n";
   echo "<table border=\"0\" cellpadding=\"5\" width=\"95%\">\n";
   echo "<tr><td>";
   $treedisp->printMenu();
   echo "</td></tr>\n";
   echo "</table>\n";
}

?>
