<?php
/*
stationwiz.php

Copyright (C)2002 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.

*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/locale.php");
require_once($_SESSION['CFG']->libdir."/currency.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($frm["pagecount"])){
	$frm["pagecount"]=1;
}

if(!isset($pagemax)){
	$pagemax=5;
	$frm["pagemax"] = $pagemax;	
}

switch($_REQUEST['action']){
	case "start" :
		fillPage();
		break;

	case "ifchange" :
		ifChange($_POST);
		break;		

	case "next" :
		nextPage($_POST);
		break;

	case "prev":
		prevPage($_POST);
		break;

	case "finish" :
		addStation($_POST);
		break;
}



/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function clearform()
{
   $frm["id"] = 0;
	$frm["name"] = "";
   $frm["mac"] = "";
   $frm["groupid"] = "";
   $frm["interfaceid"] = "";
   $frm["localeid"] = "";
   $frm["currencyid"] = "";
   $frm["active"] = "";
   
   return $frm;
}

function fillPage()
{
	$frm=clearform();
	$frm["pagecount"]=1;
	include("templates/stationwiz1.php");
}

function nextPage($frm)
{
	$pagecount=$frm["pagecount"];

	switch($pagecount){
	case 2:
		$frm["siteid"]="";
		include("templates/stationwiz2.php");
		break;
	case 3:
		$frm["deptid"]="";
		include("templates/stationwiz3.php");
		break;
	case 4:
		$frm["groupid"]="";
		include("templates/stationwiz4.php");
		break;
	case 5:
		$frm["interfaceid"]=2;
		include("templates/stationwiz5.php");
		break;
	case 6:
		$frm["interface"] = $frm["interfaceID"];
		$_SESSION['stationwiz'] = array();
		$_SESSION['stationwiz']['perms'] = $frm['perm_login'];
		include("templates/stationwiz6.php");
		break;
	}
}

function ifChange($frm)
{
	include("templates/stationwiz5.php");
}

function prevPage($frm)
{
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "currencyid");
}

function LocaleCombo($action, $id)
{
   $a=new Locale();
   $a->Combo($action, $id, "localeid");
}

function addStation($frm)
{
	// First we get the interface ID rather than the interface line number
	$query = "select interfaceID from interface where id = $frm[interface]";
	$result = db_query($query);
	$row = $result->FetchRow();
	$interface = $row["interfaceID"];

	// Create the new POST entry.
	$query = "insert into posts (name, mac, groupid, interfaceid, localeid, currencyid,
		active) values (
		'$frm[name]',
		'$frm[mac]',
		'$frm[group]',
		'$interface',
		0,
		'$frm[currency]',
		'Y'
		)";
	// error_log($query);
	$qid = db_query($query);

	// Now we have a list of interfaceauth records that we want to set the perm_login
	// flag on.  First we need to clear them - This may be a bit dodgy so it needs to
	// be checked.
	$query = "select authid from interface where interfaceid = $interface";
	$aid = db_query($query);
	$alist = "";
	while ($row = $aid->FetchRow()) {
		if ($alist != "")
		  $alist .= ",";
		$alist .= $row['authid'];
	}
	if ($alist != "") {
		$query = "update interfaceauth set perm_login = 'N' where authid in ($alist)";
		// error_log($query);
		// db_query($query);
	}

	// Now build an update statement that sets those ones we want set.
	$authlist = "";
	if (isset($_SESSION['stationwiz']['perms'])) {
	  // error_log('Permissions list is set');
	  foreach ($_SESSION['stationwiz']['perms'] as $authid ) {
	    if ($authlist != "")
	      $authlist .= ",";
	    $authlist .= $authid;
	  }
	}
	// error_log("List of auth ids is '$authlist'");

	if ($authlist != "") {
	  $query = "update interfaceauth set perm_login = 'Y' where id in ($authlist)";
	  // error_log($query);
	  // db_query($query);
	}
	echo "<h1>Station Added</h1>";
}

?>
