<?php
/*
collection.php

Copyright (C)2003  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}
require_once($_SESSION['CFG']->libdir."/collection.php"); 

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(collection_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addcollection();
		break;

	case "browse":
      $id=updateNav($_POST);
		browsecollection($id);
		break;

	case "edit" :
		editcollection($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelcollection($_REQUEST['id']);
      }
      else{
         deletecollection($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listcollection();
      }
      break;  
	
   case "cfmdelete" :
      deletecollection($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listcollection();
		break;

	case "add" :
		insertcollection($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listcollection();
		break;

	case "commit" :
		commitcollection($_POST);
		listcollection();
		break;
      
   case "additem":
      addItem($_POST);
      break;
      
   case "deleteitem":
      deleteItem($_REQUEST['id']);
      break;
      
   case "merge":
      collectionMerge($_SESSION["pageindex"]->current());
      break;
   
   case "mergesave":
      mergeSave($_POST);
      break;
      
	case "list":
	default :
      $id=updateNav($_POST);
		listcollection();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(collection_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = 0;
	$frm["name"] = "";
	$frm["description"] = "";
	$frm["collectionid"] = "";

	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(collection_qry2, $id);
   }
   else{
      $qry=sprintf(collection_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
	
	$cid=$row["collectionid"];
	$result=db_query("SELECT count(*) from productcollection WHERE prodcollid='$cid'");
	$crow = $result->FetchRow();

	$frm["id"] = $id;
	$frm["name"] = $row["name"];
	$frm["description"] = $row["description"];
	$frm["collectionid"] = $cid;

	return $frm;
}

function addcollection()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = "Collection Add";
	
	include("templates/colledit.php");
}

function editcollection($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Collection Edit";
		
	include("templates/colledit.php");
}

function browsecollection($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Collection Browse";
		
	include("templates/colledit.php");
}

function chkdelcollection($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Collection Delete";
		
	include("templates/colledit.php");
}

function deletecollection($id) 
{
   $qry=sprintf(collection_qry6, $id);
	db_query($qry);
}

function insertcollection($frm) 
{
   $qry=sprintf(collection_qry4, $frm['name'],$frm['description'],0);
   db_query($qry);
}

function commitcollection($frm) 
{
   $qry=sprintf(collection_qry5, $frm['name'],$frm['description'],$frm['collectionid'],$frm['id']);
	db_query($qry);
}

function addItem($frm)
{
   $plu=$frm['PLU'];
   $result=db_query("SELECT id from product where plu = '$plu'");
   if(db_num_rows($result)==0){
      echo "No product found with barcode $plu";
      return;
   }
   $row = $result->FetchRow();
   db_query("INSERT INTO productcollection VALUES ('$frm[cid]','$row[0]')"); 
   
   editcollection($frm["ID"]) ;
}

function deleteItem($cid, $id)
{
   db_query("DELETE FROM productcollection WHERE prodcollid = '$cid' AND productid='$id'");
}

function collectionMerge($id)
{
   $frm["ID"]=$id;
   $frm["newaction"] = "mergesave";
   $frm["heading"] = "Collection Label Merge";
		
	include("templates/collmerge.php");
   exit;
}

function mergeSave($frm)
{  
   $c=new Collection();
   $c->Merge($frm["id"], $frm["mergefile"]);
   /*
   if($frm["openglabel"]=="Y"){
      $fp = fopen("$label_header_template", "w+");
      if(fp){
         // general header template layout
         <?xml version="1.0"?>
         <glabels:Label xmlns:glabels="http://snaught.com/glabels/0.4/" rotate="False" width="XXX.XXX" height="XXX.XXX">
         <glabels:Media_Type>XXXXXXXX Label Sheet Name XXXXXXXX</glabels:Media_Type>
         
         // content template
         <glabels:Text x="XXX.XX" y="XX.XX" font_family="Helvetica" font_size="14" font_weight="Regular" font_italic="False" justify="Left" color="0x000000ff">
         <glabels:Line>
         <glabels:Field name="name"/>
         </glabels:Line>
         </glabels:Text>
         <glabels:Text x="XXX.XX" y="XXX.XX" font_family="Helvetica" font_size="14" font_weight="Regular" font_italic="False" justify="Right" color="0x000000ff">
         <glabels:Line>
         <glabels:Field name="price"/>
         </glabels:Line>
         </glabels:Text>
         <glabels:Barcode x="XXX.XX" y="XXX.XX" color="0x000000ff" style="UPC" text="True" scale="0.7">
         <glabels:Field name="barcode"/>
         </glabels:Barcode>
         
         // footer template (the recently created merge file)
         <glabels:Merge_Properties type="Text/Comma" src="XXXXXXXX">
         <glabels:Field key="name" loc="1"/>
         <glabels:Field key="barcode" loc="2"/>
         <glabels:Field key="price" loc="3"/>
         </glabels:Merge_Properties>
         </glabels:Label>
      }
   }
   */
}

function FillCollCombo($id)
{
   CollectionCombo($id);
}

function FillProdCollTable($action, $id) 
{
   if($action=="add" || $action=="add"){
   }
   else{
      $c=new Collection();
      $c->FillCollectionTable($action, $id);
   }
}

function listcollection()
{
	$q=$_SESSION["pageindex"]->query(collection_qry7);
	$result=db_query($q);

	echo "<br><table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Description</h3></td><td><h3>Num Prod</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		$wibbler=$row["id"];
		$n=$row["name"];
      $d=$row["description"];
		$cid=$row["collectionid"];

		$nresult=db_query("SELECT count(*) from productcollection WHERE prodcollid='$cid'");
		if($nrow = $nresult->FetchRow())
		   $num=$nrow[0];
      else
         $num="0";

		print "<tr><td>$n</td><td>$d</td><td>$num</td><td>\n";		
		print "<a href=\"collection.php?action=edit&id=$wibbler\">edit</a>&nbsp; \n";
		print "<a href=\"collection.php?action=delete&id=$wibbler\">delete</a>&nbsp; \n";
      print "<a href=\"collection.php?action=merge&id=$wibbler\">merge</a>&nbsp;\n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br>";
}

?>
