<?php
/*
deposit.php

Copyright (C)2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(deposit_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addDeposit();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseDeposit($id);
		break;

	case "edit" :
		editDeposit($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelDeposit($_REQUEST['id']);
      }
      else{
         deleteDepositn($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listDeposit();
      }
      break;  
	
   case "cfmdelete" :
      deleteDeposit($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listDeposit();
		break;

	case "add" :
		insertDeposit($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listDeposit();
		break;

	case "commit" :
		commitDeposit($_POST);
		listDeposit();
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listDeposit();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(deposit_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"]="";
   $frm["depositid"]="";
   $frm["cmid"]="";
   $frm["name"]="";
   $frm["percentage"]="";
   $frm["refundable"]="";
   $frm["type"]="";
      
   return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(deposit_qry2, $id);
   }
   else{
      $qry=sprintf(deposit_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["id"]=$id;
   $frm["depositid"]=$row["depositid"];
   $frm["cmid"]=$row["cmid"];
   $frm["name"]=$row["name"];
   $frm["percentage"]=$row["percentage"];
   $frm["refundable"]=$row["refundable"];
   $frm["type"]=$row["type"];

   // fixed discount
   $result=db_query("SELECT count(*) FROM product WHERE depositid = '$frm[depositid]'");
   $row = $result->FetchRow();
   $frm["numproduct"]=$row[0];
   return $frm;
}

function productList($id)
{
   $result=db_query("SELECT id, plu, name from product where depositid = '$id'");
   while($row = $result->FetchRow()){
      echo "<tr><td align=\"right\"><a href=\"product.php?action=browse&id=$row[0]\">$row[1]</a></td><td>$row[2]</td></tr>\n";
   }
}

function addDeposit()
{
   $frm=clearform();
	$frm["newaction"] = "add";
   $frm["heading"] = "Deposit Add";

	include("templates/depositedit.php");
}

function editDeposit($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Deposit Edit";
	include("templates/depositedit.php");
}

function browseDeposit($id) 
{
   $frm=fillform($id, true);
   $frm["newaction"] = "browse";
	$frm["heading"] = "Deposit Browse";
	include("templates/depositedit.php");
}

function chkdelDeposit($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Deposit Delete";
	include("templates/depositedit.php");
}

function deleteDeposit($id) 
{
   $qry=sprintf(deposit_qry6, $id);
   db_query($qry); 
}

function insertDeposit($frm) 
{
   $qry=sprintf(deposit_qry4, $frm['depositid'],$frm['cmid'],$frm['name'],$frm['percentage'],$frm['refundable'],
   $frm['type']);
	db_query($qry); 
}

function commitDeposit($frm) 
{
   $qry=sprintf(deposit_qry5, $frm['depositid'],$frm['cmid'],$frm['name'],$frm['percentage'],$frm['refundable'],
   $frm['type'],$frm['id']);
   db_query($qry); 
}

function CreateModTable($id)
{
   $cm=new CreateMod();
   $cm->Fill($id);
   $cm->FillTable();
}

function listDeposit()
{  
	$q=$_SESSION["pageindex"]->query(deposit_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";

	print "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Type</h3></td><td><h3>Name</h3></td><td><h3>Margin</h3></td><td><h3>Num Products</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		print "<tr><td>";
		$wibbler=$myrow["id"];
		$n=$myrow["percentage"];
      $nm=$myrow["name"];
      if($nm == "") $nm="Not Set";
      $depid = $myrow["depositid"];
      $nresult=db_query("SELECT count(*) FROM product WHERE depositid = '$depid'");
      $nrow = $nresult->FetchRow();
			
		print "$myrow[type]</td><td>$nm</td><td>$n</td><td>$nrow[0]</td><td>";
		print "<a href=\"deposit.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"deposit.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"deposit.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
				
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "</form>";
	echo "<br><br>";
}

?>
