<?php
/*
inventory.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/currency.php");
require_once($_SESSION['CFG']->libdir."/account.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(inventory_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  

  if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}


switch($_REQUEST['action']){
	case "clear" :
		addInv();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseInv($id);
		break;

	case "edit" :
		editInv($_REQUEST['id']);
		break;
   
   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelInv($_REQUEST['id']);
      }
      else{
         deleteInv($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listInv();
      }
      break;  
	
   case "cfmdelete" :
      deleteInv($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listInv();
		break;

	case "add" :
		insertInv($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listInv();
		break;

	case "commit" :
		commitInv($_POST);
      listInv();
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listInv();
		break;
}
include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(inventory_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
	$frm["id"] = 0;
	$frm["parentid"] = "";
   $frm["categoryid"] = "";
	$frm["parttype"] = "";
	$frm["partnumber"] = "";
	$frm["stocklocation"] = "";
	$frm["description"] = "";
	$frm["instock"] = "";
   $frm["maxstock"] = "";
	$frm["onorder"] = "";
	$frm["rolevel"] = "";
	$frm["roqty"] = "";
	$frm["reservedqty"] = "";
	$frm["leadtime"] = "";
	$frm["partclass"] = "";
	$frm["bqpriceid"] = "";
   $frm["cmid"]="";
	$frm["invlink"] = "";
   
   $frm["quantitynameid"] = "";
   $frm["quantitytypeid"]="";
	$frm["quantity"] = "";
	$frm["udv"] = "";
	$frm["price"] = "";
	$frm["suppliercode"] = "";
	$frm["supplierid"] = "" ;
   $frm["basecurrencyid"]="";
	$frm["accountid"]="";
   
   $frm["TaxID"] = "";
	
	return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(inventory_qry2, $id);
   }
   else{
      $qry=sprintf(inventory_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm["id"] = $id = $row["id"];
	$frm["parentid"] = $row["parentid"];
	$frm["categoryid"] = $row["categoryid"];
	$frm["partnumber"] = $row["partnumber"];
	$frm["parttype"] = $row["parttype"];
	$frm["stocklocation"] = $row["stocklocation"];
	$frm["description"] = $row["description"];
	$frm["instock"] = $row["instock"];
	$frm["maxstock"] = $row["maxstock"];
	$frm["onorder"] = $row["onorder"];
	$frm["rolevel"] = $row["rolevel"];
	$frm["roqty"] = $row["roqty"];
	$frm["reservedqty"] = $row["reservedqty"];
	$frm["leadtime"] = $row["leadtime"];
	$frm["partclass"] = $row["partclassification"];
	$frm["buyquantitypriceid"] = $row["buyquantitypriceid"];
	$frm["cmid"]=$row["cmid"];
	$frm["invlink"] = $row["invlink"];
	$frm["parttype"] = $row["parttype"];
	
	$bqid=$row["buyquantitypriceid"];
	$prodid=getprodID($id);
   $qry=sprintf(product_qry11, $prodid);
	$result=db_query($qry);
	$row = $result->FetchRow();
	
	$frm["prodid"]=$prodid;
	$frm["prodplu"] = $row["plu"];
	$frm["prodbctype"] = $row["plutype"];
	$frm["prodname"] = $row["name"];
	$frm["proddesc"] = $row["description"];
	
   $qry=sprintf(invpq_qry3, $bqid);
   $result=db_query($qry);
	$row = $result->FetchRow();

	$frm["quantitynameid"] = $row["nameid"];
	$frm["invprqid"] = $row["invprqid"];
	$frm["supplierid"] = getsuppid($frm["invprqid"]);
	$frm["quantitytypeid"]=$row["quantitytypeid"];
	$frm["quantity"] = $row["quantity"];
	$frm["udv"] = $row["udv"];
	$frm["price"] = $row["price"];
	$frm["suppliercode"] = $row["suppliercode"];
   $frm["basecurrencyid"]=$row["basecurrencyid"];
	$frm["accountid"]=$row["accountid"];
	$frm["taxid"] = $row["taxid"];
   
	return $frm;
}

function addInv()
{
   $frm=clearform();
	$frm["newaction"] = "add";
   $frm["heading"] = "Inventory Add";

	include("templates/invedit.php");
}

function editInv($id) 
{
	$frm=fillform($id, false);

	$frm["newaction"] = "commit";
   $frm["heading"] = "Inventory Edit";
		
	include("templates/invedit.php");
}

function browseInv($id) 
{
	$frm=fillform($id, true);
	$frm["newaction"] = "browse";
	$frm["heading"] = "Inventory Browse";
	include("templates/invedit.php");
}

function chkdelInv($id) 
{
	$frm = fillform($id, false);
	$frm["newaction"] = "cfmdelete";
	$frm["ID"]=$id;
	$frm["heading"] = "Inventory Delete";
	include("templates/invedit.php");
}

function deleteInv($id)
{
   // acquire the inv details
   $frm=fillform($id, false);
   
   // delete the product and sellpq
   $qry=sprintf(product_qry10, $frm['invid']);
   $result=db_query($qry);
   $row = $result->FetchRow();
   $qry=sprintf(product_qry6, $row['id']);
   db_query($qry);
   
   // !!!CHANGE ME BEFORE v0.9.7!!!
   // this is dangerous as several products can be pointed to a single sell price
   $qry=sprintf(sellpq_qry6, $row['sellquantityid']);
   db_query($qry);
   
   // delete buypq, and inv item
   $qry=sprintf(invpq_qry6, $frm['buyquantitypriceid']);
   db_query($qry);
   $qry=sprintf(inventory_qry10, $frm['invid']);
   db_query($qry);
}

function insertInv($id, $frm) 
{
   $cm=new CreateMod();
   $cm->Fill(0);
   $cmid=$cm->Commit();

   $qry=sprintf(inventory_qry11,0,$frm['categoryid'],$frm['partnumber'],$frm['parttype'],$frm['stocklocation'],
   	$frm['description'],$frm['instock'],$frm['onorder'],$frm['rolevel'],$frm['roqty'],$frm['reservedqty'],
      $frm['leadtime'],$frm['partclass'],$frm['bqpriceid'],$frm['invlink']);
	db_query($qry);
   
   $qry=sprintf(invpq_qry4,$frm['invprqid'],$frm['nameid'],$frm['quantity'],$frm['quantitytypeid'],$frm['udv'],
      $frm['price'],$frm['basecurrencyid'],$frm['supplierid'],$frm['suppliercode'],$frm['ediid'],$frm['accountid'],
      $frm['taxid']);
   db_query($qry); 
   
   $qry=sprintf(misc_qry1);
   $result=db_query($qry); 
   $row = $result->FetchRow();
   $qry=sprintf(inventory_qry12, $row[0]);
   db_query($qry);
}

function commitInv($frm) 
{
   // see if invpq has changed, or exists
   echo var_dump($frm);
   $qry=sprintf(inventory_qry5, $frm['quantitynameid'],$frm['quantity'], $frm['quantitytypeid'], $frm['udv'], $frm['price'], $frm['basecurrencyid'], $frm['supplierid'], $frm['suppliercode'],
      $frm['accountid'], $frm['taxid']);
   $result = db_query($qry);

   if($row = $result->FetchRow()){
      $bqid=$row["id"];
   }
   else{
      $qry=sprintf(inventory_qry5,$frm['quantitynameid'],$frm['quantity'],$frm['quantitytypeid'],$frm['udv'],
         $frm['price'],$frm['basecurrencyid'],$frm['supplierid'],$frm['suppliercode'],$frm['accountid'],$frm['taxid']);
      db_query($qry);

         $result=db_query(misc_qry1);
         $row = $result->FetchRow();
         $bqid=$row[0];
         $qry=sprintf(inventory_qry6, $bqid, $bqid);
         db_query($qry);
   }
   $qry=sprintf(inventory_qry7,$frm['categoryid'],$frm['partnumber'],$frm['parttype'],$frm['stocklocation'],
   	$frm['description'],$frm['instock'],$frm['onorder'],$frm['rolevel'],$frm['roqty'], $frm['reservedqty'],
   	$frm['leadtime'],$frm['partclass'],$bqid,$frm['cmid'],$frm['invlink'],$frm['id']);
	db_query($qry);

   $cm=new CreateMod();
   $cm->Fill($frm['cmid']);
   $cm->Commit();
}

function CreateModTable($id)
{
   $cm=new CreateMod();
   $cm->Fill($id);
   $cm->FillTable();
}

function AccountCombo($action, $id)
{
   $a=new Account();
   $a->Combo($action, $id, "accountid");
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "basecurrencyid");
}


function getQtID($bqp)
{
	$result=db_query("SELECT id FROM invpricequantity  WHERE invprqid  = '$bqp'");
	$myrow = $result->FetchRow();
	return $myrow["id"];
}

function getSuppID($bqp)
{
	$result=db_query("SELECT supplierid from invpricequantity  where invprqid  = '$bqp'");
   $myrow = $result->FetchRow();
	
	$sid=$myrow["supplierid"];

	$result=db_query("SELECT id from supplier where id = '$sid'");
	$srow = $result->FetchRow();
	return $srow["id"];
}

function getprodID($bqp)
{
	$result=db_query("SELECT id from product where invid  = '$bqp'");
	$myrow = $result->FetchRow();
	$prodid=$myrow["id"];
	return $prodid;
}

function getTaxID($bqp)
{
	$result=db_query("SELECT taxid FROM invpricequantity WHERE id  = '$bqp'");
	$myrow = $result->FetchRow();
	$tid=$myrow["taxid"];
	$result=db_query("SELECT id FROM taxrate WHERE id = '$tid'");
	$trow = $result->FetchRow();
	return $trow["id"];
}

function listInv()
{
	$q=$_SESSION["pageindex"]->query(inventory_qry4);
	$result=db_query($q);
        $_REQUEST['action']="list";

	print "<br><br><table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	print "<tr><td><h3>Stock Number</h3></td>\n";
	print "<td><h3>Description</h3></td>";
	print "<td><h3>S</h3></td>";
	print "<td><h3>O</h3></td>";
	print "<td><h3>D</h3></td>";
	print "<td><h3>Action</h3></td>\n</tr>\n";
	
	while($myrow = $result->FetchRow()){
		print "<tr><td>";
		printf ("%02d - %04s", $myrow["categoryid"], $myrow["partnumber"]);
		print "</td>\n<td>";
		$wibbler=$myrow["description"];
		if($wibbler==""){
			$wibbler="No Description";
		}
		$demand=0;
		print "$wibbler</td>\n";
		printf ("<td>%d</td>\n", $myrow["instock"]);
		printf ("<td>%d</td>\n", $myrow["onorder"]);
		printf ("<td>%d</td>\n", $demand);
		print  "<td>\n";
		$id=$myrow["id"];
		$catid=$myrow["categoryid"];
		$qtid=getQtID($myrow["buyquantitypriceid"]);
		$suppid=getSuppID($qtid);
		$taxid=getTaxID($qtid);

		print "<a href=\"inventory.php?action=browse&id=$id\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"inventory.php?action=edit&id=$id&catid=$catid&qtid=$qtid&suppid=$suppid&taxid=$taxid\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"inventory.php?action=delete&id=$id\">".misc_listdelete."</a>&nbsp; \n";
				
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";

}

?>
