<?php
/*
productwiz.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($frm["pagecount"])){
	$frm["pagecount"]=1;
}

if(!isset($pagemax)){
	$pagemax=4;
	$frm["pagemax"] = $pagemax;	
}

switch($_REQUEST['action']){
	default:
	case "start" :
		fillPage();
		break;

	case "next" :
		nextPage($HTTP_POST_VARS);
		break;

	case "finish" :
		commitProduct($HTTP_POST_VARS);
		break;
}

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function clearform()
{
   $frm["name"] = '';
   $frm["description"] = '';
   $frm["buydescription"] = '';
   $frm["plu"] = '';
   $frm["reciepttext"] = '';
   $frm["productid"] = '';
   $frm["invid"] = '';
   $frm["plutype"] = 'ean-13';
   $frm["instock"] = '';
   $frm["onorder"]= "";
   $frm["rolevel"] = "";
   $frm["roqty"] = "";
   $frm["leadtime"] = "";
   $frm["reservedqty"] = "";
   $frm["maxstock"] = "";
   $frm["discontinued"] = 'n';
   $frm["imageid"] = '';
   $frm["labelid"] = '';
   $frm["discountid"] = '';
   $frm["rentable"] = '0';
   $frm["depositid"] = '';
   $frm["ecommerce"] = '0';
   $frm["sellquantityid"] = '';
   $frm["numpromo"] = 'n';
   $frm["flags"] = '';
   $frm["productlink"] = '';
   $frm["keywords"] = '';
   $frm["buytaxid"] = '';
   $frm["taxid"] = '';
   $frm["ediid"] = '';
   $frm["accountid"] = '';
   $frm["basecurrencyid"] = '0'; 
   return $frm;
}

function fillPage()
{
	$frm=clearform();
	$frm["pagecount"]=1;
	include("templates/productwiz1.php");
}

function nextPage($frm)
{
	$pagecount=$frm["pagecount"];


	switch($pagecount){
	case 2:
      $frm["rentable"]=yesno(isset($frm["rentable"]));
	   $frm["ecommerce"]=yesno(isset($frm["ecommerce"]));
	   $result = db_query("SELECT id, plu, name, description FROM product where plu='$frm[plu]'");
		if($row = $result->FetchRow()){
		   $frm["id"]=$row["id"];
         $frm["name"]=$row["name"];
         $frm["description"]=$row["description"];
         $frm["plu"]=$row["plu"];
         include("templates/productexists.php");
         return;
		}  
		$frm["buydescription"]=$frm["description"];
		include("templates/productwiz2.php");
		break;
	case 3:
		include("templates/productwiz3.php");
		break;
	case 4:
		include("templates/productwiz4.php");
		break;
	case 5:
		include("templates/productwiz5.php");
		break;
	}
}

function fillform($id)
{
   $result=db_query("SELECT * FROM posts WHERE id = '$id'");
	$row = $result->FetchRow();
	
	$frm["id"] = $id;
   $frm["mac"] = $row["mac"];
   $frm["groupid"] = $row["groupid"];
   $frm["interfaceid"] = $row["interfaceid"];
   $frm["localeid"] = $row["localeid"];
   $frm["currencyid"] = $row["currencyid"];
   $frm["active"] = $row["active"];

   $if=$row["interfaceid"];
   $gid=$row["groupid"];
   $bcid = $row["currencyid"];

	if(!isset($bcid) || $bcid==0){
		$frm["currname"]="Not Set";
	}
	else{
		$result=db_query("select country, bigname from currency where id = '$bcid'");
		$row = $result->FetchRow();
		$frm["currname"]=$row["country"]. " - " . $row["bigname"];
	}
   
   if($if < 2){
      $frm["ifname"]="Not Set";
   }
   else{
      $result=db_query("select name from interface where id = '$if'");
	   $row = $result->FetchRow();
      $frm["ifname"]=$row["name"];
   }
   
   if($gid < 2){
      $frm["groupname"]="Not Set";
   }
   else{
      $result=db_query("select name from groups where id = '$gid'");
   	$row = $result->FetchRow();
      $frm["groupname"]=$row["Name"];
   }
   
   return $frm;
}


function commitProduct($frm) 
{
	// 1. Add buy price/quantity if it doesn't exist...
	$bqid=insertinvpq($frm);


	// 2. Add sell price/quantity if it doesn't exist...
	$pqid=insertprodpq($frm);

	// 3. insert inventory.
        db_query("INSERT INTO createmod VALUES(
                        '',
                        NOW(),
                        NOW(),
                        '$_SESSION[misuser]->GetEmployee',
                        '$_SESSION[misuser]->GetEmployee')");
        $cmid=db_insert_id();

	$result = db_query("INSERT INTO inventory VALUES(
			'',
			'',
			'$frm[catid]',
			'$frm[partnumber]',
			'0',
			'',
			'$frm[buydescription]',
			'$frm[instock]',
			'$frm[maxstock]',
			'$frm[onorder]',
			'$frm[rolevel]',
			'$frm[roqty]',
			'$frm[reservedqty]',
			'$frm[leadtime]',
			0,
			'$bqid',
			'$cmid',
			'0')");
	$invid=db_insert_id();

	// 4. insert product

	$result = db_query("insert into product values(
			'',
			'0',
			'$invid',
			'$frm[catid]',
			0,
			'$frm[plu]',
			'EAN-13',
			'$frm[name]',
			'$frm[description]',
			'0',
			'n',
			'0',
			'$frm[reciepttext]',
			0,
			'$pqid',
			0,
			0,
			'$frm[rentable]',
			0,
			'$frm[ecommerce]',
			0,
			0,
			'$frm[keywords]')");
	$prodid=db_insert_id();

	// 5. Slip in a cache entry so the product may be sold immediately
	$result=db_query("select rate from taxrate where id='$frm[taxid]'");
	$row=$result->FetchRow();
	db_query("insert into plu_cache values(
			'',
			'$prodid',
			'1',
			'$frm[plu]',
			'$frm[description]',
			'$frm[reciepttext]',
			'$frm[price]',
			'0',
			'0',
			'0',
			'$row[rate]',
			'0')");

	// 6. done... redirect to page...
	$frm["ID"]=$prodid;
	include("templates/wizsucess.php");
	
}

function DateControl($a, $d)
{  
   $td=new TimeDate();
   $td->parse($d);
   $td->datecontrol($a, "");
}


?>
