<?php
/*
returnsr.php

Copyright (C)2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(returntype_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}
   
switch($_REQUEST['action']){
	case "clear" :
		addReturn();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseReturn($id);
		break;

	case "edit" :
		editReturn($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelReturn($_REQUEST['id']);
      }
      else{
         deleteReturn($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listReturn();
      }
      break;  
	
   case "cfmdelete" :
      deleteReturn($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listReturn();
		break;

	case "add" :
		insertReturn($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listReturn();
		break;

	case "commit" :
		commitReturn($_POST);
		listReturn();
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listReturn();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(returntype_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"] = 0;
   $frm["name"] = "";
   $frm["active"] = "N";
   
   return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(returntype_qry2, $id);
   }
   else{
      $qry=sprintf(returntype_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["id"] = $id;
   $frm["name"] = $row["name"];
   $frm["active"] = $row["active"];

   return $frm;
}

function addReturn()
{
   $frm=clearform();
	$frm["newaction"] = "add";
   $frm["heading"] = "Return Type Add";

	include("templates/returntypeedit.php");
}

function editReturn($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Return Type Edit";
	include("templates/returntypeedit.php");
}

function browseReturn($id) 
{
   $frm=fillform($id, true);
   $frm["newaction"] = "browse";
	$frm["heading"] = "Return Type Browse";
	include("templates/returntypeedit.php");
}

function chkdelReturn($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Return Type Delete";
	include("templates/returntypeedit.php");
}

function deleteReturn($id) 
{
   $qry=sprintf(returntype_qry6, $id);
   db_query($qry); 
}

function insertReturn($frm) 
{
   $qry=sprintf(returntype_qry4, $frm['name'],yn($frm['active']));
	db_query($qry);
}

function commitReturn($frm) 
{
   $qry=sprintf(returntype_qry5, $frm['name'],yn($frm['active']), $frm['id']);
   db_query($qry);
}

function listReturn()
{  
	$q=$_SESSION["pageindex"]->query(returntype_qry7);
	$result=db_query($q);

	print "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Active</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		print "<tr><td>";
		if($myrow["name"]){
			$wibbler=$myrow["id"];
			$n=$myrow["active"];
			
			printf("%s</td><td>$n</td><td>", $myrow["name"]);
			print "<a href=\"returnstype.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
			print "<a href=\"returnstype.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
			print "<a href=\"returnstype.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		}		
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "</form>";
	echo "<br><br>";
}
?>
