<?php
/*
sellpq.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/currency.php"); 
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(sellpq_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

   
switch($_REQUEST['action']){
	case "clear" :
		addSellPrice();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseSellPrice($id);
		break;

	case "edit" :
		editSellPrice($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelSellPrice($_REQUEST['id']);
      }
      else{
         deleteSellPrice($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listSellPrice();
      }
      break;  
	
   case "cfmdelete" :
      deleteBank($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listBank();
		break;

	case "add" :
		insertSellPrice($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listSellPrice();
		break;

	case "commit" :
		commitSellPrice($_POST);
		listSellPrice();
		break;

	case "all" :
		allSellPrice();
		break;

	case "commitall":
		allSellPriceCommit($_POST);
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listSellPrice();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(sellpq_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"]="";
   $frm["pqid"]="";
   $frm["nameid"]="";
   $frm["quantity"]="";
   $frm["quantitytypeid"]="";
   $frm["udv"]="";
   $frm["price"]="";
   $frm["basecurrencyid"]="";
   $frm["taxid"]="";
   
   return $frm;
}

function fillform($id, $bOffset)
{
   
   if($bOffset){
      $qry=sprintf(sellpq_qry2, $id);
   }
   else{
      $qry=sprintf(sellpq_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
	
   $frm["id"]=$id;
   $frm["pqid"]=$row["pqid"];
   $frm["nameid"]=$row["nameid"];
   $frm["quantity"]=$row["quantity"];
   $frm["quantitytypeid"]=$row["quantitytypeid"];
   $frm["udv"]=$row["udv"];
   $frm["price"]=$row["price"];
   $frm["basecurrencyid"]=$row["basecurrencyid"];
   $frm["taxid"]=$row["taxid"];
  
   return $frm;
}

function addSellPrice()
{
   $frm=clearform();
	$frm["newaction"] = "add";
	$frm["id"] = "Auto number";
   $frm["heading"] = "Sell Price Quantity Add";

	include("templates/spedit.php");
}

function editSellPrice($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Sell Price Quantity Edit";
	include("templates/spedit.php");
}

function browseSellPrice($id) 
{
   $frm=fillform($id, true);
   $frm["newaction"] = "browse";
   $frm["heading"] = "Sell Price Quantity Browse";
	
	include("templates/spedit.php");
}

function chkdelSellPrice($id) 
{
   $frm=fillform($id, false);
   $frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Sell Price Quantity Delete";
   
   include("templates/spedit.php");
}


function deleteSellPrice($id) 
{
   $qry=srpintf(sellpq_qry6, $id);
   db_query($qry);
}

function insertSellPrice($frm) 
{
   $qry=sprintf(sellpq_qry4,$frm['pqid'],$frm['nameid'],$frm['quantity'],$frm['quantitytypeid'],$frm['udv'],
   $frm['price'],$frm['basecurrencyid'],$frm['taxid']);
	db_query($qry);
}

function commitSellPrice($frm) 
{
   $qry=sprintf(sellpq_qry5,$frm['pqid'],$frm['nameid'],$frm['quantity'],$frm['quantitytypeid'],$frm['udv'],
   $frm['price'],$frm['basecurrencyid'],$frm['taxid'],$frm['id']);
	db_query($qry);
}

function fillDependantProducts($id)
{
   $qry=sprintf(sellpq_qry8,$id);
   $result=db_query($qry);
   $ret=db_num_rows($result);
   print "<tr><td colspan=\"2\" align=\"center\"><h3>Dependant Products - $ret items</h3></td></tr>\n";
   while($r = $result->FetchRow()){
      print "<tr><td colspan=\"2\"><a href=\"product.php?action=browse&id=$r[0]\">$r[1] - $r[2]</a></td></tr>\n";
   }
}

function allSellPrice()
{
	$frm["newaction"] = "commitall";
	include("templates/spall.php");	
}

function allSellPriceCommit($frm)
{
	$p=$frm["value"];

	if($p < 0){
		$p=abs($p);
		echo "<br><br><center><i><h3>All sales prices have been reduced by $p%</h3></i></center>";
	}
	else{
		echo "<br><br><center><i><h3>All sales prices have been increased by $p%</h3></i></center>";
	}
   $n=$p/100;
   echo "p change $n";
   $qry=sprintf(sellpq_qry9,$n);
   db_query($qry);
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "basecurrencyid");
}

function listSellPrice()
{
	$q=$_SESSION["pageindex"]->query(sellpq_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";

	print "<br><table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Quantity</h3></td><td><h3>Packs Of</h3></td><td><h3>Price</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		print "<tr><td>";
		if($myrow["price"]){
			$wibbler=$myrow["id"];
			$n=$myrow["price"];
			$q=$myrow["quantity"];
			$p=$myrow["udv"];
			print "$q</td><td>$p</td><td>$n</td><td>";
			print "<a href=\"sellpq.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
			print "<a href=\"sellpq.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
			print "<a href=\"sellpq.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		}		
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "</form>";
	echo "<br><br>";
}

?>
