<?php
/*
spqname.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/account.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(sellpqname_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}


switch($_REQUEST['action']){
	case "clear" :
		addspqname();
		break;

	case "browse":
		$id=updateNav($_POST);
		browsespqname($id);
		break;

	case "edit" :
		editspqname($_REQUEST['id']);
		break;
   
   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelspqname($_REQUEST['id']);
      }
      else{
         deletespqname($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listspqname();
      }
      break;  
	
   case "cfmdelete" :
      deletespqname($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listspqname();
		break;

	case "add" :
		insertspqname($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listspqname();
		break;

	case "commit" :
		commitspqname($_POST);
		listspqname();
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listspqname();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(sellpqname_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "";
	$frm["name"] = "";
	$frm["accountid"] = "";
	$frm["onmenu"] = "";

	return $frm;
}

function fillForm($id, $bOffset)
{
   
   if($bOffset){
      $qry=sprintf(sellpqname_qry2, $id);
   }
   else{
      $qry=sprintf(sellpqname_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm["id"] = $id;
	$frm["name"] = $row["name"];
	$frm["accountid"] = $row["accountid"];
	$frm["onmenu"] = $row["onmenu"];

	return $frm;
}

function addspqname()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = "Sell Price Name Add";
	
	include("templates/spqnedit.php");
}

function editspqname($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Sell Price Name Edit";
		
	include("templates/spqnedit.php");
}

function browsespqname($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Sell Price Name Browse";
		
	include("templates/spqnedit.php");
}

function chkdelspqname($id)
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Sell Price Name Delete";
		
	include("templates/spqnedit.php");
}

function deletespqname($id) 
{
   $qry=sprintf(sellpqname_qry6, $id);
	db_query($qry);
}

function insertspqname($frm) 
{
   $qry=sprintf(sellpqname_qry4, $frm['name'],$frm['accountid'],yn($frm['onmenu']));
	db_query($qry);
}

function commitspqname($frm) 
{
   $qry=sprintf(sellpqname_qry5, $frm['name'],$frm['accountid'],yn($frm['onmenu']),$frm['id']);
	db_query($qry);
}

function fillAccountNameCombo($a, $id)
{
   $acc=new Account();
   $acc->Combo($a, $id, "accountid");
}

function listspqname()
{
	$q=$_SESSION["pageindex"]->query(sellpqname_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Account</h3></td><td><h3>On Menu</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		$wibbler=$row["id"];
		$n=$row["name"];
		$om=$row["onmenu"];

		$nid=$row["accountid"];
		$nresult=db_query("SELECT * from account WHERE accountnumber='$nid'");
		if($nrow = $nresult->FetchRow())
		   $an=$nrow["name"];
      else
         $an="Not Set";

		print "<tr><td>$n</td><td>$an</td><td>\n";
		if($om=="Y"){
			print "<input type=\"checkbox\" name=\"onmenu\" value=\"Y\" checked> On Menu";
		}
		else{
			print "<input type=\"checkbox\" name=\"onmenu\" value=\"Y\"> On Menu";
		}
		print "</td><td>\n";
		print "<a href=\"spqname.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"spqname.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"spqname.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
