<?php
/*
config.php

Copyright (C)2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/conf.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], system_cnf_pagetitle)!=0){
   $_SESSION['title']=system_cnf_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}


switch($_REQUEST['action']){
	case "client" :
		clientconfig();
		break;

	case "server":
		serverconfig();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function clientconfig()
{
   $c=new conffile("/etc/bhpos/post.conf");
   $s=$c->enum_sections();
   echo "<br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
   echo "<tr><td colspan=\"3\" align=\"center\"><h1>Post Configuration</h1></td></tr>\n";
	echo "<tr><td><h2>Key</h2><td colspan=\"2\"><h2>Value</h2></td>\n";
   
   foreach($s as $section){
      echo "<tr><td colspan=\"3\" align=\"left\"><h3>$section</h3></td></tr>\n";
       
      $k=$c->enum_keys($section);
      foreach($k as $key){
         echo "<tr><td>$key</td>\n";
         $v=$c->get_key($section, $key);
         if($v!=false){
            echo "<td>$v</td>\n";
         }
         else{
            echo "<td>&nbsp;</td>\n";
         }
         if($_SESSION['CFG']->onlinehelp){
            echo "<td><input id=hsubmit type=button name=\"namehelp\" value=\" ? \" onclick=\"show_help('confpost_$key');\"></td>";
         }
         echo "</tr>\n";
      }
   }
   echo "</table>\n";
}

function serverconfig()
{
   $c=new conffile("/etc/bhpos/plusd.conf");
   $s=$c->enum_sections();
   echo "<br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
   echo "<tr><td colspan=\"3\" align=\"center\"><h1>Plusd Configuration</h1></td></tr>\n";
	echo "<tr><td><h2>Key</h2><td colspan=\"2\"><h2>Value</h2></td>\n";
   
   foreach($s as $section){
      echo "<tr><td colspan=\"3\" align=\"left\"><h3><i>$section</i></h3></td></tr>\n";
       
      $k=$c->enum_keys($section);
      foreach($k as $key){
         echo "<tr><td>$key</td>\n";
         $v=$c->get_key($section, $key);
         if($v!=false){
            echo "<td>$v</td>\n";
         }
         else{
            echo "<td>&nbsp;</td>\n";
         }
         if($_SESSION['CFG']->onlinehelp){
            echo "<td><input id=hsubmit type=button name=\"namehelp\" value=\" ? \" onclick=\"show_help('confplusd_$key');\"></td>";
         }
         echo "</tr>\n";
      }
   }
   echo "</table>\n";
}

?>
