<?php
/*
default.php

Copyright (C)2003 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], system_def_pagetitle)!=0){
   $_SESSION['title']=system_def_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "cashdrawer" :
		cashdrawer();
		break;

	case "currency":
		currency();
		break;
      
   case "locale":
      locale();
      break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function cashdrawer()
{
   echo "<blockquote><div align=\"left\"><b>Default Cash Drawer Float</b></div>\n
         <div align=\"left\">This feature sets up the default cash drawer contents for a station.</div>\n
         <div align=\"left\">In general this would be performed when a cash drawer inner is inserted or changed.
         Usually this is at the start of day, and on a user change in active mode.</div>\n
         <div align=\"left\">This default is to simplify operation, a different amount can be set at any time.
         Or even forced during operation (though this isn't recommended).</div>\n
         <div align=\"left\">&nbsp;</div>\n<div align=\"left\">This page isn't done yet, as it relies on two other pages which are
         themselves incomplete: <ul><li>Currency Editing<li>Monetary Units Editing</ul></div>
         <div align=\"left\">This page is scheduled for v0.9.8.</div></blockquote>";
}

function currency()
{
   echo "<blockquote><div align=\"left\"><b>Default Currency</b></div>\n
   <div align=\"left\">This page is scheduled for v0.9.8.</div></blockquote>";
}
      
function locale()
{
   echo "<blockquote><div align=\"left\"><b>Default Locale</b></div>\n
   <div align=\"left\">This page is scheduled for v0.9.8.</div></blockquote>";
}

?>
