<?php
/*
synchtype.php

Copyright (C)2003 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], system_synctype_pagetitle)!=0){
   $_SESSION['title']=system_synctype_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(synchtype_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addSyncType();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseSyncType($id);
		break;

	case "edit" :
		editSyncType($_REQUEST['id']);
		break;
   
   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelSyncType($_REQUEST['id']);
      }
      else{
         deleteSyncType($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listSyncType();
      }
      break;  
	
	case "cfmdelete" :
		deleteSyncType($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listSyncType();
		break;

	case "add" :
		insertSyncType($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listSyncType();
		break;

	case "commit" :
		commitSyncType($_POST);
      listSyncType();
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listSyncType();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(synchtype_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["id"] = "";
   $frm["name"] = "";
 
   return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(synchtype_qry2, $id);
   }
   else{
      $qry=sprintf(synchtype_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["id"] = $id;
   $frm["name"] = $row["name"];
   
	return $frm;
}

function addSyncType()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	$frm["ID"] = "";
   $frm["heading"] = "Synch Type Add";

	include("templates/synchtypeedit.php");
}

function editSyncType($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Synch Type Edit";

	include("templates/synchtypeedit.php");
}

function browseSyncType($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Synch Type Browse";
	
	include("templates/synchtypeedit.php");
}

function chkdelSyncType($id)
{
   $frm=fillForm($id, false);
   $frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Confirm Sync Type Delete";
	include("templates/synchtype.php");
}

function deleteSyncType($id) 
{
   $qry=sprintf(synchtype_qry4, $id);
   db_query($qry);
}

function insertSyncType($frm) 
{
   $qry=sprintf(synchtype_qry5, $frm['name']);
	db_query($qry);
}

function commitSyncType($frm) 
{
   $qry=sprintf(synchtype_qry6, $frm['name'], $frm['id']);
	db_query($qry);
}

function listSyncType()
{
	$q=$_SESSION["pageindex"]->query(synchtype_qry7);
	$result=db_query($q);

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		$n=$row["name"];
		print "<tr><td>$n</td>";
		print "<td>";
		$wibbler=$row["id"];
		print "<a href=\"synchtype.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"synchtype.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"synchtype.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
