<?php
/*
litypes.php

Copyright (C)2004  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/auth.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['titleimg']) || $_SESSION['titleimg']!=$_SESSION['CFG']->imagedir."/tlt_user.png"){
   $_SESSION['titleimg'] = $_SESSION['CFG']->imagedir."/tlt_user.png";
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(litype_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}
 
switch($_REQUEST['action']){
	case "clear" :
		addLitype();
		break;
		
	case "browse" :
      $id=updateNav($_POST);
		browseLitype($id);
		break;

	case "edit" :
		editLitype($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelLitype($_REQUEST['id']);
      }
      else{
         deleteLitype($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listLitype($_REQUEST['id']);
      }
		break;
      
   case "cfmdelete" :
      deleteLitype($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listLitype();
		break;

	case "add" :
		insertAuth($_POST);
      $_SESSION["pageindex"]->setnum(CountNum());
		listLitype();
		break;

	case "commit" :
		commitLitype($_POST);
		listLitype();
		break;

	case "list" :
	default :
      $id=updateNav($_POST);
		listLitype();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(litype_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm['id'] = 0;
   $frm['litdata'] = BHSQL_LOGINMETHOD_DATA;
   $frm['Name'] = "" ;

   return $frm;
}

function fillform($id, $bOffset)
{

	if($bOffset){
      $qry=sprintf(litype_qry2, $id);
   }
   else{
      $qry=sprintf(litype_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm['id'] = $id;
   $frm['litdata'] = $row['litdata'];
   $frm['name'] = $row['name'];
   
	return $frm;
}

function addLitype() 
{
   $frm=clearForm();
   $frm["newaction"] = "add";
   $frm["heading"] = "Login Method Add";

	include("templates/litypeedit.php");   
}

function browseLitype($id) 
{
	$frm = fillform($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Login Method Browse";

	include("templates/litypeedit.php");
}

function editLitype($id) 
{
	$frm = fillform($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Login Method Edit";

	include("templates/litypeedit.php");
}

function deleteLitype($id) 
{
   $qry=sprintf(litype_qry7, $id);
   db_query($qry);
}

function chkdelLitype($id)
{
   $frm = fillform($id, false);
   $frm['ID'] = $id;
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Login Method Edit";
   include("templates/litypeedit.php");
}

function insertAuth($frm) 
{
   $qry=sprintf(litype_qry5, $frm['name'],$frm['litdata']);
	db_query($qry);
}

function commitLitype($frm) 
{
	$qry=sprintf(litype_qry6,$frm['name'],$frm['litdata'],$frm['id']);
	db_query($qry);
}


function listLitype()
{
   $q=$_SESSION["pageindex"]->query(litype_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Type</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		$n=$myrow["name"];
		print "<tr><td>$n</td>";
		print "<td>";
		$wibbler=$myrow["id"];
      switch($myrow['litdata']){
      case BHSQL_LOGINMETHOD_DATA: echo "Data"; break;
      case BHSQL_LOGINMETHOD_PTR: echo "Pointer"; break;
      case BHSQL_LOGINMETHOD_PAIR: echo "Pair"; break;
      }
      echo "</td><td>\n";
		print "<a href=\"litypes.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"litypes.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"litypes.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
