<?php
include("../bhmis.php");

if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['titleimg']) || $_SESSION['titleimg']!=$_SESSION['CFG']->imagedir."/tlt_station.png"){
   $_SESSION['titleimg'] = $_SESSION['CFG']->imagedir."/tlt_station.png";
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(misinterface_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}
 
switch($_REQUEST['action']){
	case "clear" :
		addInterface();
		break;
		
	case "browse" :
      $id=updateNav($_POST);
		browseInterface($id);
		break;

	case "edit" :
		editInterface($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelInterface($_REQUEST['id']);
      }
      else{
         deleteInterface($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listInterface($_REQUEST['id']);
      }
		break;
      
   case "cfmdelete" :
      deleteInterface($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listInterface();
		break;

	case "add" :
		insertInterface($_POST);
      $_SESSION["pageindex"]->setnum(CountNum());
		listInterface();
		break;

	case "commit" :
		commitInterface($_POST);
		listInterface();
		break;

	case "list" :
	default :
      $id=updateNav($_POST);
		listInterface();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(misinterface_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm['id'] = 0;
   $frm['name'] = "" ;
   $frm['description'] = "";

   return $frm;
}

function fillform($id, $bOffset)
{

	if($bOffset){
      $qry=sprintf(misinterface_qry2, $id);
   }
   else{
      $qry=sprintf(misinterface_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm['id'] = $id;
   $frm['name'] = $row['name'];
   $frm['description'] = $row['description'];

	return $frm;
}

function addInterface() 
{
   $frm=clearForm();
   $frm["newaction"] = "add";
   $frm["heading"] = "MIS Interface Add";

	include("templates/misifedit.php");   
}

function browseInterface($id) 
{
	$frm = fillform($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "MIS Interface Browse";

	include("templates/misifedit.php");
}

function editInterface($id) 
{
	$frm = fillform($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "MIS Interface Edit";

	include("templates/misifedit.php");
}

function deleteInterface($id) 
{
   $qry=sprintf(misinterface_qry7, $id);
	db_query($qry);
}

function chkdelInterface($id)
{
   $frm = fillform($id, false);
   $frm["newaction"] = "cfmdelete";
   $frm["id"] = $id;
   $frm["heading"] = "MIS Interface Delete";
   
	include("templates/misifedit.php");
}

function insertInterface($frm) 
{
   $qry=sprintf(misinterface_qry5, $frm['name'],$frm['description']);
	db_query($qry);
}

function commitInterface($frm) 
{
	$qry=sprintf(misinterface_qry6, $frm['name'],$frm['description'],$frm['id']);
	db_query($qry);
}

function listInterface()
{
   $q=$_SESSION["pageindex"]->query(misinterface_qry4);
	$result=db_query($q);
   $frm["newaction"] = "list";
   
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Description</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		$wibbler=$row["id"];
		print "<tr><td>$row[Name]</td>\n<td>$row[Description]</td>\n<td>";
		print "<a href=\"misinterface.php?action=clear\">add</a>&nbsp;\n";
		print "<a href=\"misinterface.php?action=edit&id=$wibbler\">edit</a>&nbsp; \n";
		print "<a href=\"misinterface.php?action=delete&id=$wibbler\">delete</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
