<?php
/*
 * itemtype.php
 *
 * @version	0.9.6
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2003 Al Kingsley
 * @package	MIS
 * @access	public
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}
if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], bank_pagetitle)!=0){
   $_SESSION['title']=bank_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(bankitem_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addItem();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseItem($id);
		break;

	case "edit" :
		editItem($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelItem($_REQUEST['id']);
      }
      else{
         deleteCategory($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listItem();
      }
      break;  
	
   case "cfmdelete" :
      deleteItem($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listItem();
		break;

	case "add" :
		insertItem($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listItem();
		break;

	case "commit" :
		commitItem($_POST);
      listItem();
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listItem();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(bankitem_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = 0;
	$frm["name"] = "";

	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(bankitem_qry2, $id);
   }
   else{
      $qry=sprintf(bankitem_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm["id"] = $row["id"];
	$frm["name"] = $row["name"];

	return $frm;
}

function addItem()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = bank_item_add;
	
	include("templates/itemedit.php");
}

function editItem($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = bank_item_edit;

	include("templates/itemedit.php");
}

function browseItem($id) 
{
	$frm=fillForm($id, true);

	$frm["newaction"] = "browse";
   $frm["heading"] = bank_item_browse;
	
	include("templates/itemedit.php");
}

function insertItem($frm) 
{
   $qry=sprintf(bankitem_qry4, $frm['name']);
	db_query($qry);
}

function commitItem($frm) 
{
   $qry=sprintf(bankitem_qry5, $frm['name'], $frm['id']);
   db_query($qry);
}

function chkdelItem($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["heading"] = bank_item_delete;
   $frm["newaction"] = "cfmdelete";
   
   include("templates/itemedit.php");
}

function deleteItem($id) 
{
   $qry=sprintf(bankitem_qry6, $id);
   db_query($qry);
}

function listItem()
{  
	$q=$_SESSION["pageindex"]->query(bankitem_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
	echo "<table class=\"list\">\n";
	echo "<tr><td class=\"listtitle\">Item Type Name</td><td class=\"listtitle\">Action</td></tr>";
	while($myrow = $result->FetchRow()){
		echo "<tr><td>";
		echo $myrow["name"];
		echo "</td>\n<td>";
		$wibbler=$myrow["id"];
		print "<a href=\"itemtype.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"itemtype.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"itemtype.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
