<?php
/*
acc.php

Copyright (C)2002 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/account.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], company_acc_pagetitle)!=0){
   $_SESSION['title']=company_acc_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION['pageindex']->CheckNum(account_qry1)){
   $_SESSION['pageindex']->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addAccount();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseAccount($id);
		break;

	case "edit" :
		editAccount($id);
		break;

	case "delete" :
		chkdelAccount($id);
		break;

	case "cfmdelete" :
		deleteAccount($id);
      $_SESSION["pageindex"]->deletion(CountNum());
		break;

	case "add" :
		insertAccount($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		break;

	case "commit" :
		commitAccount($id, $_POST);
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listAccount();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(account_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "0";
   $frm["parentid"] = "0";
	$frm["accountnumber"] = "";
	$frm["name"]="";
   $frm["title"]=0;
	$frm["gref"] = "";
   
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(account_qry2, $id);
   }
   else{
      $qry=sprintf(account_qry3, $id);
   }
   $frm=clearForm();
	$result=db_query($qry);
	if($row = $result->FetchRow()){
      $frm["id"] = $id;
      $frm["parentid"] = $row["parentid"];
      $frm["accountnumber"] = $row["accountnumber"];
	   $frm["name"] = $row["name"];
   	$frm["title"] = $row["title"];
	   $frm["gref"] = $row["gref"];
	}
   return $frm;
}

function addAccount()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = "Account Add";
   
	include("templates/accedit.php");
}

function editAccount($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Account Edit";

	include("templates/accedit.php");
}

function browseAccount($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Account Browse";

	include("templates/accedit.php");
}

function insertAccount($frm) 
{
	$qry=sprintf(account_qry5,$frm['parentid'],$frm['accountnumber'],$frm['name'],$frm['title'],$frm['gref']);
	db_query($qry);
}

function commitAccount($id, $frm) 
{
   $qry=sprintf(account_qry6,$frm['parentid'],$frm['accountnumber'],$frm['name'],$frm['title'],$frm['gref'],$id);
	db_query($query);
}

function deleteAccount($id) 
{
   $qry=sprintf(account_qry7,$id);
	db_query($query);
}

function fillHeadingCombo($a, $id)
{
   $acc=new Account();
   $acc->HeadingCombo($a, $id, "title");
}

function fillParentCombo($a, $id)
{
   $acc=new Account();
   $acc->Combo($a, $id, "parentid");
}

function listAccount()
{
   $q=$_SESSION["pageindex"]->query(account_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	
	echo "<tr><td><h3>Account Name</h3></td><td><h3>Action</h3></td></tr>";
	$hid=1;
	$hresult=db_query("SELECT name from accountheading WHERE id='$hid'");
	$hmyrow = $hresult->FetchRow();
	$heading=$hmyrow["name"];
	echo "<tr><td colspan=\"2\"><h3>$heading</h3></td></tr>\n";

	while($row = $result->FetchRow()){
		if($row["title"]!=$hid){
			$hid=$row["title"];
			$hresult=db_query("SELECT name from accountheading WHERE id='$hid'");
			$hrow = $hresult->FetchRow();
			$heading=$hrow["name"];
			echo "<tr><td colspan=\"2\"><h3>$heading</h3></td></tr>\n";
		}
		$n=$row["name"];
		print "<tr><td>$n</td>";
		print "<td>";
		$wibbler=$row["id"];
		print "<a href=\"acc.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"acc.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"acc.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
