<?php
/*
acchead.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/account.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], company_acch_pagetitle)!=0){
   $_SESSION['title']=company_acch_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(acchead_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addAh();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseAh($id);
		break;

	case "edit" :
		editAh($id);
		break;

	case "delete" :
		deleteAh($id);
      $_SESSION["pageindex"]->deletion(CountNum());
		listAh();
		break;

	case "add" :
		insertAh($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listAh();
		break;

	case "commit" :
		commitAh($id, $_POST);
		listAh();
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listAh();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(acchead_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "0";
	$frm["name"] = "";
	$frm["sref"] = "";
	$frm["eref"] = "";
	$frm["gref"] = "";
	$frm["type"] = 0;

	return $frm;
}
function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(acchead_qry2, $id);
   }
   else{
      $qry=sprintf(acchead_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

   $frm["id"] = $id;
   $frm["name"] = $row["name"];
	$frm["sref"] = $row["sref"];
	$frm["eref"] = $row["eref"];
	$frm["gref"] = $row["gref"];
	$frm["type"] = $row["type"];
	$frm["newaction"] = "commit";
   
   return $frm;
}

function addAh()
{
   $frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = "Account Heading Add";
	
	include("templates/accheadedit.php");
}

function editAh($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Account Heading Edit";
	
	include("templates/accheadedit.php");
}

function browseAh($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	$frm["heading"] = "Account Heading Browse";
   
	include("templates/accheadedit.php");
}

function insertAh($frm) 
{
   $qry=sprintf(acchead_qry4, $frm['name'],$frm['sref'],$frm['eref'],$frm['gref'],$frm['type']);
	db_query($qry);	
}

function commitAh($id, $frm) 
{
   $qry=sprintf(acchead_qry5, $frm['name'],$frm['sref'],$frm['eref'],$frm['gref'],$frm['type'],$id);
	db_query($qry);
}

function deleteAh($id) 
{
   $qry=sprintf(acchead_qry6,$id);
	db_query($qry);
}

function fillHeadingTypeCombo($a, $id)
{
   $acc=new Account();
   $acc->TypeCombo($a, $id, "type");
}

function listAh()
{
   $typelist=array(0=>'Income',1=>'Expense',2=>'Asset',3=>'Liability',4=>'Capital');
	
	$q=$_SESSION["pageindex"]->query(acchead_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Type</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		$n=$myrow["name"];
      $t=$myrow["type"];
      $type=$typelist[$t];
		
		print "<tr><td>$n</td><td>$type</td><td>";
		$wibbler=$myrow["id"];
		print "<a href=\"acchead.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"acchead.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"acchead.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
