<?php
/*
emp.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/address.php");
require_once($_SESSION['CFG']->libdir."/contact.php");
require_once($_SESSION['CFG']->libdir."/createmod.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], company_emp_pagetitle)!=0){
   $_SESSION['title']=company_emp_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(emp_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addEmp();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseEmp($id);
		break;

	case "edit" :
		editEmp($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelEmp($_REQUEST['id']);
      }
      else{
         deleteBank($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listEmp();
      }
		break;

	case "cfmdelete" :
		deleteEmp($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
		listEmp();
		break;

	case "add" :
		insertEmp($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listEmp();
		break;

	case "commit" :
		commitEmp($_POST);
		listEmp();
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listEmp();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(emp_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["id"] = "";
   $frm["employeeid"] = "";
   $frm["employeenumber"] = "";
   $frm["groupid"] = "";
   $frm["startdate"] = "";
   $frm["enddate"] = "";
   $frm["fname"] = "not set";
   $frm["lname"] = "not set";
   $frm["sex"] = "m";
   $frm["dob"] = "";
   $frm["addressid"] = "";
   $frm["jobdesc"] = "";
   $frm["imageid"] = "";
   $frm["paygrade"] = "";
   $frm["annualpay"] = "";
   $frm["annualhols"] = "";
   $frm["taxcode"] = "";
   $frm["nicode"] = "";
   $frm["ninumber"] = "";
   $frm["prevtax"] = "";
   $frm["prevpay"] = "";
   $frm["bankid"] = "";
   $frm["login"] = "";
   $frm["password"] = "";
   $frm["profile"] = "";
   $frm["interfaceauthid"] = "";
   $frm["notes"] = "";
   
   $frm["userid"]="";
   
	return $frm;
}

function fillForm($id, $bOffset)
{
	if($bOffset){
      $qry=sprintf(emp_qry2, $id);
   }
   else{
      $qry=sprintf(emp_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

   $frm["id"] = $row["id"];
   $frm["employeeid"] = $row["employeeid"];
   $frm["employeenumber"] = $row["employeenumber"];
   $frm["groupid"] = $row["groupid"];
   $frm["startdate"] = $row["startdate"];
   $frm["enddate"] = $row["enddate"];
   $frm["fname"] = $row["fname"];
   $frm["lname"] = $row["lname"];
   $frm["sex"] = $row["sex"];
   $frm["dob"] = $row["dob"];
   $frm["addressid"] = $row["addressid"];
   $frm["jobdesc"] = $row["jobdesc"];
   $frm["imageid"] = $row["imageid"];
   $frm["paygrade"] = $row["paygrade"];
   $frm["annualpay"] = $row["annualpay"];
   $frm["annualhols"] = $row["annualhols"];
   $frm["taxcode"] = $row["taxcode"];
   $frm["nicode"] = $row["nicode"];
   $frm["ninumber"] = $row["ninumber"];
   $frm["prevtax"] = $row["prevtax"];
   $frm["prevpay"] = $row["prevpay"];
   $frm["bankid"] = $row["bankid"];
   $frm["login"] = $row["login"];
   $frm["password"] = $row["password"];
   $frm["profile"] = $row["profile"];
   $frm["interfaceauthid"] = $row["interfaceauthid"];
   $frm["notes"] = $row["notes"];
   
	//$addrID=$row["addressID"];
	//$iaid=$row["InterfaceAuthID"];
   
   $qry=sprintf(emp_qry6, $id);
   $result=db_query($qry);
	if($row = $result->FetchRow()){
      $userID=$row["id"];
      $frm["userid"]=$row["id"];
      $litid=$row["logintypesid"];
      $qry=sprintf(emp_qry7, $userid);
      $result=db_query($qry);
	   if($row = $result->FetchRow()){
         $authID=$row["authid"];
         $interfaceID=$row["interfaceid"];
         $limethidID=$row["loginmethodid"];
      }
   }
   else{
      $frm["userid"]="";
   }
   $qry=sprintf(group_qry16, $frm["groupid"]);
	$result=db_query($qry);
	$row = $result->FetchRow();
	$frm["groupname"]=$row["name"];

	return $frm;
}

function addEmp()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	$frm["id"] = "Auto number";
   $frm["heading"] = "Employee Add";
		
	include("templates/empedit.php");
}

function editEmp($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Employee Edit";

	include("templates/empedit.php");
}

function browseEmp($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Employee Browse";

	include("templates/empedit.php");
}


function chkdelEmp($id)
{
	
   $frm=fillForm($id, false);
	$frm["newaction"] = "cfmdelete";
   $frm["deletion"] = "0";
   $frm["addressdel"] = "0";
   $frm["heading"] = "Employee Delete";
   
	include("templates/empdel.php");
}

function deleteEmp($frm) 
{
   if($frm['deletion']==0){
      $sdate=$frm['enddateyear']."-".$frm['enddatemonth']."-".$frm['enddateday'];
   }
   else{
      if($frm['addressdel']==1){
         db_query("DELETE FROM address WHERE id = '$frm[addressid]'");
      }
	   db_query("DELETE FROM employee WHERE id = '$frm[id]'");
   }
}

function insertEmp($frm)
{
   $a=new Address();
   $a->SetFromForm($frm);
   $adid=$a->Add();
   
   $sdate=$frm['startdateyear']."-".$frm['startdatemonth']."-".$frm['startdateday'];
   $edate="1971-01-01";
   $dob=$frm['DOByear']."-".$frm['DOBmonth']."-".$frm['DOBday'];
   
	$query = "INSERT into employee 
	( employeeid, employeenumber, groupid, startdate, enddate,
	fname, lname, sex, dob, addressid, jobdesc, imageid, paygrade,
	annualpay, annualhols, taxcode, nicode, ninumber, prevtax,
	prevpay, bankid, login, password, profile, interfaceauthid, notes)
	VALUES(
	'$frm[employeeid]',
   '$frm[employeenumber]',
   '$frm[groupid]',
   '$sdate',
   '$edate',
   '$frm[fname]',
   '$frm[lname]',
   '$frm[sex]',
   '$dob',
   '$adid',
   '$frm[jobdesc]',
   '$frm[imageid]',
   '$frm[paygrade]',
   '$frm[annualpay]',
   '$frm[annualhols]',
   '$frm[taxcode]',
   '$frm[nicode]',
   '$frm[ninumber]',
   '$frm[prevtax]',
   '$frm[prevpay]',
   '$frm[bankid]',
   '$frm[login]',
   '$frm[password]',
   '$frm[profile]',
   '$frm[interfaceauthid]',
   '$frm[notes]')";
   //error_log($query);
   $qid = db_query($query);

}

function commitEmp($frm) 
{
   $a=new Address();
   $a->SetFromForm($frm);
   $aid=$frm['addressid'];
   $a->Commit($aid);
   
   $sdate=$frm['startdateyear']."-".$frm['startdatemonth']."-".$frm['startdateday'];
   $edate="1971-01-01";
   $dob=$frm['DOByear']."-".$frm['DOBmonth']."-".$frm['DOBday'];

	$query = "UPDATE employee set 
	employeeid='$frm[employeeid]',
   employeenumber='$frm[employeenumber]',
   groupid='$frm[groupid]',
   startdate='$sdate',
   enddate='$edate',
   fname='$frm[fname]',
   lname='$frm[lname]',
   sex='$frm[sex]',
   dob='$dob',
   addressid='$aid',
   jobdesc='$frm[jobdesc]',
   imageid='$frm[imageid]',
   paygrade='$frm[paygrade]',
   annualpay='$frm[annualpay]',
   annualhols='$frm[annualhols]',
   taxcode='$frm[taxcode]',
   nicode='$frm[nicode]',
   ninumber='$frm[ninumber]',
   prevtax='$frm[prevtax]',
   prevpay='$frm[prevpay]',
   bankid='$frm[bankid]',
   login='$frm[login]',
   password='$frm[password]',
   profile='$frm[profile]',
   interfaceauthid='$frm[interfaceauthid]',
   notes='$frm[notes]'
	where id='$frm[id]'";
   $qid = db_query($query);
}

function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "address");
}

function DateControl($a, $d, $n)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
	   $result=db_query(login_qry1);
  		if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->datecontrol($a, $n);
}

function DateControlRanged($a, $d, $n)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
	   $result=db_query(login_qry1);
  		if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->datecontrol_ranged($a, $n, 65, 16);
}

function listEmp()
{
	$q=$_SESSION["pageindex"]->query(emp_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td colspan=\"3\" align=\"center\"><h1>Employee Maintenance</h1></td></tr>";
	echo "<tr><td><h3>Name</h3></td><td><h3>Group</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		$gid=$myrow["groupid"];
		$gresult=db_query("SELECT name from groups WHERE id='$gid'");
		$grow=$gresult->FetchRow();
		$gname=$grow["name"];
		$n=$myrow["fname"]." ".$myrow["lname"];
		print "<tr><td>$n</td><td>$gname</td>";
		print "<td>";
		$wibbler=$myrow["id"];
		print "<a href=\"emp.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"emp.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"emp.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
