<?php
/*
 * title.php
 *
 * @version	0.9.7
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2004 Al Kingsley
 * @package	MIS
 * @access	public
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], contact_pagetitle)!=0){
   $_SESSION['title']=contact_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(nametitle_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addTitle();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseTitle($id);
		break;

	case "edit" :
		editTitle($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelTitle($_REQUEST['id']);
      }
      else{
         deleteTitle($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listTitle();
      }
      break;  
	
   case "cfmdelete" :
      deleteTitle($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listTitle();
		break;

	case "add" :
		insertTitle($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listTitle();
		break;

	case "commit" :
		commitTitle($_POST);
      listTitle();
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listTitle();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(nametitle_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = 0;
	$frm["name"] = "";

	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(nametitle_qry2, $id);
   }
   else{
      $qry=sprintf(nametitle_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm["id"] = $row["id"];
	$frm["name"] = $row["name"];

	return $frm;
}

function addTitle()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = "Name Title Add";
	
	include("templates/contype.php");
}

function editTitle($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Name Title Edit";

	include("templates/contype.php");
}

function browseTitle($id) 
{
	$frm=fillForm($id, true);

	$frm["newaction"] = "browse";
   $frm["heading"] = "Name Title Browse";
	
	include("templates/contype.php");
}

function insertTitle($frm) 
{
   $qry=sprintf(nametitle_qry4, $frm['name']);
	db_query($qry);
}

function commitTitle($frm) 
{
   $qry=sprintf(nametitle_qry5, $frm['name'], $frm['id']);
   db_query($qry);
}

function chkdelTitle($id) 
{
   $frm=fillForm($id, false);
   $frm["ID"] = $id;
   $frm["heading"] = "Name Title Delete";
   $frm["newaction"] = "cfmdelete";
   
   include("templates/titleedit.php");
}

function deleteTitle($id) 
{
   $qry=sprintf(nametitle, $id);
   db_query($qry);
}

function listTitle()
{  
	$q=$_SESSION["pageindex"]->query(nametitle_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Category Name</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		echo "<tr><td>";
		echo $row["name"];
		echo "</td>\n<td>";
		$wibbler=$row["id"];
		print "<a href=\"title.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"title.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"title.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
