<?php
/**********************************************************************
 * 
 * Contact VCard stuff
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/PEAR/Contact_Vcard_Build");
require_once($_SESSION['CFG']->libdir."/PEAR/Contact_Vcard_Parse");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], contact_pagetitle)!=0){
   $_SESSION['title']=contact_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

include($_SESSION['CFG']->templatedir."/pheader.php");

switch($_REQUEST['action']){
	case "import" :
		importvcard();
		break;

   case default :
	case "export":
      exportvcard();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/


function export($frm)
{
   $vcard = new Contact_Vcard_Build();

   $qry=sprintf(vcard_qry1, $frm['id']);
   $result=$db_query($qry);
   
   if($row=$result->FetchArray()){
      $vcard->setFormattedName($row['fname'].' '.$row['lname']);
		$vcard->setName($row['lname'], $row['fname'], $row['type'],$row['title'], '');
   	$vcard->setSource($AppUI->cfg['company_name'].' '.$AppUI->cfg['page_title'].': '.$AppUI->cfg['site_domain']);
   	$vcard->setBirthday($row['birthdate']);
   	$row['contact_notes'] = str_replace("\r", " ", $row['contact_notes'] );
	   $vcard->setNote($row['contact_notes']);
   	$vcard->addOrganization($row['contact_company']);
   	$vcard->addTelephone($row['contact_phone']);
	   $vcard->addParam('TYPE', 'PF');
   	$vcard->addTelephone($row['contact_phone2']);
   	$vcard->addTelephone($row['contact_mobile']);
	   $vcard->addParam('TYPE', 'car');
   	$vcard->addEmail($row['contact_email']);
		$vcard->addParam('TYPE', 'PF');
      $vcard->addEmail($row['contact_email2']);
   	$vcard->addAddress('', $row['address2'],$row['address1'],$row['city'],$row['state'],$row['zip'],$row['country']);
	   //$vcard->addParam('TYPE', 'WORK');
   	// get back the vCard
	   $text = $vcard->fetch();
   }
}

	//send http-output with this vCard

	// BEGIN extra headers to resolve IE caching bug (JRP 9 Feb 2003)
	// [http://bugs.php.net/bug.php?id=16173]
		header("Pragma: ");
		header("Cache-Control: ");
		header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
		header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
		header("Cache-Control: no-store, no-cache, must-revalidate");  //HTTP/1.1
		header("Cache-Control: post-check=0, pre-check=0", false);
	// END extra headers to resolve IE caching bug

	header("MIME-Version: 1.0");
	header("Content-Type: text/x-vcard");
	header("Content-Disposition: attachment; filename={$contacts[0]['contact_last_name']}{$contacts[0]['contact_first_name']}.vcf");
	print_r($text);
} else {
$AppUI->setMsg( "contactIdError", UI_MSG_ERROR );
	$AppUI->redirect();
}



?>
