<?
/*
bhlib.php
Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

function redirect($url, $target="", $message="", $delay=0) 
{
   if(isset($target)){
      echo "<meta http-equiv='Window-target' content='_top'>";
   }

	echo "<meta http-equiv='Refresh' content='$delay; url=$url'>";
	if (!empty($message)) echo "<div style='font-family: Arial, Sans-serif; font-size: 12pt;' align=center>$message</div>";
	die;
}

function pv(&$var) 
{
	echo isset($var) ? htmlSpecialChars(stripslashes($var)) : "";
}

function read_template($filename, &$var) 
{
	$temp = str_replace("\\", "\\\\", implode(file($filename), ""));
	$temp = str_replace('"', '\"', $temp);
	eval("\$template = \"$temp\";");
	return $template;
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ generic funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

function fillcombo($id, $cname, $valname, $fillname, $sqlquery) 
{
	$result=db_query($sqlquery) or die('Unable to combo query');
	echo "<select name=\"$cname\" width=\"250\">\n";
	while($row = $result->FetchRow()){
		$vid=$row[$valname];
		$fn=$row[$fillname];
		if($id==$vid){ print "<option selected value=\"$vid\"> $fn </option>\n";}
		else{	print "<option value=\"$vid\"> $fn </option>\n"; }
	}
	echo "</select>\n";
}

function entry($a, $n, $s, $l, $v,$type=NULL)
{
   if($type == NULL)
       $type = "text";
   
   
   if($a=="commit" || $a=="add" || $a=="addwithref"){
      echo "<input type=\"$type\" class=\"text\" name=\"$n\" size=\"$s\" maxlength=\"$l\" value=\"";
		pv($v);
		echo "\">";
   }
   else{
      if(isset($v) && $v != ""){
         pv($v);
      }
      else{
         echo "Not Set";
      }
   }
}

function textarea($a, $n, $r, $l, $v)
{
   $c=$l/$r;
   if($a=="commit" || $a=="add" || $a=="addwithref"){
      echo "<input type=\"textarea\" name=\"$n\" rows=\"$r\" cols=\"$c\" value=\"";
		pv($v);
		echo "\">";
   }
   else{
      if(isset($v) && $v != ""){
         pv($v);
      }
      else{
         echo "Not Set";
      }
   }
}

function CheckBox($a, $cname, $value, $text)
{  
   if($a=="add" || $a=="commit"){
      if($value=='N' || $value=='0'){
    	   echo "<input type=\"checkbox\" name=\"$cname\"> $text\n";
      }
  	   else{
   	   echo "<input type=\"checkbox\" name=\"$cname\" checked> $text\n";
      }
   }
   else{
      if($value=='N' || $value=='0'){
   	   echo "<image src=".$_SESSION['CFG']->imagedir."/cancel.png width=\"13\" height=\"13\" border=\"0\">$text\n";
      }
  	   else{
   	   echo "<image src=".$_SESSION['CFG']->imagedir."/tick.png width=\"13\" height=\"13\" border=\"0\"> $text\n";
      }
   }
}

function YN($v)
{
   if(isset($v)){
      if($v=='1' || $v=='on' || $v=='Y')
	      return "Y";
      else
	      return "N";
   }
   else{
      return "N";
   }
}

function yesno($varisset)
{
// This is used to convert checkboxes into Y or N values
// Call it like so:  $result=yesno(isset($checkbox));

   if($varisset=='1')
	   return "Y";
   else
	   return "N";
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ misc funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

function helpbutton($name)
{
   if($_SESSION['CFG']->onlinehelp){
      echo "<td class=\"help\">\n";
      echo "<input class=\"help\" type=\"image\" height=\"24\" width=\"24\" name=\"namehelp\" src=\"".$_SESSION['CFG']->imagedir."/icon_help.png\" onclick=\"show_help('$name');\">\n";
      echo "</td>\n";
   }
}

function fillStatusCombo($a, $cname, $id)
{	
	if($a=="commit" || $a=="add"){
	   print "<select name=\"$cname\" width=\"250\">\n";
      $result=db_query(bhlib_qry1);
	   while($row = $result->FetchRow()){
			$boo=$row["id"];
		   $poo=$row["Name"];
		   if($id==$boo){
			   print "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		print "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
		print "</select>\n";
   }
   else{
      $qry=sprintf(bhlib_qry2, $id); 
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         echo $row[0];
      }
      else{
         echo "Not Set";
      }
   }
}

function fillTimeZoneCombo($a, $cname, $tz)
{
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"$cname\">\n";
      $z=24;
      $t=-11;
      while($z){
         if($tz==$t){
            echo "<option selected value=\"$t\">$t</option>\n";
         }
         else{
            echo "<option value=\"$t\">$t</option>\n";
         }
         $t++;
         $z--;
      }
		echo "</select>\n";
   }
   else{
      if(isset($tz)) echo $tz;
      else echo "+0";
   }
}

function fillPayTypeCombo($a, $cname, $id)
{	
	if($a=="commit" || $a=="add"){
	   print "<select name=\"$cname\" width=\"250\">\n";
      $result=db_query(bhlib_qry3);
	   while($row = $result->FetchRow()){
			$boo=$row["id"];
		   $poo=$row["name"];
		   if($id==$boo){
			   print "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		print "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
		print "</select>\n";
   }
   else{
      $qry=sprintf(bhlib_qry4, $id);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         echo $row[0];
      }
      else{
         echo "Not Set";
      }
   }
}

function fillTitleCombo($a, $cname, $id)
{	
	if($a=="commit" || $a=="add"){
	   print "<select name=\"$cname\" width=\"250\">\n";
      $result=db_query(bhlib_qry44);
	   while($row = $result->FetchRow()){
			$boo=$row["id"];
		   $poo=$row["name"];
		   if($id==$boo){
			   print "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		print "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
		print "</select>\n";
   }
   else{
      $qry=sprintf(bhlib_qry45, $id);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         echo $row[0];
      }
      else{
         echo "Not Set";
      }
   }
}


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ site/dept/group funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

function fillSiteCombo($a, $id)
{
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
      $result=db_query(bhlib_qry5);
      if(db_num_rows($result) == 0){
         echo "&nbsp;";
         return;
      }
      if(db_num_rows($result) == 1 && $a=="cfmdelete"){
         echo "The are no other sites defined";
         return;
      }
	   echo "<select name=\"siteid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         if(($a=="cfmdelete" && $id!=$boo) || $a !="cfmdelete"){
   	   	if($id==$boo){
	   	   	print "<option selected value=\"$boo\"> $poo </option>\n";
   	   	}
	   	   else{
		   	   print "<option value=\"$boo\"> $poo </option>\n";
   		   }
         }
	   }
	   echo "</select>\n";
   }
   else{
      $qry=sprintf(bhlib_qry6, $id);
      $result=db_query($qry);
      if(db_num_rows($result) == 0){
        echo "&nbsp;";
         return;
      }
      if($row = $result->FetchRow()){
         echo $row[0];
      }
   }
}

function fillDeptCombo($a, $id)
{
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
	   $result=db_query(bhlib_qry7);
      if(db_num_rows($result) == 0){
         echo "&nbsp;";
         return;
      }
      if(db_num_rows($result) == 1 && $a=="cfmdelete"){
         echo "The are no other departments defined";
         return;
      }
	   echo "<select name=\"deptid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
	   	   if($id==$boo){
   		   	print "<option selected value=\"$boo\"> $poo </option>\n";
	   	   }
   	   	else{
	   	   	print "<option value=\"$boo\"> $poo </option>\n";
   		   }
         }
	   }
      echo "</select>\n";
   }
   else{
      $qry=sprintf(bhlib_qry8, $id);
      $result=db_query($qry);
      if(db_num_rows($result) == 0){
        echo "&nbsp;";
         return;
      }
      if($row = $result->FetchRow()){
         echo $row[0];
      }
   }
}

function fillDeptFromSiteCombo($a, $siteid)
{
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
      $qry=sprintf(bhlib_qry15, $siteid);
	   $result=db_query($qry);
      if(db_num_rows($result) == 0){
         echo "There are no departments defined for this sites";
         return;
      }
	   echo "<select name=\"deptid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
	   	   if($id==$boo){
   		   	print "<option selected value=\"$boo\"> $poo </option>\n";
	   	   }
   	   	else{
	   	   	print "<option value=\"$boo\"> $poo </option>\n";
   		   }
         }
	   }
      echo "</select>\n";
   }
}

function fillGroupCombo($a, $id)
{
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
   	$result=db_query(bhlib_qry9);
      if(db_num_rows($result) == 0){
         echo "There are no groups defined for this department";
         return;
      }
	   echo "<select name=\"groupid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
   	   	if($id==$boo){
	   	   	print "<option selected value=\"$boo\"> $poo </option>\n";
   	   	}
	   	   else{
		   	   print "<option value=\"$boo\"> $poo </option>\n";
      		}
         }
	   }
   	echo "</select>\n";
   }
   else {
      $qry=sprintf(bhlib_qry10, $id);
      $result=db_query($qry);
      if(!isset($result)){
         echo "Not Set";
         return;
      }
      if(db_num_rows($result) == 0){
         echo "Not Set";
         return;
      }
      else{
         $row = $result->FetchRow();
         echo $row[0];
      }
   }
}

function fillGroupFromDeptCombo($a, $deptid)
{
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
      $qry=sprintf(bhlib_qry16, $deptid);
	   $result=db_query($qry);
      if(db_num_rows($result) == 0){
         echo "&nbsp;";
         return;
      }
      if(db_num_rows($result) == 1 && $a=="cfmdelete"){
         echo "The are no other departments defined";
         return;
      }
	   echo "<select name=\"deptid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
	   	   if($id==$boo){
   		   	print "<option selected value=\"$boo\"> $poo </option>\n";
	   	   }
   	   	else{
	   	   	print "<option value=\"$boo\"> $poo </option>\n";
   		   }
         }
	   }
      echo "</select>\n";
   }
   else{
      $qry=sprintf(bhlib_qry8, $deptid);
      $result=db_query($qry);
      if(db_num_rows($result) == 0){
        echo "&nbsp;";
         return;
      }
      if($row = $result->FetchRow()){
         echo $row[0];
      }
   }
}

function fillStationCombo($a, $id)
{
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
   	$result=db_query(bhlib_qry11);
      if(db_num_rows($result) == 0){
        echo "&nbsp;";
         return;
      }
      if(db_num_rows($result) == 1 && $a=="cfmdelete"){
         echo "The are no other stations defined";
         return;
      }
	   echo "<select name=\"stationid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
   	   	if($id==$boo){
	   	   	print "<option selected value=\"$boo\"> $poo </option>\n";
   	   	}
	   	   else{
		   	   print "<option value=\"$boo\"> $poo </option>\n";
      		}
         }
	   }
   	echo "</select>\n";
   }
   else{
      $qry=sprintf(bhlib_qry12, $id);
      $result=db_query($qry);
      if(db_num_rows($result) == 0){
        echo "&nbsp;";
         return;
      }
      if($row = $result->FetchRow()){
         echo $row[0];
      }
   }
}

function fillEnteredStation($a, $id)
{
   $s=substr($id, 0, 5);
   $d=substr($id, 5, 5);
   $g=substr($id, 10, 5);
   $n=substr($id, 15, 5);
   
   echo "<table width=\"100%\" border=\"1\"><tr>\n";
   echo "<td align=\"right\" nowrap>Site</td><td nowrap>";
   fillSiteCombo($a, $s);
   echo "</td>\n";
   echo "<td align=\"right\" nowrap>Department</td><td nowrap>";
   fillDeptCombo($a, $d);
   echo "</td></tr><tr><td align=\"right\" nowrap>Group</td>";
   echo "<td nowrap>";
   fillGroupCombo($a, $g);
   echo "</td>\n<td align=\"right\" nowrap>Station</td>";
   echo "<td nowrap>";
   fillStationCombo($a, $n);
   echo "</td>";
   echo "</tr></table>\n";
}

function fillEnteredControl($a, $id)
{
   $s=substr($id, 0, 5);
   $d=substr($id, 5, 5);
   $g=substr($id, 10, 5);
   $n=substr($id, 15, 5);
   
   echo "<table width=\"100%\" border=\"1\"><tr>\n";
   echo "<td align=\"right\" nowrap>Site</td><td nowrap>";
   fillSiteCombo($a, $s);
   echo "</td>\n";
   echo "<td align=\"right\" nowrap>Department</td><td nowrap>";
   fillDeptFromSiteCombo($a, $s);
   echo "</td></tr><tr><td align=\"right\" nowrap>Group</td>";
   echo "<td nowrap>";
   fillGroupFromDeptCombo($a, $d);
   echo "</td>\n<td align=\"right\" nowrap>Station</td>";
   echo "<td nowrap>";
   //fillStationFromGroupCombo($a, $g);
   echo "</td>";
   echo "</tr></table>\n";
}


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ user funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

function FillEmployeeName($a, $cname, $id)
{
   if($a=="commit" || $a=="add"){
	   $result=db_query(bhlib_qry13);
  		echo "<select name=\"$cname\" width=\"250\">\n";
     	while($myrow = $result->FetchRow()){
  			$boo=$myrow["employeeid"];
   		$poo=$myrow["fname"]. " " . $myrow["lname"];
         $nid=$_SESSION['misuser']->GetEmployee();
         if($nid==$boo){
   			print "<option selected value=\"$boo\"> $boo - $poo </option>\n";
	   	}
		   else{
			   print "<option value=\"$boo\"> $boo - $poo </option>\n";
  			}
   	}
	   print "</select>\n";
  	}
   else{
      $qry=sprintf(bhlib_qry14, $id);
	   $result=db_query($qry);
  		if($myrow = $result->FetchRow()){
	   	echo $myrow["fname"]. " " . $myrow["lname"];
	   }
  		else{
   		echo "Not Set";
	   }
   }
}

function FillLoginTypesCombo($a, $i)
{
   if($a=="commit" || $a=="add"){
  		echo "<select name=\"litdata\" width=\"250\">\n";
     	if($i==BHSQL_LOGINMETHOD_DATA){
         print "<option selected value=\"0\"> Data </option>\n";
         print "<option value=\"1\"> Pointer </option>\n";
         print "<option value=\"2\"> Pair </option>\n";
      }
      else if($i==BHSQL_LOGINMETHOD_PTR){
         print "<option value=\"0\"> Data </option>\n";
         print "<option selectedvalue=\"1\"> Pointer </option>\n";
         print "<option value=\"2\"> Pair </option>\n";
      }
      else if($i==BHSQL_LOGINMETHOD_PAIR){
         print "<option value=\"0\"> Data </option>\n";
         print "<option value=\"1\"> Pointer </option>\n";
         print "<option selected value=\"2\"> Pair </option>\n";
      }
  		print "</select>\n";
  	}
   else{
      if($i==BHSQL_LOGINMETHOD_DATA){
         print "Data\n";
      }
      else if($i==BHSQL_LOGINMETHOD_PTR){
         print "Pointer\n";
      }
      else if($i==BHSQL_LOGINMETHOD_PAIR){
         print "Pair\n";
      }
   }
}

function FillLoginTypesTable($a, $id)
{
   echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" bgcolor=\"#FFCCFF\" bordercolordark=\"#666600\" bordercolorlight=\"#FFFFFF\">\n";
	echo "<tr>\n";
	echo "<td colspan=\"2\" align=\"center\"><h3>Login Types</h3></td></tr>\n";
	$qry=sprintf(bhlib_qry17, $id);
   $result=db_query($qry);
	while($row = $result->FetchRow()){
		$n=$row["Name"];
		echo "<tr><td colspan=\"2\">$n</td></tr>\n";
	}
   echo "</table>\n";
}

function fillUserTable($a, $id)
{
   $qry=sprintf(bhlib_qry18, $id);
   $result=db_query($qry);
   $row = $result->FetchRow();
   $login=$row["login"];
   $password=$row["password"];
   $passivelogin=$row["profile"];
   $bclogin=$row["userdata"];
	$logintypeid=$row["logintypesid"];
   
   echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" bgcolor=\"#CCFFFF\" bordercolordark=\"#666600\" bordercolorlight=\"#FFFFFF\">\n";
	echo "<tr>\n";
	echo "<td colspan=\"2\" align=\"center\"><h3>User Entry</h3></td></tr>\n";

	echo "<tr>\n";
   echo "<td width=\"20%\" align=\"right\">ID</td>\n";
   echo "<td>\n";
	entry($a, "userid", 22, 10, $id);
	echo"</td>\n";
	echo "</tr>\n";
	
	echo "<tr>\n";
   echo "<td width=\"20%\" align=\"right\">login</td>\n";
   echo "<td>\n";
	entry($a, "login", 22, 16, $login);
	echo"</td>\n";
	echo "</tr>\n";

   echo "<tr>\n";
   echo "<td width=\"20%\" align=\"right\">password</td>\n";
   echo "<td>\n";
	entry($a, "password", 22, 16, $password, "password");
	echo"</td>\n";
	echo "</tr>\n";
	
	echo "<tr>\n";
   echo "<td width=\"20%\" align=\"right\">passive login</td>\n";
   echo "<td>\n";
	entry($a, "passivelogin", 22, 10, $passivelogin);
	echo"</td>\n";
	echo "</tr>\n";
	
	echo "<tr>\n";
   echo "<td width=\"20%\" align=\"right\">barcode login</td>\n";
   echo "<td>\n";
	entry($a, "userdata", 22, 10, $bclogin);
	echo"</td>\n";
	echo "</tr></table>\n";
}

function fillInterfacesTable($a, $id)
{
   $qry=sprintf(bhlib_qry19, $id);
   $result=db_query($qry);
   $row = $result->FetchRow();
   $AuthID=$row["id"];
   $perm_login=$row["perm_login"];
   $perm_list=$row["perm_list"];
   $perm_browse=$row["perm_browse"];
   $perm_add=$row["perm_add"];
   $perm_edit=$row["perm_edit"];
   $perm_delete=$row["perm_delete"];
   
   $qry=sprintf(bhlib_qry20, $AuthID);
   $iresult=db_query($qry);
   $irow = $iresult->FetchRow();
   $iname=$irow["Name"];
   $iid=$irow["id"];
   
   $qry=sprintf(bhlib_qry29, $iid);
   $iresult=db_query($qry);

   echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" bgcolor=\"#FFFFFF\" bordercolordark=\"#666600\" bordercolorlight=\"#FFFFFF\">\n";

   while($irow = $iresult->FetchRow()){
      $iname=$irow["name"];
      echo "<tr>\n";
      echo "<td align=\"center\"><h3>For Station - <i>$iname</i></h3></td></tr>\n";

      $qry=sprintf(bhlib_qry30, $AuthID);
      $iresult=db_query($qry);
      while($irow = $iresult->FetchRow()){
         $iname=$irow["Name"];
         $iid=$irow["id"];
         echo "<tr>\n";
         echo "<td width=\"20%\" align=\"center\">$iname</td>\n";
      	echo "</tr>\n";
      }
   }
   echo "</table>\n";
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ promo/discount/margin funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

function fillMarginTypeCombo($a, $cname, $type)
{
	$typelist = array('product', 'customer', 'user');
   
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"$cname\">\n";
	   foreach ($typelist as $typeid) {
	      print "<option ";
   	   if ($type == $typeid)
	         print "selected ";
	      print "value='$typeid'>$typeid</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $type;
   }
}

function fillDepositTypeCombo($a, $cname, $type)
{
	$typelist = array('rental', 'layby', 'returnable', 'redemption');
   
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"$cname\">\n";
	   foreach ($typelist as $typeid) {
	      print "<option ";
   	   if ($type == $typeid)
	         print "selected ";
	      print "value='$typeid'>$typeid</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $type;
   }
}

function fillPromoTypeCombo($a, $cname, $type)
{
	$typelist = array('PriceAbsolute', 'PriceIncremental', 'PriceMargin', 'ItemAbsolute', 'ItemIncremental', 'ItemMargin');

   if($a=="commit" || $a=="add"){
	   echo "<select name=\"$cname\">\n";
	   foreach ($typelist as $typeid) {
	      print "<option ";
   	   if ($type == $typeid)
	         print "selected ";
	      print "value='$typeid'>$typeid</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $type;
   }
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ product/inv funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

function fillInvCategoryCombo($a, $cname, $id)
{
	if($a=="commit" || $a=="add"){
		$result=db_query(bhlib_qry31);

		print "<select name=\"$cname\">\n";

		while($myrow = $result->FetchRow()){
			$boo=$myrow["id"];
			$poo=$myrow["name"];

			if($id==$boo){
				print "<option selected value=\"$boo\"> $boo - $poo </option>\n";
			}
			else{
				print "<option value=\"$boo\"> $boo - $poo </option>\n";
			}
		}
		print "</select>\n";
	}
	else{
      $qry=sprintf(bhlib_qry32, $id);
		$result=db_query($qry);
		if($myrow = $result->FetchRow()){
			$n=$myrow["name"];
			echo $n;
		}
		else{
			echo "Not Set";
		}
	}
}

function fillBarcodeTypes($a, $id)
{
   $idlist = array('EAN-13', 'EAN-8', 'UPC-A', 'UPC-E', 'ISBN', 'EAN-13W', 'EAN-13Q','EAN-13P', 'EAN-13I', 'BH-SC6');
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"plutype\">\n";
   	foreach ($idlist as $key=>$idname) {
	   	echo "<option ";
		   if($key == $id)
   			echo "selected ";
	   	echo " value=\"$key\">$idname</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $idlist[$id];
   }
}

function fillProductFlags($a, $id)
{
	$idlist = array('None', 'Incomplete');
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"flags\">\n";
   	foreach($idlist as $key=>$idname) {
	   	echo "<option ";
		   if($key == $id)
   			echo "selected ";
	   	echo " value=\"$key\">$idname</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $idlist[$id];
   }
}

function fillproductPriceNameCombo($a, $cname, $id)
{
   if($a=="commit" || $a=="add"){
   	print "<select name=\"$cname\">\n";
   	print "<option value='0'>Not Set</option>\n";
      $result=db_query(bhlib_qry41);
	
      while($row = $result->FetchRow()){
	   	$boo=$row["id"];
		   $poo=$row["name"];
		
   		if($id==$boo){
	   		print "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		print "<option value=\"$boo\"> $poo </option>\n";
		   }
   	}
	   print "</select>\n";
   }
   else{
      $qry=sprintf(bhlib_qry41, $id);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         echo $row[0];
      }
      else{
         echo "Not Set";
      }
   }
}

function fillinvPriceNameCombo($a, $cname, $id)
{
   if($a=="commit" || $a=="add"){
   	print "<select name=\"$cname\" width=\"250\">\n";

      $result=db_query(bhlib_qry33);
	
      while($row = $result->FetchRow()){
	   	$boo=$row["id"];
		   $poo=$row["name"];
		
   		if($id==$boo){
	   		print "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		print "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
	   print "</select>\n";
   }
   else{
      $qry=sprintf(bhlib_qry34, $id);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         echo $row[0];
      }
      else{
         echo "Not Set";
      }
   }
}

function fillSupplierPriceTable($a, $cname, $id)
{
   echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" bgcolor=\"#CCCCFF\">\n";
   echo "<tr><td><h3>Supplier Name</h3></td><td><h3>Supplier Code</h3></td></tr>\n";
   if($a=="commit" || $a=="add"){
      $qry=sprintf(bhlib_qry35, $id);
      $result=db_query($qry);
      if(db_num_rows($result)==0){
         echo "<tr><td colspan=\"2\">No Suppliers found</td></tr>\n</table>\n";
         return;
      }
   	while($myrow = $result->FetchRow()){
         echo "<tr>";
		   $sid=$myrow["supplierid"];
         $scode=$myrow["suppliercode"];
         $qry=sprintf(bhlib_qry36, $sid);
		   $sresult=db_query($qry);
		   if($srow = $sresult->FetchRow()){
		      echo "<td>$srow[0]</td>\n";
		   }
         else{
            echo "<td>Not Set</td>\n";
         }
         if(isset($scode)){
            echo "<td>$scode</td>\n";
         }
         else{
            echo "<td>Not Set</td>\n";
         }
         echo "</tr><tr><td>\n";
       // undef looking below -- Terry
         fillInvBQTable($a, $sid, $id);
	   }
   }
   else{
   }
}

function fillInvBQTable($a, $supplierid, $invbqid)
{

   $qry=sprintf(bhlib_qry43, $invbqid, $supplierid);
   $result=db_query($qry);
   
   echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" bgcolor=\"#CCCCFF\">\n";
   echo "<tr align=\"center\"> \n";
   echo "<td colspan=\"4\"><h3>Price Quantity</h3></td></tr><tr>\n";
   if($row=$result->FetchRow()){   
      echo "<td align=\"right\" class=label width=\"20%\">Quantity</td>\n";
      echo "<td>";
      entry($a, "quantity", 12, 8, $row["quantity"]);
      echo "</td>\n<td align=\"right\" class=label>Quantity Type</td>\n<td>";
      fillQTCombo($a, "quantitytypeid", $row["quantitytypeid"]);
      echo "</td></tr><tr>\n<td align=\"right\" class=label>Pack Size</td>\n<td>";
      entry($frm["newaction"], "udv", 12, 8, $row["udv"]); 
      echo "</td>\n<td align=\"right\" class=label>Name</td>\n<td>";
      fillinvPriceNameCombo($a, "quantitynameid", $row["quantitynameid"]);
      echo "</td></tr><tr>\n<td align=\"right\" class=label>Unit Price</td>\n<td>";
      entry($a, "price", 12, 8, $row["price"]);
      echo "</td>\n<td align=\"right\" class=label>Tax</td>\n<td>";
      fillTaxCombo($a, "taxid", $row["taxid"]);
      echo "</td></tr><tr>\n<td align=\"right\" class=label>Account</td>\n<td>";
      AccountCombo($a, $row["accountid"]);
      echo "</td>\n<td align=\"right\" class=label>Currency</td>\n<td>";
      CurrencyCombo($a, $row["basecurrencyid"]);
      echo "";
   }
   else{
      echo "<td colspan=\"4\">No Price Quantity Information found.";
   }
   echo "</td>\n</tr>\n</table>\n";
}


function fillConnectType($id)
{
   if(!isset($id)) $id="NONE";
	$idlist = array('NONE', 'DIRECT', 'PASSIVE', 'ACTIVE');
   $n=1;
	echo "<select name=\"ConnectMethod\" width=\"250\">\n";
	foreach ($idlist as $idname) {
		echo "<option ";
		if ($idname == $id)
			echo "selected ";
		echo " value=\"$n\">" . ucwords($idname) . "</option>\n";
      $n++;
	}
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ suppliers ~~~~~~~~~~~~~~~~~~~~~~~~~*/

function fillSupplierCombo($a, $cname, $id)
{	
	if($a=="commit" || $a=="add"){
	   print "<select name=\"$cname\" width=\"250\">\n";
      $result=db_query(bhlib_qry46);
      if($result){
   	   while($row = $result->FetchRow()){
	   		$boo=$row["id"];
		      $poo=$row["name"];
		      if($id==$boo){
			      print "<option selected value=\"$boo\"> $poo </option>\n";
		      }
      		else{
	      		print "<option value=\"$boo\"> $poo </option>\n";
		      }
	      }
		   print "</select>\n";
      }
      else{
         echo "Not Set";
      }
   }
   else{
      $qry=sprintf(bhlib_qry47, $id);
      $result=db_query($qry);
      if($result){
         if($row = $result->FetchRow()){
            echo $row[0];
         }
         else{
            echo "Not Set";
         }
      }
      else{
         echo "Not Set";
      }
   }
}

function fillSupplierCombofrombq($a, $cname, $id)
{
   $qry=sprintf(bhlib_qry48, $id);
	$result=db_query($qry);
	
	echo "<select name=\"$cname\" width=\"250\">\n";

	while($myrow = $bqresult->FetchRow()){
		$sid=$myrow["supplierid"];
      $qry=sprintf(bhlib_qry49, $sid);
		$sresult=db_query($qry);
		$srow = $sresult->FetchRow();
		
		$boo=$srow["id"];
		$poo=$srow["name"];
		if($spid==$boo){
			echo "<option selected value=\"$boo\"> $poo </option>\n";
		}
		else{
			echo "<option value=\"$boo\"> $poo </option>\n";
		}
	}
	
	echo "</select>\n";
}

function fillSupplierTable($a, $cname, $id)
{
   $qry=sprintf(bhlib_qry50, $sid);
   $result=db_query($qry);

	while($row = $result->FetchRow()){
      echo "<tr>";
		$sid=$row["supplierid"];
      $scode=$row["suppliercode"];
      $qry=sprintf(bhlib_qry51, $sid);
		$sresult=db_query($qry);
		if($srow = $sresult->FetchRow()){
		   echo "<td>$srow[0]</td>";
		}
      else{
         echo "<td>Not Set</td>";
      }
      if(isset($scode)){
         echo "<td>$scode</td>";
      }
      else{
         echo "<td>Not Set</td>";
      }
      echo "</tr>";
	}
}

   
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ date/time funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/* depreciated - use the timedate class */




/*----------------------------------- CUT HERE -----------------------------------*/

/* Things below this line are either being re-written, rationalized, or replaced.
   If used, checked, and functional, and queries replaced from query file, 
   move above this line.
*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ product/inv funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

function insertinvpq($frm)
{

        if ($frm["basecurrencyid"] == '0')
           $frm["basecurrencyid"]=getdefaultBCID();

        // See if buy(inventory) price/quantity exists...
        $result = db_query("SELECT * FROM invpricequantity where
                 nameID='$frm[BuynameID]' AND
                 Quantity='$frm[BuyQuantity]' AND
                 QuantityTypeID='$frm[BuyQuantityTypeID]' AND
                 UDV='$frm[BuyUDV]' AND
                 Price='$frm[BuyPrice]' AND
					  basecurrencyid='$frm[basecurrencyid]' AND
					  SupplierID='$frm[supplierID]' AND
					  ediID='$frm[ediID]' AND
					  accountID='$frm[accountID]' AND
                 TaxID='$frm[BuyTaxID]'");

        if($row = $result->FetchRow()){
             $bqid=$row["id"];
        }
        else{
             db_query("INSERT INTO invpricequantity VALUES(
				           '',
         	           '',
				           '1',
				           '$frm[BuyQuantity]',
				           '$frm[BuyQuantityTypeID]',
		                 '$frm[BuyUDV]',
				           '$frm[BuyPrice]',
				           '$frm[basecurrencyid]',
				           '$frm[supplierID]',
				           '$frm[supplierCode]',
				           '$frm[ediID]',
                       '$frm[accountID]',
                       '$frm[BuyTaxID]')");

             $bqid=db_insert_id();
             db_query("UPDATE invpricequantity SET invprqID='$bqid' WHERE ID='$bqid'");
        }
		  return $bqid;
}

function insertprodpq($frm)
{
        if ($frm["basecurrencyid"] == '0')
		$frm["basecurrencyid"]=getdefaultBCID();

        // See if sell price/quantity exists...
        $result = db_query("SELECT * FROM prodpricequantity where 
              nameID='$frm[nameid]' AND 
              Quantity='$frm[quantity]' AND
              QuantityTypeID='$frm[quantitytypeid]' AND
              UDV='$frm[udv]' AND
              Price='$frm[price]' AND
	      basecurrencyid='$frm[basecurrencyid]' AND
              TaxID='$frm[taxid]'");

        if($row = $result->FetchRow()){
            $pqid=$row["id"];
	}
	else{

        	db_query("INSERT INTO prodpricequantity (pqid,nameid,quantity,quantitytypeid,udv,price,basecurrencyid,taxid) VALUES
		('0',
		 '1',
		 '$frm[quantity]',
		 '$frm[quantitytypeid]',
		 '$frm[udv]',
		 '$frm[price]',
		 '$frm[basecurrencyid]',
		 '$frm[taxid]')");

            //$pqid=db_insert_id();
            //db_query("UPDATE prodpricequantity set pqID='$pqid' where ID='$pqid'");
        }

        return $pqid;
}

function getdefaultBCID()
{
        // Grab a default basecurrencyid.  This could be
        // pulled from many places (site, station, other products)
        $result=db_query(bhlib_qry40);
        $row=$result->FetchRow();
        return $row["basecurrencyid"];
}


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ general funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

function fillQTCombo($a,$cname,$id)
{
	if($a=="commit" || $a=="add"){
		print "<select name=\"$cname\" width=\"250\">\n";
	   $qtresult=db_query("SELECT id, name FROM invitemquantitytype");
	
		while($qtrow = $qtresult->FetchRow()){
			$boo=$qtrow["id"];
			$poo=$qtrow["name"];
		
			if($id==$boo){
				print "<option selected value=\"$boo\"> $poo </option>\n";
			}
			else{
				print "<option value=\"$boo\"> $poo </option>\n";
			}
		}
		print "</select>\n";
	}
	else{
		$qtresult=db_query("SELECT name FROM invitemquantitytype where id='$id'");
		if($qtrow = $qtresult->FetchRow()){
			$poo=$qtrow["name"];
			echo "$poo";
		}
	}
}

function fillTaxCombo($a, $cname, $id)
{
	if($a=="commit" || $a=="add"){
		$result=db_query("SELECT * FROM  taxrate");
		print "<select name=\"$cname\" width=\"250\">\n";

		while($myrow = $result->FetchRow()){
			$boo=$myrow["id"];
			$poo=$myrow["accountid"];
         $rate=$myrow["rate"] * 100;
		
			$aresult=db_query("select name from account where accountnumber = '$poo'");
			$arow=$aresult->FetchRow();
         if($arow["name"]==""){
			   $n=$rate."%";
         }
         else{
            $n=$arow["name"]." - ".$rate."%";
         }
			if($id==$boo){
				print "<option selected value=\"$boo\"> $n </option>\n";
			}
			else{
				print "<option value=\"$boo\"> $n </option>\n";
			}
		}
		print "</select>\n";
	}
	else{
		$result=db_query("SELECT * FROM  taxrate");
		if($myrow = $result->FetchRow()){
			$poo=$myrow["accountid"];
         $rate=$myrow["rate"] * 100;
			$aresult=db_query("select name from account where accountnumber = '$poo'");
			$arow=$aresult->FetchRow();
         if($arow["name"]==""){
			   $n=$rate."%";
         }
         else{
            $n=$arow["name"]." - ".$rate."%";
         }
			echo "$n";
		}
	}
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ interface funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

function fillInterfaceCombo($id)
{
	echo "<select name=\"interface\" width=\"250\">\n";

	$result=db_query("SELECT * FROM interface");
	while($row = $result->FetchRow()){
		$rowID=$row["id"];
		$InterfaceID=$row["id"];
		$AuthID=$row["authid"];
		$Name=$row["name"];

		$poo=$AuthID." - ".$Name;
		if($id==$rowID){
			print "<option selected value=\"$InterfaceID\"> $poo </option>\n";
		}
		else{
			print "<option value=\"$InterfaceID\"> $poo </option>\n";
		}
	}
	echo "</select>\n";
}

function fillInterfaceAuthTable($id)
{
	echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\">\n";
	echo "<tr>\n";
	echo "<td colspan=\"3\" align=\"center\"><h3>Interfaces</h3></td></tr>\n";
	echo "<tr><td>Grp</td><td>Name</td><td>Login</td></tr>\n";

	$result=db_query("SELECT * FROM interface WHERE id='$id'");
	if ($row = $result->FetchRow())
	$result = db_query("SELECT * from interface where id = '$row[id]'");

	while($row = $result->FetchRow()){
		$ID=$row["id"];
		$InterfaceID=$row["id"];
		$AuthID=$row["id"];
		$Name=$row["name"];
		
		$liresult=db_query("SELECT perm_login FROM authority WHERE id='$ID'");
		$lirow = $liresult->FetchRow();
		$lilogin=$lirow["perm_login"];

		echo "<tr>\n";
		echo "<td>$AuthID</td>\n";
		echo "<td>$Name</td><td>\n";
		if($lilogin=="N"){
			echo "<input type=\"checkbox\" name=\"perm_login[]\" value=\"$AuthID\">";
		}
		else{
			echo "<input type=\"checkbox\" name=\"perm_login[]\" value=\"$AuthID\" checked>";
		}
		echo "</td>\n";
		echo "</tr>\n";
	}
	echo "</table>\n";
}

function fillInterfaceTable($id)
{
	echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\">\n";
	echo "<tr>\n";
	echo "<td colspan=\"3\" align=\"center\"><h3>Interfaces</h3></td></tr>\n";
	echo "<tr><td>Grp</td><td>Name</td><td>Login</td></tr>\n";

	$result=db_query("SELECT * FROM interface WHERE id='$id'");
	while($row = $result->FetchRow()){
		$ID=$row["id"];
		$InterfaceID=$row["id"];
		$AuthID=$row["authid"];
		$Name=$row["name"];
		
		$liresult=db_query("SELECT perm_login FROM authority WHERE id='$AuthID'");
		$lirow = $liresult->FetchRow();
		$lilogin=$lirow["perm_login"];

		echo "<tr>\n";
		echo "<td>$AuthID</td>\n";
		echo "<td>$Name</td><td>\n";
		if($lilogin=="N"){
			echo "<input type=\"checkbox\" name=\"perm_login\" value=\"N\">";
		}
		else{
			echo "<input type=\"checkbox\" name=\"perm_login\" value=\"Y\" checked>";
		}
		echo "</td>\n";
		echo "</tr>\n";
	}
	echo "</table>\n";
}

function fillLoginMethodControl($a, $userid)
{  
   $result=db_query("SELECT * FROM userauth WHERE userid = '$userid'");
   print "<table border=\"1\" cellspacing=\"2\" cellpadding=\"2\">\n";
   print "<tr><td>Name</td><td>Method</td><td colspan=\"7\">Permissions</td></tr>\n";
	//if($a=="commit" || $a=="add"){\
      while($row = $result->FetchRow()){
         $ifid=$row["interfaceid"];
	  	   $boo=$row["loginmethodid"];
         $poo=$row["id"];
         $nresult=db_query("SELECT * FROM postinterface WHERE id='$ifid'");
         if($nrow = $nresult->FetchRow()){
            $postID=$nrow["postid"];
            $interID=$nrow["interfaceid"];
            $presult=db_query("SELECT name FROM posts WHERE id='$postID'");
            if($prow = $presult->FetchRow()){
               $postname=$prow["name"];
               print "<tr><td colspan=\"9\"><b>$postname</b></td></tr>\n";
            }
            
            $iresult=db_query("SELECT name FROM interface WHERE id='$interID'");
            if($irow = $iresult->FetchRow()){
               $ifname=$irow["name"];
               //print "<td colspan=\"8\">$ifname</td>\n";
            }
            else{
               $ifname="No Name";
            }
         }
         print "<tr>\n";
         $mresult=db_query("SELECT id, Name FROM loginmethod WHERE id='$boo'");
         print "<tr>\n";
         if($mrow = $mresult->FetchRow()){
            $goo=$mrow["id"];
            $zoo=$mrow["name"];
            print "<td>$ifname</td>\n";
   	  		print "<td>$zoo</td>\n";
            $aresult=db_query("SELECT * FROM authority WHERE id='$poo'");
            if($arow = $aresult->FetchRow()){
               if($arow["perm_login"]=='Y'){
                  print "<td><input type=\"checkbox\" name=\"perm_login\" value=\"1\" checked> login</td>\n";
               }
               else{
                  print "<td><input type=\"checkbox\" name=\"perm_login\" value=\"0\"> login</td>\n";
               }
               if($arow["perm_list"]=='Y'){
                  print "<td><input type=\"checkbox\" name=\"perm_list\" value=\"1\" checked> list</td>\n";
               }
               else{
                  print "<td><input type=\"checkbox\" name=\"perm_list\" value=\"0\"> list</td>\n";
               }
               if($arow["perm_browse"]=='Y'){
                  print "<td><input type=\"checkbox\" name=\"perm_browse\" value=\"1\" checked> browse</td>\n";
               }
               else{
                  print "<td><input type=\"checkbox\" name=\"perm_browse\" value=\"0\"> browse</td>\n";
               }
               if($arow["perm_add"]=='Y'){
                  print "<td><input type=\"checkbox\" name=\"perm_add\" value=\"1\" checked> add</td>\n";
               }
               else{
                  print "<td><input type=\"checkbox\" name=\"perm_add\" value=\"0\"> add</td>\n";
               }
               if($arow["perm_edit"]=='Y'){
                  print "<td><input type=\"checkbox\" name=\"perm_edit\" value=\"1\" checked> edit</td>\n";
               }
               else{
                  print "<td><input type=\"checkbox\" name=\"perm_edit\" value=\"0\"> edit</td>\n";
               }
               if($arow["perm_delete"]=='Y'){
                  print "<td><input type=\"checkbox\" name=\"perm_delete\" value=\"1\" checked> delete</td>\n";
               }
               else{
                  print "<td><input type=\"checkbox\" name=\"perm_delete\" value=\"0\"> delete</td>\n";
               }
               if($arow["perm_shutdown"]=='Y'){
                  print "<td><input type=\"checkbox\" name=\"perm_shutdown\" value=\"1\" checked> shutdown</td>\n";
               }
               else{
                  print "<td><input type=\"checkbox\" name=\"perm_shutdown\" value=\"0\"> shutdown</td>\n";
               }
            }
	      }
         print "</tr>\n";
	   }
   //}
   print "</table>\n";
}

function fillLoginMethodCombo($a, $id)
{
   if($a=="commit" || $a=="add"){
      echo "<select name=\"loginmethodID\" width=\"250\">\n";
	   if(!isset($id) || $id < 2){
		   $id=0;
		   print "<option selected value=\"0\"> None Selected </option>\n";
	   }
      $result=db_query("SELECT id, Name FROM loginmethod WHERE id='$id'");
	
   	while($row = $result->FetchRow()){
	   	$boo=$row["id"];
		   $poo=$row["country"]. " - " . $row["bigname"];
   		if($id==$boo){
	   		print "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		print "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
	   echo "</select>\n";
   }
   else{
      if(!isset($id) || $id < 2){
		   $id=0;
		   print "None Selected";
         return;
	   }
      $result=db_query("select id, country, bigname from currency where id='$id'");
   	$row = $result->FetchRow();
      echo $row["country"]. " - " . $row["bigname"];
   }
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ purchase order funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

function fillPurchaseItemsTable($a, $id)
{
   $result=db_query("select purchaseorderid,supplierid from purchaseorder where id='$id'");
   $row = $result->FetchRow();
   $pid=$row["purchaseorderid"];
   $sid=$row["supplierid"];
   
   $total=0.00;
   $row_count=1;
   echo "<table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"2\">";
   echo "<tr><td>ID</td><td>Name</td><td>Qty</td><td>Price</td><td>ST</td><td></td></tr>";
   
   $result=db_query("SELECT * from purchaseorderitems WHERE purchaseorderID='$pid'");
	while($row = $result->FetchRow()){
	  if($row_count%2==0){
	     echo "<tr bgcolor=\"#CCFFCC\">\n";
	  }
	  else{
	     echo "<tr>\n";
	  }
     $qty=$row["quantity"];
     $iid=$row["inventoryid"];
     
     $iresult=db_query("select name,buyquantitypriceid from inventory where id='$iid'");
     $irow = $iresult->FetchRow();
     $ipq=$irow["buyquantitypriceid"];
     $name=$irow["name"];
     
     $presult=db_query("SELECT * from invpricequantity WHERE id='$ipq'");
     $prow = $presult->FetchRow();
     $price=$row["price"];
     $st=$price * $qty;
	  
	  echo "<td></td></tr>";
	  $row_count++;
	}
	echo "<tr><td colspan=\"3\" align=\"right\">total :</td><td>$total</td></tr>";
	if($a=="commit" || $a=="add"){
	   echo "<tr><td>";
	   entry($a, "invid", 16, 32, "");
	   echo "</td><td>";
	   entry($a, "name", 48, 32, "");
	   echo "</td><td>";
	   entry($a, "qty", 8, 8, "0");
	   echo "</td><td>";
	   entry($a, "qty", 8, 8, "0");
	   echo "</td><td>st</td><td>add</td></tr>";
	}
	echo "</table>";
}

function fillPurchaseStatusCombo($a, $cname, $id)
{
   $typelist = array(
      2=>'Awaiting Approval',
      3=>'Waiting for Dispatch',
      4=>'Waiting for Delivery',
      5=>'Part Delivery',
      6=>'Damaged Delivery',
      7=>'Delivered',
      13=>'Waiting to Pay');

   if($a=="commit" || $a=="add"){
	   echo "<select name=\"$cname\" width=\"250\">\n";
	   foreach($typelist as $tid=>$typeid){
	      print "<option ";
   	   if($id == $tid)
	         print "selected ";
	      print "value='$tid'>$typeid</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $typelist[$id];
   }
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ timedate funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
/* depreciated - use the timedate class - will be removed in v0.9.7 */

function dateth($d) 
{
   //$jeb="<sup>";
   $jeb="";
   if($d=='01' || $d=='1' || $d=='21' || $d=='31'){
      $jeb.="st";
   }
   else if($d=='02' || $d=='2' || $d=='22'){
      $jeb.="nd";
   }
   else if($d=='03' || $d=='3' || $d=='23'){
      $jeb.="rd";
   }
   else{
      $jeb.="th";
   }
   //$jeb.="</sup>";
   return $jeb;
}

function monthname($month, $bshort) 
{
	$name="";

	switch($month){
	case 1:
		$name="January";
		break;
	case 2:
		$name="February";
		break;
	case 3:
		$name="March";
		break;
	case 4:
		$name="April";
		break;
	case 5:
		$name="May";
		break;
	case 6:
		$name="June";
		break;
	case 7:
		$name="July";
		break;
	case 8:
		$name="August";
		break;
	case 9:
		$name="September";
		break;
	case 10:
		$name="October";
		break;
	case 11:
		$name="November";
		break;
	case 12:
		$name="December";
		break;
	}

	if($bshort)
		$name=substr($name, 0, 3);

	return $name;
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ debug func ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

function show_post_vars() {
  global $_POST;

  foreach($_POST as $var => $val)
    error_log("'$var' = '$val'");
}

?>
