<?php
/*
 * chargeaccount.php
 * Part of:
 * BhPos, Copyright (C) 2001-2004 Al Kingsley
 * BhPos comes with ABSOLUTELY NO WARRANTY.
 *
 * @version	0.9.7
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2004 Al Kingsley
 * @package	MIS
 * @access	public
 */
 require_once($_SESSION['CFG']->libdir."/discount.php");
 
 class ChargeItem
 {
   var $id;
   var $chargeaccountid;
   var $targetid;
   var $transid;
   var $when;
   var $amount;

   function ChargeItem($id=false, $bOffset=false)
   {
      if(isset($id)){
         if(isset($bOffset)){
            $this->Fill($id, $bOffset);
         }
         else{
            $this->Fill($id, false);
         }
      }
      else{
         $this->id=0;
         $this->chargeaccountid=0;
         $this->targetid=0;
         $this->transid=0;
         $this->when=new TimeDate();
         $this->amount=0.0;
      }
   }
   
   function Fill($id, $bOffset=false)
   {
      if($bOffset){
         $qry=sprintf(chargeitem_qry2, $id);
      }
      else{
         $qry=sprintf(chargeitem_qry3, $id);
      }
	   $result=db_query($qry);
	   if($row = $result->FetchRow()){
         $this->id=$id;
         $this->chargeaccountid=0;
         $this->targetid=0;
         $this->transid=0;
         $this->when=new TimeDate();
         $this->amount=0.0;
         return false;
      }
      return true;
   }
   
   function Add()
   {
      $qry=sprintf(chargeitem_qry4, $this->targetid, $this->transid, $this->when->ansi(), $this->margin, $this->amount);
      db_query($qry);
       
      $result=db_query(misc_qry1);
      if($row = $result->FetchRow()){
         $this->id=$row[0];
      }
      return $this->ID;
   }
   
   function Commit($id)
   {
      $qry=sprintf(chargeitem_qry5, $this->targetid, $this->transid, $this->when->ansi(), $this->margin, $this->amount,
      $this->id);
      db_query($qry);
   }
   
   function Delete($id=false)
   {
      if(isset($id)){
         $qry=sprintf(chargeitem_qry6, $id);
      }
      else{
         $qry=sprintf(chargeitem_qry6, $this->id);
      }
	   db_query($qry);
   }
   
   function Combo($a, $cname, $id)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $result=db_query(chargeitem_qry7);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id "];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(chargeitem_qry3, $id);
         $result=db_query($qry);
      	if($row = $result->FetchRow()){
		      $poo=$row["name"];
            echo $poo;
         }
         else echo "Not Set";
      }
   }
   
   function TypeCombo($a, $id)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"type\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   if($id==BHSQL_DISCOUNT_PRODUCT){
	      	echo "<option selected value=\"BHSQL_DISCOUNT_PRODUCT\"> Product </option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_CUSTOMER\"> Customer</option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_USER\"> User </option>\n";
		   }
   		else if($id==BHSQL_DISCOUNT_CUSTOMER){
	   	   echo "<option value=\"BHSQL_DISCOUNT_PRODUCT\"> Product </option>\n";
            echo "<option selected value=\"BHSQL_DISCOUNT_CUSTOMER\"> Customer</option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_USER\"> User </option>\n";
   	   }
         else if($id==BHSQL_DISCOUNT_USER){
            echo "<option value=\"BHSQL_DISCOUNT_PRODUCT\"> Product </option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_CUSTOMER\"> Customer</option>\n";
            echo "<option selected value=\"BHSQL_DISCOUNT_USER\"> User </option>\n";
         }
	      echo "</select>\n";
      }
      else{
         if($id==BHSQL_DISCOUNT_PRODUCT){
	      	echo "Product";
		   }
   		else if($id==BHSQL_DISCOUNT_CUSTOMER){
	   	   echo "Customer";
   	   }
         else if($id==BHSQL_DISCOUNT_USER){
            echo "User";
         }
      }
   }
}

class ChargeAccount
{
   var $id;
   var $chargeid;
   var $typeid;
   var $cmid;
   var $creditlimit;
   var $lasttransaction;
   var $accountid;
   var $standardterms;
   var $codterms;
   var $prepaidterms;
   var $termstype;
   var $duemonthend;
   var $duedays;
   var $discountdays;
   var $discountid;
   var $notes;
   
   var $items;
   
   function ChargeAccount($id=false)
   {
      if($id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      else{
         $this->id=0;
         $this->chargeid=0;
         $this->typeid=0;
         $this->cmid=0;
         $this->creditlimit=0.0;
         $this->lasttransaction= new timedate();
         $this->accountid='0';
         $this->standardterms='N';
         $this->codterms='N';
         $this->prepaidterms='N';
         $this->termstype='N';
         $this->duemonthend='N';
         $this->duedays=0;
         $this->discountdays=0;
         $this->discountid=0;
         $this->notes='';
      }
   }
   
   function GetID() { return $this->ID; }
   
   function Fill($id, $bOffset=false)
   {
      if($id==0){
         return false;
      }
      
      if($bOffset){
         $qry=sprintf(chargeacc_qry2, $id);
      }
      else{
         $qry=sprintf(chargeacc_qry3, $id);
      }
      
	   $result=db_query($qry);
      if($row = $result->FetchRow()){
         $this->id=$row['id'];
         $this->chargeid=$id;
         $this->typeid=$row['typeid'];
         $this->cmid=$row['cmid'];
         $this->creditlimit=$row['creditlimit'];
         $this->lasttransaction->parse($row['lasttransaction']);
         $this->accountid=$row['accountid'];
         $this->standardterms=$row['standardterms'];
         $this->codterms=$row['codterms'];
         $this->prepaidterms=$row['prepaidterms'];
         $this->termstype=$row['termstype'];
         $this->duemonthend=$row['duemonthend'];
         $this->duedays=$row['duedays'];
         $this->discountdays=$row['discountdays'];
         $this->discountid=$row['discountid'];
         $this->notes=$row['notes'];
         
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l,$m,$n,$o)
   {
      $this->chargeid=$a;
      $this->typeid=$b;
      $this->cmid=$c;
      $this->creditlimit=$d;
      $this->lasttransaction->parse($e);
      $this->accountid=$f;
      $this->standardterms=$g;
      $this->codterms=$h;
      $this->prepaidterms=$i;
      $this->termstype=$j;
      $this->duemonthend=$k;
      $this->duedays=$l;
      $this->discountdays=$m;
      $this->discountid=$n;
      $this->notes=$o;
   }
   
   function SetFromForm($frm)
   {
      $this->chargeid=$frm['chargeid'];
      $this->typeid=$frm['typeid'];
      $this->cmid=$frm['cmid'];
      $this->creditlimit=$frm['creditlimit'];
      $this->lasttransaction->parse($frm['lasttransaction']);
      $this->accountid=$frm['accountid'];
      $this->standardterms=$frm['standardterms'];
      $this->codterms=$frm['codterms'];
      $this->prepaidterms=$frm['prepaidterms'];
      $this->termstype=$frm['termstype'];
      $this->duemonthend=$frm['duemonthend'];
      $this->duedays=$frm['duedays'];
      $this->discountdays=$frm['discountdays'];
      $this->discountid=$frm['discountid'];
      $this->notes=$frm['notes'];
   }
   
   function Add()
   {
      if($this->chargeID==0){
         db_query("INSERT INTO chargeaccount VALUES ('', ''
            '$this->chargeid',
            '$this->typeid',
            '$this->cmid',
            '$this->creditlimit',
            '$this->lasttransaction->ansidate()',
            '$this->accountid',
            '$this->standardterms',
            '$this->codterms',
            '$this->prepaidterms',
            '$this->termstype',
            '$this->duemonthend',
            '$this->duedays',
            '$this->discountdays',
            '$this->discountid',
            '$this->notes'");
         
         $this->ID=db_insert_id();
         db_query("UPDATE chargeaccount SET chargeid='$this->id' where id='$this->id'");
      }
      else{
         db_query("INSERT INTO chargeaccount VALUES ('',
         '$this->chargeid',
         '$this->typeid',
         '$this->cmid',
         '$this->creditlimit',
         '$this->lasttransaction->ansidate()',
         '$this->accountid',
         '$this->standardterms',
         '$this->codterms',
         '$this->prepaidterms',
         '$this->termstype',
         '$this->duemonthend',
         '$this->duedays',
         '$this->discountdays',
         '$this->discountid',
         '$this->notes'");
      
         $this->ID=db_insert_id();
       }
       return $this->id;
   }
   
   function AddItem($i) 
	{
		$found=0;

		if(isset($i)){
			if(count($this->items)!=0){
				foreach($this->items as $num=>$ii){
					$plu=$ii->GetPLU();
					$tplu=$InvItem->GetPLU();
					if($plu==$tplu){
						$tqty=$ii->GetQty() + $InvItem->GetQty();
						$ii->SetQty($tqty);
						$this->items[$num] = $ii;
						$found=1;
						break;
					}
				}
			}
			if($found==0){
				array_push($this->items, $i);
			}
		}
	}
   
   function Commit()
   {
      db_query("UPDATE chargeaccount SET 
         chargeid='$this->chargeid',
         typeid='$this->typeid',
         cmid='$this->cmid',
         creditlimit='$this->creditlimit',
         lasttransaction='$this->lasttransaction->ansidate()',
         accountid='$this->accountid',
         standardterms='$this->standardterms',
         codterms='$this->codterms',
         prepaidterms='$this->prepaidterms',
         termstype='$this->termstype',
         duemonthend='$this->duemonthend',
         duedays='$this->duedays',
         discountdays='$this->discountdays',
         discountid='$this->discountid',
         notes='$this->notes'
			where id = '$this->id'");
   }
   
   function Delete()
   {
      db_query("DELETE from chargeaccount WHERE id = $this->id");
   }
   
   function FillItemsTable($a, $cid, $title)
   {
      $result=db_query("SELECT * FROM chargeitems WHERE chargeid = '$cid'");
      if(db_num_rows($result)==0){
         return false;
      }
   }
   
   function Combo($a, $id, $title)
   {
   }
   
   function TypeCombo($a, $cname, $id)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $result=db_query(chargeacctype_qry4);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(chargeacctype_qry3, $id);
         $result=db_query($qry);
      	if($row = $result->FetchRow()){
		      $poo=$row["name"];
            echo $poo;
         }
         else echo "Not Set";
      }
   }
   
   function DiscountTable($a, $id, $title, $bOffset=false)
   {
   }
   
   function Table($a, $id, $title, $bOffset=false)
   {
      if($id!=0){
         if(!$this->Fill($id, $bOffset)){
            return;
         }
      }
      echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"chargeaccount\">\n";
	   echo "<tr>\n";
	   echo "<td colspan=\"2\" align=\"center\"><h3>$title</h3></td></tr>\n";

      echo "<tr><td width=\"20%\" align=\"right\">Type</td><td>\n";
      $this->TypeCombo($a, "typeid", $this->typeid);
   	echo"</td></tr>\n";
      
      echo "<tr><td width=\"20%\" align=\"right\">Account</td><td>\n";
      $acc=new Account();
      $acc->Combo($a, $this->accountid, "accountid");
   	echo"</td></tr>\n";
      
	   echo "<tr><td width=\"20%\" align=\"right\">Credit Limit</td><td>\n";
	   entry($a, "creditlimit", 16, 16, $this->creditlimit);
   	echo"</td></tr>\n";
	
   	echo "<tr><td align=\"right\">Last Transaction</td><td>\n";
      if(isset($this->lasttransaction)){
         $this->lasttransaction->datecontrol($a, "");
      }
      else{
         echo "Not Set";
      }
   	echo"</td></tr>\n";

   	echo "<tr><td align=\"right\">Due Days</td><td>\n";
      entry($a, "duedays", 8, 8,$this->duedays);
   	echo"</td></tr>\n";
      
      echo "<tr><td align=\"right\">Discount Days</td><td>\n";
      entry($a, "discountdays", 8, 8,$this->discountdays);
   	echo"</td></tr>\n";
      
      echo "<tr><td>&nbsp;</td><td>\n";
      CheckBox($a, "standardterms", $this->standardterms, "Standard Terms");
      echo "</td></tr>\n";
      echo "<tr><td>&nbsp;</td><td>\n";
      CheckBox($a, "codterms", $this->codterms, "COD Terms");
      echo "</td></tr>\n";
      echo "<tr><td>&nbsp;</td><td>\n";
      CheckBox($a, "prepaidterms", $this->prepaidterms, "Prepaid Terms");
      echo "</td></tr>\n";
      echo "<tr><td>&nbsp;</td><td>\n";
      CheckBox($a, "termstype", $this->termstype, "Type Terms");
      echo "</td></tr>\n";
      echo "<tr><td>&nbsp;</td><td>\n";
      CheckBox($a, "duemonthend", $this->duemonthend, "Due Month End");
      echo "</td></tr>\n";
      
      echo "<tr><td colspan=\"2\" align=\"right\">";
      $d=new Discount($this->discountid, false);
      $d->Table($a, $id, "General Discount", $bOffset, true);
   	echo"</td></tr>\n";
      
   	echo "</table>\n";
   }
}

?>
