<?php
require_once("timedate.php");

/*
 * creatmod.
 *
 * @version	0.9.6
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2003 Al Kingsley
 * @package	MIS
 * @access	public
 */
 
class CreateMod
{
   /** The createmod db id.
   * @var	id
   */
   var $id;
   
   /** The created date.
   * @var	creationdate
   */
   var $creationdate;
   var $modifieddate;
   var $createdby;
   var $modifiedby;

   function CreateMod()
   {
      $this->id=0;
      $this->creationdate=new TimeDate();
      $this->modifieddate=new TimeDate();
      $this->createdby=0;
      $this->modifiedby=0;
   }
   
   function Fill($id)
   {  
      if($id==0){
         if(isset($_SESSION['misuser'])){
   	      $this->createdby=$this->modifiedby=$_SESSION['misuser']->GetEmployee();
         }
         return false;
      }
      $qry=sprintf(createmod_qry1, $id);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->creationdate->parse($row[1]);
         $this->modifieddate->parse($row[2]);
         $this->createdby=$row[3];
         $this->modifiedby=$row[4];

         return true;
      }
      return false;
   }
   
   function Commit()
   {  
      $result=db_query(login_qry1);
      $row = $result->FetchRow();
      
      if($this->id==0){ // new entry
         $this->modifiedby=$this->createdby=$_SESSION['misuser']->GetEmployee();
         $this->modifieddate->parse($row[0]);
         $this->creationdate->parse($row[0]);
         $mts=$this->modifieddate->ansidateEx();
         $cts=$this->creationdate->ansidateEx();
         $qry=sprintf(createmod_qry2, $cts,$mts,$this->createdby,$this->modifiedby);
         db_query($qry);
         $result=db_query(misc_qry1);
         $row = $result->FetchRow();
         $this->id=$row[0];
      }
      else{ // modified entry
         $this->modifiedby=$_SESSION['misuser']->GetEmployee();
         $this->modifieddate->parse($row[0]);
         $mts=$this->modifieddate->ansidate();
         $qry=sprintf(createmod_qry3, $mts, $this->modifiedby, $this->id);
         db_query($qry);
      }
      return $this->ID;
   }
   
   function Find($bOutput)
   {
      $bcreationdate=0;
      $bmodifieddate=0;
      $bcreatedby=0;
      $bmodifiedby=0;
      $band=0;
      
      $query="select * from createmod where ";
      if($this->creationdate->Filled()){
         $query.="creationdate='$this->creationdate->ansidate()'";
         $bcreationdate=1;
         $band=1;
      }
      if($this->ModifiedDate->Filled()){
         if($band==0){
            $query.="modifieddate='$this->modifieddate->ansidate()'";
            $band=1;
         }
         else{
            $query.="and modifieddate='$this->modifieddate->ansidate()'";
         }
         $bmodifieddate=1;
      }
      if($this->creadedby!=0){
         if($band==0){
            $query.="creadedby='$this->creadedby'";
            $band=1;
         }
         else{
            $query.="and creadedby='$this->creadedby'";
         }
         $bcreadedby=1;
      }
      if($this->modifiedby!=0){
         if($band==0){
            $query.="modifiedby='$this->modifiedby'";
            $band=1;
         }
         else{
            $query.="and modifiedby='$this->modifiedby'";
         }
         $bmodifiedby=1;
      }
      
      $result=db_query($query);
      $n=db_num_rows($result);
      if(!$bOutput){
         if($n==0){
            return false;
         }
         else{
            return true;
         }
      }
      
      if($n==0){
         echo "<br><br><center><h2>No matching Create/Modify found for search Criteria</h2></center>";
         return false;
      }
   }
   
   function FillTable()
   {
      $qry=sprintf(createmod_qry4, $this->createdby);
	   $result=db_query($qry);
  	   if($row = $result->FetchRow()){
  		   $cwho=$row["fname"]." ".$row["lname"];
         if($cwho==' '){
            $cwho="Not Set";
         }
      }
  	   else{
  		   $cwho="Not Set";
      }
      $qry=sprintf(createmod_qry4, $this->modifiedby);
	   $result=db_query($qry);
  	   if($row = $result->FetchRow()){
   	   $mwho=$row["fname"]." ".$row["lname"];
         if($mwho==' '){
            $mwho="Not Set";
         }
      }
  	   else{
  		   $mwho="Not Set";
      }
   
      echo "<table class=\"createmod\">\n";
	   echo "<tr><td align='right' width=\"20%\">" . bhsys_cm_createdon . "</td><td>";
      $this->creationdate->datedisplay();
   	echo "</td></tr><tr><td align='right'>" . bhsys_cm_createdby . "</td><td>$cwho</td></tr>\n";
	   echo "<tr><td align='right'>" . bhsys_cm_modifiedon . "</td><td>";
		$this->modifieddate->datedisplay();
   	echo "</td></tr><tr><td align='right'>" . bhsys_cm_modifiedby . "</td><td>$mwho</td>\n";
      echo "</tr></table>";
   }
}

?>
