<?php
/*
discount.php

   Copyright (C) 2004 Al Kingsley
   
	
*/


/*
 * discount.php
 *
 * Part of:
 * BhPos, Copyright (C) 2001-2004 Al Kingsley
 * BhPos comes with ABSOLUTELY NO WARRANTY.
 *
 * @version	0.9.7
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2004 Al Kingsley
 * @package	MIS
 * @access	public
 */
 
 class Discount
 {
   var $ID;
   var $DiscountID;
   var $type;
   var $ident;
   var $targetID;
   var $Margin;
   var $Status; 
  

   function Discount($id=false, $bOffset=false)
   {
      if(isset($id)){
         if(isset($bOffset)){
            $this->Fill($id, $bOffset);
         }
         else{
            $this->Fill($id, false);
         }
      }
      else{
         $this->ID=0;
         $this->DiscountID=0;
         $this->type=0;
         $this->ident="";
         $this->targetID=0;
         $this->Margin=0.0;
         $this->Status=0;
      }
   }
   
   function Fill($id, $bOffset=false)
   {
      if($bOffset){
         $qry=sprintf(discount_qry2, $id);
      }
      else{
         $qry=sprintf(discount_qry3, $id);
      }
	   $result=db_query($qry);
	   if($row = $result->FetchRow()){
         $this->ID=$id;
         $this->DiscountID=$row['DiscountID'];
         $this->type=$row['type'];
         $this->ident=$row['ident'];
         $this->targetID=$row['targetID'];
         $this->Margin=$row['Margin'];
         $this->Status=$row['Status'];
         return false;
      }
      return true;
   }
   
   function Add()
   {
      $qry=sprintf(discount_qry4,$this->type, $this->ident, $this->targetID, $this->Margin, $this->Status);
      
      db_query($qry);
       
      db_query(misc_qry1);
      if($row = $result->FetchRow()){
         $this->ID=$row[0];
      }
      return $this->ID;
   }
   
   function Commit($id)
   {
      $qry=sprintf(discount_qry5,$this->type, $this->ident, $this->targetID, $this->Margin, $this->Status, $this-ID);
      db_query($qry);
   }
   
   function Delete($id=false)
   {
      if(isset($id)){
         $qry=sprintf(discount_qry6, $id);
      }
      else{
         $qry=sprintf(discount_qry6, $this->ID);
      }
	   db_query($qry);
   }
   
   function Combo($a, $cname, $id)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $result=db_query(discount_qry7);
      	while($row = $result->FetchRow()){
	      	$boo=$row["ID"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(discount_qry3, $id);
         $result=db_query($qry);
      	if($row = $result->FetchRow()){
		      $poo=$row["name"];
            echo $poo;
         }
         else echo "Not Set";
      }
   }
   
   function TypeCombo($a, $id)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"type\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   if($id==BHSQL_DISCOUNT_PRODUCT){
	      	echo "<option selected value=\"BHSQL_DISCOUNT_PRODUCT\"> Product </option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_CUSTOMER\"> Customer</option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_USER\"> User </option>\n";
		   }
   		else if($id==BHSQL_DISCOUNT_CUSTOMER){
	   	   echo "<option value=\"BHSQL_DISCOUNT_PRODUCT\"> Product </option>\n";
            echo "<option selected value=\"BHSQL_DISCOUNT_CUSTOMER\"> Customer</option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_USER\"> User </option>\n";
   	   }
         else if($id==BHSQL_DISCOUNT_USER){
            echo "<option value=\"BHSQL_DISCOUNT_PRODUCT\"> Product </option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_CUSTOMER\"> Customer</option>\n";
            echo "<option selected value=\"BHSQL_DISCOUNT_USER\"> User </option>\n";
         }
	      echo "</select>\n";
      }
      else{
         if($id==BHSQL_DISCOUNT_PRODUCT){
	      	echo "Product";
		   }
   		else if($id==BHSQL_DISCOUNT_CUSTOMER){
	   	   echo "Customer";
   	   }
         else if($id==BHSQL_DISCOUNT_USER){
            echo "User";
         }
      }
   }
   
   function Table($a, $id, $title, $bOffset=true, $bInside=false)
   {
      if($bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\">\n";
         echo "<tr align=\"center\"><td colspan=\"2\"><h2>$title</h2></td></tr>\n";
      }
      echo "<tr><td align=\"right\" width=\"20%\">Type</td><td>\n";
      entry($a, "DiscountID", 12, 8, $this->DiscountID);
      echo "</td></tr><tr><td align=\"right\">Type</td><td>\n";
      $this->TypeCombo($a, $this->type);
      echo "</td></tr><tr><td align=\"right\">Identity</td><td>\n";
      entry($a, "ident", 12, 8, $this->ident);
      echo "</td></tr><tr><td align=\"right\">Target</td><td>\n";
      entry($a, "targetID", 12, 8, $this->targetID);
      echo "</td></tr><tr><td align=\"right\">Margin</td><td>\n";
      entry($a, "Margin", 12, 8, $this->Margin);
      echo "</td></tr><tr><td align=\"right\">Status</td><td>\n";
      entry($a, "Status", 64, 64, $this->Status);
      echo "</td></tr>\n";
      if($bInside){
         echo "</table>\n";
      }
   }
}   
class DiscountCollection
{
   var $discountID;
   var $items;
      
   function DiscountCollection($id=false)
   {
      if(isset($id)){
         $this->Fill($id);
      }
      else{
         $this->ID=0;
      }
   }
   
   function Fill($id)
   {
      $this->ID=$id;
      $qry=sprintf(discount_qry8, $id);
	   $result=db_query($qry);
	   while($row = $result->FetchRow()){
         $d=new Discount($row['ID'], false);
         array_push($this->items, $d);
      }
   }
   
   function Table($a, $id, $title, $bOffset=true, $bInside=false)
   {
      if($bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\">\n";
         echo "<tr align=\"center\"><td colspan=\"2\"><h2>$title</h2></td></tr>\n";
      }
      echo "<tr><td><h3>Type</h3></td><td><h3>Margin</h3></td><td><h3>Stauts</h3></td></tr>\n";
      echo "<tr><td>\n";
      entry($a, "DiscountID", 12, 8, $this->DiscountID);
      echo "</td><td>\n";
      $this->TypeCombo($a, $this->type);
      echo "</td><td>\n";
      entry($a, "Margin", 12, 8, $this->Margin);
      echo "</td><td>\n";
      entry($a, "Status", 64, 64, $this->Status);
      echo "</td></tr>\n";
      if($bInside){
         echo "</table>\n";
      }
   }
}
   
?>
