<?
/*
mysqllib.php

Copyright (C)2002  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.

*/
if(!isset($DB_DIE_ON_FAIL)) { $DB_DIE_ON_FAIL = true; }
if(!isset($DB_DEBUG)) { $DB_DEBUG = false; }

function db_connect($dbhost, $dbname, $dbuser, $dbpass) 
{
	global $DB_DIE_ON_FAIL, $DB_DEBUG;

	if(!$dbh=mysql_pconnect($dbhost, $dbuser, $dbpass)){
		if($DB_DEBUG){
			echo "<h2>Can't connect to $dbhost as $dbuser</h2>";
			echo "<p><b>MySQL Error</b>: ", mysql_error();
		} 
		else{
			echo "<h2>Database error encountered</h2>";
		}

		if($DB_DIE_ON_FAIL){
			echo "<p>This script cannot continue, terminating.";
			die();
		}
	}

	if(!mysql_select_db($dbname)){
		if($DB_DEBUG){
			echo "<h2>Can't select database $dbname</h2>";
			echo "<p><b>MySQL Error</b>: ", mysql_error();
		} 
		else{
			echo "<h2>Database error encountered</h2>";
		}

		if($DB_DIE_ON_FAIL){
			echo "<p>This script cannot continue, terminating.";
			die();
		}
	}

	return $dbh;
}

function db_disconnect() 
{
	mysql_close();
}

function db_query($query, $debug=false, $die_on_debug=true, $silent=false) 
{
	global $DB_DIE_ON_FAIL, $DB_DEBUG;

	if($debug){
		echo "<pre>" . htmlspecialchars($query) . "</pre>";

		if($die_on_debug) die;
	}

	$qid=mysql_query($query);

	if(!$qid && !$silent){
		if($DB_DEBUG){
			echo "<h2>Can't execute query</h2>";
			echo "<pre>" . htmlspecialchars($query) . "</pre>";
			echo "<p><b>MySQL Error</b>: ", mysql_error();
		} 
		else{
			echo "<h2>Database error encountered</h2>";
		}

		if($DB_DIE_ON_FAIL){
			echo "<p>This script cannot continue, terminating.";
			die();
		}
	}

	return $qid;
}

function db_quotes($qry) 
{
}

// crap wrappers
function db_fetch_array($qid){ return mysql_fetch_array($qid); }
function db_fetch_row($qid){ return mysql_fetch_row($qid); }
function db_fetch_object($qid){ return mysql_fetch_object($qid); }
function db_num_rows($qid){ return mysql_num_rows($qid); }
function db_affected_rows(){ return mysql_affected_rows(); }
function db_insert_id(){ return mysql_insert_id(); }
function db_free_result($qid){ mysql_free_result($qid); }
function db_num_fields($qid){ return mysql_num_fields($qid); }
function db_field_name($qid, $fieldno){ return mysql_field_name($qid, $fieldno); }
function db_field_type($qid, $fieldno){ return mysql_field_type($qid, $fieldno); }
function db_data_seek($qid, $row){ if (db_num_rows($qid)) { return mysql_data_seek($qid, $row); } }


?>
