<?php
/*
schedule.php - usual boring crap

Copyright (C) 2003 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001 - 2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

class crontab{
   var $minute;
	var $hour;
	var $day;
   var $dayofweek;
	var $month;
	var $command;
	var $directory;
	var $filelist;
   var $crontab_line;
	
	function crontab()
   {
      $this->minute="*";
	   $this->hour="*";
	   $this->day="*";
      $this->dayofweek="*";
   	$this->month="*";
	   $this->command="";
      $this->directory="/usr/share/bhpos/schedule";
      
      $this->filelist=array();
      $this->crontab_line=array();
   }
   
   function Open($filename)
   {
      unset($this->crontab_line);
      $this->crontab_line=array();
      
      if(!$filename)
			return false;
			
		if(file_exists($filename)){
			if(!$fp=fopen($filename, 'r')){
            return false;
			}
         while(!feof($fp)){
            $line=fgets($fp, 512);
            $line=ltrim($line);
            // wait until lines start with numbers or *
            //$temp=preg_split("/[\s]+/", $line);
            //if($temp[0]=="*" || etc...) continue;
            array_push($this->crontab_line, $line);
         }
         fclose($fp);
		}
      return true;
   }
   
   function Save()
   {
   }
   
   function Add()
   {
   }
   
   function Remove()
   {
   }
   
   function dirparse($dir)
   {
      unset($this->filelist);
      $this->filelist=array();
      
      if(is_dir($dir)){
         if($dh=opendir($dir)){
            while(($file = readdir($dh))!==false){
               array_push($this->filelist, $file);
            }
            closedir($dh);
         }
      }
   }
   
   function readable_cronentity($ce)
   {
      if($ce="*") return "";
      
      if(preg_match("/,/", $ce)){   // list
      }
      if(preg_match("/-/", $ce)){   // range
      }
      if(preg_match("/\//", $ce)){  // skip
      }
   }
   
   function readable_cronline()
   {
      // Note: day of week, and day of month are OR'ed if both not '*'
      if($this->month!="*"){
      }
      if($this->dayofweek!="*"){
      }
      if($this->day!="*"){
      }
      if($this->hour!="*"){
      }
      if($this->minute!="*"){
      }
   }
   
   function parse_cronitem($line)
   {
      $cron_entries=preg_split("/[\s]+/", $line);
      
      // first 5 entries are the period (TODO: add validation)
      $this->minute=$cron_entries[0];     // 0-59
      $this->hour=$cron_entries[1];       // 0-23
      $this->day=$cron_entries[2];        // 1-31
      $this->month=$cron_entries[3];      // 1-12 (or names - 3 letter, case insentitive)
      $this->dayofweek=$cron_entries[4];  // 0-7 (or names - 3 letter, case insentitive)
      $this->command=$cron_entries[5];
   }
   
   function list_hourly()
   {
      
   }
   
   function list_daily()
   {
      $tdir=$directory."/daily";
      dirparse($tdir);
      foreach($this->filelist as $f){
         if(Open($f)){
            echo "<tr><td></td></tr>\n";
         }
      }
   }
   
   function list_weekly()
   {
      
   }
   
   function list_monthly()
   {
      
   }
   
	function Set($m, $h, $d, $m, $dow)
   {
	   if($m=="0")
			$this->minute=0;
		elseif($m)
			$this->minute=$min;
		else
			$this->minute="*";
			
		if($h=="0")
			$this->hour=0;
		elseif($h)
			$this->hour=$hour;
		else
			$this->hour="*";
		$this->month=($m) ? $m : "*";
		$this->day=($d) ? $d : "*";
		$this->dayofweek=($dow) ? $dow : "*";
			
   }
		
   function setDirectory($directory)
   {
		if(!$directory) return false;
			
		if(is_dir($directory)){
			if($dh=opendir($directory)){
				$this->directory=$directory;
				return true;
			}
         else
				return false;
		}
      else{
			if(mkdir($directory, 0700)){
				$this->directory=$directory;
				return true;
			}
		}
		return false;
	}

   function createCronFile($filename=NULL)
   {
		if(!$filename)
			return false;
			
		if(file_exists($this->directory.$filename)){
			if($handle=fopen($this->directory.$filename, 'a')){
				$this->handle=&$handle;
				$this->filename=$filename;
				return true;
			}else
				return false;
		}
			
		if(!$handle=fopen($this->directory.$filename, 'a'))
			return false;
		else{
			$this->handle=&$handle;
			$this->filename=$filename;
			return true;
		}
	}

   function setCommand($command)
   {
		if($command){
			$this->command=$command;
			return false;
		}else
			return false;
	}

   function saveCronFile()
   {
		$command=$this->minute." ".$this->hour." ".$this->day." ".$this->month." ".$this->dayofweek." ".$this->command."\n";
		if(!fwrite($this->handle, $command))
			return true;
		else
			return false;
	}

   function addToCrontab()
   {
		if(!$this->filename)
			exit('No name specified for cron file');
						
		if(exec($crontabPath."crontab ".$this->directory.$this->filename))
			return true;
		else
			return false;
	}

   function Close(){
		fclose($this->handle);
		return true;
	}
}
		
?>
