<?php

/**********************************************************************
 * 
 * Company Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/

/*****************************************
 * account queries
 *****************************************/
define("account_qry1", "select count(*) from account");
define("account_qry2", "select * from account limit 1 offset %d");
define("account_qry3", "select * from account where id = '%d'");
define("account_qry4", "select * from account");
define("account_qry5", "insert into account values(0,'%d','%s','%s','%d','%d')");
define("account_qry6", "update account set parentid='%d'.accountnumber='%s',name='%d',title='%d',gref='%d' where id = '%d'");
define("account_qry7", "delete from account where id = '%d'");
define("account_qry8", "select type from accountheading where id = '%d'");

/*****************************************
 * accountheading queries
 *****************************************/
define("acchead_qry1", "select count(*) from accountheading");
define("acchead_qry2", "select * from accountheading limit 1 offset %d");
define("acchead_qry3", "select * from accountheading where id = '%d'");
define("acchead_qry4", "insert into accountheading	values (0,'%s','%d','%d','%d','%d')");
define("acchead_qry5", "update accountheading set name='%s',sref='%d',eref='%d',gref='%d',type='%d' where id='%d'");
define("acchead_qry6", "delete from accountheading where id = '%d'");
define("acchead_qry7", "select * from accountheading");

/*****************************************
 * department queries
 *****************************************/
define("dept_qry1", "select count(*) from departments");
define("dept_qry2", "select * from departments limit 1 offset %d");
define("dept_qry3", "select * from departments where id = '%d'");
define("dept_qry4", "select * from departments");
define("dept_qry5", "select * from departments where siteid='%d'");

/*****************************************
 * employee queries
 *****************************************/
define("emp_qry1", "select count(*) from employee");
define("emp_qry2", "select * from employee limit 1 offset %d");
define("emp_qry3", "select * from employee where id = '%d'");
define("emp_qry4", "select * from employee");
define("emp_qry5", "select id, fname, lname from employee where groupid='%d'");
define("emp_qry6", "select * from users where employeeid='%d'");
define("emp_qry7", "select * from userauth where userid='%d'");
define("emp_qry8", "select name from groups where id='%d'"); 

/*****************************************
 * gaccref queries
 *****************************************/
define("gacc_qry1", "select count(*) from gaccref");
define("gacc_qry2", "select * from gaccref limit 1 offset %d");
define("gacc_qry3", "select * from gaccref where id = '%d'");
define("gacc_qry4", "select * from gaccref");

/*****************************************
 * group queries
 *****************************************/
define("group_qry1", "select count(*) from groups");
define("group_qry2", "select * from groups limit 1 offset %d");
define("group_qry3", "select * from groups where id = '%d'");
define("group_qry5", "select * from groups where deptid='%d'");
define("group_qry6", "select * from groups where deptid='%d'");
define("group_qry7", "select count(*) from posts where groupid='%d'");
define("group_qry8", "select count(*) from employee where groupid='%d'");
define("group_qry9", "select id, name from posts where groupid='%d'");
define("group_qry10", "select id, fname, lname from employee where groupid='%d'");
define("group_qry11", "update posts set groupid = '%d' where groupid='%d'");
define("group_qry12", "update employee set groupid = '%d' where groupid='%d'");
define("group_qry13", "delete from groups where id='%d'");
define("group_qry14", "INSERT INTO groups VALUES(0,'0','%s','%d','%d','%d','%s'"); 
define("group_qry15", "UPDATE groups SET name='%s',deptid='%d',localeid='%d',currencyid='%d',active='%d'where id='%d'");
define("group_qry16", "select name from groups where id = '%d'");

/*****************************************
 * setup queries
 *****************************************/
define("setup_qry1", "select * from setup");
define("setup_qry2", "update setup set name='%s',accountingdate='%s',regnumber='%s',vatnumber='%s' where id='0'");
define("setup_qry3", "update createmod set modifieddate='%s', modifiedby='%d' where id='%d'");
define("setup_qry4", "select name from setup");

/*****************************************
 * site queries
 *****************************************/
define("site_qry1", "select count(*) from sites");
define("site_qry2", "select * from sites limit 1 offset %d");
define("site_qry3", "select * from sites where id = '%d'");
define("site_qry4", "insert into sites values (0,0,'%s','%d','%d','%d','%d','%d','%f','%s','%s','%s','%s','%c')");
define("site_qry5", "update sites set name='%s',addressid='%d',contactid='%d',localeid='%d',currencyid='%d',
		annualbudget='%f',site='%s',encryption='%s',login='%s',password='%s',active='%c',bankid='%d' where id='%d'");
define("site_qry6", "delete from sites where id = '%d'");
define("site_qry7", "select id, name from sites");
define("site_qry8", "update departments set siteid = '%d' where siteid = '%d'");
define("site_qry9", "update departments set siteid = '0' where siteid = '%d'");
define("site_qry10", "select id, name from departments where siteid = '%d'");
define("site_qry11", "select id, fname, lname from employee where id = '%d' order by lname");
define("site_qry12", "select name from sites where id = '%d'");

 /****************************************
 * tax queries
 *****************************************/
define("tax_qry1", "select count(*) from taxrate");
define("tax_qry2", "select * from taxrate limit 1 offset %d");
define("tax_qry3", "select * from taxrate where id = '%d'");
define("tax_qry4", "select * from account where accountnumber='%d'");
//define("tax_qry4", "insert into taxrate (accountid, rate, onmenu) values ('$frm[accountid]','$frm[rate]','$frm[onmenu]')");
//define("tax_qry5", "update taxrate set accountid=$frm[accountid], rate='$frm[rate]', onmenu='$frm[onmenu]' where id='$id'");
//define("tax_qry6", "delete from taxrate where id = $id");
define("tax_qry7", "select * from taxrate");
?>
