<?php

/**********************************************************************
 * 
 * Company Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/

/*****************************************
 * account queries
 *****************************************/
define("account_qry1", "SELECT count(*) FROM account");
define("account_qry2", "SELECT * FROM account LIMIT 1 OFFSET %d");
define("account_qry3", "SELECT * FROM account WHERE ID = '%d'");
define("account_qry4", "SELECT * from account");
define("account_qry5", "INSERT INTO account VALUES(0,'%d','%s','%s','%d','%d')");
define("account_qry6", "UPDATE account SET parentID='%d'.AccountNumber='%s',name='%d',title='%d',gref='%d' WHERE ID = '%d'");
define("account_qry7", "DELETE FROM account WHERE ID = '%d'");
define("account_qry8", "SELECT type from accountheading where ID = '%d'");

/*****************************************
 * accountheading queries
 *****************************************/
define("acchead_qry1", "SELECT count(*) FROM accountheading");
define("acchead_qry2", "SELECT * FROM accountheading LIMIT 1 OFFSET %d");
define("acchead_qry3", "SELECT * FROM accountheading WHERE ID = '%d'");
define("acchead_qry4", "INSERT INTO accountheading	VALUES (0,'%s','%d','%d','%d','%d')");
define("acchead_qry5", "UPDATE accountheading SET name='%s',sref='%d',eref='%d',gref='%d',type='%d' WHERE ID='%d'");
define("acchead_qry6", "delete from accountheading where ID = '%d'");
define("acchead_qry7", "SELECT * from accountheading");

/*****************************************
 * department queries
 *****************************************/
define("dept_qry1", "SELECT count(*) FROM departments");
define("dept_qry2", "SELECT * FROM departments LIMIT 1 OFFSET %d");
define("dept_qry3", "SELECT * FROM departments WHERE ID = '%d'");
define("dept_qry4", "SELECT * FROM departments");
define("dept_qry5", "SELECT * FROM departments WHERE siteID='%d'");

/*****************************************
 * employee queries
 *****************************************/
define("emp_qry1", "SELECT count(*) FROM employee");
define("emp_qry2", "SELECT * FROM employee LIMIT 1 OFFSET %d");
define("emp_qry3", "SELECT * FROM employee WHERE ID = '%d'");
define("emp_qry4", "SELECT * FROM employee");
define("emp_qry5", "SELECT ID, fname, lname FROM employee WHERE groupID='%d'");

/*****************************************
 * gaccref queries
 *****************************************/
define("gacc_qry1", "SELECT count(*) FROM gaccref");
define("gacc_qry2", "SELECT * FROM gaccref LIMIT 1 OFFSET %d");
define("gacc_qry3", "SELECT * FROM gaccref WHERE ID = '%d'");
define("gacc_qry4", "SELECT * from gaccref");

/*****************************************
 * group queries
 *****************************************/
define("group_qry1", "SELECT count(*) FROM groups");
define("group_qry2", "SELECT * FROM groups LIMIT 1 OFFSET %d");
define("group_qry3", "SELECT * FROM groups WHERE ID = '%d'");
define("group_qry5", "SELECT * FROM groups WHERE deptID='%d'");
define("group_qry6", "SELECT * FROM groups WHERE deptID='%d'");
define("group_qry7", "select count(*) from posts where groupid='%d'");
define("group_qry8", "select count(*) from employee where groupid='%d'");
define("group_qry9", "select id, name from posts where groupid='%d'");
define("group_qry10", "select id, fname, lname from employee where groupid='%d'");
define("group_qry11", "update posts set groupid = '%d' where groupid='%d'");
define("group_qry12", "update employee set groupid = '%d' where groupid='%d'");
define("group_qry13", "delete from groups where id='%d'");
define("group_qry14", "INSERT INTO groups VALUES(0,'0','%s','%d','%d','%d','%s'"); 
define("group_qry15", "UPDATE groups SET name='%s',deptid='%d',localeid='%d',currencyid='%d',active='%d'where id='%d'");
define("group_qry16", "select name from groups where id = '%d'");

/*****************************************
 * setup queries
 *****************************************/
define("setup_qry1", "SELECT * FROM setup");
define("setup_qry2", "UPDATE setup SET name='%s',accountingDate='%s',regNumber='%s',vatNumber='%s' WHERE ID='0'");
define("setup_qry3", "UPDATE createmod SET ModifiedDate='%s', ModifiedBy='%d' WHERE ID='%d'");
define("setup_qry4", "SELECT name FROM setup");

/*****************************************
 * site queries
 *****************************************/
define("site_qry1", "SELECT count(*) FROM sites");
define("site_qry2", "SELECT * FROM sites LIMIT 1 OFFSET %d");
define("site_qry3", "SELECT * FROM sites WHERE ID = '%d'");
define("site_qry4", "INSERT INTO sites VALUES (0,0,'%s','%d','%d','%d','%d','%d','%f','%s','%s','%s','%s','%c')");
define("site_qry5", "UPDATE sites SET name='%s',addressID='%d',contactID='%d',localeID='%d',currencyID='%d',
		AnnualBudget='%f',site='%s',encryption='%s',login='%s',password='%s',Active='%c',bankID='%d' WHERE ID='%d'");
define("site_qry6", "DELETE FROM sites WHERE ID = '%d'");
define("site_qry7", "SELECT ID, name from sites");
define("site_qry8", "UPDATE departments SET SiteID = '%d' WHERE SiteID = '%d'");
define("site_qry9", "UPDATE departments SET SiteID = '0' WHERE SiteID = '%d'");
define("site_qry10", "SELECT ID, name FROM departments WHERE siteID = '%d'");
define("site_qry11", "SELECT ID, fname, lname from employee WHERE ID = '%d' ORDER BY lname");
define("site_qry12", "select name from sites where id = '%d'");

 /****************************************
 * tax queries
 *****************************************/
define("tax_qry1", "SELECT count(*) FROM taxrate");
define("tax_qry2", "SELECT * FROM taxrate LIMIT 1 OFFSET %d");
define("tax_qry3", "SELECT * FROM taxrate WHERE ID = '%d'");
define("tax_qry4", "select * from account where accountnumber='%d'");
//define("tax_qry4", "INSERT INTO taxrate (accountID, Rate, OnMenu) VALUES ('$frm[accountID]','$frm[rate]','$frm[OnMenu]')");
//define("tax_qry5", "UPDATE taxrate SET accountID=$frm[accountID], Rate='$frm[rate]', OnMenu='$frm[OnMenu]' WHERE ID='$id'");
//define("tax_qry6", "DELETE from taxrate where ID = $id");
define("tax_qry7", "SELECT * FROM taxrate");
?>
