<?php
/**********************************************************************
 * 
 * Reports Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/

/****************************************
 *  product queries
 ****************************************/
define("reportprod_qry1", "select plu, sum(quantity) as val from transactionitems where enteredat between '%s' and '%s'
      group by plu order by val desc limit %d");
define("reportprod_qry2", "select unitprice, tax from plu_cache where plu='%s'");

/****************************************
 *  location queries
 ****************************************/
define("reportloc_qry1", "select plu, sum(quantity) as val from transactionitems where enteredat between '%s' and '%s'
      and enteredstation='%s' group by plu order by val desc limit %d");
define("reportloc_qry2", "select name, unitprice, tax from plu_cache where plu='%s'");

/****************************************
 *  user queries
 ****************************************/
define("reportuser_qry1", "select plu, sum(quantity) as val from transactionitems where enteredat between '%s' and '%s'
      and enteredby='%d' group by plu order by val desc limit %d");
define("reportuser_qry2", "select unitprice, tax from plu_cache where plu='%s'");

/****************************************
 *  target queries
 ****************************************/
define("target_qry1", "select count(*) from prodtarget");
define("target_qry2", "select * from prodtarget limit 1 offset %d");
define("target_qry3", "select * from prodtarget where id = '%d'");
define("target_qry4", "select * from prodtarget");
define("target_qry5", "DELETE from prodtarget WHERE ID = '%d'");
define("target_qry6", "INSERT INTO prodtarget VALUES('','%d','%d','%d','%d','%d','%d'");
define("target_qry7", "UPDATE prodtarget SET cmid='%d,productid='%d',periodtype='%d',
   	period='%d',targetType='%d',target='%d' WHERE id='%d'");
      
/****************************************
 *  reporter queries
 ****************************************/
define("reporter_qry1", "select count(*) from prodtarget");
define("reporter_qry2", "select distinct nameid, count(*) from transaction where enteredat between '%s' and '%s'");
define("reporter_qry3", "select name from product where plu='%s'");
define("reporter_qry4", "select unitprice, tax from plu_cache where plu='%s'");
define("reporter_qry5", "select count(quantity) from transactionitems where enteredat between '%s' and '%s' and (transactionid or id) not in (select transid from return)");
define("reporter_qry6", "select sum(amount) from paymentitem where enteredat between '%s' and '%s' and transid not in (select transid from return)");
define("reporter_qry7", "select count(quantity) from transactionitems where enteredat between '%s' and '%s' and transactionid not in (select transid from return) and plu='%s'");
define("reporter_qry8", "select count(quantity) from transactionitems where enteredat between '%s' and '%s' and transactionid in (select transid from return) and plu='%s'");
define("reporter_qry9", "select count(quantity) from transactionitems where enteredat between '%s' and '%s' and transactionid in (select transid from return)");
define("reporter_qry10", "select sum(amount) from paymentitem where enteredat between '%s' and '%s' and transid in (select transid from return)");
define("reporter_qry11", "select count(quantity) from transactionitems where enteredat between '%s' and '%s' and transactionid in (select transid from return)");
define("reporter_qry12", "select invid, name from product where plu='%s'");
define("reporter_qry13", "select id from inventory where id='%d'");
define("reporter_qry14", "select sum(quantity), max(quantity) from transactionitems where enteredat between '%s' and '%s' and plu='%s'");
define("reporter_qry15", "select count(pi.quantity) from purchaseorderitems as pi, purchaseorder as po where po.dispatchdate between '%s' and '%s' and pi.inventoryid ='%d'");
define("reporter_qry16", "select pi.inventoryid, max(pi.quantity) from purchaseorderitems as pi, purchaseorder as po where po.dispatchdate between '%s' and '%s' group by pi.inventoryid");
define("reporter_qry17", "select id, max(instock + onorder) from inventory group by id");
define("reporter_qry18", "select max(to_days(po.arriveddate) - to_days(po.dispatchdate)) from purchaseorderitems as pi, purchaseorder as po  where pi.inventoryid = '%d'");
define("reporter_qry19", "select id, invid, plu, name from product where plu='%s'");
define("reporter_qry20", "select id, buyquantitypriceid from inventory where id='%d'");
define("reporter_qry21", "select price, supplierid from invpricequantity where id = '%d'");
//define("reporter_qry22", "select sum(quantity) from transactionitems as q, sum(amount) from paymentitem as t
//price from sellprice as sp, unitprice from buyprice as bp
//where enteredat between '%s' and '%s' and transactionid in (select transid from return) and plu='%s' and 
//(max(sp-bp) * q) LIMIT '%d'");

?>
