<?php
/**********************************************************************
 * 
 * Stock Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/

/****************************************
 * bpqname queries
 ****************************************/
define("bpqname_qry1", "SELECT count(*) FROM bqname");
define("bpqname_qry2", "SELECT * FROM bqname LIMIT 1 OFFSET %d");
define("bpqname_qry3", "SELECT * FROM bqname WHERE ID = '%d'");
define("bpqname_qry4", "INSERT INTO bqname (name,accountid,onmenu) VALUES('%s', '%d','%s')");
define("bpqname_qry5", "UPDATE bqname SET name='%s',accountID='%d',OnMenu='%s' WHERE ID = '%d'");
define("bpqname_qry6", "DELETE FROM bqname WHERE ID = '%d'");
define("bpqname_qry7", "SELECT * FROM bqname");

/****************************************
 * collection queries
 ****************************************/
define("collection_qry1", "SELECT count(*) FROM collection");
define("collection_qry2", "SELECT * FROM collection LIMIT 1 OFFSET %d");
define("collection_qry3", "SELECT * FROM collection WHERE ID = '%d'");
define("collection_qry4", "INSERT INTO collection VALUES('', '%s','%s','%d')");
define("collection_qry5", "UPDATE collection SET name='%s', description='%d', collectionID='%d' WHERE ID = '%d'");
define("collection_qry6", "DELETE FROM collection WHERE ID = '%d'");
define("collection_qry7", "SELECT * FROM collection");
define("collection_qry8", "SELECT ID FROM product WHERE PLU = '%s'");
define("collection_qry9", "INSERT INTO productcollection VALUES ('%d','%d')");
define("collection_qry10", "DELETE FROM productcollection WHERE prodcollID = '%d' AND productID='%d'");

/****************************************
 * deposit queries
 ****************************************/
define("deposit_qry1", "SELECT count(*) FROM deposit");
define("deposit_qry2", "SELECT * FROM deposit LIMIT 1 OFFSET %d");
define("deposit_qry3", "SELECT * FROM deposit WHERE ID = '%d'");
define("deposit_qry4", "INSERT INTO deposit VALUES('','%d','%d','%s','%f','%s','%d')");
define("deposit_qry5", "UPDATE deposit SET depositid='%d',cmid='%d',name='%s',percentage='%f',
   refundable='%s',type='%d'WHERE ID = '%d'");
define("deposit_qry6", "DELETE FROM deposit WHERE ID = '%d'");
define("deposit_qry7", "SELECT * FROM deposit");

/****************************************
 * discount queries
 ****************************************/
define("discount_qry1", "SELECT count(*) FROM discount");
define("discount_qry2", "SELECT * FROM discount LIMIT 1 OFFSET %d");
define("discount_qry3", "SELECT * FROM discount WHERE ID = '%d'");
define("discount_qry4", "INSERT INTO discount VALUES(0,'%d','%s','%d','%d','%f','%s'");
define("discount_qry5", "UPDATE discount SET DiscountID='%d',type='%d',ident='%d',targetID='%d',
   Margin='%f',Status='%s' WHERE ID='%d'");
define("discount_qry6", "DELETE FROM discount WHERE ID='%d'");
define("discount_qry7", "SELECT * FROM discount");
define("discount_qry8", "SELECT count(*) FROM product WHERE discountID = '%d'");

/****************************************
 * invpricequantity queries
 ****************************************/
define("invpq_qry1", "SELECT count(*) FROM invpricequantity");
define("invpq_qry2", "SELECT * FROM invpricequantity ORDER BY id LIMIT 1 OFFSET %d");
define("invpq_qry3", "SELECT * FROM invpricequantity WHERE ID = '%d' ORDER BY id");
define("invpq_qry4", "INSERT INTO invpricequantity (invprqid,nameid,quantity,quantitytypeid,udv,price,basecurrencyid,supplierid,suppliercode,ediid,accountid,taxid) VALUES ('%d','%d','%d','%d','%d','%f','%d','%d','%s','%d','%d','%d')");
define("invpq_qry5", "UPDATE invpricequantity SET invprqid='%d', nameid='%d',quantity='%d',quantitytypeid='%d',udv='%d',
   price='%f',basecurrencyid='%d',supplierid='%d',suppliercode='%s',ediid='%d',accountid='%d',taxid='%d' where id='%d'");
define("invpq_qry6", "DELETE FROM invpricequantity where ID='%d'");
define("invpq_qry7", "SELECT * FROM invpricequantity ORDER BY id");
define("invpq_qry8", "SELECT ID, Description from inventory WHERE buyquantitypriceid='%d'");

/****************************************
 * invcat queries
 ****************************************/
define("invcat_qry1", "SELECT count(*) FROM category");
define("invcat_qry2", "SELECT * FROM category ORDER BY id LIMIT 1 OFFSET %d");
define("invcat_qry3", "SELECT * FROM category WHERE ID = '%d'");
define("invcat_qry4", "INSERT INTO category (parentid,name,description) VALUES ('%d','%s','%s')");
define("invcat_qry5", "UPDATE category SET parentid='%d',name='%s',description='%s' WHERE id = '%d'");
define("invcat_qry6", "UPDATE category SET name='Unused' WHERE ID = '%d'");
define("invcat_qry7", "SELECT * FROM category ORDER BY id");
define("invcat_qry8", "SELECT DISTINCT parentID,name FROM category WHERE id='%d' ORDER BY parentID");
define("invcat_qry9", "SELECT * FROM category WHERE parentID='%d'");

/****************************************
 * inventory queries
 ****************************************/
define("inventory_qry1", "SELECT count(*) FROM inventory");
define("inventory_qry2", "SELECT * FROM inventory LIMIT 1 OFFSET %d");
define("inventory_qry3", "SELECT * FROM inventory WHERE ID = '%d'");
define("inventory_qry4", "SELECT * FROM inventory");
define("inventory_qry5", "SELECT * FROM invpricequantity where nameID='%d' AND Quantity='%d' AND
      QuantityTypeID='%d' AND UDV='%d' AND Price='%f' AND basecurrencyid='%d' AND SupplierID='%d' AND
		SupplierCode='%s' AND accountID='%d' AND TaxID='%d");
define("inventory_qry6", "INSERT INTO invpricequantity VALUES(0,0,'%d','%d','%d','%d','%f','%d','%d','%s',0,'%d','%d')");
define("inventory_qry7", "UPDATE invpricequantity SET invprqID='%d' WHERE ID='%d'");
define("inventory_qry8", "UPDATE inventory SET CategoryID='%d',PartNumber='%s',PartType='%d',StockLocation='%s',
   	Description='%s',InStock='%d',OnOrder='%d',ROLevel='%d',ROQty='%d',ReservedQty='%d',LeadTime='%d',
   	PartClassification='%d',buyquantitypriceid='%d',CMID='%d',invLink='%d' WHERE id = '%d'");
define("inventory_qry9", "SELECT buyquantitypriceid FROM inventory WHERE ID = '%d'");
define("inventory_qry10", "DELETE FROM inventory WHERE ID = '%d'");
define("inventory_qry11", "INSERT INTO inventory VALUES('','%d','%d','%s','%d','%s','%s','%d','%d','%d','%d','%d',
       '%d','%d','%d','%d','%d' WHERE id = '%d'");
define("inventory_qry12", "UPDATE inventory SET buyquantitypriceid='%d' WHERE id = '%d'");

/****************************************
 * label queries
 ****************************************/
define("label_qry1", "SELECT count(*) FROM label");
define("label_qry2", "SELECT * FROM label LIMIT 1 OFFSET %d");
define("label_qry3", "SELECT * FROM label WHERE ID = '%d'");
define("label_qry4", "INSERT INTO label VALUES('','%d','%d','%s','%d','%d','%s')");
define("label_qry5", "UPDATE label SET labelID='%d',type='%d',name='%s',xdim='%d',ydim='%d',data='%s' WHERE ID = '%d'");
define("label_qry6", "DELETE FROM label WHERE ID = '%d'");
define("label_qry7", "SELECT * FROM label");

/****************************************
 * margin queries
 ****************************************/
define("margin_qry1", "SELECT count(*) FROM margin");
define("margin_qry2", "SELECT * FROM margin LIMIT 1 OFFSET %d");
define("margin_qry3", "SELECT * FROM margin WHERE ID = '%d'");
define("margin_qry4", "INSERT INTO margin (marginid, name, margin, productcollid) VALUES ('%d','%s','%f','%d')");
define("margin_qry5", "UPDATE margin SET marginID='%d',name='%s',margin='%f',productcollID='%d'WHERE ID = '%d'");
define("margin_qry6", "DELETE FROM margin WHERE ID = '%d'");
define("margin_qry7", "SELECT * FROM margin");


/****************************************
 * return queries
 ****************************************/
define("return_qry1", "SELECT count(*) FROM return");
define("return_qry2", "SELECT * FROM return LIMIT 1 OFFSET %d");
define("return_qry3", "SELECT * FROM return WHERE ID = '%d'");
define("return_qry4", "INSERT INTO return VALUES('','%d','%d','%s','%s','%f','%s','%d')");
define("return_qry5", "UPDATE return SET type='%d',StartDate='%s',EndDate='%s',Margin='%f',Memo='%s',
   promoLinkID='%d' WHERE ID = '%d'");
define("return_qry6", "DELETE FROM return WHERE ID = '%d'");
define("return_qry7", "SELECT * FROM return");

/****************************************
 * product queries
 ****************************************/
define("product_qry1", "SELECT count(*) FROM product");
define("product_qry2", "SELECT * FROM product LIMIT 1 OFFSET %d");
define("product_qry3", "SELECT * FROM product WHERE ID = '%d'");
define("product_qry4", "INSERT INTO product VALUES('','%d','%d','%d','%d','%s','%d','%s','%s','%d','%s','%d',
   '%s','%d','%d','%d','%d','%s','%d','%s','%d','%d','%s')");
define("product_qry6", "DELETE FROM product WHERE ID = '%d'");
define("product_qry7", "SELECT * FROM product ORDER BY id"); 
define("product_qry8", "UPDATE product SET  sellquantityid='%d' WHERE ID='%d'"); 
define("product_qry9", "SELECT InvID, sellquantityid FROM product WHERE ID = '%d'"); 
define("product_qry10", "SELECT ID,InvID,sellquantityid FROM product WHERE InvID = '%d'");
define("product_qry11", "SELECT PLU,PLUType,Name,Description FROM product WHERE ID = '%d'");

/****************************************
 * promotion queries
 ****************************************/
define("promotion_qry1", "SELECT count(*) FROM promotion");
define("promotion_qry2", "SELECT * FROM promotion LIMIT 1 OFFSET %d");
define("promotion_qry3", "SELECT * FROM promotion WHERE ID = '%d'");
define("promotion_qry4", "SELECT * FROM promotion");
 
 
/****************************************
 * returntype queries
 ****************************************/
define("returntype_qry1", "SELECT count(*) FROM returntype");
define("returntype_qry2", "SELECT * FROM returntype LIMIT 1 OFFSET %d");
define("returntype_qry3", "SELECT * FROM returntype WHERE ID = '%d'");
define("returntype_qry4", "INSERT INTO returntype VALUES('','%s','%s')");
define("returntype_qry5", "UPDATE returntype SET Name='%s', Active='%s' WHERE ID = '%d'");
define("returntype_qry6", "DELETE FROM returntype WHERE ID = '%d'");
define("returntype_qry7", "SELECT * FROM returntype");
define("returntype_qry8", "SELECT ID, Name from returntype where Active='Y'");
define("returntype_qry9", "SELECT name from returntype where ID='%d'");

/****************************************
 * sellpq queries
 ****************************************/
define("sellpq_qry1", "SELECT count(*) FROM prodpricequantity");
define("sellpq_qry2", "SELECT * FROM prodpricequantity LIMIT 1 OFFSET %d");
define("sellpq_qry3", "SELECT * FROM prodpricequantity WHERE ID = '%d'");
define("sellpq_qry4", "INSERT INTO prodpricequantity (pqid,nameid,quantity,quantitytypeid,udv,price,basecurrencyid,taxid) VALUES('%d','%d','%d','%d','%d','%f','%d','%d')");
define("sellpq_qry5", "UPDATE prodpricequantity SET pqID='%d',nameID='%d',Quantity='%d',QuantityTypeID='%d',
   UDV='%d',Price='%f',basecurrencyid='%d',TaxID='%d' WHERE ID='%d'");
define("sellpq_qry6", "DELETE FROM prodpricequantity WHERE ID='%d'");
define("sellpq_qry7", "SELECT * FROM prodpricequantity");
define("sellpq_qry8", "SELECT ID, PLU, Name, Description from product WHERE sellquantityid='%d'");
define("sellpq_qry9", "UPDATE prodpricequantity SET Price=(Price + (Price * %f)) WHERE 1");

/****************************************
 * sellpqname queries
 ****************************************/
define("sellpqname_qry1", "SELECT count(*) FROM pqname");
define("sellpqname_qry2", "SELECT * FROM pqname LIMIT 1 OFFSET %d");
define("sellpqname_qry3", "SELECT * FROM pqname WHERE ID = '%d'");
define("sellpqname_qry4", "INSERT INTO pqname (name, accountid, onmenu) VALUES('%s', '%d', '%s')");
define("sellpqname_qry5", "UPDATE pqname SET name='%s', accountID='%d',OnMenu='%s' WHERE id='%d'");
define("sellpqname_qry6", "DELETE FROM pqname WHERE ID = '%d'");
define("sellpqname_qry7", "SELECT * FROM pqname");

/****************************************
 * stocktake queries
 ****************************************/
define("stocktake_qry1", "DROP TABLE IF EXISTS stocktake_products");
define("stocktake_qry2", "CREATE TABLE IF NOT EXISTS stocktake_products(ID int(11) NOT NULL auto_increment,
	    PLU varchar(16) NOT NULL, InStock int(11) NOT NULL,CurrentStock int(11) NOT NULL,PRIMARY KEY (ID))");
define("stocktake_qry3", "SELECT PLU, InStock FROM product ORDER BY PLU");
define("stocktake_qry4", "INSERT INTO stocktake_products VALUES(0,'%s','%d','0')");
define("stocktake_qry5", "SELECT CurrentStock FROM stocktake_products WHERE PLU='%s'");
define("stocktake_qry6", "UPDATE stocktake_products SET CurrentStock='%d' WHERE PLU='%s'");
define("stocktake_qry7", "SELECT PLU, CurrentStock FROM stocktake_products ORDER BY PLU");
define("stocktake_qry8", "UPDATE product SET InStock='%d' WHERE PLU='%s'");
define("stocktake_qry9", "SELECT * FROM synch WHERE Implemented='N' AND typeID='6'");
define("stocktake_qry10", "INSERT INTO synch VALUES(0,'6',CURRENT_TIMESTAMP(0),CURRENT_TIMESTAMP(0),'','N')");
define("stocktake_qry11", "SELECT ID FROM synch WHERE Implemented='N' AND typeID='6'");
define("stocktake_qry12", "UPDATE synch SET Implemented='Y', ImplementationAt=CURRENT_TIMESTAMP(0) WHERE ID= '%d'");
define("stocktake_qry13", "SELECT * from stocktake_products WHERE InStock!=CurrentStock");
define("stocktake_qry14", "UPDATE inventory SET InStock='%d' WHERE ID=(SELECT invID from product WHERE product.PLU='%s')");
define("stocktake_qry15", "UPDATE stocktake_products SET InStock='%d' WHERE PLU='%s'");
define("stocktake_qry16", "SELECT * FROM stocktake_products WHERE PLU='%s'");

/****************************************
 * uplu queries
 ****************************************/
define("uplu_qry1", "SELECT count(*) FROM u_plu");
define("uplu_qry2", "SELECT * FROM u_plu LIMIT 1 OFFSET %d");
define("uplu_qry3", "SELECT * FROM u_plu WHERE ID = '%d'");
define("uplu_qry4", "INSERT INTO plu_cache VALUES('','%d','%d','%s','%s','%s','%f','%f','%d','%f','%f','%d')");
define("uplu_qry5", "SELECT ID FROM taxrate WHERE Rate = '%f'");
define("uplu_qry6", "DELETE FROM u_plu WHERE ID = '%d'");
define("uplu_qry7", "SELECT * FROM u_plu");
define("uplu_qry8", "SELECT Rate FROM taxrate WHERE ID = '%d'");

?>
