<?
/*
supplier.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

class Supplier
{
   var $id;
   var $cmid;
   var $supplierid;
   var $typeid;
   var $name;
   var $addressid;
   var $invoicename;
   var $invoicecontactid;
   var $contactid;
   var $chargeid;
   var $ediid;
   var $acccountid;
   var $linkid;
   var $type;
   var $active;
   var $notes;
   
   function Supplier($id=false)
   {
      if(isset($id)){
         $this->Fill($id);
      }
      else{
         $this->id=0;
         $this->cmid=0;
         $this->supplierid=0;
         $this->typeid=0;
         $this->name="";
         $this->addressid=0;
         $this->invoicename="";
         $this->invoicecontactid=0;
         $this->contactid=0;
         $this->chargeid=0;
         $this->ediid=0;
         $this->acccountid=0;
         $this->linkid=0;
         $this->type=0;
         $this->active='N';
         $this->notes="";
      }
   }
   
   function Fill($id, $bOffset=true)
   {
      if($bOffset){
         $qry=sprintf(bank_qry7, $id);
      }
      else{
         $qry=sprintf(banklib_qry6, $id);
      }
      
	   $result=db_query($qry);
      if($row = $result->FetchRow()){
         $this->ID=$id;
         $this->cmid=$row["cmid"];
         $this->supplierid=$row["supplierid"];
         $this->typeid=$row["typeid"];
         $this->name=$row["name"];
         $this->addressid=$row["addressid"];
         $this->invoicename=$row["invoicename"];
         $this->invoicecontactid=$row["invoicecontactid"];
         $this->contactid=$row["contactid"];
         $this->chargeid=$row["chargeid"];
         $this->ediid=$row["ediid"];
         $this->acccountid=$row["acccountid"];
         $this->linkid=$row["linkid"];
         $this->type=$row["type"];
         $this->active=$row["active"];
         $this->notes==$row["notes"];

         return true;
      }
      return false;
   }
   
   function Combo($id)
   {
   }
   
   function Table($id)
   {
   }
}




	function CheckPLU()
	{
		if(!isset($this->plu) || $this->plu==""){
			return 1;
		}
		$result=db_query("select id, invid, plu, name from product where plu='$this->plu'");
		if(db_num_rows($result)==0){
			return 2;
		}
		$row = $result->FetchRow());
		$this->productid=$row["id"];
		$this->name=$row["name"];
		$this->invid=$row["invid"];
		db_free_result($result); 
		
		$result=db_query("select id, buyquantitypriceid from inventory where id='$this->invid'");
		if(db_num_rows($result)==0){
			return 3;
		}
		$row = $result->FetchRow();
		$bqid=$row["buyquantitypriceid"];
		db_free_result($result); 

		$result=db_query("select price, supplierid from invpricequantity where id = '$bqid'");
		if(db_num_rows($result)==0){
			return 4;
		}
		$row = $result->FetchRow();
		$this->price=$row["price"];
		$this->supplierid=$row["supplierid"];
		db_free_result($result); 
		
		return 0;
	}

	function Total()
	{
		return (float) $this->qty * $this->price;
	}

	function GetInvID() { return $this->invid; }
	function GetProdID() { return $this->productid; }
	function GetPLU() { return $this->plu; }
	function GetName() { return $this->name; }
	function GetQty() { return $this->qty; }
	function GetPrice() { return $this->price; }
	function GetSupplier() { return $this->supplierid; }
	function GetFlags() { return $this->flags; }
   function GetStatus() { return $this->status; }

	function SetInvID($iid) { $this->invid=$iid; }
	function SetProdID($pid) { $this->productid=$pid; }
	function SetPLU($p) { $this->plu=$p; }
	function SetName($n) { $this->name=$n; }
	function SetQty($q) { $this->qty=$q; }
	function SetPrice($p) { $this->price=$p; }
	function SetSupplier($s) { $this->supplierid=$s; }
	function SetFlags($f) { $this->flags=$f; }
   function SetStatus($s) 
   {
      switch($s){
      case 'unknown':
      case 'ok':
      case 'missing':
      case 'damaged':
      case 'wrongitem':
      case 'underqty':
      case 'overqty':
         $this->status=$s; 
         return false;
      }
      return true;
   }
}

class InvItems
{
	var $num_items;
	var $supplierid;
	var $items;	
	var $curr_item;
	var $total;

	function InvItems()
	{
		$this->init();
	}

	function init() 
	{
		$this->num_items = 0;
		$this->supplierid = 0;
		$this->items = array();
		$this->curr_item = 0;
		$this->total = 0.00;
	}

	function cleanup() 
	{
		foreach($this->items as $i){
			unset($this->items[$i]);
		}
	}

	function Add($InvItem) 
	{
		$found=0;

		if(isset($InvItem)){
			if(count($this->items)!=0){
				foreach($this->items as $num=>$ii){
					$plu=$ii->GetPLU();
					$tplu=$InvItem->GetPLU();
					if($plu==$tplu){
						$tqty=$ii->GetQty() + $InvItem->GetQty();
						$ii->SetQty($tqty);
						$this->items[$num] = $ii;
						$found=1;
						break;
					}
				}
			}
			if($found==0){
				$this->num_items++;
				array_push($this->items, $InvItem);
			}
		}

	}

	function delete($num) 
	{
		if(isset($num)) {
			unset($this->items[$num]);
			$this->num_item--;
		}
	}

	function NumItems() { return $this->num_items; }
	function CurrItem() { return $this->curritem; }
	function GetSupplier() { return $this->supplierid; }
	function SetSupplier($s) { $this->supplierid=$s; }

	function listAllSupplierProducts()
	{
		$result=db_query("select id from invpricequantity where supplierid='$this->supplierid'");
		if(db_num_rows($result)==0){
			return 1;
		}
		$row = $result->FetchRow();
		$bqid=$row["id"];
		db_free_result($result); 

		$result=db_query("select id from inventory where buyquantitypriceid='$bqid'");
		if(db_num_rows($result)==0){
			return 2;
		}

		echo "<table border=\"0\" cellpadding=\"2\" width=\"100%\" bgcolor=\"#FFFFFF\">\n";
		echo "<tr><td colspan=\"5\" align=\"left\" bgcolor=\"#002277\"><font color=\"#FFFFFF\">Items by Supplier</font></td></tr>";
		echo "<tr><td><b>PLU</b></td><td><b>Name</b></td><td><b>Price</b></td><td><b>Qty</b></td><td></td></tr>\n";

		while($row = $result->FetchRow()){
			$iid=$row["id"];
			$presult=db_query("select plu, name from product where invid='$iid'");
			if(db_num_rows($presult)==0){
			}
			else{
				echo "<td>'$row[plu]'</td>\n";
				echo "<td>'$row[name]'</td>\n";
				echo "<td>$price</td>\n";
				echo "<td><input type=\"text\" name=\"Qty\" size=\"8\" maxlength=\"8\" value=\"$qty\"></td>\n";

				db_free_result($presult); 
			}
			echo "</tr>\n";
		}
		echo "</table>\n";
	}

	function fillpitems($pid)
	{
		if(count($this->items)!=0){
			foreach($this->items as $num=>$ii){
				$iid=$ii->GetInvId();
				$qty=$ii->GetQty();
				db_query("INSERT INTO purchaseorderitems VALUES ('','$pid','$qty','$iid')");
			}
		}
		else{
			return 1;
		}
	}

	function buildItemList($title)
	{
		$count=0;
		$gtotal=0.00;
		$numi=$this->num_items;
		
		echo "<table border=\"0\" cellpadding=\"2\" width=\"100%\" bgcolor=\"#FFFFFF\">\n";
		echo "<tr><td colspan=\"6\" align=\"left\" bgcolor=\"#002277\"><font color=\"#FFFFFF\">$title - $numi Items</font></td></tr>";
		echo "<tr><td><b>PLU</b></td><td><b>Qty</b></td><td><b>Name</b></td><td><b>Price</b></td><td><b>Sub</b></td><td></td></tr>\n";
		if(count($this->items)!=0){
			foreach($this->items as $num=>$ii){
				$count++;

				$plu=$ii->GetPLU();
				$qty=$ii->GetQty();
				$name=$ii->GetName();
				$price=$ii->GetPrice();
				$total=$ii->Total();
				$gtotal+=$total;

				if(($count%2)==0){
					echo "<tr bgcolor=\"#CCCCCC\">\n";
				}
				else{
					echo "<tr bgcolor=\"FFFFFF\">\n";
				}
				if($this->curr_item==$count){
					echo "<td><input type=\"text\" name=\"plu\" size=\"16\" maxlength=\"13\" value=\"$plu\"></td>\n";
					echo "<td><input type=\"text\" name=\"qty\" size=\"8\" maxlength=\"8\" value=\"$qty\"></td>\n";
					echo "<td><input type=\"text\" name=\"name\" size=\"32\" maxlength=\"32\" value=\"$name\"></td>\n";
					echo "<td><input type=\"text\" name=\"price\" size=\"8\" maxlength=\"12\" value=\"$price\"></td>\n";
					echo "<td><input type=\"text\" name=\"sub\" size=\"10\" maxlength=\"12\" value=\"$total\"></td>\n";
					echo "<td><input type=\"hidden\" name=\"action\" value=\"itemedit\">\n";
					echo "<input type=\"hidden\" name=\"itemid\" value=\"$num\">\n";
					echo "<a href=\"purchase.php?action=itemedit&itemid=$num\">commit</a>\n</td>\n";
				}
				else{
					echo "<td>$plu</td>\n";
					echo "<td>$qty</td>\n";
					echo "<td>$name</td>\n";
					echo "<td>$price</td>\n";
					echo "<td>$total</td>\n";
					echo "<td><a href=\"purchase.php?action=itemeditsel&itemid=$num\">edit</a>&nbsp;\n";
					echo "<a href=\"purchase.php?action=itemdelete&itemid=$num\">delete</a>&nbsp;</td>\n";
				}
				echo "</tr>\n";
			}
		}
		if($this->curr_item==0){	// no current item so add field
			echo "<tr bgcolor=\"FFFFFF\">\n";
			//echo "<form name=\"purch\" method=\"post\" action=\"$_SERVER['PHP_SELF']\">\n";
			echo "<td><input type=\"text\" name=\"plu\" size=\"16\" maxlength=\"13\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"qty\" size=\"8\" maxlength=\"8\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"name\" size=\"32\" maxlength=\"32\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"price\" size=\"8\" maxlength=\"12\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"sub\" size=\"10\" maxlength=\"12\" value=\"\"></td>\n";
			echo "<td><input type=\"hidden\" name=\"action\" value=\"itemadd\"></td>\n";
			echo "<td><input type=\"submit\" value=\"Add\">\n</td>\n";
			echo "</tr>\n";
		}
		echo "<tr><td colspan=\"4\" align=\"right\" bgcolor=\"#002277\"><font color=\"#FFFFFF\">Total</td>\n";
		echo "<td>$gtotal</font></td><td>&nbsp;</td></tr>\n";
		echo "</table>\n";
	}
   
   function buildCheckInList($title, $poid)
	{
      $result=db_query("SELECT * from purchaseorderitems WHERE purchaseorderid='$poid'");
      if(db_num_rows($result)==0){
         print "<br><br><center>No purchase order items found...</center>";
      }
      else{
      	echo "<br><br>";
      	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
   	   echo "<tr><td colspan=\"5\"><h2>Purchase Order Items for Order: $poid</h2></td></tr>\n";
      	echo "<tr><td><h3>PLU</h3></td><td><h3>Name</h3></td><td><h3>Qty</h3></td><td><h3>Status</h3></td></tr>\n";
	   	while($row = $result->FetchRow()){
		   	$qty=$row["quantity"];
			   $invid=$row["inventoryid"];

      		$sresult=db_query("select stocklocation from inventory where id='$invid'");
            $srow = $sresult->FetchRow();
            $sl=$srow["stocklocation"];

   			$sresult=db_query("select plu,name from product where invid='$invid'");
	   		$srow = $sresult->FetchRow();
            $plu=$srow["plu"];
			   $name=$srow["name"];
            
            // push back inv items with status=unknown
            $ni = new InvItem();
	         $ni->SetInvID($invID);
            $ni->SetQty($qty);
            $ni->SetStatus('unknown');
            $this->Add($ni);
            
	   		echo "<tr><td>$plu</td><td>$name</td><td>$qty</td><td>\n";
            $this->statuscombo('add', 'unknown',$invID);
            echo "</td></tr>\n";
		   }
   		echo "<tr><td align=\"center\" colspan=\"5\"><input type=\"submit\" value=\"Check Items In\"></td></tr>\n";
	   	echo "</table>\n";
	   }
   }
   
   function statuscombo($a, $tid, $id)
   {
      $typelist = array(0=>'unknown',1=>'ok',2=>'missing',3=>'damaged',4=>'wrongitem',5=>'underqty',6=>'overqty');
   
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"status:$id\" width=\"250\">\n";
	      foreach ($typelist as $typeid) {
	         print "<option ";
   	      if($tid == $typeid)
	            print "selected ";
   	      print "value='$typeid'>$typeid</option>\n";
	      }
	      echo "</select>\n";
      }
      else{
         echo $type;
      }
   }
   
   function checkItemsIn($frm)
	{
      db_query("INSERT INTO transaction VALUES()");
      $tid=db_insert_id();
      
      db_query("UPDATE purchaseorder SET transactionid='$tid' WHERE purchaseorderid='$pid'");
      
      foreach($items as $iitem){
         $invid=$iitem->GetInvID();
         if($frm["status.$invid"]=='ok'){
            // credit stock, update purchaseorderitems, remove from array
            
            $result=db_query("INSERT INTO transactionitems VALUES('', '$tid', NOW(),
            '$userID','$misip','ITEMTYPE_PURCHASE','$plu','$qty')");
         }
         else{
            // create discrepancy report for status!=ok,
         }
      }
   }
}

class ProductItems
{
	var $num_items;
	var $customerID;
	var $items;	
	var $curr_item;
	var $total;

	function ProductItems()
	{
		$this->init();
	}

	function init() 
	{
		$this->num_items = 0;
		$this->customerID = 0;
		$this->items = array();
		$this->curr_item = 0;
		$this->total = 0.00;
	}

	function cleanup() 
	{
		foreach($this->items as $i) {
			unset($this->items[$i]);

		}
	}

	function Add($InvItem) 
	{
		$num_items++;
		
		if(isset($InvItem)){
			array_push($this->items, $InvItem);
		}
	}

	function delete($num) 
	{
		if(isset($num)) {
			unset($this->items[$num]);
			$this->num_item--;
		}
	}

	function NumItems() { return $this->num_items; }
	function CurrItem() { return $this->curritem; }
	function GetCustomer() { return $this->customerID; }
	function SetCustomer($s) { $this->customerID=$s; }

	function listAllSupplierProducts()
	{
		$result=db_query("SELECT ID, buyquantitypriceid from inventory WHERE supplierID='$this->supplierID'");
		while($row = $result->FetchRow()){
			$invID=$row["ID"];
			$bqid=$row["buyquantitypriceid"];
			$presult=db_query("SELECT PLU, name from product WHERE InvID='$invID'");
			$prow = $presult->FetchRow();

			$bqresult=db_query("SELECT Price, SupplierID FROM invpricequantity WHERE supplierID = '$this->supplierID'");
			$bqrow = $bqresult->FetchRow()
			$price=$row["Price"];
		}
	}

	function buildItemList()
	{
		$count=0;
		$gtotal=0.00;
		$numi=$this->num_items+1;
		
		echo "<table border=\"0\" cellpadding=\"2\" width=\"100%\" bgcolor=\"#FFFFFF\">\n";
		echo "<tr><td colspan=\"6\" align=\"left\" bgcolor=\"#002277\"><font color=\"#FFFFFF\">Purchase Order - $numi Items</font></td></tr>";
		echo "<tr><td><b>PLU</b></td><td><b>Qty</b></td><td><b>Name</b></td><td><b>Price</b></td><td><b>Sub</b></td><td></td></tr>\n";
		if(count($this->items)!=0){
			foreach($this->items as $num=>$ii){
				$count++;

				$plu=$ii->GetPLU();
				$qty=$ii->GetQty();
				$name=$ii->GetName();
				$price=$ii->GetPrice();
				$total=$ii->Total();
				$gtotal+=$total;

				if(($count%2)==0){
					echo "<tr bgcolor=\"#CCCCCC\">\n";
				}
				else{
					echo "<tr bgcolor=\"FFFFFF\">\n";
				}
				if($this->curr_item==$count){
					echo "<td><input type=\"text\" name=\"PLU\" size=\"16\" maxlength=\"13\" value=\"$plu\"></td>\n";
					echo "<td><input type=\"text\" name=\"Qty\" size=\"8\" maxlength=\"8\" value=\"$qty\"></td>\n";
					echo "<td><input type=\"text\" name=\"Name\" size=\"32\" maxlength=\"32\" value=\"$name\"></td>\n";
					echo "<td><input type=\"text\" name=\"Price\" size=\"8\" maxlength=\"12\" value=\"$price\"></td>\n";
					echo "<td><input type=\"text\" name=\"Sub\" size=\"10\" maxlength=\"12\" value=\"$total\"></td>\n";
					echo "<td><input type=\"hidden\" name=\"action\" value=\"itemedit\"></td>\n";
					echo "<td><input type=\"hidden\" name=\"itemid\" value=\"$num\"></td>\n";
					echo "<td><a href=\"purchase.php?action=itemedit&itemid=$num\">commit</a>\n</td>\n";
				}
				else{
					echo "<td>$plu</td>\n";
					echo "<td>$qty</td>\n";
					echo "<td>$name</td>\n";
					echo "<td>$price</td>\n";
					echo "<td>$total</td>\n";
					echo "<td><a href=\"purchase.php?action=itemeditsel&itemid=$num\">edit</a>&nbsp;\n";
					echo "<a href=\"purchase.php?action=itemdelete&itemid=$num\">delete</a>&nbsp;</td>\n";
				}
				echo "</tr>\n";
			}
		}
		if($this->curr_item==0){	// no current item so add field
			echo "<tr bgcolor=\"FFFFFF\">\n";
			//echo "<form name=\"purch\" method=\"post\" action=\"$_SERVER['PHP_SELF']\">\n";
			echo "<td><input type=\"text\" name=\"PLU\" size=\"16\" maxlength=\"13\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Qty\" size=\"8\" maxlength=\"8\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Name\" size=\"32\" maxlength=\"32\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Price\" size=\"8\" maxlength=\"12\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Sub\" size=\"10\" maxlength=\"12\" value=\"\"></td>\n";
			echo "<td><input type=\"hidden\" name=\"action\" value=\"itemadd\"></td>\n";
			echo "<td><input type=\"submit\" value=\"Add\">\n</td>\n";
			echo "</tr>\n";
		}
		echo "<tr><td colspan=\"4\" align=\"right\" bgcolor=\"#002277\"><font color=\"#FFFFFF\">Total</td>\n";
		echo "<td>$gtotal</font></td><td>&nbsp;</td></tr>\n";
		echo "</table>\n";
	}
}

?>
