<?php
/*
discount.php

Copyright (C)2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/discount.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(discount_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

   
switch($_REQUEST['action']){
	case "clear" :
		addDiscount();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseDiscount($id);
		break;

	case "edit" :
		editDiscount($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelDiscount($_REQUEST['id']);
      }
      else{
         deleteDiscount($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listDiscount();
      }
      break;  
	
   case "cfmdelete" :
      deleteDiscount($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listDiscount();
		break;

	case "add" :
		insertDiscount();
      $_SESSION["pageindex"]->addition(CountNum());
		listDiscount();
		break;

	case "commit" :
		commitDiscount($id, $_POST);
		listDiscount();
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listDiscount();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(discount_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"]="";
   $frm["discountid"]="";
   $frm["type"]="product";
   $frm["ident"]="";
   $frm["targetid"]="";
   $frm["margin"]="";
   $frm["status"]=""; 
      
   return $frm;
}

function fillform($id, $bOffset)
{
   
   if($bOffset){
      $qry=sprintf(discount_qry2, $id);
   }
   else{
      $qry=sprintf(discount_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["id"]=$id;
   $frm["discountid"]=$row["discountid"];
   $frm["type"]=$row["type"];
   $frm["ident"]=$row["ident"];
   $frm["targetid"]=$row["targetid"];
   $frm["margin"]=$row["margin"];
   $frm["status"]=$row["status"];
   
   // fixed discount
   if($frm["discountid"]!=0){
      $result=db_query("select count(*) from product where discountid = '$frm[discountid]'");
      $row = $result->FetchRow();
      $frm["numproduct"]=$row[0];
   }
   else{
      $frm["numproduct"]=0;
   }
   
   return $frm;
}

function productList($id)
{
   if($id==0) return;
   $result=db_query("select id, plu, name from product where discountid = '$id'");
   while($row = $result->FetchRow()){
      echo "<tr><td align=\"right\"><a href=\"product.php?action=browse&id=$row[0]\">$row[1]</a></td><td>$row[2]</td></tr>\n";
   }
}

function addDiscount()
{
   $frm=clearform();
	$frm["newaction"] = "add";
   $frm["heading"] = "Discount Add";

	include("templates/discountedit.php");
}

function editDiscount($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Discount Edit";
	include("templates/discountedit.php");
}

function browseDiscount($id) 
{
   $frm=fillform($id, true);
   $frm["newaction"] = "browse";
	$frm["heading"] = "Discount Browse";
	include("templates/discountedit.php");
}

function chkdelDiscount($id)
{
   $frm=fillform($id, false);
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Discount Delete";
	include("templates/discountedit.php");
}

function deleteDiscount($id) 
{
   $qry=sprintf(discount_qry6, $id);
   db_query($qry); 
}

function insertDiscount($frm) 
{
   $qry=sprintf(discount_qry4, $frm['discountid'],$frm['type'],$frm['ident'],$frm['targetid'],
   $frm['margin'],$frm['status']);
   db_query($qry); 
}

function commitDiscount($frm) 
{
   $qry=sprintf(discount_qry4, $frm['discountid'],$frm['type'],$frm['ident'],$frm['targetid'],
   $frm['margin'],$frm['status'],$frm['id']);
   db_query($qry); 
}

function listDiscount()
{  
	$q=$_SESSION["pageindex"]->query(discount_qry7);
	$result=db_query($q);

	print "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Type</h3></td><td><h3>Margin</h3></td><td><h3>Num Products</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		print "<tr><td>";
		$wibbler=$myrow["id"];
		$n=$myrow["margin"];
      $qry=sprintf(discount_qry8, $myrow['discountid']);
      $nresult=db_query($qry);
      $nrow = $nresult->FetchRow();
			
		print "$myrow[type]</td><td>$n</td><td>$nrow[0]</td><td>";
		print "<a href=\"discount.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"discount.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"discount.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
				
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "</form>";
	echo "<br><br>";
}

?>
