<?php
/*
invcat.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(invcat_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addCategory();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseCategory($id);
		break;

	case "edit" :
		editCategory($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelCategory($_REQUEST['id']);
      }
      else{
         deleteCategory($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listCategory();
      }
      break;  
	
   case "cfmdelete" :
      deleteCategory($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listCategory();
		break;

	case "add" :
		insertCategory($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listCategory();
		break;

	case "commit" :
		commitCategory($_POST);
      listCategory();
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listCategory();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(invcat_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = 0;
	$frm["parentid"] = "";
	$frm["name"] = "";
	$frm["description"] = "";

	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(invcat_qry2, $id);
   }
   else{
      $qry=sprintf(invcat_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm["id"] = $row["id"];
	$frm["name"] = $row["name"];
	$frm["parentid"] = $row["parentid"];
	$frm["description"] = $row["description"];

	if($row["parentid"]==0){
		$frm["parentname"] = "Not Set";
	}
	else{
		$result=db_query("SELECT name FROM category WHERE id = '$frm[parentid]'");
		$row = $result->FetchRow();
		$frm["parentname"] = $row["name"];
	}

	return $frm;
}

function addCategory()
{        
	$frm=clearForm();
	$frm["newaction"] = "add";
        $frm["heading"] = "Category Add";
	
	include("templates/catedit.php");
}

function editCategory($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Category Edit";

	include("templates/catedit.php");
}

function browseCategory($id) 
{
	$frm=fillForm($id, true);

	$frm["newaction"] = "browse";
   $frm["heading"] = "Category Browse";
	
	include("templates/catedit.php");
}

function insertCategory($frm) 
{
   $qry=sprintf(invcat_qry4, $frm['parentid'], $frm['name'], $frm['description']);
	db_query($qry);
}

function commitCategory($frm) 
{
   $qry=sprintf(invcat_qry5, $frm['parentid'], $frm['name'], $frm['description'], $frm['id']);
   db_query($qry);
}

function chkdelCategory($id) 
{
   $frm=fillForm($id, false);
   $frm["ID"] = $id;
   $frm["heading"] = "Category Delete";
   $frm["newaction"] = "cfmdelete";
   
   include("templates/catedit.php");
}

function deleteCategory($id) 
{
   $qry=sprintf(invcat_qry6, $id);
	
	include("templates/catdel.php");
}

function listCategory()
{  
	$q=$_SESSION["pageindex"]->query(invcat_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Category Name</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		print "<tr><td>";
		if($myrow["name"]){
			printf ("%02d - %s", $myrow["id"], $myrow["name"]);
		}
		else{
			printf ("%02d - Unused", $myrow["id"]);
		}
		print "</td><td>";
		$wibbler=$myrow["id"];
		print "<a href=\"invcat.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"invcat.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"invcat.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

function parentSelection($parent_id, $newaction)
{
	if($newaction == "browse" || $newaction=="cfmdelete") {
		if ($parent_id == 0) {
			echo "Not Set";
		}
		else {
                        $qry=sprintf(invcat_qry8, $parent_id);
			$result = db_query($qry);
			$myrow = $result->FetchRow();
			echo $myrow['name'];
		}
	}
	else {
		echo "<select name='parentid'>\n";
		echo "<option value='0'>Not Set</option>\n";
		$result = db_query(invcat_qry7);
		while ($myrow = $result->FetchRow()) {
			echo "<option value='" . $myrow['id'] . "'";
			if ($myrow['id'] == $parent_id)
				echo " selected";
			echo  ">" . $myrow['name'] . "</option>\n";
		}
		echo "</select>\n";
	}
}

?>
