<?php
/*
label.php

Copyright (C)2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(label_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}


switch($_REQUEST['action']){
	case "clear" :
		addLabel();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseLabel($id);
		break;

	case "edit" :
		editLabel($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelLabel($_REQUEST['id']);
      }
      else{
         deleteLabel($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listLabel();
      }
      break;  
	
   case "cfmdelete" :
      deleteLabel($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listLabel();
		break;

	case "add" :
		insertLabel($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listLabel();
		break;

	case "commit" :
		commitLabel($_POST);
		listLabel();
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listLabel();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(label_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"]=0;
   $frm["labelid"]="";
   $frm["type"]="item";
   $frm["name"]="";
   $frm["xdim"]="";
   $frm["ydim"]="";
   $frm["data"]="";
   
   return $frm;
}

function fillform($id, $bOffset)
{
   
   if($bOffset){
      $qry=sprintf(label_qry2, $id);
   }
   else{
      $qry=sprintf(label_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
	
   $frm["id"]=$id;
   $frm["labelid"]=$row["labelid"];
   $frm["type"]=$row["type"];
   $frm["name"]=$row["name"];
   $frm["xdim"]=$row["xdim"];
   $frm["ydim"]=$row["ydim"];
   $frm["data"]=$row["data"];

   return $frm;
}

function addLabel()
{
   $frm=clearform();
	$frm["newaction"] = "add";
   $frm["heading"] = "Label Add";

	include("templates/labeledit.php");
}

function editLabel($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Label Edit";
	include("templates/labeledit.php");
}

function browseLabel($id) 
{
   $frm=fillform($id, true);
   $frm["newaction"] = "browse";
	$frm["heading"] = "Label Browse";
	include("templates/labeledit.php");
}

function chkdelLabel($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Label Delte";
	include("templates/labeledit.php");
}

function deleteLabel($id) 
{
   $qry=sprintf(label_qry6, $id);
   db_query($qry); 
}

function insertLabel($frm) 
{
   $qry=sprintf(label_qry4, $frm['labelid'],$frm['type'],$frm['name'],$frm['xdim'],$frm['ydim'],$frm['data']);
	db_query($qry);
}

function commitLabel($id, $frm) 
{
   $qry=sprintf(label_qry4, $frm['labelid'],$frm['type'],$frm['name'],$frm['xdim'],$frm['ydim'],$frm['data'],$frm['ID']);
	db_query($qry);
}

function fillLabelTypeCombo($a, $l, $d)
{
   $idlist = array('item', 'shelf', 'rx');
   
   if($a=="commit" || $a=="add"){
      echo "<select name=\"$l\">\n";
      foreach($idlist as $idname){
		   echo "<option ";
   		if ($idname == $d)
	   		echo "selected ";
		   echo " value='$idname'>$idname</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      if(isset($d)) echo $d;
      else echo "item";
   }
}

function listLabel()
{  
	$q=$_SESSION["pageindex"]->query(label_qry7);
	$result=db_query($q);

	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Type</h3></td><td><h3>Text</h3></td><td><h3>data</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		echo "<tr><td>";
		$wibbler=$myrow["id"];
		$t=$myrow["type"];
		$n=$myrow["name"];
		$d=$myrow["data"];
		echo "$t</td><td>$n</td><td>$d</td><td>";
		echo "<a href=\"label.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		echo "<a href=\"label.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		echo "<a href=\"label.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "</form>";
	echo "<br><br>";
}

?>
