<?php
/*
margins.php

Copyright (C)2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(margin_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

   
switch($_REQUEST['action']){
	case "clear" :
		addMargin();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseMargin($id);
		break;

	case "edit" :
		editMargin($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelMargin($_REQUEST['id']);
      }
      else{
         deleteMargin($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listMargin();
      }
      break;  
	
   case "cfmdelete" :
      deleteMargin($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listMargin();
		break;

	case "add" :
		insertMargin($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listMargin();
		break;

	case "commit" :
		commitMargin($_POST);
		listMargin();
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listMargin();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(margin_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"]="";
   $frm["marginid"]="";
   $frm["name"]="";
   $frm["margin"]="";
   $frm["productcollid"]="";
   
   $frm["prodcollid"]="";
   $frm["productid"]="";
   
   return $frm;
}

function fillform($id, $bOffset)
{
   
   if($bOffset){
      $qry=sprintf(margin_qry2, $id);
   }
   else{
      $qry=sprintf(margin_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["id"]=$id;
   $frm["marginid"]=$row["marginid"];
   $frm["name"]=$row["name"];
   $frm["margin"]=$row["margin"];
   $frm["productcollid"]=$row["productcollid"];
   
   $result=db_query("select count(*) from productcollection where prodcollid = '$frm[productcollid]'");
   $row = $result->FetchRow();
   $frm["numproduct"]=$row[0];
   
   return $frm;
}

function addMargin()
{
   $frm=clearform();
	$frm["newaction"] = "add";
   $frm["heading"] = "Margin Add";

	include("templates/marginedit.php");
}

function editMargin($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Margin Edit";
	include("templates/marginedit.php");
}

function browseMargin($id) 
{
   $frm=fillform($id, true);
   $frm["newaction"] = "browse";
	$frm["heading"] = "Margin Browse";
	include("templates/marginedit.php");
}

function chkdelMargin($id)
{
   $frm=fillform($id, false);
   $frm["newaction"] = "cfmdelete";
	$frm["heading"] = "Margin Delete";
	include("templates/marginedit.php");
}

function deleteMargin($id) 
{
   $qry=sprintf(margin_qry6, $id);
   db_query($qry);
}

function insertMargin($frm) 
{
   $qry=sprintf(margin_qry4, $frm['marginid'],$frm['name'],$frm['margin'],$frm['productcollid']);
	db_query($qry);
}

function commitMargin($frm) 
{
   $qry=sprintf(margin_qry5, $frm['marginid'],$frm['name'],$frm['margin'],$frm['productcollid'],$frm['id']);
	db_query($qry);
}

function listMargin()
{  
	$q=$_SESSION["pageindex"]->query(margin_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Margin</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		echo "<tr><td>";
		$wibbler=$row["id"];
		echo "$row[name]</td><td>$row[margin]</td><td>";
		echo "<a href=\"margin.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		echo "<a href=\"margin.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		echo "<a href=\"margin.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
