<?php
/*
product.php

Copyright (C)2002  Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.

*/
require_once("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/currency.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(product_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addProd();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseProd($id);
		break;

	case "edit" :
		editProd($_REQUEST['id']);
		break;

	case "promoshow" :
		break;

	case "flagsshow" :
		break;
   
   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelProd($_REQUEST['id']);
      }
      else{
         deleteProd($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listProd();
      }
      break;  
	
   case "cfmdelete" :
      deleteProd($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listProd();
		break;

	case "add" :
		insertProd($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
    	listProd();
		break;

	case "commit" :
		commitProd($_POST);
		break;
      
   case "search":
      findProduct();
      break;
   
   case "list":
	default :
		$id=updateNav($_POST);
		listProd();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(product_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}


function clearform()
{
   $frm["productid"] = '';
   $frm["invid"] = '';
   $frm["categoryid"] = '';
   $frm["plu"] = '';
   $frm["prodplu"] = 'EAN-13';
   $frm["name"] = '';
   $frm["description"] = '';
   $frm["instock"] = '';
   $frm["discontinued"] = 'N';
   $frm["imageid"] = '';
   $frm["reciepttext"] = '';
   $frm["labelid"] = '';
   $frm["sellquantityid"] = '';
   $frm["discountid"] = '';
   $frm["promotionid"] = '';
   $frm["rentable"] = 'N';
   $frm["depositid"] = '';
   $frm["ecommerce"] = 'N';
   $frm["flags"] = '';
   $frm["productLink"] = '';
   $frm["keywords"] = '';

   $frm["nameid"] = '0';
   $frm["QuantityTypeid"] = '';
   $frm["price"] = '';
   $frm["udv"] = '';
   $frm["quantity"] = '';
   $frm["baseCurrencyid"]= '';
   $frm["taxid"]= '';

   $frm["imgid"] = '';
   $frm["reffile"] = '';
   $frm["width"] = '';
   $frm["height"] = '';
   $frm["bbp"] = '';
   $frm["scale"] = '';

   $frm["numpromo"] = 'N';
   $frm["showpromo"] = '';
	
   $frm["promoid"] = '';
   $frm["Startdate"] = '';
   $frm["enddate"] = '';
   $frm["margin"] = '';
   $frm["memo"] = '';
   
   return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(product_qry2, $id);
   }
   else{
      $qry=sprintf(product_qry3, $id);
   }
	$result=db_query($qry);
   $row = $result->FetchRow();

   $frm["id"] = $id;
   $frm["productid"] = $row["productid"];
   $frm["invid"] = $row["invid"];
   $frm["categoryid"] = $row["categoryid"];
   $frm["plu"] = $row["plu"];
   $frm["prodplu"] = $row["plutype"];
   $frm["name"] = $row["name"];
   $frm["description"] = $row["description"];
   $frm["instock"] = $row["instock"];
   $frm["discontinued"] = $row["discontinued"];
   $frm["imageid"] = $row["imageid"];
   $frm["reciepttext"] = $row["reciepttext"];
   $frm["discountid"] = $row["discountid"];
   $frm["sellquantityid"] = $row["sellquantityid"];
   $frm["promotionid"] = $row["promotionid"];
   $frm["rentable"] = $row["rentable"];
   $frm["depositid"] = $row["depositid"];
   $frm["ecommerce"] = $row["ecommerce"];
   $frm["flags"] = $row["flags"];
   $frm["productlink"] = $row["productlink"];
   $frm["keywords"] = $row["keywords"];

   $pqid=$row["sellquantityid"];

   $result=db_query("SELECT nameid, quantitytypeid, quantity, udv, price, taxid, basecurrencyid from prodpricequantity where pqid = '$pqid'");
	$qtrow = $result->FetchRow();
	$frm["nameid"] = $qtrow["nameid"];
	$frm["quantitytypeid"] = $qtrow["quantitytypeid"];
	$frm["price"] = $qtrow["price"];
	$frm["udv"] = $qtrow["udv"];
	$frm["quantity"] = $qtrow["quantity"];
	$frm["basecurrencyid"]=$qtrow["basecurrencyid"];
	$frm["taxid"]=$qtrow["taxid"];
   
	$taxid=$qtrow["taxid"];
	$qtyid=$qtrow["quantitytypeid"];
	$frm["taxid"]=$taxid;
	if(!isset($qtyid) || $qtyid==0){
		$frm["qtyname"]="Not Set";
	}
	else{
		$result=db_query("SELECT name FROM invitemquantitytype WHERE id='$qtyid'");
		$row = $result->FetchRow();
		$frm["qtyname"]=$row["name"];
	}
		
	$result=db_query("SELECT * FROM taxrate WHERE id = '$taxid'");
	$row = $result->FetchRow();
	$frm["taxid"] = $row["taxid"];
	$frm["taxaccount"] = $row["accountid"];
	
	if(!isset($taxid) || $taxid==0){
		$frm["taxname"]="Not Set";
	}
	else{
		$result=db_query("SELECT name FROM account WHERE accountnumber = '$taxid'");
		$row=$result->FetchRow();
		$frm["taxname"]=$row["name"];
	}
	
/*
	$frm["pqid"] = '';
   $frm["iinvprqid"] = '';
   $frm["Quantity"] = '';
   

	$frm["imgid"] = '';
   $frm["RefFile"] = '';
   $frm["width"] = '';
   $frm["height"] = '';
   $frm["bbp"] = '';
   $frm["scale"] = '';
*/
	$frm["numpromo"] = 0;
	$frm["showpromo"] = 0;
/*	
	$frm["promoid"] = '';
   $frm["StartDate"] = '';
   $frm["EndDate"] = '';
   $frm["Margin"] = '';
   $frm["Memo"] = '';
*/

	
	return $frm;
}

function findProduct()
{
   include("templates/prodsearch.php");
}

function ListResults()
{
// List all inventory and adjust for outstanding sales.
// Provide a link to "reconcile" stock against sales / returns.

   global $HTTP_POST_VARS;
   if(!isset($HTTP_POST_VARS['searchin']))
     exit();

   $search = str_replace(" ","%",$HTTP_POST_VARS['searchfor']);
   if( $search != "") {
      $search = "%" . $search . "%";

      switch($HTTP_POST_VARS['searchin']) {
         case 'PLU':
            $search = "AND product.PLU LIKE '$search'";
            $sortby = "product.PLU";
            break;
         case 'Name':
            $search = "AND product.Name LIKE '$search'";
            $sortby = "product.Name";
            break;
         case 'Descr':
            $search = "AND inventory.Description LIKE '$search'";
            $sortby = "inventory.Description";
            break;
         case 'Keyw':
            $search = "AND product.Keywords LIKE '$search'";
            $sortby = "product.Keywords";
            break;
         default:
            $search = "";
            $sortby = "inventory.Description";
            break;
      }
   }
   else {
      $sortby = "inventory.Description";
   }
   // First cache the transactions in a local array to speed up the main loop.
   $result=db_query("SELECT transactionitems.PLU, SUM(transactionitems.quantity) 
      FROM transaction, transactionitems
      WHERE transaction.transactionID = transactionitems.transactionID AND transaction.Reconciled = 'N' 
      GROUP BY transactionitems.PLU");

   while($row=$result->FetchRow()){
      $transcache[]=$row;
   }

   // Now create a nice list of products/inventory
   $result=db_query("SELECT product.ID as PID, product.InvID, product.PLU, product.Name, product.Keywords, inventory.ID,
     inventory.Description, inventory.InStock, inventory.OnOrder, inventory.ROLevel
     from product, inventory WHERE product.InvID = inventory.ID $search ORDER BY $sortby");

   // Iterate over the nice list
   while($row=$result->FetchRow()){
      if($row['name']=="")
        $row['name']="&nbsp;";

      if($row['description']=="")
        $row['description']="&nbsp;";

      // Quick check to see if the product needs to be reconciled.
      $sold=0;
      if(isset($transcache)) {
         foreach ( $transcache as $arr) {
            if($arr["plu"] == $row["plu"]) {
               $sold=$arr[1];
               break;
            }
         }
      }

      $nq=$row["instock"] - $sold;

      echo "<tr><td>";
      echo "<a href=\"product.php?action=edit&id=$row[pid]\">";
      echo "$row[PLU]</a></td>\n";
      echo "<td>$row[Name]</td>\n";
      echo "<td>$row[Description]</td>\n";
      echo "<td align=\"right\">$row[InStock]</td>\n";
      echo "<td align=\"right\">$sold</td>\n";

      if($nq < $row["rolevel"])
         echo "<td align=\"right\"><font color=\"FF0000\">$nq</font></td>";
      else
         echo "<td align=\"right\">$nq</td>";

      echo "<td align=\"right\">$row[rolevel]</td>\n";
      echo "<td align=\"right\">$row[onorder]</td>\n";
      echo "</tr>";
   }
}

function addProd()
{

/*
   OK, the trouble here is that adding a product requires linking to the inventory, blah blah blah.
   This might as well just call the product wizard to do it properly, unless the wizard is to be
   completely dropped in favor of this thingie...

	$frm=clearform();
	$frm["newaction"] = "add";
	$frm["id"] = "Auto number";
   $frm["heading"] = "Product Add";

	include("templates/prodedit.php");
*/
   $frm["newaction"] = "";
   echo "Please use the <a href=\"../stock/productwiz.php?action=start\">Product Wizard</a> for this";
}

function editProd($id) 
{
	$frm=fillform($id, false);

	$frm["newaction"] = "commit";
   $frm["heading"] = "Product Edit";
		
	include("templates/prodedit.php");
}

function browseProd($id) 
{
	$frm=fillform($id, true);
	$frm["newaction"] = "browse";
	$frm["heading"] = "Product Browse";
	$_SESSION["pageindex"]->setprev("browse");
	
	include("templates/prodedit.php");
}

function deleteProd($id)
{
   $frm=fillform($id, false);
   
   // acquire buy price and delete it
   $qry=sprintf(inventory_qry9, $frm['invid']);
   $result=db_query($qry);
   $row = $result->FetchRow();
   $qry=sprintf(invpq_qry6, $row[0]);
   db_query($qry);
   
   // delete inv item
   $qry=sprintf(inventory_qry10, $frm['invid']);
   db_query($qry);
   
   // delete [if exists] image, 
   // delete [if unique to product] promotion 
   // delete [if unique to product] discount 
   // delete [if unique to product/site] margin

   // delete sell price
   // !!!CHANGE ME BEFORE v0.9.6!!!
   // this is dangerous as several products can be pointed to a single sell price
   $qry=sprintf(sellpq_qry6, $frm['sellquantityid']);
   db_query($qry);
   
   //delete product
   $qry=sprintf(product_qry6, $id);
   db_query($qry);
}

function chkdelProd($id) 
{
   $frm=fillform($id);
   $frm["heading"] = "Product Delete";
   $frm["newaction"]="cfmdelete";
   include("templates/prodedit.php");
}

function insertProd($frm) 
{
   $frm["rentable"]=yesno(isset($frm["rentable"]));
   $frm["Discontinued"]=yesno(isset($frm["Discontinued"]));
   $frm["eCommerce"]=yesno(isset($frm["eCommerce"]));
   $frm["numpromo"]=yesno(isset($frm["numpromo"]));

   $pqid=insertprodpq($frm);

   /*
   $qry=sprintf(product_qry4,'0','0',$frm['categoryid'],$frm['plu'],$frm['plutype'],
		$frm['name'],$frm['description'],$frm['instock'],$frm['discontinued'],$frm['imageid'],
		$frm['reciepttext'],$frm['discountid'],$pqid,$frm['numpromo'],$frm['rentable'],
      $frm['depositid'],$frm['ecommerce'],$frm['flags'],$frm['productlink'],$frm['keywords']");
   $db_query($qry);
*/
}

function commitProd($frm) 
{
	$_SESSION["pageindex"]->setprev("commit");
        
	$frm["rentable"]=yesno(isset($frm["rentable"]));
	$frm["discontinued"]=yesno(isset($frm["discontinued"]));
	$frm["ecommerce"]=yesno(isset($frm["ecommerce"]));
	/* $frm["numpromo"]=yesno(isset($frm["numpromo"])); */
        
	/* temporary */
	$frm["numpromo"] = '0';
	
	$pqid=insertprodpq($frm);
   $id = $frm["id"];
   
   db_query("UPDATE product SET
      categoryid = '$frm[categoryid]',
	 	plu='$frm[plu]',
		plutype='$frm[plutype]',
		name='$frm[name]',
		description='$frm[description]',
      instock = '$frm[instock]',
      discontinued = '$frm[discontinued]',
      imageid = '$frm[imageid]',
		reciepttext='$frm[reciepttext]',
      discountid = '$frm[discountid]',
		sellquantityid='$pqid'
      promotionid='$frm[numpromo]', 
      rentable='$frm[rentable]',
      depositid = '$frm[depositid]',
		ecommerce='$frm[ecommerce]',
		flags = '$frm[flags]',
      productlink = '$frm[productlink]',
      keywords='$frm[keywords]',
		WHERE id = '$id'");
	echo "Changes Committed.  If you want, ";
	echo "<a href=\"product.php?action=browse&id=$id\">";
	echo "check the product out</a>."; 
}

function PromotionTable($pid)
{
   $qry=sprintf(promotion_qry3, $pid);
   $result=db_query($qry);
   if($row = $result->FetchRow()){
      echo "<table class=\"promotion\">\n"; //width="100%" border="1" cellspacing="2" cellpadding="2" bgcolor="#CCFFCC">
      echo "<tr><td colspan=\"4\" align=\"center\"><h3>Promotions</h3></td></tr>\n";
      echo "<tr><td class=label>Start Date</td>\n<td>";
	   echo "<td>class=label>End Date</td>\n<td>";
      echo "<td class=label>Type</td>\n<td>";
      echo "<td class=label>Margin</td>\n<td>";
      entry($a, "margin", 32, 32, $row['margin']);
      echo "<\td>\n<td class=label>Memo</td>\n<td>";
      entry($a, "memo", 32, 32, $row['memo']);
      echo "</tr></table>\n";
   }
}

function listProd()
{
	$q=$_SESSION["pageindex"]->query(product_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";

	print "<br><br><table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	print "<tr><td><h3>PLU</h3></td>\n";
	print "<td><h3>Name</h3></td>";
//	print "<td><h3>Promo</h3></td>";
	print "<td><h3>Action</h3></td>\n</tr>\n";
	
	while($row = $result->FetchRow()){
	   $p=$row["plu"];
	   $d=$row["name"];
	   echo "<tr><td>$p</td><td>$d</td>\n";
		
		$id=$row["id"];
		
		print "<td><a href=\"product.php?action=browse&id=$id\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"product.php?action=edit&id=$id\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"product.php?action=delete&id=$id\">".misc_listdelete."</a>&nbsp; \n";
				
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

function CurrencyCombo($action, $cname, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, $cname);
}

?>
