<?php
/*
producttab.php

Copyright (C)2004  Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
require_once("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/currency.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(product_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

include($_SESSION['CFG']->templatedir."/pheader.php");

switch($_REQUEST['action']){
   case "search":
      findProduct();
      break;
   
   case "searchsubmit":
      submitfindProduct();
      break;
  
   case 'edit':
      tab_inventory($_REQUEST['id'], $_POST);
      break;
      
   case 'inventory':
      tab_inventory($_REQUEST['inventoryid'], $_POST);
      break;
   
   case 'product':
      tab_product($_REQUEST['productid'], $_POST);
      break;
      
   case 'other':
      tab_other($_REQUEST['productid'], $_POST);
      break;
      
   case 'sellprice':
      tab_sellprice($_REQUEST['productid'], $_POST);
      break;
      
   case 'commit':
      commit($_POST);
      break;
      
	case "list":
	default :
		$id=updateNav($_POST);
		listProd();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
 function CountNum()
{
   $result=db_query(product_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"] = 0;
	$frm["parentid"] = "";
   $frm["catid"] = "";
	$frm["parttype"] = "";
	$frm["partnumber"] = "";
	$frm["stocklocation"] = "";
	$frm["description"] = "";
	$frm["instock"] = "";
   $frm["maxstock"] = "";
	$frm["onorder"] = "";
	$frm["rolevel"] = "";
	$frm["roqty"] = "";
	$frm["reservedqty"] = "";
	$frm["leadtime"] = "";
	$frm["partclass"] = "";
	$frm["bqpriceid"] = "";
   $frm["cmid"]="";
	$frm["invlink"] = "";
   
   $frm["productid"] = '';
   $frm["invid"] = '';
   $frm["categoryid"] = '';
   $frm["plu"] = '';
   $frm["prodplu"] = 'ean-13';
   $frm["name"] = '';
   $frm["description"] = '';
   $frm["instock"] = '';
   $frm["discontinued"] = 'n';
   $frm["imageid"] = '';
   $frm["reciepttext"] = '';
   $frm["labelid"] = '';
   $frm["sellquantityid"] = '';
   $frm["discountid"] = '';
   $frm["rentable"] = 'n';
   $frm["depositid"] = '';
   $frm["ecommerce"] = 'n';
   $frm["flags"] = '';
   $frm["productlink"] = '';
   $frm["keywords"] = '';

   $frm["nameid"] = '0';
   $frm["quantitytypeid"] = '';
   $frm["price"] = '';
   $frm["udv"] = '';
   $frm["quantity"] = '';
   $frm["basecurrencyid"]= '';
   $frm["taxid"]= '';

   $frm["imgid"] = '';
   $frm["reffile"] = '';
   $frm["width"] = '';
   $frm["height"] = '';
   $frm["bbp"] = '';
   $frm["scale"] = '';

   $frm["numpromo"] = 'n';
   $frm["showpromo"] = '';
	
   $frm["promoid"] = '';
   $frm["startdate"] = '';
   $frm["enddate"] = '';
   $frm["margin"] = '';
   $frm["memo"] = '';
   
   return $frm;
}

function fillform($id)
{
   $result=db_query("SELECT * FROM product WHERE id = '$id'");
   $row = $result->FetchRow();

   $frm["id"] = $frm["productid"] = $id;
   $frm["productid"] = $row["productid"];
   $frm["invid"] = $row["invid"];
   $frm["inventoryid"] = $row["invid"];
   $frm["categoryid"] = $row["categoryid"];
   $frm["plu"] = $row["plu"];
   $frm["prodplu"] = $row["plutype"];
   $frm["name"] = $row["name"];
   $frm["description"] = $row["description"];
   $frm["instock"] = $row["instock"];
   $frm["discontinued"] = $row["discontinued"];
   $frm["imageid"] = $row["imageid"];
   $frm["reciepttext"] = $row["reciepttext"];
   $frm["discountid"] = $row["discountid"];
   $frm["sellquantityid"] = $row["sellquantityid"];
   $frm["numpromo"] = $row["promotionid"];
   $frm["rentable"] = $row["rentable"];
   $frm["depositid"] = $row["depositid"];
   $frm["ecommerce"] = $row["ecommerce"];
   $frm["flags"] = $row["flags"];
   $frm["productlink"] = $row["productlink"];
   $frm["keywords"] = $row["keywords"];

   $pqid=$row["sellquantityid"];

   $result=db_query("select nameid, quantitytypeid, quantity, udv, price, taxid, basecurrencyid from prodpricequantity where pqid = '$pqid'");
	$qtrow = $result->FetchRow();
	$frm["nameid"] = $qtrow["nameid"];
	$frm["quantitytypeid"] = $qtrow["quantitytypeid"];
	$frm["price"] = $qtrow["price"];
	$frm["udv"] = $qtrow["udv"];
	$frm["quantity"] = $qtrow["quantity"];
	$frm["basecurrencyid"]=$qtrow["basecurrencyid"];
	$frm["taxid"]=$qtrow["taxid"];
   
	$taxid=$qtrow["taxid"];
	$qtyid=$qtrow["quantitytypeid"];
	$frm["taxid"]=$taxid;
	if(!isset($qtyid) || $qtyid==0){
		$frm["qtyname"]="not set";
	}
	else{
		$result=db_query("select name from invitemquantitytype where id='$qtyid'");
		$row = $result->FetchRow();
		$frm["qtyname"]=$row["name"];
	}
		
	$tresult=db_query("select * from taxrate where id = '$taxid'");
	$qnrow = $result->FetchRow();
	$frm["tax"] = $qnrow["tax"];
	$frm["taxaccount"] = $qnrow["accountid"];
	
	if(!isset($taxid) || $taxid==0){
		$frm["taxname"]="Not Set";
	}
	else{
		$aresult=db_query("SELECT name FROM account WHERE accountnumber = '$taxid'");
		$arow=$aresult->FetchRow();
		$frm["taxname"]=$arow["name"];
	}
   
   $qry=sprintf(deposit_qry3, $frm["depositid"]);
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["depid"]=$frm["depositid"];
   $frm["depositid"]=$row["depositid"];
   $frm["cmid"]=$row["cmid"];
   $frm["name"]=$row["name"];
   $frm["percentage"]=$row["percentage"];
   $frm["refundable"]=$row["refundable"];
   $frm["type"]=$row["type"];
	
/*
	$frm["pqid"] = '';
   $frm["iinvprqid"] = '';
   $frm["quantity"] = '';
   

	$frm["imgid"] = '';
   $frm["reffile"] = '';
   $frm["width"] = '';
   $frm["height"] = '';
   $frm["bbp"] = '';
   $frm["scale"] = '';
*/
	$frm["numpromo"] = 0;
	$frm["showpromo"] = 0;
/*	
	$frm["promoid"] = '';
   $frm["startdate"] = '';
   $frm["enddate"] = '';
   $frm["margin"] = '';
   $frm["memo"] = '';
*/
	return $frm;
}

function fillinvform($id)
{
   $qry=sprintf(product_qry9, $id);
   $result=db_query($qry);
	$row = $result->FetchRow();
   $invid=$row[0];
   
   $qry=sprintf(inventory_qry3, $invid);
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm["id"] = $row["id"];
   $frm["inventoryid"] = $row["id"];
	$frm["parentid"] = $row["parentid"];
	$frm["categoryid"] = $row["categoryid"];
	$frm["partnumber"] = $row["partnumber"];
	$frm["parttype"] = $row["parttype"];
	$frm["stocklocation"] = $row["stocklocation"];
	$frm["description"] = $row["description"];
	$frm["instock"] = $row["instock"];
	$frm["maxstock"] = $row["maxstock"];
	$frm["onorder"] = $row["onorder"];
	$frm["rolevel"] = $row["rolevel"];
	$frm["roqty"] = $row["roqty"];
	$frm["reservedqty"] = $row["reservedqty"];
	$frm["leadtime"] = $row["leadtime"];
	$frm["partclassification"] = $row["partclassification"];
	$frm["buyquantitypriceid"] = $row["buyquantitypriceid"];
	$frm["cmid"]=$row["cmid"];
	$frm["invlink"] = $row["invlink"];
	
	$bqid=$row["buyquantitypriceid"];
	$bqresult=db_query("select * from invpricequantity  where id = '$bqid'");
	$row = $bqresult->FetchRow();
   
   $frm["id"]=$row["id"];
   $frm["invprqid"]=$row["invprqid"];
   $frm["nameid"]=$row["nameid"];
   $frm["quantity"]=$row["quantity"];
   $frm["quantitytypeid"]=$row["quantitytypeid"];
   $frm["udv"]=$row["udv"];
   $frm["price"]=$row["price"];
   $frm["basecurrencyid"]=$row["basecurrencyid"];
   $frm["supplierid"]=$row["supplierid"];
   $frm["suppliercode"]=$row["suppliercode"];
   $frm["ediid"]=$row["ediid"];
   $frm["accountid"]=$row["accountid"];
   $frm["taxid"]=$row["taxid"];
   
	return $frm;
}

function fillpriceform($id)
{
   $frm=fillform($id);
   $qry=sprintf(discount_qry3, $id);
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["discountid"]=$row["discountid"];
   $frm["type"]=$row["type"];
   $frm["ident"]=$row["ident"];
   $frm["targetid"]=$row["targetid"];
   $frm["margin"]=$row["margin"];
   $frm["status"]=$row["status"];
   
   $qry=sprintf(margin_qry3, $id);
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["marginid"]=$row["marginid"];
   $frm["name"]=$row["name"];
   $frm["mmargin"]=$row["margin"];
   $frm["productcollid"]=$row["productcollid"];
   
   $qry=sprintf(promotion_qry3, $id);
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["promotionid"] = $row["promotionid"];
   $frm["type"] = $row["type"];
   $frm["startdate"] = $row["startdate"];
   $frm["enddate"] = $row["enddate"];
   $frm["margin"] = $row["margin"];
   $frm["memo"] = $row["memo"];
   $frm["promolinkid"] = $row["promolinkid"];
   
   return $frm;
}

function findProduct()
{
	$frm=clearform();
   $frm["newaction"] = "searchsubmit";
   include("templates/qpsearch.php");
}

function submitfindProduct()
{
// List all inventory and adjust for outstanding sales.
// Provide a link to "reconcile" stock against sales / returns.

   global $_POST;
   if(!isset($_POST['searchin']))
     exit();

   echo "<table width=\"90%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\">\n";
   echo "<tr><td><b>PLU</b></td><td><b>Name</b></td><td><b>Description</b></td></tr>\n";
   $search = str_replace(" ","%",$_POST['searchfor']);
   if( $search != "") {
      $search = "%" . $search . "%";

      switch($_POST['searchin']) {
         case 'PLU':
            $search = "and product.plu like '$search'";
            $sortby = "product.plu";
            break;
         case 'Name':
            $search = "and product.name like '$search'";
            $sortby = "product.name";
            break;
         case 'Descr':
            $search = "and inventory.description like '$search'";
            $sortby = "inventory.description";
            break;
         case 'Keyw':
            $search = "and product.keywords like '$search'";
            $sortby = "product.keywords";
            break;
         default:
            $search = "";
            $sortby = "inventory.description";
            break;
      }
   }
   else {
      $sortby = "inventory.description";
   }
   // First cache the transactions in a local array to speed up the main loop.
   $result=db_query("select transactionitems.plu, sum(transactionitems.quantity) 
      from transaction, transactionitems
      where transaction.transactionid = transactionitems.transactionid and transaction.reconciled = 'n' 
      group by transactionitems.plu");

   while($row=$result->FetchRow()){
      $transcache[]=$row;
   }

   // Now create a nice list of products/inventory
   $result=db_query("select product.id as pid, product.invid, product.plu, product.name, product.keywords, inventory.id,
     inventory.description from product, inventory where product.invid = inventory.id $search order by $sortby");

   // Iterate over the nice list
   while($row=$result->FetchRow()){
      if($row['name']=="")
        $row['name']="&nbsp;";

      if($row['description']=="")
        $row['description']="&nbsp;";

      // Quick check to see if the product needs to be reconciled.
      $sold=0;
      if(isset($transcache)) {
         foreach ( $transcache as $arr) {
            if($arr["plu"] == $row["plu"]) {
               $sold=$arr[1];
               break;
            }
         }
      }

      echo "<tr><td><a href=\"producttab.php?action=edit&id=$row[pid]\">$row[plu]</a></td>\n";
      echo "<td>$row[name]</td>\n";
      echo "<td>$row[description]</td>\n";
      echo "</tr></table>";
   }
}

function tab_inventory($id, $frm)
{
   if(isset($frm)){
      if(isset($frm['lasttab'])){
         if($frm['lasttab']!="inventory"){
            invcommit($frm);
         }
      }
   }
   $frm=fillinvform($id);
   $frm['productID']=$id;
   $frm['newaction']="commit";
   $frm['lasttab']="inventory";
   include("templates/producttab_inventory.php");
}

function tab_product($id, $frm)
{
   if(isset($frm)){
      if(isset($frm['lasttab'])){
         if($frm['lasttab']!="product"){
            prodcommit($frm);
         }
      }
   }
   $frm=fillform($id);
   $frm['newaction']="commit";
   $frm['productID']=$id;
   $frm['lasttab']="product";
   include("templates/producttab_product.php");
}

function tab_other($id, $frm)
{
   $frm=fillform($id);
   $frm['newaction']="commit";
   $frm['lasttab']="other";
   include("templates/producttab_other.php");
}

function tab_sellprice($id, $frm)
{
   $frm=fillpriceform($id);
   $frm['newaction']="commit";
   $frm['lasttab']="sellprice";
   include("templates/producttab_sellprice.php");
}

function commit($frm)
{
   switch($frm['lasttab']){
   case 'inventory':
      invcommit($frm);
      break;
   }
}

function invcommit($frm)
{
   $cm=new CreateMod();
   $cm->Fill($frm['CMID']);
   $cm->Commit();
   
   $qry=sprintf(inventory_qry8,$frm['inventoryID'],$frm['parentID'],$frm['CategoryID'],$frm['PartNumber'],
	$frm['PartType'],$frm['StockLocation'],$frm['Description'],$frm['InStock'],$frm['MaxStock'],$frm['OnOrder'],
	$frm['ROLevel'],$frm['ROQty'],$frm['ReservedQty'],$frm['LeadTime'],$frm['PartClassification'],
	$frm['buyquantitypriceid'],$frm['CMID'],$frm['invlink'],$frm['ID']);
   db_query($qry);
   
   $qry=sprintf(invpq_qry5, $frm['invprqID'],$frm['nameID'],$frm['Quantity'],$frm['QuantityTypeID'],$frm['UDV'],
      $frm['Price'],$frm['basecurrencyid'],$frm['SupplierID'],$frm['SupplierCode'],$frm['ediID'],$frm['accountID'],
      $frm['TaxID'], $frm['ID']);
   db_query($qry);
}

function prodcommit($frm)
{
}

function othercommit($frm)
{
}

function sellcommit($frm)
{
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "basecurrencyid");
}

function CreateModTable($id)
{
   $cm=new CreateMod();
   $cm->Fill($id);
   $cm->FillTable();
}

function DateControl($a, $d)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
	   $result=db_query(login_qry1);
  		if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->datecontrol($a, "");
}





function addProd()
{

/*
   OK, the trouble here is that adding a product requires linking to the inventory, blah blah blah.
   This might as well just call the product wizard to do it properly, unless the wizard is to be
   completely dropped in favor of this thingie...

	$frm=clearform();
	$frm["newaction"] = "add";
	$frm["id"] = "Auto number";
   $frm["heading"] = "Product Add";

	include("templates/prodedit.php");
*/

   global $action;

   echo "Please use the <a href=\"../stock/productwiz.php\">Product Wizard</a> for this";
   $action="";

}

function editProd($id) 
{
	$frm=fillinvform($id);

	$frm["newaction"] = "commit";
   $frm["heading"] = "Product Edit";
		
	include("templates/prodedit.php");
}

function browseProd($id) 
{
	$frm=fillform($id);
	$frm["newaction"] = "browse";
	$frm["heading"] = "Product Browse";
	$_SESSION["pageindex"]->setprev("browse");
	
	include("templates/prodedit.php");
}

function deleteProd($id)
{
	$frm=fillform($id);
        $frm["heading"] = "Product Delete";
        $frm["newaction"]="kill";
        include("templates/prodedit.php");
}

function killProd($id) 
{

$frm=fillform($id);
//echo "Sorry, delete function does not work yet.  Need to delete inventory and product";
db_query("DELETE from inventory where ID=$frm[InvID]");
db_query("DELETE from product where ID=$id");
echo "Product (and inventory) for $frm[Name] deleted!";
$action="";

}

function insertProd($id, $frm) 
{
	//$qid = db_query("INSERT INTO product VALUES ('')");
/*
        $frm["rentable"]=yesno(isset($frm["rentable"]));
        $frm["Discontinued"]=yesno(isset($frm["Discontinued"]));
        $frm["eCommerce"]=yesno(isset($frm["eCommerce"]));
        $frm["numpromo"]=yesno(isset($frm["numpromo"]));

        $pqid=insertprodpq($frm);

        $qid = db_query("INSERT INTO product VALUES( 
		'',
		'0',
		
                PLU='$frm[PLU]',
                PLUType='$frm[prodPLU]',
                Name='$frm[Name]',
                Description='$frm[Description]',
                RecieptText='$frm[RecieptText]',
                Keywords='$frm[Keywords]',
                Discontinued='$frm[Discontinued]',
                eCommerce='$frm[eCommerce]',
                Rentable='$frm[rentable]',
                PromotionID='$frm[numpromo]',
                sellquantityid='$pqid'
                WHERE id = $id");
*/
}

function commitProd($id, $frm) 
{
	$_SESSION["pageindex"]->setprev("commit");

	$frm["rentable"]=yesno(isset($frm["rentable"]));
	$frm["discontinued"]=yesno(isset($frm["discontinued"]));
	$frm["ecommerce"]=yesno(isset($frm["ecommerce"]));
	$frm["numpromo"]=yesno(isset($frm["numpromo"]));

	$pqid=insertprodpq($frm);

	$qid = db_query("update product set 
	 	plu='$frm[plu]',
		plutype='$frm[prodplu]',
		name='$frm[name]',
		description='$frm[description]',
		reciepttext='$frm[reciepttext]',
		keywords='$frm[keywords]',
		discontinued='$frm[discontinued]',
		ecommerce='$frm[ecommerce]',
		rentable='$frm[rentable]',
		promotionid='$frm[numpromo]',
		sellquantityid='$pqid'
		WHERE id = $id");
	echo "Changes Committed.  If you want, ";
	echo "<a href=\"product.php?action=browse&id=$id\">";
	echo "check the product out</a>."; 
}


/*
function fillInvCombo($sel)
{
	$result=db_query("SELECT * FROM InvCategory");

	print "<select name=\"catid\" width=\"250\">\n";

	while($myrow = $result->FetchRow()){
		$boo=$myrow["ID"];
		$poo=$myrow["name"];

		if($sel==$boo){
			print "<option selected value=\"$boo\"> $boo - $poo </option>\n";
		}
		else{
			print "<option value=\"$boo\"> $boo - $poo </option>\n";
		}
	}
	
	print "</select>\n";
}

function listPromo($productid)
{

	
}
*/

function listProd()
{
	if ($_SESSION["pageindex"]->getprev() != "list") {
		$_SESSION["pageindex"]->start();
		$_SESSION["pageindex"]->setprev("list");
	}
	$offset=1;
	$x=0;
	$maxid=$_SESSION["pageindex"]->num();	
	$numresults=$maxid;
	$q="SELECT * from product";
	$q=$_SESSION["pageindex"]->query($q);
	$result=db_query($q);

	$x=$offset+$numresults-1;
	print "<html><head></head><body>\n";
	print "<br><br><table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	print "<tr><td colspan=\"5\"><i>Rows $offset to $x of $maxid</i></td></tr>";
	
	print "<tr><td><h3>PLU</h3></td>\n";
	print "<td><h3>PLU Type</h3></td>\n";
	print "<td><h3>Name</h3></td>";
//	print "<td><h3>Promo</h3></td>";
	print "<td><h3>Action</h3></td>\n</tr>\n";
	
	while($myrow = $result->FetchRow()){
	   $p=$myrow["plu"];
	   $t=$myrow["plutype"];
	   $d=$myrow["name"];
	   echo "<tr><td>$p</td><td>$t</td><td>$d</td>\n";
		
		$id=$myrow["id"];
		
		print "<td><a href=\"product.php?action=clear&id=$id\">add</a>&nbsp;\n";
		print "<a href=\"product.php?action=edit&id=$id\">edit</a>&nbsp; \n";
		print "<a href=\"product.php?action=delete&id=$id\">delete</a>&nbsp; \n";
				
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
	echo "<table width=\"100%\">";
}

?>
