<?php
/*
promotion.php

Copyright (C)2003 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(promotion_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

include("../templates/pheader.php");
   
switch($_REQUEST['action']){
	case "clear" :
		addPromotion();
		break;

	case "browse":
      $id=updateNav($_POST);
		browsePromotion($id);
		break;

	case "edit" :
		editPromotion($id);
		break;

	case "delete" :
		deletePromotion($id);
      $_SESSION["pageindex"]->deletion(CountNum());
		listMeasure($id);
		break;

	case "add" :
		insertPromotion();
      $_SESSION["pageindex"]->addition(CountNum());
		listDiscount($id);
		break;

	case "commit" :
		commitPromotion($id, $_POST);
		listDiscount($id);
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listPromotion();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(promotion_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"] = "";
   $frm["promotionid"] = "";
   $frm["type"] = "pricemargin";
   $frm["margin"] = "";
   $frm["memo"] = "";
   $frm["promolinkid"] = "";
   
   $result=db_query("SELECT NOW()");
	$row = $result->FetchRow();
   $frm["startdate"]=$row[0];
   $frm["enddate"]=$row[0];
   
   return $frm;
}

function fillform($id, $bOffset)
{
   
   if($bOffset){
      $qry=sprintf(promotion_qry2, $id);
   }
   else{
      $qry=sprintf(promotion_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["id"] = $id;
   $frm["promotionid"] = $row["promotionid"];
   $frm["type"] = $row["type"];
   $frm["startdate"] = $row["startdate"];
   $frm["enddate"] = $row["enddate"];
   $frm["margin"] = $row["margin"];
   $frm["memo"] = $row["memo"];
   $frm["promolinkid"] = $row["promolinkid"];
   
   /*
   if($frm["targetID"]!=0){
      $result=db_query("SELECT count(*) FROM productcollection WHERE prodcollID = '$frm[targetID]'");
      $row = $result->FetchRow());
      $frm["numproduct"]=$row[0];
   }
   else{
      $frm["numproduct"]=0;
   }
   */
   return $frm;
}

function addPromotion()
{
   $frm=clearform();
	$frm["newaction"] = "add";
	$frm["id"] = "Auto number";
   $frm["heading"] = "Promotion Add";

	include("templates/promoedit.php");
}

function editPromotion($id) 
{
   $frm=fillform($id,false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Promotion Edit";
	include("templates/promoedit.php");
}

function browsePromotion($id) 
{
   $frm=fillform($id, true);
   $frm["newaction"] = "browse";
	$frm["heading"] = "Promotion Browse";
	include("templates/promoedit.php");
}

function deletePromotion($id) 
{
   $frm["heading"] = "Promotion Delete";
   db_query("DELETE FROM discount where ID='$id'"); 
}

function insertPromotion($id, $frm) 
{
	$qid = db_query("INSERT INTO promotion VALUES ('',
   '$frm[promotionID]',
   '$frm[type]',
   '$frm[StartDate]',
   '$frm[EndDate]',
   '$frm[Margin]',
   '$frm[Memo]',
   '$frm[promoLinkID]')");
}

function commitPromotion($id, $frm) 
{
   $qid = db_query("UPDATE promotion SET
   promotionID='$frm[promotionID]',
   type='$frm[type]',
   StartDate=$frm[StartDate]',
   EndDate='$frm[EndDate]',
   Margin='$frm[Margin]',
   Meo='$frm[Memo]',
   promoLinkID='$frm[promoLinkID]
   where ID='$id'");
}

function listPromotion()
{  
	$q=$_SESSION["pageindex"]->query(promotion_qry4);
	$result=db_query($q);

	print "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Margin</h3></td><td><h3>Num Products</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		print "<tr><td>";
		if($myrow["name"]){
			$wibbler=$myrow["ID"];
			$n=$myrow["margin"];
			
			print "$myrow[name]</td><td>$n</td><td><td>0</td>";
			print "<a href=\"discount.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
			print "<a href=\"discount.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
			print "<a href=\"discount.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		}		
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "</form>";
	echo "<br><br>";
}

?>
