<?php
/*
returns.php

Copyright (C)2003  Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(return_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

   
switch($_REQUEST['action']){
	case "clear" :
		addReturn();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseReturn($id);
		break;

	case "edit" :
		editReturn($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelReturn($_REQUEST['id']);
      }
      else{
         deleteReturn($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listReturn();
      }
      break;  
	
   case "cfmdelete" :
      deleteReturn($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listReturn();
		break;

	case "add" :
		insertReturn($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listReturnt($id);
		break;

	case "commit" :
		commitReturn($_POST);
		listReturn($id);
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listReturn();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(return_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"] = "0r";
   $frm["transid"] = "";
   $frm["destination"] = "stock";
   $frm["todestat"] = "";
   $frm["todestby"] = "";
   $frm["reasonid"]="";
   
   $frm["reasonname"]="";
   $frm["numitems"]=0;
   return $frm;
}

function fillform($id, $bOffset)
{
   
   if($bOffset){
      $qry=sprintf(return_qry2, $id);
   }
   else{
      $qry=sprintf(return_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
   if(db_num_rows($result) == 0){
      echo "No Outstanding Returns Stock in Holding\n";
      exit;
   }
   
   $frm["id"] = $id;
   $frm["transid"] = $row["transid"];
   $frm["destination"] = $row["destination"];
   $frm["todestat"] = $row["todestat"];
   $frm["todestby"] = $row["todestby"];
   $frm["reasonid"] = $row["reasonid"];
   
   $result=db_query("select name from returntype where id = '$frm[reasonid]'");
   $row = $result->FetchRow();
   $frm["reasonname"] = $row["reasonname"];
   
   $result=db_query("select count(*) from transactionitems where id = '$frm[transid]'");
   $row = $result->FetchRow();
   $frm["numitems"] = $row[0];
   
   return $frm;
}

function addReturn()
{
   $frm=clearform();
	$frm["newaction"] = "add";
   $frm["heading"] = "Return Add";

	include("templates/returnedit.php");
}

function editReturn($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Return Edit";
	include("templates/returnedit.php");
}

function browseReturn($id) 
{
   $frm=fillform($id, true);
   $frm["newaction"] = "browse";
	$frm["heading"] = "Return Browse";
	include("templates/returnedit.php");
}

function chkdelReturn($id)
{
   $frm=fillform($id, false);
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Return Delete";
	include("templates/returnedit.php");
}

function deleteReturn($id) 
{
   $qry=sprintf(return_qry6, $id);
   db_query($qry); 
}

function insertReturn($frm) 
{
   $qry=sprintf(return_qry4,$frm['promotionid'],$frm['type'],$frm['startdate'],$frm['enddate'],$frm['margin'],
   $frm['memo'],$frm['promolinkid']);
   
	db_query($qry); 
}

function commitReturn($frm) 
{
   $qry=sprintf(return_qry5,$frm['promotionid'],$frm['type'],$frm['startdate'],$frm['enddate'],$frm['margin'],
   $frm['memo'],$frm['promolinkid'],$frm['id']);
   
   db_query($qry);
}

function fillReturnsDestCombo($a, $id)
{
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
      echo "<select name=\"destination\">\n";
      if($id=="stock"){
         echo "<option selected value=\"1\"> Stock </option>\n";
      }
      else{
         echo "<option value=\"1\"> Stock </option>\n";
      }
      if($id=="vendor"){
         echo "<option selected value=\"2\"> Vendor </option>\n";
      }
      else{
         echo "<option value=\"2\"> Vendor </option>\n";
      }
      if($id=="stock"){
         echo "<option selected value=\"3\"> Scrap </option>\n";
      }
      else{
         echo "<option value=\"3\"> Scrap </option>\n";
      }
   }
   else{
      echo $id;
   }
}

function fillReturnsTypeCombo($a, $id)
{
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
      $result=db_query(returntype_qry8);
      if(db_num_rows($result) == 0){
         echo "&nbsp;";
         return;
      }
	   echo "<select name=\"returnreasonid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         if($id==$boo){
	   	  	print "<option selected value=\"$boo\"> $poo </option>\n";
   	   }
	   	else{
		      print "<option value=\"$boo\"> $poo </option>\n";
   		}
	   }
	   echo "</select>\n";
   }
   else{
      $qry=sprintf(returntype_qry9, $id);
      $result=db_query($qry);
      if(db_num_rows($result) == 0){
        echo "&nbsp;";
         return;
      }
      if($row = $result->FetchRow()){
         echo $row[0];
      }
   }
}

function listReturn()
{  
	$q=$_SESSION["pageindex"]->query(return_qry7);
	$result=db_query($q);

	print "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>TransID</h3></td><td><h3>Destination</h3></td><td><h3>Reason</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		print "<tr><td>";
		if($myrow["transid"]){
			$wibbler=$myrow["id"];
			$n=$myrow["destination"];
			$res=db_query("SELECT name from returntype where id = '$myrow[reasonid]'");
	      $row = $res->FetchRow();
         if($row){
            $r=$row[0];
         }
         else{
            $r="not set";
         }
			print "$myrow[transid]</td><td>$n</td><td>$r</td><td>";
			print "<a href=\"returns.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
			print "<a href=\"returns.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
			print "<a href=\"returns.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		}		
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "</form>";
	echo "<br><br>";
}

?>
