<?php
/*
stocktake.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

switch($_REQUEST['action']){
	case "start" :
		start();
		break;

	case "add" :
		item($_POST);
		break;

	case "end" :
		endst();
		break;

	case "commit":
		commit();
		break;
      
   case "commititem":
		commititem($_REQUEST['plu']);
      listDiscrepancy();
		break;

	case "list":
		listDiscrepancy();
		break;
}

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function clearForm() 
{
	$frm["id"] = "";
   $frm["plu"] = "";
   $frm["quantity"] = "";
   
	return $frm;
}

function start()
{
   generate_synch_entry();
   
	echo "Creating temporary table...\n<br>";
	$result=db_query(stocktake_qry1);
	
	db_query(stocktake_qry2);
	echo "Generating current stock levels\n<br>";
	$result=db_query(stocktake_qry3);
   $num=db_num_rows($result);
	while($row = $result->FetchRow()){
      $qry=sprintf(stocktake_qry4, $row["plu"], $row["instock"]);
		db_query($qry);
	}
	echo "Stock take mode engaged for $num products\n<br>";
   
	$frm=clearForm();
	$frm["newaction"]="add";
	include("templates/stocktake.php");
}

function item($frm)
{
	$q=$frm["quantity"];

   $qry=sprintf(stocktake_qry5, $frm["plu"]);
	$result=db_query($qry);
	if($row = $result->FetchRow()){
		$qty=$row["currentstock"];
		$qty+=$q;
      $qry=sprintf(stocktake_qry6, $qty, $frm["plu"]);
		db_query($qry);
	}
	else{
		echo "<br><center>PLU not found!</center><br>";
		$frm["newaction"]="add";
		include("templates/stocktake.php");
		exit;
	}
	$frm=clearForm();
	$frm["newaction"]="add";
	include("templates/stocktake.php");
}

function endst()
{
	echo "<br><br><center>";
	echo "<a href=\"stocktake.php?action=commit\">commit these values to stock (new stock levels)?</a><br><br>\n";
	echo "<a href=\"stocktake.php?action=list\">generate stock discrepancy report?</a><br><br>\n";
	echo "</center>";
}

function commit()
{
	$count=0;

	$result=db_query(stocktake_qry7);
	while($row = $result->FetchRow()){
      $qry=sprintf(stocktake_qry8, $row["currentstock"], $row["plu"]);
      db_query($qry);
      $qry=sprintf(stocktake_qry14, $row["currentstock"], $row["plu"]);
		db_query($qry);
		$count++;
	}	
	echo "<br><br>Processed $count products\n";
   close_synch_entry();
}

function commititem($plu)
{
   $qry=sprintf(stocktake_qry16, $plu);
   $result=db_query($qry);
	$row = $result->FetchRow();
   
   $qry=sprintf(stocktake_qry8, $row["currentstock"], $plu);
   db_query($qry);
   $qry=sprintf(stocktake_qry14, $row["currentstock"], $plu);
   db_query($qry);
   $qry=sprintf(stocktake_qry15, $row["currentstock"], $plu);
   db_query($qry);
}

function generate_synch_entry()
{
	$result=db_query(stocktake_qry9);
   if(db_num_rows($result) > 0){
		print "<br>The synch table has outstanding entries, cannot perform operation\n<br>";
		exit;
	}
   echo "<br>Creating synch entry...\n<br>";
	db_query(stocktake_qry10);
}

function close_synch_entry()
{
	$result=db_query(stocktake_qry11);
	if($row = $result->FetchRow()){
      $qry=sprintf(stocktake_qry12, $row[0]);
		db_query($qry);
      echo "Closing synch entry...\n<br>";
	}
}

function listDiscrepancy()
{
   close_synch_entry();
	$result=db_query(stocktake_qry13);

	echo "<br><table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Barcode</h3></td><td><h3>InStock</h3></td><td><h3>Stock Take</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		echo "<tr><td>$row[plu]</td>\n";
		if($row['instock'] < $row['currentstock']){
         echo "<td>$row[instock]</td><td>$row[currentstock]</td>\n";
      }
      else{
         echo "<td>$row[instock]</td><td>$row[currentstock]</td>\n";
      }
      echo "<td><a href=\"stocktake.php?action=commititem&plu=$row[plu]\">Commit</a></td>\n";
		echo "</tr>\n";
	}
	echo "</table><br>";
   include($_SESSION['CFG']->templatedir."/footer.php");
}
?>
