<?php
/*
uplu.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(uplu_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "edit" :
		editUplu($_REQUEST['id']);
		break;

	case "delete" :
		deleteUplu($id);
		listUplu();
		break;

	case "commit" :
		commitUplu($_POST);
      listUplu();
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listUplu();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(uplu_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function fillForm($id)
{
   $qry=sprintf(uplu_qry3, $id);
   
	$result=db_query($qry);
	$row = $result->FetchRow();
   $frm["id"] = $id;
   $frm["entryat"] = $row["entryat"];
   $frm["plu"] = $row["plu"];
   $frm["plutype"] = $row["plutype"];
   $frm["name"] = $row["name"];
   $frm["unitprice"] = $row["unitprice"];
   $frm["discount"] = $row["discount"];
   $frm["tax"] = $row["tax"];
   
   // additional for plu cache
   $frm["rectext"] = "";
   $frm["disptext"] = "";
   $frm["updatecache"] = 'Y';
   
   $qry=sprintf(uplu_qry5, $row["tax"]);
   $result=db_query($qry);
   if(db_num_rows($result)==0){
      $frm["taxid"]=0;
      $frm["badtax"] = "Y";
   }
   else{
      $frm["taxid"]=$row['id'];
      $frm["badtax"] = "N";
   }
	return $frm;
}

function editUplu($id) 
{
	$result=db_query("SELECT id FROM u_plu");
	$ret=db_num_rows($result);
	
	if($ret==0){
		include("templates/uplu_none.php");
		exit;
	}
	else{
		$frm=fillForm($id);
		$frm["newaction"] = "commit";
		include("templates/uplu.php");
	}
}

function deleteUplu($id) 
{
   $qry=sprintf(uplu_qry6, $id);
	db_query($qry);
}


function commitUplu($frm) 
{

   // throw in a minimal inv entry

   $cm=new CreateMod();
   $cm->Fill(0);
   $cmid=$cm->Commit();
 
   $qry=sprintf(inventory_qry6, 0,0,0,0,'','',0,0,0,0,0,0,0,0,0,$cmid,0);
   db_query($qry);
   
   $result=db_query(misc_qry1);
   $row = $result->FetchRow();
   $invid=$row[0];
   
   // add product with flags='unfinished entry' (2)
   $qry=sprintf(product_qry4, 0,$invid,0,0,$frm['plu'],0,$frm['name'],'',0,'N',0,$frm['rectext'],0,0,0,0,'N',0,'N',2,0,'');
   db_query($qry);
   
   $result=db_query(misc_qry1);
   $row = $result->FetchRow();
   $prodid=$row[0];
   
   // add a sell price quantity
   $qry=sprintf(sellpq_qry4, 0,0,1,2,1,$frm['unitprice'],0,$frm['taxid']);
   db_query($qry);
   $result=db_query(misc_qry1);
   $row = $result->FetchRow();
   $sellpqid=$row[0];
   
   // update the product for sell price
   $qry=sprintf(product_qry8, $sellpqid, $prodid);
   db_query($qry);
   
   // update plu_cache
   if(YN($frm['updatecache'])=="Y"){
      $qry=sprintf(uplu_qry8, $frm['taxid']);
      $result=db_query($qry);
      $row = $result->FetchRow();
      $tax=$row[0];
      $qry=sprintf(uplu_qry4, $prodid,0,$frm['plu'],$frm['disptext'],$frm['rectext'],$frm['unitprice'],0.0,0,0.0,$tax,0);
      db_query($qry);
   }
   
   // delete u_plu entry
   $qry=sprintf(uplu_qry6, $frm['id']);
	db_query($qry);
}

function listUplu()
{
	$q=$_SESSION["pageindex"]->query(uplu_qry7);
	$result=db_query($q);

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Barcode</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		$plu=$myrow["plu"];
		print "<tr><td>$plu</td><td>";
		$wibbler=$myrow["id"];
		print "<a href=\"uplu.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"uplu.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"uplu.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
