<?php
/*
transaction.php

Copyright (C)2004  Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/transaction.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], transaction_pagetitle)!=0){
   $_SESSION['title']=transaction_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(transaction_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear":
		addTrans();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseTrans($id);
		break;

	case "edit" :
		editTrans($_REQUEST['id']);
		break;

	case "delete" :
		deleteTrans($id);
      $_SESSION["pageindex"]->setnum(CountNum());
      listTrans($id);
		break;

	case "add" :
		insertTrans($_POST);
      $_SESSION["pageindex"]->setnum(CountNum());
		break;

	case "commit" :
		commitTrans($_POST);
      listBank(1);
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listTrans($id);
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(transaction_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["id"] = 0;
   $frm["transactionid"] = "";
   $frm["enteredat"] = "";
   $frm["enteredby"] = "";
   $frm["enteredstation"] = "";
   $frm["statusid"] = "";
   $frm["paymenttypeid"] = "";
   $frm["refnum"] = "";
   $frm["description"] = "";
   $frm["open"] = "";
   $frm["reconciled"] = "";
   $frm["taxable"] = "";
   $frm["settlementid"] = "";
   $frm["linkid"] = "";

	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(transaction_qry2, $id);
   }
   else{
      $qry=sprintf(transaction_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm["id"] = $id;
	$frm["transactionid"] = $row["transactionid"];
	$frm["enteredat"] = $row["enteredat"];
	$frm["enteredby"] = $row["enteredby"];
	$frm["enteredstation"] = $row["enteredstation"];
	$frm["statusid"]=$row["statusid"];
	$frm["paymenttypeid"]=$row["paymenttypeid"];
	$frm["refnum"]=$row["refnum"];
	$frm["description"]=$row["description"];
	$frm["open"] = $row["open"];
   $frm["reconciled"] = $row["reconciled"];
   $frm["taxable"] = $row["taxable"];
   $frm["settlementid"] = $row["settlementid"];
   $frm["linkid"] = $row["linkid"];
	
	return $frm;
}

function addTrans()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	$frm["heading"] = "Transaction Add";

	include("templates/transedit.php");
}

function editTrans($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Transaction Edit";

	include("templates/transedit.php");
}

function browseTrans($id) 
{
   $frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Transaction Browse";
	
	include("templates/transedit.php");
}

function chkdelTrans($id)
{
	$result=db_query("SELECT ID FROM transactionItems WHERE transid = '$id'");
	$frm["numitems"]=db_num_rows($result);

	$result=db_query("SELECT name FROM departments WHERE id = '$id'");
	$row = $result->FetchRow();
	$frm["name"]=$row["name"];

	$frm["newaction"] = "cfmdelete";
	include("templates/transdel.php");
}

function deleteTrans($id) 
{
/*
	if($frm["reassign"]=="1"){
		$ndept=$frm["departments"];
		$qid = db_query("UPDATE groups SET DeptID = '$ndept'	WHERE DeptID = $id");
	}
	else{
		$qid = db_query("UPDATE Groups SET DeptID = '0'	WHERE DeptID = $id");	
	}

	// death to department
	$qid = db_query("DELETE FROM departments WHERE ID = $id");

	listSite();*/
}

function insertTrans($frm) 
{
}

function commitTrans($id, $frm) 
{
}

function fillTransCombo($id)
{
	$result=db_query("SELECT * from transaction");
	echo "<select name=\"department\" width=\"250\">\n";
	while($row = $result->FetchRow()){
		$boo=$row["ID"];
		$poo=$row["name"];
		if($id==$boo){
			print "<option selected value=\"$boo\"> $poo </option>\n";
		}
		else{
			print "<option value=\"$boo\"> $poo </option>\n";
		}
	}
	echo "</select>\n";
}

function TransTable($a, $id)
{
   $t=new Transaction();
   if($a=='edit'){
      $t->Table($a, $id, "", false, true);
   }
   else{
      $t->Table($a, $id, "", true, true);
   }
}

function listTrans($tid)
{
   $q=$_SESSION["pageindex"]->query(transaction_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>ID</h3></td><td><h3>Description</h3></td><td><h3>Num Items</h3></td><td><h3>Total</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
      $tid=$row['transactionid'];
		echo "<tr><td>$tid</td><td>";
      if(isset($row['Description'])){
         echo $row['Description'];
      }
      else{
         echo "&nbsp";
      }
      echo "</td><td>";
      $qry=sprintf(transaction_qry11, $tid);
      $tresult=db_query($qry);
      if($trow = $result->FetchRow()){
         echo $trow[0];
      }
      else{
         echo "0";
		}
		echo "</td><td>";
      $qry=sprintf(transaction_qry12, $tid);
      $tresult=db_query($qry);
      if($trow = $result->FetchRow()){
         echo $trow[0];
      }
      else{
         echo "0";
		}
      echo "</td><td>";
		$wibbler=$row['id'];
		echo "<a href=\"transaction.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		echo "<a href=\"transaction.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		echo "<a href=\"transaction.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

function listTranItems($tid)
{
   $result=db_query("SELECT plu, quantity from transactionitems where transactionid='$tid'");
   $rt=0.00;
   $st=0.00;
   echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\" bgcolor=\"#FFFFFF\">\n";
   echo "<tr><td colspan=\"6\" align=\"center\">Transaction Items</td></tr>";
   echo "<tr><td>PLU</td><td>Name</td><td>Qty</td><td>Price</td><td>Sub</td><td>Total</td></tr>\n";
	while($row = $result->FetchRow()){
	   $p=$row["plu"];
	   $q=$row["quantity"];
      $nresult=db_query("SELECT disptext, unitprice from plu_cache where plu='$p'");
	   if($nrow = $result->FetchRow()){
   	   $n=$nrow["disptext"];
   	   $up=$nrow["unitprice"];
   	}
	   $st=(float) $up*$q;
	   $rt+=$st;
	   echo "<tr><td>\n";
	   echo "$p</td><td>$n</td><td>$q</td><td>";
	   printf("%0.2f", $up);
	   echo "</td>\n<td>";
	   printf("%0.2f", $st);
	   echo "</td>\n<td>";
	   printf("%0.2f", $rt);
	   echo "</td></tr>\n";
	}
	echo "</table>";
}

?>
