<?php

include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/auth.php");
require_once($_SESSION['CFG']->libdir."/user.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], user_pagetitle)!=0){
   $_SESSION['title']=user_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(user_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}
 
switch($_REQUEST['action']){
	case "clear" :
		clearUser();
		break;
		
	case "browse" :
      $id=updateNav($_POST);
		browseUser($id);
		break;

	case "edit" :
		editUser($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelUser($_REQUEST['id']);
      }
      else{
         deleteUser($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listUser($_REQUEST['id']);
      }
		break;
      
   case "cfmdelete" :
      deleteUser($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listUser();
		break;

	case "add" :
		addUser($_POST);
      $_SESSION["pageindex"]->setnum(CountNum());
		listUser();
		break;

	case "commit" :
		userCommit($_POST);
		listUser();
		break;

	case "list" :
	default :
      $id=updateNav($_POST);
		listUser();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(user_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(user_qry2, $id);
   }
   else{
      $qry=sprintf(user_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm["id"] = $row["id"];
	$frm["login"] = $row["login"];
	$frm["password"] = $row["password"];
	$frm["userdata"] = $row["userdata"];
	$frm["profile"] = $row["profile"];
	$frm["logintypesid"] = $row["logintypesid"];
	$frm["employeeid"] = $row["employeeid"];

	$teid=$row["employeeid"];
        
	$uqry=sprintf(user_qry15, $teid);
	$result=db_query($uqry);
	$erow = $result->FetchRow();
	$frm["fname"] = $erow["fname"];
	$frm["lname"] = $erow["lname"];
	$frm["employeenumber"] = $erow["employeenumber"];
	$frm["groupid"] = $erow["groupid"];
	
	$gid=$erow["groupid"];
	$unqry = sprintf(user_qry16, $gid);
	$result=db_query($unqry);
	$row = $result->FetchRow();
	$frm["groupName"]=$row["name"];

	return $frm;
}

function clearForm()
{
	$frm["id"] = "";
	$frm["login"] = "";
	$frm["password"] = "";
	$frm["userdata"] = "";
	$frm["profile"] = "";
	$frm["logintypesid"] = "";
	$frm["employeeid"] = "";

	$frm["fname"] = "";
	$frm["lname"] = "";
	$frm["enumber"] = "";
	$frm["groupid"] = "";
   $frm["groupname"] = "";

   return $frm;
}

function browseUser($id) 
{
	$frm = fillform($id, true);
	$frm["newaction"] = "browse";

	include("templates/useredit.php");
}

function editUser($id) 
{
	$frm = fillform($id, false);
	$frm["newaction"] = "commit";

	include("templates/useredit.php");
}

function clearUser() 
{
   $frm=clearForm();
   $frm["newaction"] = "add";

	include("templates/useredit.php");   
}

function deleteUser($frm) 
{
	$qid = db_query("DELETE FROM users WHERE id = '$id'");
	include("templates/userdel.php");
}

function chkdelUser($id)
{
}

function userInsert($frm) 
{
	$query = "INSERT INTO users (logintypesid, login, password, employeeid, profile, userdata)
	VALUES('$frm[logintypesid]','$frm[login]','$frm[password]','$frm[userid]','$frm[passivelogin]', '$frm[userdata]')";
	error_log($query);
	$qid = db_query($query);
}

function chkaddUser($frm)
{
        $query = "SELECT id FROM users WHERE login LIKE '$frm[login]'";
	$result = db_query($query);
	$chkid = $result->FetchRow();
	if($chkid['id'] != '')
	{
	      return true;
	}else{
	      return false;
	}
}

function addUser($frm)
{
        if(chkaddUser($frm) == false){
            $query = sprintf(user_qry5, $frm['logintypesid'],$frm['login'],$frm['password'],$frm['userid'],$frm['passivelogin'], $frm['userdata']);
	    db_query($query);
	}else{
	    print "User exists";
	}
}

function userCommit($frm) 
{
	$query = "UPDATE users SET
	   logintypesid = '$frm[logintypesid]',
	   login = '$frm[login]',
	   password = '$frm[password]',
	   employeeid = '$frm[userid]',
	   profile = '$frm[passivelogin]',
		userdata = '$frm[userdata]'
   	where id = '$frm[id]'";
	error_log($query);
	$qid = db_query($query);
}

function postControl($a, $id)
{
   global $u;
   $u=new User();
   $u->StationCombo($a, $id, "postid");
}

function ifControl($a, $id)
{
   global $u;
   $u->InterfaceCombo($a, $id, "interfaceid");
}

function liControl($a, $id)
{
   global $u;
   $u->LoginTypesCombo($a, $id, "logintypesid");
}

function PermTable($a, $id)
{
   global $u;
   /*
   $frm['postid']
   $frm['interfaceid']
   $frm['logintypesid']
   */ 
   //$u->Permtable($a, $id, "authID");
}

function listUser()
{
	$result=db_query("SELECT * from users ORDER BY id");
/*
	frm["login"] = $row["Login"]; 
	frm["password"] = $row["Password"];
	frm["profile"] = $row["Profile"]; 
	frm["ifauth"] = $row["InterfaceAuthID"];
	frm["logintypes"] = $row["logintypesid"];

	$eid=$row["ID"];
	$result=db_query("SELECT fname, lname from Employee WHERE UserID='$eid');
	$erow = $result->FetchRow();
	frm["fname"] = $erow["fname"]; 
	frm["lname"] = $erow["lname"];

	global $_SESSION;

	$action=db_query("SELECT * FROM EmployeeLog WHERE stamper < (NOW()-1) 
		ORDER BY EmployeeID, stamper, actionID DESC");
	$numaction=db_num_rows();


	$booboofish = $_SESSION["employee"]["ID"];

	$sql="SELECT actionID, stamper FROM EmployeeLog WHERE  
		actionID = '3' OR actionID = '5' OR actionID = '7' ORDER BY stamper DESC";
	$result=db_query($sql);
		

*/
		
	print "<form method=\"post\" action=\"users.php\">";
	
	print "<br><br><table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	print "<tr><td><h3>Name</h3></td>\n";
	print "<td><h3>Login</h3></td>";
	print "<td><h3>Action</h3></td>\n</tr>\n";
	
	while($row = $result->FetchRow()){

		$eid=$row["employeeid"];
		$eresult=db_query("SELECT id, fname, lname from employee WHERE id='$eid'");
		$erow = $eresult->FetchRow();
		print "<tr><td>";
		$name=$erow["fname"]." ".$erow["lname"]; 
		if($name == " "){
		   print "&nbsp;";
		}
		else{
   		print "$name";
      }
		print "</td>\n<td>";
		$wibbler=$row["login"];
		print "$wibbler</td><td>\n";
		$id=$row["id"];
		$eid=$erow["id"];
		print "<a href=\"users.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"users.php?action=edit&id=$id&emp=$eid\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"users.php?action=delete&id=$id\">".misc_listdelete."</a>&nbsp; \n";
				
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
	
}

?>
